searchData={"items":[{"type":"task","title":"mix umya_spreadsheet_ex.install","doc":"Install the umya_spreadsheet_ex package with Igniter","ref":"Mix.Tasks.UmyaSpreadsheetEx.Install.html"},{"type":"task","title":"Example - mix umya_spreadsheet_ex.install","doc":"```sh\nmix igniter.install umya_spreadsheet_ex\n```","ref":"Mix.Tasks.UmyaSpreadsheetEx.Install.html#module-example"},{"type":"module","title":"UmyaSpreadsheet.AdvancedFillFunctions","doc":"Functions for applying advanced fill patterns to cells in a spreadsheet, including gradient fills and pattern fills.\n\nThis module provides functionality for:\n- Creating gradient fills with multiple color stops\n- Applying pattern fills with various patterns\n- Managing complex fill styles beyond simple background colors","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.clear_fill/3","doc":"Clears all fill formatting from a cell.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#clear_fill/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.clear_fill/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#clear_fill/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.clear_fill/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#clear_fill/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.clear_fill/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Clear all fill formatting from cell A1\n    :ok = UmyaSpreadsheet.AdvancedFillFunctions.clear_fill(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#clear_fill/3-examples"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.get_gradient_fill/3","doc":"Gets the gradient fill information for a cell.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#get_gradient_fill/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.get_gradient_fill/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#get_gradient_fill/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.get_gradient_fill/3","doc":"- `{:ok, {degree, gradient_stops}}` on success where gradient_stops is a list of `{position, color}` tuples\n- `{:error, reason}` on failure or if no gradient fill exists","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#get_gradient_fill/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.get_gradient_fill/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    case UmyaSpreadsheet.AdvancedFillFunctions.get_gradient_fill(spreadsheet, \"Sheet1\", \"A1\") do\n      {:ok, {degree, stops}} ->\n        IO.inspect(\"Gradient angle: \" <> degree})\n        IO.inspect(\"Gradient stops: \" <> inspect(stops))\n      {:error, reason} ->\n        IO.puts(\"No gradient fill: \" <> reason)\n    end","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#get_gradient_fill/3-examples"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.get_pattern_fill/3","doc":"Gets the pattern fill information for a cell.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#get_pattern_fill/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.get_pattern_fill/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#get_pattern_fill/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.get_pattern_fill/3","doc":"- `{:ok, {pattern_type, foreground_color, background_color}}` on success\n- `{:error, reason}` on failure or if no pattern fill exists","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#get_pattern_fill/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.get_pattern_fill/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    case UmyaSpreadsheet.AdvancedFillFunctions.get_pattern_fill(spreadsheet, \"Sheet1\", \"A1\") do\n      {:ok, {pattern, fg_color, bg_color}} ->\n        IO.inspect(\"Pattern: \" <> pattern <> \", FG: \" <> fg_color <> \", BG: \" <> bg_color)\n      {:error, reason} ->\n        IO.puts(\"No pattern fill: \" <> reason)\n    end","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#get_pattern_fill/3-examples"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.set_custom_gradient_fill/6","doc":"Sets a custom gradient fill with multiple color stops and validation.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_custom_gradient_fill/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.set_custom_gradient_fill/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `degree` - The angle of the gradient in degrees (0-360)\n- `gradient_stops` - List of tuples `{position, color}` where position is 0.0-1.0\n- `validate_positions` - Whether to validate and sort gradient stop positions (default: true)","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_custom_gradient_fill/6-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.set_custom_gradient_fill/6","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_custom_gradient_fill/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.set_custom_gradient_fill/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Create a complex multi-color gradient\n    gradient_stops = [\n      {0.0, \"#FF0000\"},   # Red at start\n      {0.25, \"#FFFF00\"},  # Yellow at 25%\n      {0.5, \"#00FF00\"},   # Green at 50%\n      {0.75, \"#00FFFF\"},  # Cyan at 75%\n      {1.0, \"#0000FF\"}    # Blue at end\n    ]\n    :ok = UmyaSpreadsheet.AdvancedFillFunctions.set_custom_gradient_fill(\n      spreadsheet, \"Sheet1\", \"A1\", 90.0, gradient_stops, true\n    )","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_custom_gradient_fill/6-examples"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.set_gradient_fill/5","doc":"Sets a gradient fill for a cell with custom gradient stops.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_gradient_fill/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.set_gradient_fill/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `degree` - The angle of the gradient in degrees (0-360)\n- `gradient_stops` - List of tuples `{position, color}` where position is 0.0-1.0 and color is a hex string","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_gradient_fill/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.set_gradient_fill/5","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_gradient_fill/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.set_gradient_fill/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Create a gradient from red to blue\n    gradient_stops = [{0.0, \"#FF0000\"}, {1.0, \"#0000FF\"}]\n    :ok = UmyaSpreadsheet.AdvancedFillFunctions.set_gradient_fill(\n      spreadsheet, \"Sheet1\", \"A1\", 45.0, gradient_stops\n    )","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_gradient_fill/5-examples"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.set_linear_gradient_fill/6","doc":"Sets a simple linear gradient fill between two colors.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_linear_gradient_fill/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.set_linear_gradient_fill/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `start_color` - The starting color as a hex string\n- `end_color` - The ending color as a hex string\n- `angle` - Optional angle in degrees (default: 0.0)","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_linear_gradient_fill/6-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.set_linear_gradient_fill/6","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_linear_gradient_fill/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.set_linear_gradient_fill/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Create a horizontal gradient from green to yellow\n    :ok = UmyaSpreadsheet.AdvancedFillFunctions.set_linear_gradient_fill(\n      spreadsheet, \"Sheet1\", \"A1\", \"#00FF00\", \"#FFFF00\", 0.0\n    )","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_linear_gradient_fill/6-examples"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill/6","doc":"Sets a pattern fill for a cell.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_pattern_fill/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `pattern_type` - The pattern type (atom or string)\n- `foreground_color` - The foreground color as a hex string\n- `background_color` - Optional background color as a hex string","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_pattern_fill/6-parameters"},{"type":"function","title":"Pattern Types - UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill/6","doc":"Available pattern types include:\n- `:solid` - Solid fill\n- `:dark_gray` - Dark gray pattern\n- `:medium_gray` - Medium gray pattern\n- `:light_gray` - Light gray pattern\n- `:gray_125` - 12.5% gray pattern\n- `:gray_0625` - 6.25% gray pattern\n- `:dark_horizontal` - Dark horizontal lines\n- `:dark_vertical` - Dark vertical lines\n- `:dark_down` - Dark diagonal lines (down)\n- `:dark_up` - Dark diagonal lines (up)\n- `:dark_grid` - Dark grid pattern\n- `:dark_trellis` - Dark trellis pattern\n- `:light_horizontal` - Light horizontal lines\n- `:light_vertical` - Light vertical lines\n- `:light_down` - Light diagonal lines (down)\n- `:light_up` - Light diagonal lines (up)\n- `:light_grid` - Light grid pattern\n- `:light_trellis` - Light trellis pattern","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_pattern_fill/6-pattern-types"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill/6","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_pattern_fill/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Apply a solid red fill\n    :ok = UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill(\n      spreadsheet, \"Sheet1\", \"A1\", :solid, \"#FF0000\"\n    )\n\n    # Apply a diagonal pattern with blue foreground and white background\n    :ok = UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill(\n      spreadsheet, \"Sheet1\", \"B1\", :dark_down, \"#0000FF\", \"#FFFFFF\"\n    )","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_pattern_fill/6-examples"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.set_radial_gradient_fill/5","doc":"Sets a radial gradient fill from center to edge.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_radial_gradient_fill/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.set_radial_gradient_fill/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `center_color` - The center color as a hex string\n- `edge_color` - The edge color as a hex string","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_radial_gradient_fill/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.set_radial_gradient_fill/5","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_radial_gradient_fill/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.set_radial_gradient_fill/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Create a radial gradient from white center to blue edge\n    :ok = UmyaSpreadsheet.AdvancedFillFunctions.set_radial_gradient_fill(\n      spreadsheet, \"Sheet1\", \"A1\", \"#FFFFFF\", \"#0000FF\"\n    )","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_radial_gradient_fill/5-examples"},{"type":"function","title":"UmyaSpreadsheet.AdvancedFillFunctions.set_three_color_gradient_fill/7","doc":"Sets a three-color gradient fill with start, middle, and end colors.","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_three_color_gradient_fill/7"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AdvancedFillFunctions.set_three_color_gradient_fill/7","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `start_color` - The starting color as a hex string\n- `middle_color` - The middle color as a hex string\n- `end_color` - The ending color as a hex string\n- `angle` - Optional angle in degrees (default: 0.0)","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_three_color_gradient_fill/7-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AdvancedFillFunctions.set_three_color_gradient_fill/7","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_three_color_gradient_fill/7-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AdvancedFillFunctions.set_three_color_gradient_fill/7","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Create a three-color gradient: red -> yellow -> green\n    :ok = UmyaSpreadsheet.AdvancedFillFunctions.set_three_color_gradient_fill(\n      spreadsheet, \"Sheet1\", \"A1\", \"#FF0000\", \"#FFFF00\", \"#00FF00\", 45.0\n    )","ref":"UmyaSpreadsheet.AdvancedFillFunctions.html#set_three_color_gradient_fill/7-examples"},{"type":"module","title":"UmyaSpreadsheet.AutoFilterFunctions","doc":"Functions for working with auto filters in spreadsheets.\n\nAuto filters allow users to filter data in Excel by adding dropdown menus to column headers.","ref":"UmyaSpreadsheet.AutoFilterFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.AutoFilterFunctions.get_auto_filter_range/2","doc":"Gets the range of an auto filter in a worksheet.","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#get_auto_filter_range/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AutoFilterFunctions.get_auto_filter_range/2","doc":"* `spreadsheet` - The spreadsheet struct\n* `sheet_name` - Name of the worksheet","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#get_auto_filter_range/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AutoFilterFunctions.get_auto_filter_range/2","doc":"* The range of the auto filter (e.g., \"A1:E10\") or `nil` if no auto filter exists","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#get_auto_filter_range/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AutoFilterFunctions.get_auto_filter_range/2","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E10\")\n    iex> UmyaSpreadsheet.get_auto_filter_range(spreadsheet, \"Sheet1\")\n    \"A1:E10\"","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#get_auto_filter_range/2-examples"},{"type":"function","title":"UmyaSpreadsheet.AutoFilterFunctions.has_auto_filter/2","doc":"Checks if a worksheet has an auto filter.","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#has_auto_filter/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AutoFilterFunctions.has_auto_filter/2","doc":"* `spreadsheet` - The spreadsheet struct\n* `sheet_name` - Name of the worksheet","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#has_auto_filter/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.AutoFilterFunctions.has_auto_filter/2","doc":"* `true` if the worksheet has an auto filter, `false` otherwise","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#has_auto_filter/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.AutoFilterFunctions.has_auto_filter/2","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E10\")\n    iex> UmyaSpreadsheet.has_auto_filter(spreadsheet, \"Sheet1\")\n    true","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#has_auto_filter/2-examples"},{"type":"function","title":"UmyaSpreadsheet.AutoFilterFunctions.remove_auto_filter/2","doc":"Removes an auto filter from a worksheet.","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#remove_auto_filter/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AutoFilterFunctions.remove_auto_filter/2","doc":"* `spreadsheet` - The spreadsheet struct\n* `sheet_name` - Name of the worksheet","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#remove_auto_filter/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.AutoFilterFunctions.remove_auto_filter/2","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E10\")\n    iex> UmyaSpreadsheet.remove_auto_filter(spreadsheet, \"Sheet1\")\n    :ok","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#remove_auto_filter/2-examples"},{"type":"function","title":"UmyaSpreadsheet.AutoFilterFunctions.set_auto_filter/3","doc":"Sets an auto filter for a range of cells in a worksheet.\n\nThis adds filter dropdown buttons to the top row of the specified range.","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#set_auto_filter/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.AutoFilterFunctions.set_auto_filter/3","doc":"* `spreadsheet` - The spreadsheet struct\n* `sheet_name` - Name of the worksheet\n* `range` - Cell range in A1 notation (e.g., \"A1:E10\")","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#set_auto_filter/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.AutoFilterFunctions.set_auto_filter/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E10\")\n    :ok","ref":"UmyaSpreadsheet.AutoFilterFunctions.html#set_auto_filter/3-examples"},{"type":"module","title":"UmyaSpreadsheet.BackgroundFunctions","doc":"Functions for manipulating and inspecting cell background colors in a spreadsheet.","ref":"UmyaSpreadsheet.BackgroundFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.BackgroundFunctions.get_cell_background_color/3","doc":"Gets the background color of a cell.","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_background_color/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.BackgroundFunctions.get_cell_background_color/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_background_color/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.BackgroundFunctions.get_cell_background_color/3","doc":"- `{:ok, color}` on success where color is a hex color code (e.g., \"FFFFFF00\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_background_color/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.BackgroundFunctions.get_cell_background_color/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, color} = UmyaSpreadsheet.BackgroundFunctions.get_cell_background_color(spreadsheet, \"Sheet1\", \"A1\")\n    # => \"FFFFFF00\" (yellow background)","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_background_color/3-examples"},{"type":"function","title":"UmyaSpreadsheet.BackgroundFunctions.get_cell_foreground_color/3","doc":"Gets the foreground color of a cell.","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_foreground_color/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.BackgroundFunctions.get_cell_foreground_color/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_foreground_color/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.BackgroundFunctions.get_cell_foreground_color/3","doc":"- `{:ok, color}` on success where color is a hex color code (e.g., \"FFFFFFFF\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_foreground_color/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.BackgroundFunctions.get_cell_foreground_color/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, color} = UmyaSpreadsheet.BackgroundFunctions.get_cell_foreground_color(spreadsheet, \"Sheet1\", \"A1\")\n    # => \"FFFFFFFF\" (white foreground)","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_foreground_color/3-examples"},{"type":"function","title":"UmyaSpreadsheet.BackgroundFunctions.get_cell_pattern_type/3","doc":"Gets the pattern type of a cell's fill.","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_pattern_type/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.BackgroundFunctions.get_cell_pattern_type/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_pattern_type/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.BackgroundFunctions.get_cell_pattern_type/3","doc":"- `{:ok, pattern_type}` on success where pattern_type is a string (e.g., \"solid\", \"none\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_pattern_type/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.BackgroundFunctions.get_cell_pattern_type/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, pattern} = UmyaSpreadsheet.BackgroundFunctions.get_cell_pattern_type(spreadsheet, \"Sheet1\", \"A1\")\n    # => \"solid\"","ref":"UmyaSpreadsheet.BackgroundFunctions.html#get_cell_pattern_type/3-examples"},{"type":"function","title":"UmyaSpreadsheet.BackgroundFunctions.set_background_color/4","doc":"Sets the background color of a cell.","ref":"UmyaSpreadsheet.BackgroundFunctions.html#set_background_color/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.BackgroundFunctions.set_background_color/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `color` - The color code (e.g., \"#FF0000\" for red)","ref":"UmyaSpreadsheet.BackgroundFunctions.html#set_background_color/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.BackgroundFunctions.set_background_color/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.BackgroundFunctions.html#set_background_color/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.BackgroundFunctions.set_background_color/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Set cell background to light blue\n    :ok = UmyaSpreadsheet.BackgroundFunctions.set_background_color(spreadsheet, \"Sheet1\", \"A1\", \"#CCECFF\")","ref":"UmyaSpreadsheet.BackgroundFunctions.html#set_background_color/4-examples"},{"type":"module","title":"UmyaSpreadsheet.BorderFunctions","doc":"Functions for manipulating cell borders in a spreadsheet.","ref":"UmyaSpreadsheet.BorderFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.BorderFunctions.set_border_style/5","doc":"Sets the border style for a cell.","ref":"UmyaSpreadsheet.BorderFunctions.html#set_border_style/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.BorderFunctions.set_border_style/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `border_position` - The border position (\"top\", \"right\", \"bottom\", \"left\", \"diagonal\", \"outline\", \"all\")\n- `border_style` - The border style (\"thin\", \"medium\", \"thick\", \"dashed\", \"dotted\", \"double\", \"none\")","ref":"UmyaSpreadsheet.BorderFunctions.html#set_border_style/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.BorderFunctions.set_border_style/5","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.BorderFunctions.html#set_border_style/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.BorderFunctions.set_border_style/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Set top border to thick\n    :ok = UmyaSpreadsheet.BorderFunctions.set_border_style(spreadsheet, \"Sheet1\", \"A1\", \"top\", \"thick\")\n\n    # Set all borders to thin\n    :ok = UmyaSpreadsheet.BorderFunctions.set_border_style(spreadsheet, \"Sheet1\", \"B2\", \"all\", \"thin\")","ref":"UmyaSpreadsheet.BorderFunctions.html#set_border_style/5-examples"},{"type":"module","title":"UmyaSpreadsheet.CSVFunctions","doc":"Functions for exporting spreadsheets to CSV format.","ref":"UmyaSpreadsheet.CSVFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.CSVFunctions.write_csv/3","doc":"Exports a sheet to CSV format with default options.","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CSVFunctions.write_csv/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet to export\n- `path` - The output path for the CSV file","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CSVFunctions.write_csv/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.CSVFunctions.write_csv(spreadsheet, \"Sheet1\", \"output.csv\")","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv/3-examples"},{"type":"function","title":"UmyaSpreadsheet.CSVFunctions.write_csv/4","doc":"Exports a sheet to CSV format with custom options.","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CSVFunctions.write_csv/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet to export\n- `path` - The output path for the CSV file\n- `options` - A map of CSV writer options with the following fields:\n    - `:encoding` - The character encoding to use (default: \"UTF8\")\n    - `:delimiter` - The field delimiter (default: \",\")\n    - `:do_trim` - Whether to trim whitespace (default: false)\n    - `:wrap_with_char` - Character to wrap fields with (default: \"\")","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CSVFunctions.write_csv/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    options = %{\n      encoding: \"UTF8\",\n      delimiter: \";\",\n      do_trim: true,\n      wrap_with_char: \"\"\"\n    }\n\n    :ok = UmyaSpreadsheet.CSVFunctions.write_csv(spreadsheet, \"Sheet1\", \"output.csv\", options)","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv/4-examples"},{"type":"function","title":"UmyaSpreadsheet.CSVFunctions.write_csv_with_options/4","doc":"Exports a sheet to CSV format with custom options.","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv_with_options/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CSVFunctions.write_csv_with_options/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet to export\n- `path` - The output path for the CSV file\n- `options` - A map of CSV writer options with the following fields:\n    - `:encoding` - The character encoding to use (default: \"UTF8\")\n    - `:delimiter` - The field delimiter (default: \",\")\n    - `:do_trim` - Whether to trim whitespace (default: false)\n    - `:wrap_with_char` - Character to wrap fields with (default: \"\")","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv_with_options/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CSVFunctions.write_csv_with_options/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    options = %{\n      encoding: \"UTF8\",\n      delimiter: \";\",\n      do_trim: true,\n      wrap_with_char: \"\"\"\n    }\n\n    :ok = UmyaSpreadsheet.CSVFunctions.write_csv_with_options(spreadsheet, \"Sheet1\", \"output.csv\", options)","ref":"UmyaSpreadsheet.CSVFunctions.html#write_csv_with_options/4-examples"},{"type":"module","title":"UmyaSpreadsheet.CellFunctions","doc":"Functions for manipulating individual cells in a spreadsheet.","ref":"UmyaSpreadsheet.CellFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_border_color/4","doc":"Gets the border color of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_border_color/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_border_color/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `border_position` - \"top\", \"bottom\", \"left\", \"right\", or \"diagonal\"","ref":"UmyaSpreadsheet.CellFunctions.html#get_border_color/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_border_color/4","doc":"- `{:ok, color}` where color is the border color in hex format (e.g., \"#FF0000\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_border_color/4-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_border_style/4","doc":"Gets the border style of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_border_style/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_border_style/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `border_position` - \"top\", \"bottom\", \"left\", \"right\", or \"diagonal\"","ref":"UmyaSpreadsheet.CellFunctions.html#get_border_style/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_border_style/4","doc":"- `{:ok, style}` where style is the border style (e.g., \"solid\", \"dashed\", \"dotted\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_border_style/4-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_background_color/3","doc":"Gets the background color of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_background_color/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_background_color/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_background_color/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_background_color/3","doc":"- `{:ok, color}` where color is the background color in hex format (e.g., \"#FFFFFF\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_background_color/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_foreground_color/3","doc":"Gets the foreground color of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_foreground_color/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_foreground_color/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_foreground_color/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_foreground_color/3","doc":"- `{:ok, color}` where color is the foreground color in hex format (e.g., \"#000000\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_foreground_color/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_format_code/3","doc":"Gets the number format code of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_format_code/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_format_code/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_format_code/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_format_code/3","doc":"- `{:ok, format_code}` where format_code is the number format code (e.g., \"0.00\", \"m/d/yyyy\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_format_code/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_hidden/3","doc":"Gets the hidden status of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_hidden/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_hidden/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_hidden/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_hidden/3","doc":"- `{:ok, hidden}` where hidden is a boolean indicating if the cell is hidden\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_hidden/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_horizontal_alignment/3","doc":"Gets the horizontal alignment of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_horizontal_alignment/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_horizontal_alignment/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_horizontal_alignment/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_horizontal_alignment/3","doc":"- `{:ok, alignment}` where alignment is \"general\", \"left\", \"center\", \"right\", etc.\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_horizontal_alignment/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_locked/3","doc":"Gets the locked status of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_locked/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_locked/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_locked/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_locked/3","doc":"- `{:ok, locked}` where locked is a boolean indicating if the cell is locked\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_locked/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_number_format_id/3","doc":"Gets the number format ID of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_number_format_id/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_number_format_id/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_number_format_id/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_number_format_id/3","doc":"- `{:ok, format_id}` where format_id is the number format ID\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_number_format_id/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_pattern_type/3","doc":"Gets the pattern type of a cell's fill.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_pattern_type/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_pattern_type/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_pattern_type/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_pattern_type/3","doc":"- `{:ok, pattern_type}` where pattern_type is the pattern type (e.g., \"solid\", \"none\")\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_pattern_type/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_text_rotation/3","doc":"Gets the text rotation of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_text_rotation/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_text_rotation/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_text_rotation/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_text_rotation/3","doc":"- `{:ok, angle}` where angle is the rotation angle in degrees\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_text_rotation/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_value/3","doc":"Gets the value of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_value/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_value/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_value/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_value/3","doc":"- The cell value as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_value/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.get_cell_value/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    \"Hello\" = UmyaSpreadsheet.CellFunctions.get_cell_value(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_value/3-examples"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_vertical_alignment/3","doc":"Gets the vertical alignment of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_vertical_alignment/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_vertical_alignment/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_vertical_alignment/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_vertical_alignment/3","doc":"- `{:ok, alignment}` where alignment is \"top\", \"center\", \"bottom\", etc.\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_vertical_alignment/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_cell_wrap_text/3","doc":"Gets the wrap text setting of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_wrap_text/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_cell_wrap_text/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_wrap_text/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_cell_wrap_text/3","doc":"- `{:ok, wrap}` where wrap is a boolean indicating if text wrapping is enabled\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_cell_wrap_text/3-returns"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.get_formatted_value/3","doc":"Gets the formatted value of a cell (as displayed in Excel).","ref":"UmyaSpreadsheet.CellFunctions.html#get_formatted_value/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.get_formatted_value/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_formatted_value/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.get_formatted_value/3","doc":"- The formatted cell value as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#get_formatted_value/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.get_formatted_value/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    \"12/31/2023\" = UmyaSpreadsheet.CellFunctions.get_formatted_value(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.CellFunctions.html#get_formatted_value/3-examples"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.remove_cell/3","doc":"Removes a cell from the spreadsheet.","ref":"UmyaSpreadsheet.CellFunctions.html#remove_cell/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.remove_cell/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.CellFunctions.html#remove_cell/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.remove_cell/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#remove_cell/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.remove_cell/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.CellFunctions.remove_cell(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.CellFunctions.html#remove_cell/3-examples"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.set_cell_alignment/5","doc":"Sets the cell alignment.","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_alignment/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.set_cell_alignment/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `horizontal` - Horizontal alignment (\"left\", \"center\", \"right\", \"justify\")\n- `vertical` - Vertical alignment (\"top\", \"center\", \"bottom\")","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_alignment/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.set_cell_alignment/5","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_alignment/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.set_cell_alignment/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.CellFunctions.set_cell_alignment(spreadsheet, \"Sheet1\", \"A1\", \"center\", \"center\")","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_alignment/5-examples"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.set_cell_indent/4","doc":"Sets the text indentation level for a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_indent/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.set_cell_indent/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `level` - The indentation level","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_indent/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.set_cell_indent/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_indent/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.set_cell_indent/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.CellFunctions.set_cell_indent(spreadsheet, \"Sheet1\", \"A1\", 2)","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_indent/4-examples"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.set_cell_rotation/4","doc":"Sets the text rotation angle for a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_rotation/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.set_cell_rotation/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `angle` - The rotation angle in degrees","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_rotation/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.set_cell_rotation/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_rotation/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.set_cell_rotation/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.CellFunctions.set_cell_rotation(spreadsheet, \"Sheet1\", \"A1\", 45)","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_rotation/4-examples"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.set_cell_value/4","doc":"Sets the value of a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_value/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.set_cell_value/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `value` - The value to set","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_value/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.set_cell_value/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_value/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.set_cell_value/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.CellFunctions.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Hello\")","ref":"UmyaSpreadsheet.CellFunctions.html#set_cell_value/4-examples"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.set_number_format/4","doc":"Sets the number format for a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#set_number_format/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.set_number_format/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `format_code` - The format code (e.g., \"0.00\", \"m/d/yyyy\")","ref":"UmyaSpreadsheet.CellFunctions.html#set_number_format/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.set_number_format/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#set_number_format/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.set_number_format/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Set number format to 2 decimal places\n    :ok = UmyaSpreadsheet.CellFunctions.set_number_format(spreadsheet, \"Sheet1\", \"A1\", \"0.00\")\n    # Set date format\n    :ok = UmyaSpreadsheet.CellFunctions.set_number_format(spreadsheet, \"Sheet1\", \"B1\", \"m/d/yyyy\")","ref":"UmyaSpreadsheet.CellFunctions.html#set_number_format/4-examples"},{"type":"function","title":"UmyaSpreadsheet.CellFunctions.set_wrap_text/4","doc":"Sets text wrapping for a cell.","ref":"UmyaSpreadsheet.CellFunctions.html#set_wrap_text/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CellFunctions.set_wrap_text/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `wrap` - Boolean indicating whether to wrap text","ref":"UmyaSpreadsheet.CellFunctions.html#set_wrap_text/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.CellFunctions.set_wrap_text/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.CellFunctions.html#set_wrap_text/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.CellFunctions.set_wrap_text/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.CellFunctions.set_wrap_text(spreadsheet, \"Sheet1\", \"A1\", true)","ref":"UmyaSpreadsheet.CellFunctions.html#set_wrap_text/4-examples"},{"type":"module","title":"UmyaSpreadsheet.ChartFunctions","doc":"Functions for creating and manipulating charts in a spreadsheet.","ref":"UmyaSpreadsheet.ChartFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.ChartFunctions.add_chart/9","doc":"Adds a chart to a spreadsheet.","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart/9"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ChartFunctions.add_chart/9","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `chart_type` - The type of chart (e.g., \"bar\", \"line\", \"pie\")\n- `from_cell` - The top-left cell of the chart position\n- `to_cell` - The bottom-right cell of the chart position\n- `title` - The title of the chart\n- `data_series` - A list of data series ranges\n- `series_titles` - A list of series titles\n- `point_titles` - A list of point titles (categories)","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart/9-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ChartFunctions.add_chart/9","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart/9-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ChartFunctions.add_chart/9","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ChartFunctions.add_chart(\n      spreadsheet,\n      \"Sheet1\",\n      \"bar\",\n      \"E2\",\n      \"K15\",\n      \"Sales Chart\",\n      [\"B2:B10\"],\n      [\"Sales\"],\n      [\"Jan\", \"Feb\", \"Mar\", \"Apr\", \"May\", \"Jun\", \"Jul\", \"Aug\", \"Sep\"]\n    )","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart/9-examples"},{"type":"function","title":"UmyaSpreadsheet.ChartFunctions.add_chart_with_options/15","doc":"Adds a chart to a spreadsheet with advanced options.","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart_with_options/15"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ChartFunctions.add_chart_with_options/15","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `chart_type` - The type of chart (e.g., \"bar\", \"line\", \"pie\")\n- `from_cell` - The top-left cell of the chart position\n- `to_cell` - The bottom-right cell of the chart position\n- `title` - The title of the chart\n- `data_series` - A list of data series ranges\n- `series_titles` - A list of series titles\n- `point_titles` - A list of point titles (categories)\n- `style` - Chart style number\n- `vary_colors` - Boolean indicating whether to vary colors by point\n- `view_3d` - 3D view options (rotation, perspective)\n- `legend` - Legend options (position, overlay)\n- `axes` - Axes options (titles, formatting)\n- `data_labels` - Data label options","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart_with_options/15-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ChartFunctions.add_chart_with_options/15","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart_with_options/15-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ChartFunctions.add_chart_with_options/15","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ChartFunctions.add_chart_with_options(\n      spreadsheet,\n      \"Sheet1\",\n      \"bar\",\n      \"E2\",\n      \"K15\",\n      \"Sales Chart\",\n      [\"B2:B10\"],\n      [\"Sales\"],\n      [\"Jan\", \"Feb\", \"Mar\", \"Apr\", \"May\", \"Jun\", \"Jul\", \"Aug\", \"Sep\"],\n      2,\n      true,\n      %{rot_x: 30, rot_y: 20, perspective: 30, height_percent: 100},\n      %{position: \"right\", overlay: false},\n      %{category_axis_title: \"Month\", value_axis_title: \"Amount\"},\n      %{show_values: true, show_percent: false, show_category_name: false, show_series_name: true, position: \"outside_end\"}\n    )","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart_with_options/15-examples"},{"type":"function","title":"UmyaSpreadsheet.ChartFunctions.add_chart_with_options/16","doc":"Adds a chart to a spreadsheet with advanced options, including chart-specific options.","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart_with_options/16"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ChartFunctions.add_chart_with_options/16","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `chart_type` - The type of chart (e.g., \"bar\", \"line\", \"pie\")\n- `from_cell` - The top-left cell of the chart position\n- `to_cell` - The bottom-right cell of the chart position\n- `title` - The title of the chart\n- `data_series` - A list of data series ranges\n- `series_titles` - A list of series titles\n- `point_titles` - A list of point titles (categories)\n- `style` - Chart style number\n- `vary_colors` - Boolean indicating whether to vary colors by point\n- `view_3d` - 3D view options (rotation, perspective)\n- `legend` - Legend options (position, overlay)\n- `axes` - Axes options (titles, formatting)\n- `data_labels` - Data label options\n- `chart_specific` - Chart-specific options","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart_with_options/16-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ChartFunctions.add_chart_with_options/16","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ChartFunctions.html#add_chart_with_options/16-returns"},{"type":"function","title":"UmyaSpreadsheet.ChartFunctions.set_chart_3d_view/7","doc":"Sets 3D view properties for a chart.","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_3d_view/7"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ChartFunctions.set_chart_3d_view/7","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `chart_index` - The index of the chart (0-based)\n- `rot_x` - X-axis rotation (degrees)\n- `rot_y` - Y-axis rotation (degrees)\n- `perspective` - Perspective (0-100)\n- `height_percent` - Height as percentage of width","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_3d_view/7-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ChartFunctions.set_chart_3d_view/7","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_3d_view/7-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ChartFunctions.set_chart_3d_view/7","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ChartFunctions.set_chart_3d_view(spreadsheet, \"Sheet1\", 0, 30, 20, 30, 100)","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_3d_view/7-examples"},{"type":"function","title":"UmyaSpreadsheet.ChartFunctions.set_chart_axis_titles/5","doc":"Sets axis titles for a chart.","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_axis_titles/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ChartFunctions.set_chart_axis_titles/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `chart_index` - The index of the chart (0-based)\n- `category_axis_title` - The title for the category (X) axis\n- `value_axis_title` - The title for the value (Y) axis","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_axis_titles/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ChartFunctions.set_chart_axis_titles/5","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_axis_titles/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ChartFunctions.set_chart_axis_titles/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ChartFunctions.set_chart_axis_titles(spreadsheet, \"Sheet1\", 0, \"Month\", \"Sales (USD)\")","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_axis_titles/5-examples"},{"type":"function","title":"UmyaSpreadsheet.ChartFunctions.set_chart_data_labels/8","doc":"Sets data labels for a chart.","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_data_labels/8"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ChartFunctions.set_chart_data_labels/8","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `chart_index` - The index of the chart (0-based)\n- `show_values` - Boolean indicating whether to show values\n- `show_percent` - Boolean indicating whether to show percentages\n- `show_category_name` - Boolean indicating whether to show category names\n- `show_series_name` - Boolean indicating whether to show series names\n- `position` - The position of the data labels (e.g., \"outside_end\", \"center\", \"inside_end\")","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_data_labels/8-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ChartFunctions.set_chart_data_labels/8","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_data_labels/8-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ChartFunctions.set_chart_data_labels/8","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ChartFunctions.set_chart_data_labels(\n      spreadsheet,\n      \"Sheet1\",\n      0,\n      true,\n      false,\n      true,\n      false,\n      \"outside_end\"\n    )","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_data_labels/8-examples"},{"type":"function","title":"UmyaSpreadsheet.ChartFunctions.set_chart_legend_position/5","doc":"Sets the legend position for a chart.","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_legend_position/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ChartFunctions.set_chart_legend_position/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `chart_index` - The index of the chart (0-based)\n- `position` - The position of the legend (e.g., \"right\", \"left\", \"top\", \"bottom\", \"top_right\")\n- `overlay` - Boolean indicating whether the legend should overlay the chart","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_legend_position/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ChartFunctions.set_chart_legend_position/5","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_legend_position/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ChartFunctions.set_chart_legend_position/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ChartFunctions.set_chart_legend_position(spreadsheet, \"Sheet1\", 0, \"right\", false)","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_legend_position/5-examples"},{"type":"function","title":"UmyaSpreadsheet.ChartFunctions.set_chart_style/4","doc":"Sets the chart style.","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_style/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ChartFunctions.set_chart_style/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `chart_index` - The index of the chart (0-based)\n- `style` - The style number (1-48)","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_style/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ChartFunctions.set_chart_style/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_style/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ChartFunctions.set_chart_style/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ChartFunctions.set_chart_style(spreadsheet, \"Sheet1\", 0, 5)","ref":"UmyaSpreadsheet.ChartFunctions.html#set_chart_style/4-examples"},{"type":"module","title":"UmyaSpreadsheet.CommentFunctions","doc":"Functions for working with cell comments in spreadsheets.","ref":"UmyaSpreadsheet.CommentFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.CommentFunctions.add_comment/5","doc":"Adds a comment to a cell.","ref":"UmyaSpreadsheet.CommentFunctions.html#add_comment/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CommentFunctions.add_comment/5","doc":"* `spreadsheet` - The spreadsheet reference\n* `sheet_name` - Name of the worksheet\n* `cell_address` - Cell address in A1 notation (e.g., \"A1\", \"B2\")\n* `text` - Text content of the comment\n* `author` - Name of the comment author","ref":"UmyaSpreadsheet.CommentFunctions.html#add_comment/5-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CommentFunctions.add_comment/5","doc":"iex> UmyaSpreadsheet.add_comment(spreadsheet, \"Sheet1\", \"A1\", \"This is a comment\", \"John Doe\")\n    :ok","ref":"UmyaSpreadsheet.CommentFunctions.html#add_comment/5-examples"},{"type":"function","title":"UmyaSpreadsheet.CommentFunctions.get_comment/3","doc":"Gets the comment text and author from a cell.","ref":"UmyaSpreadsheet.CommentFunctions.html#get_comment/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CommentFunctions.get_comment/3","doc":"* `spreadsheet` - The spreadsheet reference\n* `sheet_name` - Name of the worksheet\n* `cell_address` - Cell address in A1 notation (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.CommentFunctions.html#get_comment/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CommentFunctions.get_comment/3","doc":"iex> UmyaSpreadsheet.get_comment(spreadsheet, \"Sheet1\", \"A1\")\n    {:ok, \"This is a comment\", \"John Doe\"}","ref":"UmyaSpreadsheet.CommentFunctions.html#get_comment/3-examples"},{"type":"function","title":"UmyaSpreadsheet.CommentFunctions.get_comments_count/2","doc":"Gets the number of comments in a sheet.","ref":"UmyaSpreadsheet.CommentFunctions.html#get_comments_count/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CommentFunctions.get_comments_count/2","doc":"* `spreadsheet` - The spreadsheet reference\n* `sheet_name` - Name of the worksheet","ref":"UmyaSpreadsheet.CommentFunctions.html#get_comments_count/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CommentFunctions.get_comments_count/2","doc":"iex> UmyaSpreadsheet.get_comments_count(spreadsheet, \"Sheet1\")\n    3","ref":"UmyaSpreadsheet.CommentFunctions.html#get_comments_count/2-examples"},{"type":"function","title":"UmyaSpreadsheet.CommentFunctions.has_comments/2","doc":"Checks if a sheet has any comments.","ref":"UmyaSpreadsheet.CommentFunctions.html#has_comments/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CommentFunctions.has_comments/2","doc":"* `spreadsheet` - The spreadsheet reference\n* `sheet_name` - Name of the worksheet","ref":"UmyaSpreadsheet.CommentFunctions.html#has_comments/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CommentFunctions.has_comments/2","doc":"iex> UmyaSpreadsheet.has_comments(spreadsheet, \"Sheet1\")\n    true","ref":"UmyaSpreadsheet.CommentFunctions.html#has_comments/2-examples"},{"type":"function","title":"UmyaSpreadsheet.CommentFunctions.remove_comment/3","doc":"Removes a comment from a cell.","ref":"UmyaSpreadsheet.CommentFunctions.html#remove_comment/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CommentFunctions.remove_comment/3","doc":"* `spreadsheet` - The spreadsheet reference\n* `sheet_name` - Name of the worksheet\n* `cell_address` - Cell address in A1 notation (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.CommentFunctions.html#remove_comment/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CommentFunctions.remove_comment/3","doc":"iex> UmyaSpreadsheet.remove_comment(spreadsheet, \"Sheet1\", \"A1\")\n    :ok","ref":"UmyaSpreadsheet.CommentFunctions.html#remove_comment/3-examples"},{"type":"function","title":"UmyaSpreadsheet.CommentFunctions.update_comment/5","doc":"Updates an existing comment in a cell.","ref":"UmyaSpreadsheet.CommentFunctions.html#update_comment/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.CommentFunctions.update_comment/5","doc":"* `spreadsheet` - The spreadsheet reference\n* `sheet_name` - Name of the worksheet\n* `cell_address` - Cell address in A1 notation (e.g., \"A1\", \"B2\")\n* `text` - New text content for the comment\n* `author` - Optional new author name (if nil, keeps the existing author)","ref":"UmyaSpreadsheet.CommentFunctions.html#update_comment/5-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.CommentFunctions.update_comment/5","doc":"iex> UmyaSpreadsheet.update_comment(spreadsheet, \"Sheet1\", \"A1\", \"Updated comment\")\n    :ok\n\n    iex> UmyaSpreadsheet.update_comment(spreadsheet, \"Sheet1\", \"A1\", \"Updated comment\", \"Jane Smith\")\n    :ok","ref":"UmyaSpreadsheet.CommentFunctions.html#update_comment/5-examples"},{"type":"module","title":"UmyaSpreadsheet.ConditionalFormatting","doc":"Functions for conditional formatting.","ref":"UmyaSpreadsheet.ConditionalFormatting.html"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_above_below_average_rule/6","doc":"Adds an above or below average rule for conditional formatting.\n\nThis rule highlights cells that are above or below the average value of the selected range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_above_below_average_rule/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_above_below_average_rule/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `rule_type` - The type of rule: \"above\", \"below\", \"above_equal\", \"below_equal\"\n- `std_dev` - Optional standard deviation for more advanced rules (nil for basic average)\n- `format_style` - The color to apply when the condition is met (e.g., \"#FF0000\" for red)","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_above_below_average_rule/6-parameters"},{"type":"function","title":"Rule Types - UmyaSpreadsheet.ConditionalFormatting.add_above_below_average_rule/6","doc":"- `\"above\"` - Highlight cells above the average\n- `\"below\"` - Highlight cells below the average\n- `\"above_equal\"` - Highlight cells above or equal to the average\n- `\"below_equal\"` - Highlight cells below or equal to the average","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_above_below_average_rule/6-rule-types"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_above_below_average_rule/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Highlight cells above average in green\n    :ok = UmyaSpreadsheet.add_above_below_average_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"above\",\n      nil,\n      \"#00FF00\"\n    )\n\n    # Highlight cells below average in red\n    :ok = UmyaSpreadsheet.add_above_below_average_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"B1:B10\",\n      \"below\",\n      nil,\n      \"#FF0000\"\n    )\n\n    # Highlight cells above average plus one standard deviation in blue\n    :ok = UmyaSpreadsheet.add_above_below_average_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"C1:C10\",\n      \"above\",\n      1,\n      \"#0000FF\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_above_below_average_rule/6-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_cell_is_rule/7","doc":"Adds a cell \"is\" rule for conditional formatting based on text conditions.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_cell_is_rule/7"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_cell_is_rule/7","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `operator` - The text comparison operator (\"beginsWith\", \"endsWith\", \"contains\", \"notContains\")\n- `value1` - The text value for comparison\n- `value2` - Not used, pass nil\n- `format_style` - The color to apply when the condition is met (e.g., \"#FF0000\" for red)","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_cell_is_rule/7-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_cell_is_rule/7","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Highlight cells that begin with \"Error\" in red\n    :ok = UmyaSpreadsheet.add_cell_is_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"beginsWith\",\n      \"Error\",\n      nil,\n      \"#FF0000\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_cell_is_rule/7-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_cell_value_rule/7","doc":"Adds a cell value rule for conditional formatting.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_cell_value_rule/7"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_cell_value_rule/7","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `operator` - The comparison operator (\"equal\", \"notEqual\", \"greaterThan\", \"lessThan\", \"greaterThanOrEqual\", \"lessThanOrEqual\", \"between\", \"notBetween\")\n- `value1` - The first value for comparison\n- `value2` - The second value for comparison (required for \"between\" and \"notBetween\" operators)\n- `format_style` - The color to apply when the condition is met (e.g., \"#FF0000\" for red)","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_cell_value_rule/7-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_cell_value_rule/7","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Highlight cells equal to 50 in red\n    :ok = UmyaSpreadsheet.add_cell_value_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"equal\",\n      \"50\",\n      nil,\n      \"#FF0000\"\n    )\n\n    # Highlight cells between 30 and 70 in green\n    :ok = UmyaSpreadsheet.add_cell_value_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"between\",\n      \"30\",\n      \"70\",\n      \"#00FF00\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_cell_value_rule/7-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_color_scale/9","doc":"Adds a color scale conditional formatting rule to a range of cells (two-color version).","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_color_scale/9"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_color_scale/9","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `min_type` - The minimum value type-value tuple or nil for automatic\n- `max_type` - The maximum value type-value tuple or nil for automatic\n- `color` - The color to use for the data bars (e.g., \"#638EC6\")","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_color_scale/9-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_color_scale/9","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Add data bars with automatic min/max\n    :ok = UmyaSpreadsheet.add_data_bar(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      nil,\n      nil,\n      \"#638EC6\"\n    )\n\n    # Add data bars with fixed min/max\n    :ok = UmyaSpreadsheet.add_data_bar(\n      spreadsheet,\n      \"Sheet1\",\n      \"B1:B10\",\n      {\"num\", \"0\"},\n      {\"num\", \"100\"},\n      \"#FF0000\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_color_scale/9-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_color_scale/12","doc":"Adds a color scale conditional formatting rule to a range of cells (three-color version).","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_color_scale/12"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_color_scale/12","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `min_type` - The minimum value type string or nil for automatic\n- `min_value` - The minimum value or nil for automatic\n- `min_color` - The color or color map for minimum values (e.g., \"#FF0000\" for red)\n- `mid_type` - The midpoint value type string or nil for automatic\n- `mid_value` - The midpoint value or nil for automatic\n- `mid_color` - The color or color map for midpoint values (e.g., \"#FFFF00\" for yellow)\n- `max_type` - The maximum value type string or nil for automatic\n- `max_value` - The maximum value or nil for automatic\n- `max_color` - The color or color map for maximum values (e.g., \"#00FF00\" for green)","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_color_scale/12-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_color_scale/12","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Add a three-color scale (red-yellow-green)\n    :ok = UmyaSpreadsheet.add_color_scale(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"min\",\n      nil,\n      %{argb: \"FFFF0000\"},\n      \"percentile\",\n      \"50\",\n      %{argb: \"FFFFFF00\"},\n      \"max\",\n      nil,\n      %{argb: \"FF00FF00\"}\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_color_scale/12-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_data_bar/6","doc":"Adds a data bar conditional formatting rule to a range of cells.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_data_bar/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_data_bar/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `min_value` - Tuple of {type, value} for minimum, or nil for automatic\n- `max_value` - Tuple of {type, value} for maximum, or nil for automatic\n- `color` - The color to use for the data bars (e.g., \"#638EC6\")","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_data_bar/6-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_data_bar/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Add data bars with automatic min/max\n    :ok = UmyaSpreadsheet.add_data_bar(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      nil,\n      nil,\n      \"#638EC6\"\n    )\n\n    # Add data bars with fixed min/max\n    :ok = UmyaSpreadsheet.add_data_bar(\n      spreadsheet,\n      \"Sheet1\",\n      \"B1:B10\",\n      {\"num\", \"0\"},\n      {\"num\", \"100\"},\n      \"#FF0000\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_data_bar/6-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_icon_set/5","doc":"Adds an icon set rule for conditional formatting.\n\nIcon sets display different icons based on the values in the cells, providing a visual\nrepresentation of data trends.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_icon_set/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_icon_set/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `icon_style` - The style of icons to use (currently supports basic icon sets)\n- `thresholds` - A list of threshold tuples {type, value} defining the icon boundaries","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_icon_set/5-parameters"},{"type":"function","title":"Threshold Types - UmyaSpreadsheet.ConditionalFormatting.add_icon_set/5","doc":"- `{\"min\", \"\"}` - Use the minimum value in the range\n- `{\"max\", \"\"}` - Use the maximum value in the range\n- `{\"number\", \"X\"}` - Use a specific number\n- `{\"percent\", \"X\"}` - Use X percent of the range\n- `{\"percentile\", \"X\"}` - Use the Xth percentile\n- `{\"formula\", \"X\"}` - Use a formula result","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_icon_set/5-threshold-types"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_icon_set/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Simple 3-icon set with percentile thresholds\n    :ok = UmyaSpreadsheet.add_icon_set(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"3_traffic_lights\",\n      [\n        {\"percentile\", \"33\"},\n        {\"percentile\", \"67\"}\n      ]\n    )\n\n    # 5-icon set with custom number thresholds\n    :ok = UmyaSpreadsheet.add_icon_set(\n      spreadsheet,\n      \"Sheet1\",\n      \"B1:B10\",\n      \"5_arrows\",\n      [\n        {\"number\", \"20\"},\n        {\"number\", \"40\"},\n        {\"number\", \"60\"},\n        {\"number\", \"80\"}\n      ]\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_icon_set/5-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_text_rule/6","doc":"Adds a text rule conditional formatting rule.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_text_rule/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_text_rule/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `operator` - The text operator (\"contains\", \"notContains\", \"beginsWith\", \"endsWith\")\n- `text` - The text to search for\n- `format_style` - The color to apply when the condition is met (e.g., \"#FF0000\" for red)","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_text_rule/6-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_text_rule/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Highlight cells containing \"Error\" in red\n    :ok = UmyaSpreadsheet.add_text_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"contains\",\n      \"Error\",\n      \"#FF0000\"\n    )\n\n    # Highlight cells beginning with \"Warning\" in orange\n    :ok = UmyaSpreadsheet.add_text_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"beginsWith\",\n      \"Warning\",\n      \"#FFA500\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_text_rule/6-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.add_top_bottom_rule/7","doc":"Adds a top/bottom rule for conditional formatting.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_top_bottom_rule/7"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.add_top_bottom_rule/7","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The cell range to apply formatting to (e.g., \"A1:A10\")\n- `rule_type` - The rule type (\"top\", \"bottom\")\n- `rank` - The number of top/bottom items to highlight\n- `percent` - Whether rank is a percentage (true) or a count (false)\n- `format_style` - The color to apply when the condition is met (e.g., \"#FF0000\" for red)","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_top_bottom_rule/7-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.add_top_bottom_rule/7","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Highlight top 3 values in green\n    :ok = UmyaSpreadsheet.add_top_bottom_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"top\",\n      3,\n      false,\n      \"#00FF00\"\n    )\n\n    # Highlight bottom 10% of values in red\n    :ok = UmyaSpreadsheet.add_top_bottom_rule(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\",\n      \"bottom\",\n      10,\n      true,\n      \"#FF0000\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#add_top_bottom_rule/7-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.get_above_below_average_rules/3","doc":"Gets all above/below average rules for a sheet or specific range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_above_below_average_rules/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.get_above_below_average_rules/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - Optional. The cell range to get rules for. If nil, returns all rules for the sheet.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_above_below_average_rules/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ConditionalFormatting.get_above_below_average_rules/3","doc":"A list of maps, each representing an above/below average rule with the following keys:\n\n- `:range` - The cell range the rule applies to\n- `:rule_type_value` - \"above\", \"below\", \"above_equal\", or \"below_equal\"\n- `:std_dev` - Optional standard deviation value\n- `:format_style` - The color to apply when the condition is met","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_above_below_average_rules/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.get_above_below_average_rules/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Get all above/below average rules in Sheet1\n    rules = UmyaSpreadsheet.get_above_below_average_rules(\n      spreadsheet,\n      \"Sheet1\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_above_below_average_rules/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.get_cell_value_rules/3","doc":"Gets all cell value rules for a sheet or specific range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_cell_value_rules/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.get_cell_value_rules/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - Optional. The cell range to get rules for. If nil, returns all rules for the sheet.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_cell_value_rules/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ConditionalFormatting.get_cell_value_rules/3","doc":"A list of maps, each representing a cell value rule with the following keys:\n\n- `:range` - The cell range the rule applies to\n- `:operator` - The comparison operator (e.g., \":equal\", \":greater_than\")\n- `:formula` - The formula or value to compare against\n- `:format_style` - The color or style to apply when the condition is met","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_cell_value_rules/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.get_cell_value_rules/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Get all cell value rules in Sheet1\n    rules = UmyaSpreadsheet.get_cell_value_rules(\n      spreadsheet,\n      \"Sheet1\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_cell_value_rules/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.get_color_scales/3","doc":"Gets all color scale rules for a sheet or specific range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_color_scales/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.get_color_scales/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - Optional. The cell range to get rules for. If nil, returns all rules for the sheet.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_color_scales/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ConditionalFormatting.get_color_scales/3","doc":"A list of maps, each representing a color scale rule with the following keys:\n\n- `:range` - The cell range the rule applies to\n- `:min_type` - The type for minimum value (e.g., \":min\", \":number\", \":percent\")\n- `:min_value` - The minimum value (if applicable)\n- `:min_color` - The color for minimum values\n- `:mid_type` - Optional. The type for midpoint value\n- `:mid_value` - Optional. The midpoint value\n- `:mid_color` - Optional. The color for midpoint values\n- `:max_type` - The type for maximum value\n- `:max_value` - The maximum value (if applicable)\n- `:max_color` - The color for maximum values","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_color_scales/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.get_color_scales/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Get all color scale rules in Sheet1\n    rules = UmyaSpreadsheet.get_color_scales(\n      spreadsheet,\n      \"Sheet1\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_color_scales/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.get_conditional_formatting_rules/3","doc":"Gets all conditional formatting rules for a sheet or specific range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_conditional_formatting_rules/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.get_conditional_formatting_rules/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - Optional. The cell range to get rules for. If nil, returns all rules for the sheet.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_conditional_formatting_rules/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ConditionalFormatting.get_conditional_formatting_rules/3","doc":"A list of maps, each representing a conditional formatting rule with the following keys:\n\n- `:range` - The cell range the rule applies to\n- `:rule_type` - The type of rule (\":cell_is\", \":color_scale\", \":data_bar\", \":icon_set\", etc.)\n- Other rule-specific fields depending on the rule type","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_conditional_formatting_rules/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.get_conditional_formatting_rules/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Get all conditional formatting rules in Sheet1\n    rules = UmyaSpreadsheet.get_conditional_formatting_rules(\n      spreadsheet,\n      \"Sheet1\"\n    )\n\n    # Get conditional formatting rules for a specific range\n    range_rules = UmyaSpreadsheet.get_conditional_formatting_rules(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1:A10\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_conditional_formatting_rules/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.get_data_bars/3","doc":"Gets all data bar rules for a sheet or specific range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_data_bars/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.get_data_bars/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - Optional. The cell range to get rules for. If nil, returns all rules for the sheet.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_data_bars/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ConditionalFormatting.get_data_bars/3","doc":"A list of maps, each representing a data bar rule with the following keys:\n\n- `:range` - The cell range the rule applies to\n- `:min_value` - Optional tuple of {type, value} for minimum\n- `:max_value` - Optional tuple of {type, value} for maximum\n- `:color` - The color of the data bars","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_data_bars/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.get_data_bars/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Get all data bar rules in Sheet1\n    rules = UmyaSpreadsheet.get_data_bars(\n      spreadsheet,\n      \"Sheet1\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_data_bars/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.get_icon_sets/3","doc":"Gets all icon set rules for a sheet or specific range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_icon_sets/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.get_icon_sets/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - Optional. The cell range to get rules for. If nil, returns all rules for the sheet.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_icon_sets/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ConditionalFormatting.get_icon_sets/3","doc":"A list of maps, each representing an icon set rule with the following keys:\n\n- `:range` - The cell range the rule applies to\n- `:icon_style` - The style of icons to use\n- `:thresholds` - A list of threshold tuples {type, value} defining the icon boundaries","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_icon_sets/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.get_icon_sets/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Get all icon set rules in Sheet1\n    rules = UmyaSpreadsheet.get_icon_sets(\n      spreadsheet,\n      \"Sheet1\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_icon_sets/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.get_text_rules/3","doc":"Gets all text rules for a sheet or specific range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_text_rules/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.get_text_rules/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - Optional. The cell range to get rules for. If nil, returns all rules for the sheet.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_text_rules/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ConditionalFormatting.get_text_rules/3","doc":"A list of maps, each representing a text rule with the following keys:\n\n- `:range` - The cell range the rule applies to\n- `:operator` - The text operator (\"contains\", \"notContains\", \"beginsWith\", \"endsWith\")\n- `:text` - The text to search for\n- `:format_style` - The color to apply when the condition is met","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_text_rules/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.get_text_rules/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Get all text rules in Sheet1\n    rules = UmyaSpreadsheet.get_text_rules(\n      spreadsheet,\n      \"Sheet1\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_text_rules/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ConditionalFormatting.get_top_bottom_rules/3","doc":"Gets all top/bottom rules for a sheet or specific range.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_top_bottom_rules/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ConditionalFormatting.get_top_bottom_rules/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - Optional. The cell range to get rules for. If nil, returns all rules for the sheet.","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_top_bottom_rules/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ConditionalFormatting.get_top_bottom_rules/3","doc":"A list of maps, each representing a top/bottom rule with the following keys:\n\n- `:range` - The cell range the rule applies to\n- `:rule_type_value` - \"top\" or \"bottom\"\n- `:rank` - The number of top/bottom items to highlight\n- `:percent` - Whether rank is a percentage (true) or a count (false)\n- `:format_style` - The color to apply when the condition is met","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_top_bottom_rules/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ConditionalFormatting.get_top_bottom_rules/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Get all top/bottom rules in Sheet1\n    rules = UmyaSpreadsheet.get_top_bottom_rules(\n      spreadsheet,\n      \"Sheet1\"\n    )","ref":"UmyaSpreadsheet.ConditionalFormatting.html#get_top_bottom_rules/3-examples"},{"type":"module","title":"UmyaSpreadsheet.CsvWriterOption","doc":"Represents configuration options for CSV export.\n\nThis module provides a way to configure options for CSV export, including:\n- Encoding format (UTF-8, ShiftJIS, etc.)\n- Trimming options for cell values\n- Character wrapping for cell values\n- Delimiter character for separating values","ref":"UmyaSpreadsheet.CsvWriterOption.html"},{"type":"function","title":"UmyaSpreadsheet.CsvWriterOption.encode_value_to_string/1","doc":"Converts an Elixir encoding atom to the Rust encoding value.\n\nThis function is for internal use to convert our friendly atom names to the exact\nencoding names used in the Rust library.","ref":"UmyaSpreadsheet.CsvWriterOption.html#encode_value_to_string/1"},{"type":"function","title":"UmyaSpreadsheet.CsvWriterOption.new/0","doc":"Creates a new CSV writer option struct with default values.","ref":"UmyaSpreadsheet.CsvWriterOption.html#new/0"},{"type":"function","title":"Examples - UmyaSpreadsheet.CsvWriterOption.new/0","doc":"iex> UmyaSpreadsheet.CsvWriterOption.new()\n    %UmyaSpreadsheet.CsvWriterOption{\n      csv_encode_value: :utf8,\n      do_trim: false,\n      wrap_with_char: \"\",\n      delimiter: \",\"\n    }","ref":"UmyaSpreadsheet.CsvWriterOption.html#new/0-examples"},{"type":"function","title":"UmyaSpreadsheet.CsvWriterOption.set_csv_encode_value/2","doc":"Sets the CSV encoding value.\n\nAvailable encodings:\n  - `:utf8` - UTF-8 encoding (default)\n  - `:shift_jis` - Shift JIS encoding\n  - `:koi8u` - KOI8-U encoding\n  - `:koi8r` - KOI8-R encoding\n  - `:iso88598i` - ISO-8859-8-I encoding\n  - `:gbk` - GBK encoding","ref":"UmyaSpreadsheet.CsvWriterOption.html#set_csv_encode_value/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.CsvWriterOption.set_csv_encode_value/2","doc":"iex> opts = UmyaSpreadsheet.CsvWriterOption.new()\n    iex> UmyaSpreadsheet.CsvWriterOption.set_csv_encode_value(opts, :shift_jis)\n    %UmyaSpreadsheet.CsvWriterOption{csv_encode_value: :shift_jis, do_trim: false, wrap_with_char: \"\"}","ref":"UmyaSpreadsheet.CsvWriterOption.html#set_csv_encode_value/2-examples"},{"type":"function","title":"UmyaSpreadsheet.CsvWriterOption.set_delimiter/2","doc":"Sets the delimiter character used to separate fields in the CSV file.\nDefault is comma (\",\").","ref":"UmyaSpreadsheet.CsvWriterOption.html#set_delimiter/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.CsvWriterOption.set_delimiter/2","doc":"iex> opts = UmyaSpreadsheet.CsvWriterOption.new()\n    iex> UmyaSpreadsheet.CsvWriterOption.set_delimiter(opts, \";\")\n    %UmyaSpreadsheet.CsvWriterOption{csv_encode_value: :utf8, do_trim: false, wrap_with_char: \"\", delimiter: \";\"}","ref":"UmyaSpreadsheet.CsvWriterOption.html#set_delimiter/2-examples"},{"type":"function","title":"UmyaSpreadsheet.CsvWriterOption.set_do_trim/2","doc":"Sets whether to trim whitespace from cell values.","ref":"UmyaSpreadsheet.CsvWriterOption.html#set_do_trim/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.CsvWriterOption.set_do_trim/2","doc":"iex> opts = UmyaSpreadsheet.CsvWriterOption.new()\n    iex> UmyaSpreadsheet.CsvWriterOption.set_do_trim(opts, true)\n    %UmyaSpreadsheet.CsvWriterOption{csv_encode_value: :utf8, do_trim: true, wrap_with_char: \"\"}","ref":"UmyaSpreadsheet.CsvWriterOption.html#set_do_trim/2-examples"},{"type":"function","title":"UmyaSpreadsheet.CsvWriterOption.set_wrap_with_char/2","doc":"Sets the character to wrap cell values with.","ref":"UmyaSpreadsheet.CsvWriterOption.html#set_wrap_with_char/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.CsvWriterOption.set_wrap_with_char/2","doc":"iex> opts = UmyaSpreadsheet.CsvWriterOption.new()\n    iex> UmyaSpreadsheet.CsvWriterOption.set_wrap_with_char(opts, \"\"\")\n    %UmyaSpreadsheet.CsvWriterOption{csv_encode_value: :utf8, do_trim: false, wrap_with_char: \"\\\"\", delimiter: \",\"}","ref":"UmyaSpreadsheet.CsvWriterOption.html#set_wrap_with_char/2-examples"},{"type":"type","title":"UmyaSpreadsheet.CsvWriterOption.t/0","doc":"","ref":"UmyaSpreadsheet.CsvWriterOption.html#t:t/0"},{"type":"module","title":"UmyaSpreadsheet.DataValidation","doc":"Functions for applying data validation to spreadsheets.\n\nData validation allows you to control what users can enter in a cell,\nand provides feedback when invalid data is entered. Thi    # Convert numerical values to strings as required by the Rust NIF\n  value1_str = Float.to_string(value1)\n  value2_str = if value2, do: Float.to_string(value2), else: nil\n\n  case UmyaNative.add_number_validation(\n         UmyaSpreadsheet.unwrap_ref(ref),\n         sheet_name,\n         cell_range,\n         operator,\n         value1_str,\n         value2_str,\n         allow_blank,\n         error_title,\n         error_message,rovides functions for:\n\n* List validation (dropdown lists)\n* Number validation (numerical constraints)\n* Date validation (date constraints)\n* Text length validation (character count constraints)\n* Custom formula validation (formula-based constraints)","ref":"UmyaSpreadsheet.DataValidation.html"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.add_custom_validation/9","doc":"Adds custom formula validation to a range of cells.\n\nThis allows specifying a custom Excel formula for validation.","ref":"UmyaSpreadsheet.DataValidation.html#add_custom_validation/9"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.add_custom_validation/9","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Range of cells in A1 notation (e.g., \"A1:B10\")\n  * `formula` - Excel formula that should evaluate to TRUE/FALSE (without the = sign)\n  * `allow_blank` - Whether to allow blank/empty values (default: true)\n  * `error_title` - Optional title for error message when validation fails\n  * `error_message` - Optional description for error message when validation fails\n  * `prompt_title` - Optional title for input prompt\n  * `prompt_message` - Optional description for input prompt","ref":"UmyaSpreadsheet.DataValidation.html#add_custom_validation/9-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.add_custom_validation/9","doc":"```elixir\n# Custom validation to ensure value is divisible by 3\nDataValidation.add_custom_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"MOD(A1,3)=0\",\n  true,\n  \"Invalid Value\",\n  \"Please enter a value divisible by 3\",\n  \"Value Input\",\n  \"Enter a value divisible by 3\"\n)\n```","ref":"UmyaSpreadsheet.DataValidation.html#add_custom_validation/9-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.add_date_validation/11","doc":"Adds date validation to a range of cells.\n\nThis restricts input to dates that meet specified conditions.","ref":"UmyaSpreadsheet.DataValidation.html#add_date_validation/11"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.add_date_validation/11","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Range of cells in A1 notation (e.g., \"A1:B10\")\n  * `operator` - Comparison operator, one of:\n    * \"between\" - Between two dates\n    * \"notBetween\" - Not between two dates\n    * \"equal\" - Equal to date\n    * \"notEqual\" - Not equal to date\n    * \"greaterThan\" - After date\n    * \"lessThan\" - Before date\n    * \"greaterThanOrEqual\" - On or after date\n    * \"lessThanOrEqual\" - On or before date\n  * `date1` - First date for comparison as an ISO string (YYYY-MM-DD) or Elixir Date struct\n  * `date2` - Second date for comparison as an ISO string or Date struct (only required for \"between\" and \"notBetween\")\n  * `allow_blank` - Whether to allow blank/empty values (default: true)\n  * `error_title` - Optional title for error message when validation fails\n  * `error_message` - Optional description for error message when validation fails\n  * `prompt_title` - Optional title for input prompt\n  * `prompt_message` - Optional description for input prompt","ref":"UmyaSpreadsheet.DataValidation.html#add_date_validation/11-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.add_date_validation/11","doc":"```elixir\n# Allow only dates in 2023 (using string dates)\nDataValidation.add_date_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"between\",\n  \"2023-01-01\",\n  \"2023-12-31\",\n  true,\n  \"Invalid Date\",\n  \"Please enter a date in 2023\",\n  \"Date Input\",\n  \"Enter a date in 2023\"\n)\n\n# Allow only dates in 2023 (using Date structs)\nDataValidation.add_date_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"between\",\n  ~D[2023-01-01],\n  ~D[2023-12-31],\n  true,\n  \"Invalid Date\",\n  \"Please enter a date in 2023\",\n  \"Date Input\",\n  \"Enter a date in 2023\"\n)\n\n# Allow only dates after today\nDataValidation.add_date_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"B1:B10\",\n  \"greaterThan\",\n  Date.utc_today(),  # Date struct works directly\n  nil,\n  true,\n  \"Invalid Date\",\n  \"Please enter a future date\",\n  nil,\n  nil\n)\n```","ref":"UmyaSpreadsheet.DataValidation.html#add_date_validation/11-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.add_list_validation/9","doc":"Adds a dropdown list validation to a range of cells.\n\nThis creates a dropdown list that restricts input to the specified options.","ref":"UmyaSpreadsheet.DataValidation.html#add_list_validation/9"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.add_list_validation/9","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Range of cells in A1 notation (e.g., \"A1:B10\")\n  * `list_items` - List of strings to be shown in the dropdown\n  * `allow_blank` - Whether to allow blank/empty values (default: true)\n  * `error_title` - Optional title for error message when validation fails\n  * `error_message` - Optional description for error message when validation fails\n  * `prompt_title` - Optional title for input prompt\n  * `prompt_message` - Optional description for input prompt","ref":"UmyaSpreadsheet.DataValidation.html#add_list_validation/9-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.add_list_validation/9","doc":"```elixir\n# Add a simple dropdown with fruits\nDataValidation.add_list_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  [\"Apple\", \"Orange\", \"Banana\"],\n  true,\n  nil,\n  nil,\n  nil,\n  nil\n)\n\n# Add a dropdown with error message when invalid data is entered\nDataValidation.add_list_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"B1:B10\",\n  [\"Red\", \"Green\", \"Blue\"],\n  true,\n  \"Invalid Color\",\n  \"Please select a valid color from the dropdown list\",\n  \"Color Selection\",\n  \"Select a color from the list\"\n)\n```","ref":"UmyaSpreadsheet.DataValidation.html#add_list_validation/9-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.add_number_validation/11","doc":"Adds number validation to a range of cells.\n\nThis restricts input to numbers that meet specified conditions.","ref":"UmyaSpreadsheet.DataValidation.html#add_number_validation/11"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.add_number_validation/11","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Range of cells in A1 notation (e.g., \"A1:B10\")\n  * `operator` - Comparison operator, one of:\n    * \"between\" - Between two values\n    * \"notBetween\" - Not between two values\n    * \"equal\" - Equal to value\n    * \"notEqual\" - Not equal to value\n    * \"greaterThan\" - Greater than value\n    * \"lessThan\" - Less than value\n    * \"greaterThanOrEqual\" - Greater than or equal to value\n    * \"lessThanOrEqual\" - Less than or equal to value\n  * `value1` - First numeric value for comparison\n  * `value2` - Second numeric value for comparison (only required for \"between\" and \"notBetween\")\n  * `allow_blank` - Whether to allow blank/empty values (default: true)\n  * `error_title` - Optional title for error message when validation fails\n  * `error_message` - Optional description for error message when validation fails\n  * `prompt_title` - Optional title for input prompt\n  * `prompt_message` - Optional description for input prompt","ref":"UmyaSpreadsheet.DataValidation.html#add_number_validation/11-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.add_number_validation/11","doc":"```elixir\n# Allow only numbers between 1 and 10\nDataValidation.add_number_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"between\",\n  1.0,\n  10.0,\n  true,\n  \"Invalid Number\",\n  \"Please enter a number between 1 and 10\",\n  \"Number Input\",\n  \"Enter a number between 1 and 10\"\n)\n\n# Allow only numbers greater than 100\nDataValidation.add_number_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"B1:B10\",\n  \"greaterThan\",\n  100.0,\n  nil,\n  true,\n  nil,\n  nil,\n  nil,\n  nil\n)\n```","ref":"UmyaSpreadsheet.DataValidation.html#add_number_validation/11-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.add_text_length_validation/11","doc":"Adds text length validation to a range of cells.\n\nThis restricts input to text with a length that meets specified conditions.","ref":"UmyaSpreadsheet.DataValidation.html#add_text_length_validation/11"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.add_text_length_validation/11","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Range of cells in A1 notation (e.g., \"A1:B10\")\n  * `operator` - Comparison operator, one of:\n    * \"between\" - Between two lengths\n    * \"notBetween\" - Not between two lengths\n    * \"equal\" - Equal to length\n    * \"notEqual\" - Not equal to length\n    * \"greaterThan\" - Longer than length\n    * \"lessThan\" - Shorter than length\n    * \"greaterThanOrEqual\" - At least length characters\n    * \"lessThanOrEqual\" - At most length characters\n  * `length1` - First length value for comparison\n  * `length2` - Second length value for comparison (only required for \"between\" and \"notBetween\")\n  * `allow_blank` - Whether to allow blank/empty values (default: true)\n  * `error_title` - Optional title for error message when validation fails\n  * `error_message` - Optional description for error message when validation fails\n  * `prompt_title` - Optional title for input prompt\n  * `prompt_message` - Optional description for input prompt","ref":"UmyaSpreadsheet.DataValidation.html#add_text_length_validation/11-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.add_text_length_validation/11","doc":"```elixir\n# Limit text to between 5 and 10 characters\nDataValidation.add_text_length_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"between\",\n  5,\n  10,\n  true,\n  \"Invalid Text Length\",\n  \"Please enter text between 5 and 10 characters\",\n  \"Text Input\",\n  \"Enter text between 5 and 10 characters\"\n)\n\n# Limit text to at most 20 characters\nDataValidation.add_text_length_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"B1:B10\",\n  \"lessThanOrEqual\",\n  20,\n  nil,\n  true,\n  nil,\n  nil,\n  nil,\n  nil\n)\n```","ref":"UmyaSpreadsheet.DataValidation.html#add_text_length_validation/11-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.count_data_validations/3","doc":"Counts the number of data validation rules in a sheet.\n\nReturns the count of validation rules in the sheet.\nIf a cell range is provided, only counts rules applying to that range.","ref":"UmyaSpreadsheet.DataValidation.html#count_data_validations/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.count_data_validations/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Optional range of cells to count rules for (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#count_data_validations/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.count_data_validations/3","doc":"```elixir\n# Count all validation rules in a sheet\nrule_count = DataValidation.count_data_validations(spreadsheet, \"Sheet1\")\n\n# Count validation rules in a specific range\nrange_rule_count = DataValidation.count_data_validations(spreadsheet, \"Sheet1\", \"A1:A10\")\n```","ref":"UmyaSpreadsheet.DataValidation.html#count_data_validations/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.get_custom_validations/3","doc":"Gets custom formula validation rules for a sheet or range.\n\nReturns custom formula validation rules that restrict input based on a custom formula.\nEach map includes the range it applies to, formula, and various other properties.","ref":"UmyaSpreadsheet.DataValidation.html#get_custom_validations/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.get_custom_validations/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Optional range of cells to filter rules by (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#get_custom_validations/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.get_custom_validations/3","doc":"```elixir\n# Get custom formula validation rules in a sheet\ncustom_rules = DataValidation.get_custom_validations(spreadsheet, \"Sheet1\")\n```","ref":"UmyaSpreadsheet.DataValidation.html#get_custom_validations/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.get_data_validations/3","doc":"Gets all data validation rules for a sheet or range.\n\nReturns a list of maps, each containing details about a data validation rule.\nEach map includes the range it applies to and various other properties depending on the rule type.","ref":"UmyaSpreadsheet.DataValidation.html#get_data_validations/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.get_data_validations/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Optional range of cells to filter rules by (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#get_data_validations/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.get_data_validations/3","doc":"```elixir\n# Get all validation rules in a sheet\nrules = DataValidation.get_data_validations(spreadsheet, \"Sheet1\")\n```","ref":"UmyaSpreadsheet.DataValidation.html#get_data_validations/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.get_date_validations/3","doc":"Gets date validation rules for a sheet or range.\n\nReturns date validation rules that restrict input to date values.\nEach map includes the range it applies to, operator, date values, and various other properties.","ref":"UmyaSpreadsheet.DataValidation.html#get_date_validations/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.get_date_validations/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Optional range of cells to filter rules by (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#get_date_validations/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.get_date_validations/3","doc":"```elixir\n# Get date validation rules in a sheet\ndate_rules = DataValidation.get_date_validations(spreadsheet, \"Sheet1\")\n```","ref":"UmyaSpreadsheet.DataValidation.html#get_date_validations/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.get_list_validations/3","doc":"Gets list validation rules for a sheet or range.\n\nReturns list validation rules that restrict input to specified options.\nEach map includes the range it applies to, the list items, and various other properties.","ref":"UmyaSpreadsheet.DataValidation.html#get_list_validations/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.get_list_validations/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Optional range of cells to filter rules by (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#get_list_validations/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.get_list_validations/3","doc":"```elixir\n# Get list validation rules in a sheet\nlist_rules = DataValidation.get_list_validations(spreadsheet, \"Sheet1\")\n```","ref":"UmyaSpreadsheet.DataValidation.html#get_list_validations/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.get_number_validations/3","doc":"Gets number validation rules for a sheet or range.\n\nReturns number validation rules that restrict input to numeric values.\nEach map includes the range it applies to, operator, values, and various other properties.","ref":"UmyaSpreadsheet.DataValidation.html#get_number_validations/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.get_number_validations/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Optional range of cells to filter rules by (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#get_number_validations/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.get_number_validations/3","doc":"```elixir\n# Get number validation rules in a sheet\nnumber_rules = DataValidation.get_number_validations(spreadsheet, \"Sheet1\")\n```","ref":"UmyaSpreadsheet.DataValidation.html#get_number_validations/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.get_text_length_validations/3","doc":"Gets text length validation rules for a sheet or range.\n\nReturns text length validation rules that restrict input based on text length.\nEach map includes the range it applies to, operator, length values, and various other properties.","ref":"UmyaSpreadsheet.DataValidation.html#get_text_length_validations/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.get_text_length_validations/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Optional range of cells to filter rules by (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#get_text_length_validations/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.get_text_length_validations/3","doc":"```elixir\n# Get text length validation rules in a sheet\ntext_length_rules = DataValidation.get_text_length_validations(spreadsheet, \"Sheet1\")\n```","ref":"UmyaSpreadsheet.DataValidation.html#get_text_length_validations/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.has_data_validations/3","doc":"Checks if a sheet has any data validation rules.\n\nReturns `true` if the sheet has any validation rules, `false` otherwise.\nIf a cell range is provided, only checks for rules applying to that range.","ref":"UmyaSpreadsheet.DataValidation.html#has_data_validations/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.has_data_validations/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Optional range of cells to check (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#has_data_validations/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.has_data_validations/3","doc":"```elixir\n# Check if a sheet has any validation rules\nhas_rules = DataValidation.has_data_validations(spreadsheet, \"Sheet1\")\n\n# Check if a specific range has validation rules\nhas_rules_in_range = DataValidation.has_data_validations(spreadsheet, \"Sheet1\", \"A1:A10\")\n```","ref":"UmyaSpreadsheet.DataValidation.html#has_data_validations/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DataValidation.remove_data_validation/3","doc":"Removes all data validation from a range of cells.","ref":"UmyaSpreadsheet.DataValidation.html#remove_data_validation/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DataValidation.remove_data_validation/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet\n  * `cell_range` - Range of cells in A1 notation (e.g., \"A1:B10\")","ref":"UmyaSpreadsheet.DataValidation.html#remove_data_validation/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.DataValidation.remove_data_validation/3","doc":"```elixir\n# Remove all validation from a range\nDataValidation.remove_data_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:B10\"\n)\n```","ref":"UmyaSpreadsheet.DataValidation.html#remove_data_validation/3-examples"},{"type":"module","title":"UmyaSpreadsheet.DocumentProperties","doc":"Functions for managing document properties and custom metadata in spreadsheets.\n\nThis module provides comprehensive functionality for:\n- Custom document properties (metadata)\n- Core document properties (title, description, subject, etc.)\n- Property management utilities\n\nDocument properties allow you to store additional metadata about your spreadsheets,\nsuch as author information, project details, custom business data, and more.","ref":"UmyaSpreadsheet.DocumentProperties.html"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.clear_custom_properties/1","doc":"Clears all custom properties.","ref":"UmyaSpreadsheet.DocumentProperties.html#clear_custom_properties/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.clear_custom_properties/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#clear_custom_properties/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.clear_custom_properties/1","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#clear_custom_properties/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.clear_custom_properties/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.clear_custom_properties(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#clear_custom_properties/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_all_properties/1","doc":"Gets all core document properties as a map.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_all_properties/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_all_properties/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_all_properties/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_all_properties/1","doc":"- `{:ok, properties_map}` - Map of all core properties\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_all_properties/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_all_properties/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, properties} = UmyaSpreadsheet.DocumentProperties.get_all_properties(spreadsheet)\n    # properties = %{\n    #   title: \"My Report\",\n    #   description: \"Monthly sales report\",\n    #   creator: \"John Doe\",\n    #   ...\n    # }","ref":"UmyaSpreadsheet.DocumentProperties.html#get_all_properties/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_category/1","doc":"Gets the document category.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_category/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_category/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_category/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_category/1","doc":"- `{:ok, category}` - The document category as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_category/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_category/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"Business\"} = UmyaSpreadsheet.DocumentProperties.get_category(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_category/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_company/1","doc":"Gets the document company.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_company/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_company/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_company/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_company/1","doc":"- `{:ok, company}` - The document company as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_company/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_company/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"Acme Corp\"} = UmyaSpreadsheet.DocumentProperties.get_company(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_company/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_created/1","doc":"Gets the document created date.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_created/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_created/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_created/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_created/1","doc":"- `{:ok, created}` - The created date as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_created/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_created/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"2024-01-01T00:00:00Z\"} = UmyaSpreadsheet.DocumentProperties.get_created(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_created/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_creator/1","doc":"Gets the document creator.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_creator/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_creator/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_creator/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_creator/1","doc":"- `{:ok, creator}` - The document creator as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_creator/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_creator/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"John Doe\"} = UmyaSpreadsheet.DocumentProperties.get_creator(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_creator/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_custom_properties_count/1","doc":"Gets the count of custom properties.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_properties_count/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_custom_properties_count/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_properties_count/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_custom_properties_count/1","doc":"- `{:ok, count}` - Number of custom properties\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_properties_count/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_custom_properties_count/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, 3} = UmyaSpreadsheet.DocumentProperties.get_custom_properties_count(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_properties_count/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_custom_property/2","doc":"Gets a custom document property value by name.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_property/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_custom_property/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `property_name` - The name of the custom property","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_property/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_custom_property/2","doc":"- `{:ok, value}` - The property value (string, number, boolean, or date)\n- `{:error, :not_found}` - If the property doesn't exist\n- `{:error, reason}` - On other failures","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_property/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_custom_property/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"Project Alpha\"} = UmyaSpreadsheet.DocumentProperties.get_custom_property(spreadsheet, \"ProjectName\")\n    {:error, :not_found} = UmyaSpreadsheet.DocumentProperties.get_custom_property(spreadsheet, \"NonExistent\")","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_property/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_custom_property_names/1","doc":"Gets a list of all custom property names.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_property_names/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_custom_property_names/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_property_names/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_custom_property_names/1","doc":"- `{:ok, [property_names]}` - List of property names as strings\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_property_names/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_custom_property_names/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, [\"ProjectName\", \"Version\", \"IsApproved\"]} = UmyaSpreadsheet.DocumentProperties.get_custom_property_names(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_custom_property_names/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_description/1","doc":"Gets the document description.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_description/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_description/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_description/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_description/1","doc":"- `{:ok, description}` - The document description as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_description/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_description/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"Sales data for Q4\"} = UmyaSpreadsheet.DocumentProperties.get_description(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_description/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_keywords/1","doc":"Gets the document keywords.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_keywords/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_keywords/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_keywords/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_keywords/1","doc":"- `{:ok, keywords}` - The document keywords as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_keywords/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_keywords/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"sales, data, analysis\"} = UmyaSpreadsheet.DocumentProperties.get_keywords(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_keywords/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_last_modified_by/1","doc":"Gets the document last modified by.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_last_modified_by/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_last_modified_by/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_last_modified_by/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_last_modified_by/1","doc":"- `{:ok, last_modified_by}` - The last modified by as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_last_modified_by/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_last_modified_by/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"Jane Smith\"} = UmyaSpreadsheet.DocumentProperties.get_last_modified_by(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_last_modified_by/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_manager/1","doc":"Gets the document manager.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_manager/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_manager/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_manager/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_manager/1","doc":"- `{:ok, manager}` - The document manager as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_manager/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_manager/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"Bob Johnson\"} = UmyaSpreadsheet.DocumentProperties.get_manager(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_manager/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_modified/1","doc":"Gets the document modified date.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_modified/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_modified/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_modified/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_modified/1","doc":"- `{:ok, modified}` - The modified date as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_modified/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_modified/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"2024-05-15T12:30:00Z\"} = UmyaSpreadsheet.DocumentProperties.get_modified(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_modified/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_subject/1","doc":"Gets the document subject.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_subject/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_subject/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_subject/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_subject/1","doc":"- `{:ok, subject}` - The document subject as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_subject/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_subject/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"Financial Analysis\"} = UmyaSpreadsheet.DocumentProperties.get_subject(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_subject/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.get_title/1","doc":"Gets the document title.","ref":"UmyaSpreadsheet.DocumentProperties.html#get_title/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.get_title/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.DocumentProperties.html#get_title/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.get_title/1","doc":"- `{:ok, title}` - The document title as a string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#get_title/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.get_title/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"My Spreadsheet\"} = UmyaSpreadsheet.DocumentProperties.get_title(spreadsheet)","ref":"UmyaSpreadsheet.DocumentProperties.html#get_title/1-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.has_custom_property/2","doc":"Checks if a custom property exists.","ref":"UmyaSpreadsheet.DocumentProperties.html#has_custom_property/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.has_custom_property/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `property_name` - The name of the property to check","ref":"UmyaSpreadsheet.DocumentProperties.html#has_custom_property/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.has_custom_property/2","doc":"- `{:ok, true}` if the property exists\n- `{:ok, false}` if the property doesn't exist\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#has_custom_property/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.has_custom_property/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, true} = UmyaSpreadsheet.DocumentProperties.has_custom_property(spreadsheet, \"ProjectName\")\n    {:ok, false} = UmyaSpreadsheet.DocumentProperties.has_custom_property(spreadsheet, \"NonExistent\")","ref":"UmyaSpreadsheet.DocumentProperties.html#has_custom_property/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.remove_custom_property/2","doc":"Removes a custom document property.","ref":"UmyaSpreadsheet.DocumentProperties.html#remove_custom_property/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.remove_custom_property/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `property_name` - The name of the custom property to remove","ref":"UmyaSpreadsheet.DocumentProperties.html#remove_custom_property/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.remove_custom_property/2","doc":"- `:ok` on success (even if property didn't exist)\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#remove_custom_property/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.remove_custom_property/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.remove_custom_property(spreadsheet, \"ProjectName\")","ref":"UmyaSpreadsheet.DocumentProperties.html#remove_custom_property/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_category/2","doc":"Sets the document category.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_category/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_category/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `category` - The category to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_category/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_category/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_category/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_category/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_category(spreadsheet, \"Business\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_category/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_company/2","doc":"Sets the document company.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_company/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_company/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `company` - The company name to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_company/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_company/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_company/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_company/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_company(spreadsheet, \"Acme Corp\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_company/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_created/2","doc":"Sets the document created date.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_created/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_created/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `created` - The created date to set (ISO 8601 format recommended)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_created/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_created/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_created/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_created/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_created(spreadsheet, \"2024-01-01T00:00:00Z\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_created/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_creator/2","doc":"Sets the document creator.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_creator/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_creator/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `creator` - The creator name to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_creator/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_creator/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_creator/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_creator/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_creator(spreadsheet, \"John Doe\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_creator/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_custom_property/3","doc":"Sets a custom document property with automatic type detection.\n\nThis is a convenience function that automatically calls the appropriate\ntype-specific function based on the value type.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_custom_property/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `property_name` - The name of the custom property\n- `value` - The value to set (string, number, or boolean)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_custom_property/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_custom_property/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property(spreadsheet, \"ProjectName\", \"Project Alpha\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property(spreadsheet, \"Version\", 1.5)\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property(spreadsheet, \"IsApproved\", true)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_custom_property_bool/3","doc":"Sets a custom document property with a boolean value.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_bool/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_custom_property_bool/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `property_name` - The name of the custom property\n- `value` - The boolean value to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_bool/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_custom_property_bool/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_bool/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_custom_property_bool/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property_bool(spreadsheet, \"IsApproved\", true)\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property_bool(spreadsheet, \"IsPublic\", false)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_bool/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_custom_property_date/3","doc":"Sets a custom document property with a date value.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_date/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_custom_property_date/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `property_name` - The name of the custom property\n- `value` - The date value as a string (ISO 8601 format recommended)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_date/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_custom_property_date/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_date/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_custom_property_date/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property_date(spreadsheet, \"ReleaseDate\", \"2024-12-31T00:00:00Z\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_date/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_custom_property_number/3","doc":"Sets a custom document property with a numeric value.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_number/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_custom_property_number/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `property_name` - The name of the custom property\n- `value` - The numeric value to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_number/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_custom_property_number/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_number/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_custom_property_number/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property_number(spreadsheet, \"Version\", 1.5)\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property_number(spreadsheet, \"Count\", 42)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_number/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_custom_property_string/3","doc":"Sets a custom document property with a string value.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_string/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_custom_property_string/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `property_name` - The name of the custom property\n- `value` - The string value to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_string/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_custom_property_string/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_string/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_custom_property_string/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_custom_property_string(spreadsheet, \"ProjectName\", \"Project Alpha\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_custom_property_string/3-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_description/2","doc":"Sets the document description.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_description/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_description/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `description` - The description to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_description/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_description/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_description/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_description/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_description(spreadsheet, \"Sales data for Q4\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_description/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_keywords/2","doc":"Sets the document keywords.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_keywords/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_keywords/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `keywords` - The keywords to set (typically comma-separated)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_keywords/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_keywords/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_keywords/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_keywords/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_keywords(spreadsheet, \"sales, data, analysis\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_keywords/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_last_modified_by/2","doc":"Sets the document last modified by.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_last_modified_by/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_last_modified_by/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `last_modified_by` - The last modified by name to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_last_modified_by/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_last_modified_by/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_last_modified_by/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_last_modified_by/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_last_modified_by(spreadsheet, \"Jane Smith\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_last_modified_by/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_manager/2","doc":"Sets the document manager.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_manager/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_manager/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `manager` - The manager name to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_manager/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_manager/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_manager/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_manager/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_manager(spreadsheet, \"Bob Johnson\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_manager/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_modified/2","doc":"Sets the document modified date.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_modified/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_modified/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `modified` - The modified date to set (ISO 8601 format recommended)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_modified/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_modified/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_modified/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_modified/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_modified(spreadsheet, \"2024-05-15T12:30:00Z\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_modified/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_properties/2","doc":"Sets multiple document properties at once.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_properties/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_properties/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `properties` - A map of property names to values","ref":"UmyaSpreadsheet.DocumentProperties.html#set_properties/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_properties/2","doc":"- `:ok` on success\n- `{:error, reason}` on first failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_properties/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_properties/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    properties = %{\n      title: \"My Report\",\n      description: \"Monthly sales report\",\n      creator: \"John Doe\",\n      company: \"Acme Corp\"\n    }\n    :ok = UmyaSpreadsheet.DocumentProperties.set_properties(spreadsheet, properties)","ref":"UmyaSpreadsheet.DocumentProperties.html#set_properties/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_subject/2","doc":"Sets the document subject.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_subject/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_subject/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `subject` - The subject to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_subject/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_subject/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_subject/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_subject/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_subject(spreadsheet, \"Financial Analysis\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_subject/2-examples"},{"type":"function","title":"UmyaSpreadsheet.DocumentProperties.set_title/2","doc":"Sets the document title.","ref":"UmyaSpreadsheet.DocumentProperties.html#set_title/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.DocumentProperties.set_title/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `title` - The title to set","ref":"UmyaSpreadsheet.DocumentProperties.html#set_title/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.DocumentProperties.set_title/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.DocumentProperties.html#set_title/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.DocumentProperties.set_title/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.DocumentProperties.set_title(spreadsheet, \"My Spreadsheet\")","ref":"UmyaSpreadsheet.DocumentProperties.html#set_title/2-examples"},{"type":"module","title":"UmyaSpreadsheet.Drawing","doc":"Functions for working with shapes, text boxes, and connectors in Excel spreadsheets.","ref":"UmyaSpreadsheet.Drawing.html"},{"type":"function","title":"UmyaSpreadsheet.Drawing.add_connector/6","doc":"Adds a connector line between two cells in a spreadsheet.\n\nA connector is a line that connects two cells, useful for creating flowcharts and diagrams.","ref":"UmyaSpreadsheet.Drawing.html#add_connector/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Drawing.add_connector/6","doc":"* `spreadsheet` - A spreadsheet struct\n* `sheet_name` - The name of the sheet to add the connector to\n* `from_cell` - The starting cell address for the connector (e.g., \"A1\")\n* `to_cell` - The ending cell address for the connector (e.g., \"B5\")\n* `line_color` - The color of the connector line. Can be a named color (e.g., \"black\") or a hex color code\n* `line_width` - The width of the connector line in points","ref":"UmyaSpreadsheet.Drawing.html#add_connector/6-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Drawing.add_connector/6","doc":"* `:ok` - Connector was successfully added\n* `{:error, :not_found}` - Sheet was not found\n* `{:error, :error}` - Failed to add connector for another reason","ref":"UmyaSpreadsheet.Drawing.html#add_connector/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Drawing.add_connector/6","doc":"# Add a red connector line from cell A1 to cell C3\n    UmyaSpreadsheet.add_connector(spreadsheet, \"Sheet1\", \"A1\", \"C3\", \"red\", 1.5)","ref":"UmyaSpreadsheet.Drawing.html#add_connector/6-examples"},{"type":"function","title":"UmyaSpreadsheet.Drawing.add_shape/9","doc":"Adds a shape to a spreadsheet at the specified cell position.","ref":"UmyaSpreadsheet.Drawing.html#add_shape/9"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Drawing.add_shape/9","doc":"* `spreadsheet` - A spreadsheet struct\n* `sheet_name` - The name of the sheet to add the shape to\n* `cell_address` - The cell address where the shape should be placed (e.g., \"A1\")\n* `shape_type` - The type of shape to add. Supported types:\n  * \"rectangle\" - Rectangle shape\n  * \"ellipse\" or \"oval\" or \"circle\" - Ellipse/oval shape\n  * \"rounded_rectangle\" - Rectangle with rounded corners\n  * \"triangle\" - Triangle shape\n  * \"right_triangle\" - Right triangle shape\n  * \"pentagon\" - Pentagon shape\n  * \"hexagon\" - Hexagon shape\n  * \"octagon\" - Octagon shape\n  * \"trapezoid\" - Trapezoid shape\n  * \"diamond\" - Diamond shape\n  * \"arrow\" - Arrow shape\n  * \"line\" - Line shape\n  * \"connector\" - Connector line (use add_connector/6 for connecting two cells)\n* `width` - The width of the shape in pixels\n* `height` - The height of the shape in pixels\n* `fill_color` - The fill color for the shape. Can be a named color (e.g., \"red\", \"blue\") or a hex color code (e.g., \"FF0000\")\n* `outline_color` - The outline/border color for the shape. Can be a named color or hex code\n* `outline_width` - The width of the outline/border in points","ref":"UmyaSpreadsheet.Drawing.html#add_shape/9-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Drawing.add_shape/9","doc":"* `:ok` - Shape was successfully added\n* `{:error, :not_found}` - Sheet was not found\n* `{:error, :error}` - Failed to add shape for another reason","ref":"UmyaSpreadsheet.Drawing.html#add_shape/9-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Drawing.add_shape/9","doc":"# Add a blue rectangle at cell A1\n    UmyaSpreadsheet.add_shape(spreadsheet, \"Sheet1\", \"A1\", \"rectangle\", 200, 100, \"#0000FF\", \"black\", 1.0)\n\n    # Add a red circle at cell B5\n    UmyaSpreadsheet.add_shape(spreadsheet, \"Sheet1\", \"B5\", \"ellipse\", 150, 150, \"red\", \"black\", 1.0)","ref":"UmyaSpreadsheet.Drawing.html#add_shape/9-examples"},{"type":"function","title":"UmyaSpreadsheet.Drawing.add_text_box/10","doc":"Adds a text box to a spreadsheet at the specified cell position.\n\nA text box is a rectangular shape with text inside it.","ref":"UmyaSpreadsheet.Drawing.html#add_text_box/10"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Drawing.add_text_box/10","doc":"* `spreadsheet` - A spreadsheet struct\n* `sheet_name` - The name of the sheet to add the text box to\n* `cell_address` - The cell address where the text box should be placed (e.g., \"A1\")\n* `text` - The text to display inside the text box\n* `width` - The width of the text box in pixels\n* `height` - The height of the text box in pixels\n* `fill_color` - The background color for the text box. Can be a named color (e.g., \"white\") or a hex color code\n* `text_color` - The color of the text. Can be a named color (e.g., \"black\") or a hex color code\n* `outline_color` - The border color for the text box. Can be a named color or hex code\n* `outline_width` - The width of the border in points","ref":"UmyaSpreadsheet.Drawing.html#add_text_box/10-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Drawing.add_text_box/10","doc":"* `:ok` - Text box was successfully added\n* `{:error, :not_found}` - Sheet was not found\n* `{:error, :error}` - Failed to add text box for another reason","ref":"UmyaSpreadsheet.Drawing.html#add_text_box/10-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Drawing.add_text_box/10","doc":"# Add a white text box with black text at cell A1\n    UmyaSpreadsheet.add_text_box(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1\",\n      \"Hello World\",\n      200,\n      100,\n      \"white\",\n      \"black\",\n      \"gray\",\n      1.0\n    )","ref":"UmyaSpreadsheet.Drawing.html#add_text_box/10-examples"},{"type":"function","title":"UmyaSpreadsheet.Drawing.count_drawing_objects/3","doc":"Counts drawing objects (shapes, text boxes, connectors) in a worksheet.","ref":"UmyaSpreadsheet.Drawing.html#count_drawing_objects/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Drawing.count_drawing_objects/3","doc":"* `spreadsheet` - A spreadsheet struct\n* `sheet_name` - The name of the sheet to count objects in\n* `cell_range` - Optional cell range to filter by position (e.g., \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#count_drawing_objects/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Drawing.count_drawing_objects/3","doc":"* `{:ok, count}` - The number of drawing objects found\n* `{:error, :not_found}` - Sheet was not found\n* `{:error, :error}` - Failed to count drawing objects for another reason","ref":"UmyaSpreadsheet.Drawing.html#count_drawing_objects/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Drawing.count_drawing_objects/3","doc":"# Count all drawing objects in Sheet1\n    {:ok, count} = UmyaSpreadsheet.Drawing.count_drawing_objects(spreadsheet, \"Sheet1\")\n\n    # Count drawing objects in cells A1 through C10\n    {:ok, count} = UmyaSpreadsheet.Drawing.count_drawing_objects(spreadsheet, \"Sheet1\", \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#count_drawing_objects/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Drawing.get_connectors/3","doc":"Gets all connectors in a worksheet.\n\nThis function retrieves all connector lines from the specified worksheet.","ref":"UmyaSpreadsheet.Drawing.html#get_connectors/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Drawing.get_connectors/3","doc":"* `spreadsheet` - A spreadsheet struct\n* `sheet_name` - The name of the sheet to get connectors from\n* `cell_range` - Optional cell range to filter connectors by position (e.g., \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#get_connectors/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Drawing.get_connectors/3","doc":"* `{:ok, connectors}` - List of connector maps, each containing:\n  * `:from_cell` - The starting cell address for the connector\n  * `:to_cell` - The ending cell address for the connector\n  * `:line_color` - The color of the connector line (hex code)\n  * `:line_width` - The width of the connector line in points\n* `{:error, :not_found}` - Sheet was not found\n* `{:error, :error}` - Failed to get connectors for another reason","ref":"UmyaSpreadsheet.Drawing.html#get_connectors/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Drawing.get_connectors/3","doc":"# Get all connectors in Sheet1\n    {:ok, connectors} = UmyaSpreadsheet.Drawing.get_connectors(spreadsheet, \"Sheet1\")\n\n    # Get connectors in cells A1 through C10\n    {:ok, connectors} = UmyaSpreadsheet.Drawing.get_connectors(spreadsheet, \"Sheet1\", \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#get_connectors/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Drawing.get_shapes/3","doc":"Gets all shapes in a worksheet.\n\nThis function retrieves all shapes (rectangles, ellipses, etc.) from the specified worksheet.","ref":"UmyaSpreadsheet.Drawing.html#get_shapes/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Drawing.get_shapes/3","doc":"* `spreadsheet` - A spreadsheet struct\n* `sheet_name` - The name of the sheet to get shapes from\n* `cell_range` - Optional cell range to filter shapes by position (e.g., \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#get_shapes/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Drawing.get_shapes/3","doc":"* `{:ok, shapes}` - List of shape maps, each containing:\n  * `:type` - The type of shape (\"rectangle\", \"ellipse\", etc.)\n  * `:cell` - The cell address where the shape is placed\n  * `:width` - The width of the shape in pixels\n  * `:height` - The height of the shape in pixels\n  * `:fill_color` - The fill color for the shape (hex code)\n  * `:outline_color` - The outline/border color for the shape (hex code)\n  * `:outline_width` - The width of the outline/border in points\n* `{:error, :not_found}` - Sheet was not found\n* `{:error, :error}` - Failed to get shapes for another reason","ref":"UmyaSpreadsheet.Drawing.html#get_shapes/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Drawing.get_shapes/3","doc":"# Get all shapes in Sheet1\n    {:ok, shapes} = UmyaSpreadsheet.Drawing.get_shapes(spreadsheet, \"Sheet1\")\n\n    # Get shapes in cells A1 through C10\n    {:ok, shapes} = UmyaSpreadsheet.Drawing.get_shapes(spreadsheet, \"Sheet1\", \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#get_shapes/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Drawing.get_text_boxes/3","doc":"Gets all text boxes in a worksheet.\n\nThis function retrieves all text boxes from the specified worksheet.","ref":"UmyaSpreadsheet.Drawing.html#get_text_boxes/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Drawing.get_text_boxes/3","doc":"* `spreadsheet` - A spreadsheet struct\n* `sheet_name` - The name of the sheet to get text boxes from\n* `cell_range` - Optional cell range to filter text boxes by position (e.g., \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#get_text_boxes/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Drawing.get_text_boxes/3","doc":"* `{:ok, text_boxes}` - List of text box maps, each containing:\n  * `:cell` - The cell address where the text box is placed\n  * `:text` - The text content of the text box\n  * `:width` - The width of the text box in pixels\n  * `:height` - The height of the text box in pixels\n  * `:fill_color` - The background color for the text box (hex code)\n  * `:text_color` - The color of the text (hex code)\n  * `:outline_color` - The border color for the text box (hex code)\n  * `:outline_width` - The width of the border in points\n* `{:error, :not_found}` - Sheet was not found\n* `{:error, :error}` - Failed to get text boxes for another reason","ref":"UmyaSpreadsheet.Drawing.html#get_text_boxes/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Drawing.get_text_boxes/3","doc":"# Get all text boxes in Sheet1\n    {:ok, text_boxes} = UmyaSpreadsheet.Drawing.get_text_boxes(spreadsheet, \"Sheet1\")\n\n    # Get text boxes in cells A1 through C10\n    {:ok, text_boxes} = UmyaSpreadsheet.Drawing.get_text_boxes(spreadsheet, \"Sheet1\", \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#get_text_boxes/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Drawing.has_drawing_objects/3","doc":"Checks if a worksheet has any drawing objects (shapes, text boxes, connectors).","ref":"UmyaSpreadsheet.Drawing.html#has_drawing_objects/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Drawing.has_drawing_objects/3","doc":"* `spreadsheet` - A spreadsheet struct\n* `sheet_name` - The name of the sheet to check\n* `cell_range` - Optional cell range to filter by position (e.g., \"A1:C10\")","ref":"UmyaSpreadsheet.Drawing.html#has_drawing_objects/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Drawing.has_drawing_objects/3","doc":"* `{:ok, has_objects}` - Boolean indicating whether the sheet has drawing objects\n* `{:error, :not_found}` - Sheet was not found\n* `{:error, :error}` - Failed to check for drawing objects for another reason","ref":"UmyaSpreadsheet.Drawing.html#has_drawing_objects/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Drawing.has_drawing_objects/3","doc":"# Check if Sheet1 has any drawing objects\n    {:ok, has_objects} = UmyaSpreadsheet.Drawing.has_drawing_objects(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.Drawing.html#has_drawing_objects/3-examples"},{"type":"module","title":"UmyaSpreadsheet.ErrorHandling","doc":"Helper functions for standardizing error handling across the UmyaSpreadsheet library.","ref":"UmyaSpreadsheet.ErrorHandling.html"},{"type":"function","title":"UmyaSpreadsheet.ErrorHandling.standardize_ok_result/1","doc":"Standardizes success return values, ensuring they follow the {:ok, value} pattern.","ref":"UmyaSpreadsheet.ErrorHandling.html#standardize_ok_result/1"},{"type":"function","title":"UmyaSpreadsheet.ErrorHandling.standardize_result/1","doc":"Standardizes result format for NIF functions that might return mixed formats.\nThis is the main function to use for most function return value processing.","ref":"UmyaSpreadsheet.ErrorHandling.html#standardize_result/1"},{"type":"function","title":"UmyaSpreadsheet.ErrorHandling.unwrap_error/1","doc":"Unwraps nested error tuples to ensure a standardized error format.\nThis helps with fixing the nested error tuples like {:error, {:error, reason}} to {:error, reason}","ref":"UmyaSpreadsheet.ErrorHandling.html#unwrap_error/1"},{"type":"module","title":"UmyaSpreadsheet.FileFormatOptions","doc":"Advanced file format options for Excel files.\n\nThis module provides additional control over file format options that are available in the\nunderlying Rust library but were not previously exposed in the Elixir wrapper.\n\nOptions include:\n- Compression level control for XLSX files\n- Enhanced encryption options\n- Converting a spreadsheet directly to a binary without writing to disk","ref":"UmyaSpreadsheet.FileFormatOptions.html"},{"type":"function","title":"UmyaSpreadsheet.FileFormatOptions.get_compression_level/1","doc":"Gets the default compression level used for XLSX files.\n\nThis function returns the current default compression level that will be used when\nwriting XLSX files with the standard write function.","ref":"UmyaSpreadsheet.FileFormatOptions.html#get_compression_level/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FileFormatOptions.get_compression_level/1","doc":"* `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.FileFormatOptions.html#get_compression_level/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FileFormatOptions.get_compression_level/1","doc":"* Integer from 0 to 9 representing the compression level (0 = no compression, 9 = maximum compression)","ref":"UmyaSpreadsheet.FileFormatOptions.html#get_compression_level/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FileFormatOptions.get_compression_level/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.FileFormatOptions.get_compression_level(spreadsheet)\n    6","ref":"UmyaSpreadsheet.FileFormatOptions.html#get_compression_level/1-examples"},{"type":"function","title":"UmyaSpreadsheet.FileFormatOptions.get_encryption_algorithm/1","doc":"Gets the encryption algorithm used for a password-protected spreadsheet.\n\nThis function returns the encryption algorithm used to protect the spreadsheet,\nor nil if the spreadsheet is not encrypted.","ref":"UmyaSpreadsheet.FileFormatOptions.html#get_encryption_algorithm/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FileFormatOptions.get_encryption_algorithm/1","doc":"* `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.FileFormatOptions.html#get_encryption_algorithm/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FileFormatOptions.get_encryption_algorithm/1","doc":"* A string representing the encryption algorithm (e.g., \"AES256\") if the spreadsheet is encrypted\n* `nil` if the spreadsheet is not encrypted\n* `{:error, reason}` if the operation failed","ref":"UmyaSpreadsheet.FileFormatOptions.html#get_encryption_algorithm/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FileFormatOptions.get_encryption_algorithm/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.FileFormatOptions.get_encryption_algorithm(spreadsheet)\n    nil\n\n    iex> {:ok, spreadsheet} = UmyaSpreadsheet.read(\"encrypted.xlsx\", \"password\")\n    iex> UmyaSpreadsheet.FileFormatOptions.get_encryption_algorithm(spreadsheet)\n    \"AES256\"","ref":"UmyaSpreadsheet.FileFormatOptions.html#get_encryption_algorithm/1-examples"},{"type":"function","title":"UmyaSpreadsheet.FileFormatOptions.is_encrypted/1","doc":"Checks if a spreadsheet has encryption enabled.\n\nThis function checks if the spreadsheet has any workbook protection or encryption\nsettings enabled.","ref":"UmyaSpreadsheet.FileFormatOptions.html#is_encrypted/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FileFormatOptions.is_encrypted/1","doc":"* `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.FileFormatOptions.html#is_encrypted/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FileFormatOptions.is_encrypted/1","doc":"* Boolean indicating if encryption is enabled","ref":"UmyaSpreadsheet.FileFormatOptions.html#is_encrypted/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FileFormatOptions.is_encrypted/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.FileFormatOptions.is_encrypted(spreadsheet)\n    false\n\n    iex> {:ok, spreadsheet} = UmyaSpreadsheet.read_xlsx_with_password(\"encrypted.xlsx\", \"secret123\")\n    iex> UmyaSpreadsheet.FileFormatOptions.is_encrypted(spreadsheet)\n    true","ref":"UmyaSpreadsheet.FileFormatOptions.html#is_encrypted/1-examples"},{"type":"function","title":"UmyaSpreadsheet.FileFormatOptions.to_binary_xlsx/1","doc":"Converts a spreadsheet to binary XLSX format without writing to disk.\n\nThis function is useful when you need to:\n- Send an Excel file in an HTTP response\n- Store Excel files in a database\n- Process Excel files in memory without touching the filesystem","ref":"UmyaSpreadsheet.FileFormatOptions.html#to_binary_xlsx/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FileFormatOptions.to_binary_xlsx/1","doc":"* `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.FileFormatOptions.html#to_binary_xlsx/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FileFormatOptions.to_binary_xlsx/1","doc":"* Binary data representing the Excel file","ref":"UmyaSpreadsheet.FileFormatOptions.html#to_binary_xlsx/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FileFormatOptions.to_binary_xlsx/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Hello\")\n    iex> binary = UmyaSpreadsheet.FileFormatOptions.to_binary_xlsx(spreadsheet)\n    iex> is_binary(binary)\n    true\n    iex> byte_size(binary) > 0\n    true","ref":"UmyaSpreadsheet.FileFormatOptions.html#to_binary_xlsx/1-examples"},{"type":"function","title":"UmyaSpreadsheet.FileFormatOptions.write_with_compression/3","doc":"Writes a spreadsheet to disk with a specified compression level.\n\nCompression levels range from 0 (no compression) to 9 (maximum compression).\nHigher compression levels result in smaller files but take longer to create.","ref":"UmyaSpreadsheet.FileFormatOptions.html#write_with_compression/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FileFormatOptions.write_with_compression/3","doc":"* `spreadsheet` - The spreadsheet struct\n* `path` - Path where the Excel file will be saved\n* `compression_level` - Integer from 0 to 9 (0 = no compression, 9 = maximum compression)","ref":"UmyaSpreadsheet.FileFormatOptions.html#write_with_compression/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.FileFormatOptions.write_with_compression/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.FileFormatOptions.write_with_compression(spreadsheet, \"high_compression.xlsx\", 9)\n    :ok\n\n    iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.FileFormatOptions.write_with_compression(spreadsheet, \"no_compression.xlsx\", 0)\n    :ok","ref":"UmyaSpreadsheet.FileFormatOptions.html#write_with_compression/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FileFormatOptions.write_with_encryption_options/6","doc":"Writes a spreadsheet to disk with enhanced encryption options.\n\nThis function provides more control over the encryption process than the standard\n`write_with_password` function, allowing you to specify encryption algorithm,\nsalt values, and spin counts for enhanced security.","ref":"UmyaSpreadsheet.FileFormatOptions.html#write_with_encryption_options/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FileFormatOptions.write_with_encryption_options/6","doc":"* `spreadsheet` - The spreadsheet struct\n* `path` - Path where the encrypted Excel file will be saved\n* `password` - Password to protect the file with\n* `algorithm` - Encryption algorithm (e.g., \"AES128\", \"AES256\", \"default\")\n* `salt_value` - Optional salt value for password derivation (if nil, a random salt is used)\n* `spin_count` - Optional spin count for key derivation (if nil, Excel default is used)","ref":"UmyaSpreadsheet.FileFormatOptions.html#write_with_encryption_options/6-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.FileFormatOptions.write_with_encryption_options/6","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.FileFormatOptions.write_with_encryption_options(\n    ...>   spreadsheet,\n    ...>   \"highly_secure.xlsx\",\n    ...>   \"secret123\",\n    ...>   \"AES256\"\n    ...> )\n    :ok\n\n    iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.FileFormatOptions.write_with_encryption_options(\n    ...>   spreadsheet,\n    ...>   \"custom_encryption.xlsx\",\n    ...>   \"very_secret\",\n    ...>   \"AES256\",\n    ...>   \"customSalt\",\n    ...>   100000\n    ...> )\n    :ok","ref":"UmyaSpreadsheet.FileFormatOptions.html#write_with_encryption_options/6-examples"},{"type":"module","title":"UmyaSpreadsheet.FontFunctions","doc":"Functions for manipulating font styles in a spreadsheet.","ref":"UmyaSpreadsheet.FontFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_bold/3","doc":"Gets the bold state for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_bold/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_bold/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_bold/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_bold/3","doc":"- `{:ok, is_bold}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_bold/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_bold/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, is_bold} = UmyaSpreadsheet.FontFunctions.get_font_bold(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_bold/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_color/3","doc":"Gets the font color for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_color/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_color/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_color/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_color/3","doc":"- `{:ok, font_color}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_color/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_color/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, font_color} = UmyaSpreadsheet.FontFunctions.get_font_color(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_color/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_family/3","doc":"Gets the font family for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_family/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_family/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_family/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_family/3","doc":"- `{:ok, font_family}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_family/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_family/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, font_family} = UmyaSpreadsheet.FontFunctions.get_font_family(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_family/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_italic/3","doc":"Gets the italic state for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_italic/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_italic/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_italic/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_italic/3","doc":"- `{:ok, is_italic}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_italic/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_italic/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, is_italic} = UmyaSpreadsheet.FontFunctions.get_font_italic(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_italic/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_name/3","doc":"Gets the font name for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_name/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_name/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_name/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_name/3","doc":"- `{:ok, font_name}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_name/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_name/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, font_name} = UmyaSpreadsheet.FontFunctions.get_font_name(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_name/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_scheme/3","doc":"Gets the font scheme for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_scheme/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_scheme/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_scheme/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_scheme/3","doc":"- `{:ok, font_scheme}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_scheme/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_scheme/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, font_scheme} = UmyaSpreadsheet.FontFunctions.get_font_scheme(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_scheme/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_size/3","doc":"Gets the font size for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_size/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_size/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_size/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_size/3","doc":"- `{:ok, font_size}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_size/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_size/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, font_size} = UmyaSpreadsheet.FontFunctions.get_font_size(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_size/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_strikethrough/3","doc":"Gets the strikethrough state for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_strikethrough/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_strikethrough/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_strikethrough/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_strikethrough/3","doc":"- `{:ok, is_strikethrough}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_strikethrough/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_strikethrough/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, is_strikethrough} = UmyaSpreadsheet.FontFunctions.get_font_strikethrough(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_strikethrough/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.get_font_underline/3","doc":"Gets the underline style for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_underline/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.get_font_underline/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_underline/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.get_font_underline/3","doc":"- `{:ok, underline_style}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_underline/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.get_font_underline/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, underline_style} = UmyaSpreadsheet.FontFunctions.get_font_underline(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.FontFunctions.html#get_font_underline/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_bold/4","doc":"Sets the font weight (bold) for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_bold/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_bold/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `is_bold` - Boolean indicating whether the font should be bold","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_bold/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_bold/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_bold/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_bold/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_bold/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_color/4","doc":"Sets the font color for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_color/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_color/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `color` - The color code (e.g., \"#FF0000\" for red)","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_color/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_color/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_color/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_color/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Set text to red\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_color(spreadsheet, \"Sheet1\", \"A1\", \"#FF0000\")","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_color/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_family/4","doc":"Sets the font family for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_family/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_family/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `font_family` - The font family: \"roman\" (serif), \"swiss\" (sans-serif), \"modern\" (monospace),\n  \"script\", or \"decorative\"","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_family/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_family/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_family/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_family/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_family(spreadsheet, \"Sheet1\", \"A1\", \"swiss\")","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_family/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_italic/4","doc":"Sets the font style to italic for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_italic/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_italic/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `is_italic` - Boolean indicating whether the font should be italic","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_italic/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_italic/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_italic/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_italic/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_italic(spreadsheet, \"Sheet1\", \"A1\", true)","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_italic/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_name/4","doc":"Sets the font name for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_name/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_name/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `font_name` - The name of the font","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_name/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_name/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_name/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_name/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_name(spreadsheet, \"Sheet1\", \"A1\", \"Arial\")","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_name/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_scheme/4","doc":"Sets the font scheme for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_scheme/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_scheme/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `font_scheme` - The font scheme: \"major\", \"minor\", or \"none\"","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_scheme/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_scheme/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_scheme/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_scheme/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_scheme(spreadsheet, \"Sheet1\", \"A1\", \"major\")","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_scheme/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_size/4","doc":"Sets the font size for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_size/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_size/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `size` - The font size in points","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_size/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_size/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_size/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_size/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_size(spreadsheet, \"Sheet1\", \"A1\", 14)","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_size/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_strikethrough/4","doc":"Sets the font strikethrough property for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_strikethrough/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_strikethrough/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `is_strikethrough` - Boolean indicating whether the font should have strikethrough","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_strikethrough/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_strikethrough/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_strikethrough/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_strikethrough/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_strikethrough(spreadsheet, \"Sheet1\", \"A1\", true)","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_strikethrough/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FontFunctions.set_font_underline/4","doc":"Sets the font underline style for a cell.","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_underline/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FontFunctions.set_font_underline/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\")\n- `underline_style` - The underline style (\"single\", \"double\", \"none\")","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_underline/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FontFunctions.set_font_underline/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_underline/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FontFunctions.set_font_underline/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.FontFunctions.set_font_underline(spreadsheet, \"Sheet1\", \"A1\", \"single\")","ref":"UmyaSpreadsheet.FontFunctions.html#set_font_underline/4-examples"},{"type":"module","title":"UmyaSpreadsheet.FormulaFunctions","doc":"Functions for working with formulas in spreadsheets.","ref":"UmyaSpreadsheet.FormulaFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.create_defined_name/4","doc":"Creates a defined name in the spreadsheet with an associated formula.","ref":"UmyaSpreadsheet.FormulaFunctions.html#create_defined_name/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.create_defined_name/4","doc":"* `spreadsheet` - The spreadsheet struct\n* `name` - Name for the defined name\n* `formula` - Formula string (without leading =)\n* `sheet_name` - Optional name of the worksheet to scope the defined name to","ref":"UmyaSpreadsheet.FormulaFunctions.html#create_defined_name/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.create_defined_name/4","doc":"iex> UmyaSpreadsheet.create_defined_name(spreadsheet, \"TaxRate\", \"0.15\")\n    :ok\n\n    iex> UmyaSpreadsheet.create_defined_name(spreadsheet, \"Department\", \"Sales\", \"Sheet1\")\n    :ok","ref":"UmyaSpreadsheet.FormulaFunctions.html#create_defined_name/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.create_named_range/4","doc":"Creates a named range in the spreadsheet.","ref":"UmyaSpreadsheet.FormulaFunctions.html#create_named_range/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.create_named_range/4","doc":"* `spreadsheet` - The spreadsheet struct\n* `name` - Name for the range\n* `sheet_name` - Name of the worksheet\n* `range` - Cell range in A1 notation (e.g., \"A1:B5\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#create_named_range/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.create_named_range/4","doc":"iex> UmyaSpreadsheet.create_named_range(spreadsheet, \"MyRange\", \"Sheet1\", \"A1:B10\")\n    :ok","ref":"UmyaSpreadsheet.FormulaFunctions.html#create_named_range/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_bx/3","doc":"Gets the bx property of a formula.\n\nThe bx property indicates whether the formula calculation\nshould be done on exit from the cell.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_bx/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_bx/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_bx/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_bx/3","doc":"- `true` if bx is set, `false` if not set, `nil` if no formula","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_bx/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_bx/3","doc":"iex> FormulaFunctions.get_bx(spreadsheet, \"Sheet1\", \"A1\")\n    true","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_bx/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_data_table_2d/3","doc":"Gets the data table 2D property of a formula.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_data_table_2d/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_data_table_2d/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_data_table_2d/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_data_table_2d/3","doc":"- `true` if this is a 2D data table, `false` if not, `nil` if no formula","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_data_table_2d/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_data_table_2d/3","doc":"iex> FormulaFunctions.get_data_table_2d(spreadsheet, \"Sheet1\", \"A1\")\n    false","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_data_table_2d/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_data_table_row/3","doc":"Gets the data table row property of a formula.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_data_table_row/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_data_table_row/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_data_table_row/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_data_table_row/3","doc":"- `true` if this is a data table row, `false` if not, `nil` if no formula","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_data_table_row/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_data_table_row/3","doc":"iex> FormulaFunctions.get_data_table_row(spreadsheet, \"Sheet1\", \"A1\")\n    true","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_data_table_row/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_defined_names/1","doc":"Gets all defined names in the spreadsheet.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_defined_names/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_defined_names/1","doc":"- `spreadsheet`: The spreadsheet struct","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_defined_names/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_defined_names/1","doc":"- A list of tuples containing {name, address} for each defined name","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_defined_names/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_defined_names/1","doc":"iex> FormulaFunctions.get_defined_names(spreadsheet)\n    [{\"MyRange\", \"Sheet1!A1:B2\"}, {\"Total\", \"SUM(A1:A10)\"}]","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_defined_names/1-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_formula/3","doc":"Gets the formula text from a cell.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_formula/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_formula/3","doc":"- The formula text as a string, empty string if no formula","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_formula/3","doc":"iex> FormulaFunctions.get_formula(spreadsheet, \"Sheet1\", \"A1\")\n    \"=SUM(B1:B10)\"\n\n    iex> FormulaFunctions.get_formula(spreadsheet, \"Sheet1\", \"B1\")\n    \"\"","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_formula_obj/3","doc":"Gets the complete formula object from a cell.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_obj/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_formula_obj/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_obj/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_formula_obj/3","doc":"- A tuple `{text, type, shared_index, reference}` containing:\n  - `text`: The formula text\n  - `type`: The formula type as string (\"Normal\", \"Array\", \"DataTable\", \"Shared\")\n  - `shared_index`: The shared formula index (nil if not shared)\n  - `reference`: The formula reference (nil if none)","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_obj/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_formula_obj/3","doc":"iex> FormulaFunctions.get_formula_obj(spreadsheet, \"Sheet1\", \"A1\")\n    {\"=SUM(B1:B10)\", \"Normal\", nil, nil}\n\n    iex> FormulaFunctions.get_formula_obj(spreadsheet, \"Sheet1\", \"C1\")\n    {\"=A1+B1\", \"Shared\", 0, \"C1:C10\"}","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_obj/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_formula_shared_index/3","doc":"Gets the shared index of a formula in a cell.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_shared_index/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_formula_shared_index/3","doc":"- `spreadsheet`: The spreadsheet resource\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_shared_index/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_formula_shared_index/3","doc":"- The shared formula index as integer, or `nil` if not a shared formula\n\n@doc \"\"\"\nGets the shared index of a formula in a cell.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_shared_index/3-returns"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_formula_shared_index/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_shared_index/3-parameters-1"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_formula_shared_index/3","doc":"- The shared formula index as integer, or `nil` if not a shared formula","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_shared_index/3-returns-1"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_formula_shared_index/3","doc":"iex> FormulaFunctions.get_formula_shared_index(spreadsheet, \"Sheet1\", \"A1\")\n    0\n\n    iex> FormulaFunctions.get_formula_shared_index(spreadsheet, \"Sheet1\", \"B1\")\n    nil","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_shared_index/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_formula_type/3","doc":"Gets the formula type of a cell.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_type/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_formula_type/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_type/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_formula_type/3","doc":"- The formula type as a string: \"Normal\", \"Array\", \"DataTable\", \"Shared\", or \"None\"","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_type/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_formula_type/3","doc":"iex> FormulaFunctions.get_formula_type(spreadsheet, \"Sheet1\", \"A1\")\n    \"Normal\"\n\n    iex> FormulaFunctions.get_formula_type(spreadsheet, \"Sheet1\", \"B1\")\n    \"Array\"","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_formula_type/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_input_1deleted/3","doc":"Gets the input 1 deleted property of a formula.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_input_1deleted/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_input_1deleted/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_input_1deleted/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_input_1deleted/3","doc":"- `true` if input 1 is deleted, `false` if not, `nil` if no formula","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_input_1deleted/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_input_1deleted/3","doc":"iex> FormulaFunctions.get_input_1deleted(spreadsheet, \"Sheet1\", \"A1\")\n    false","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_input_1deleted/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_input_2deleted/3","doc":"Gets the input 2 deleted property of a formula.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_input_2deleted/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_input_2deleted/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_input_2deleted/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_input_2deleted/3","doc":"- `true` if input 2 is deleted, `false` if not, `nil` if no formula","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_input_2deleted/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_input_2deleted/3","doc":"iex> FormulaFunctions.get_input_2deleted(spreadsheet, \"Sheet1\", \"A1\")\n    false","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_input_2deleted/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_r1/3","doc":"Gets the R1 property of a formula.\n\nThe R1 property is used in data table formulas to specify\nthe first input cell reference.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_r1/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_r1/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_r1/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_r1/3","doc":"- The R1 reference as a string, or `nil` if not set","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_r1/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_r1/3","doc":"iex> FormulaFunctions.get_r1(spreadsheet, \"Sheet1\", \"A1\")\n    \"A1\"","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_r1/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_r2/3","doc":"Gets the R2 property of a formula.\n\nThe R2 property is used in data table formulas to specify\nthe second input cell reference.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_r2/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_r2/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_r2/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_r2/3","doc":"- The R2 reference as a string, or `nil` if not set","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_r2/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_r2/3","doc":"iex> FormulaFunctions.get_r2(spreadsheet, \"Sheet1\", \"A1\")\n    \"B1\"","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_r2/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_reference/3","doc":"Gets the reference of a formula.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_reference/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_reference/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_reference/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_reference/3","doc":"- The formula reference as a string, or `nil` if no reference","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_reference/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_reference/3","doc":"iex> FormulaFunctions.get_reference(spreadsheet, \"Sheet1\", \"A1\")\n    \"A1:A10\"","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_reference/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_shared_index/3","doc":"Gets the shared index of a formula.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_shared_index/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_shared_index/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_shared_index/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_shared_index/3","doc":"- The shared formula index as integer, or `nil` if not shared","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_shared_index/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_shared_index/3","doc":"iex> FormulaFunctions.get_shared_index(spreadsheet, \"Sheet1\", \"A1\")\n    0","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_shared_index/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.get_text/3","doc":"Gets the text content of a formula in a cell.\n\nThis is similar to `get_formula/3` but specifically gets the text property\nfrom the CellFormula object.","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_text/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.get_text/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_text/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.get_text/3","doc":"- The formula text as a string, empty string if no formula","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_text/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.get_text/3","doc":"iex> FormulaFunctions.get_text(spreadsheet, \"Sheet1\", \"A1\")\n    \"=SUM(B1:B10)\"","ref":"UmyaSpreadsheet.FormulaFunctions.html#get_text/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.is_formula/3","doc":"Checks if a cell contains a formula.","ref":"UmyaSpreadsheet.FormulaFunctions.html#is_formula/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.is_formula/3","doc":"- `spreadsheet`: The spreadsheet struct\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.FormulaFunctions.html#is_formula/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.FormulaFunctions.is_formula/3","doc":"- `true` if the cell contains a formula, `false` otherwise","ref":"UmyaSpreadsheet.FormulaFunctions.html#is_formula/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.is_formula/3","doc":"iex> FormulaFunctions.is_formula(spreadsheet, \"Sheet1\", \"A1\")\n    true\n\n    iex> FormulaFunctions.is_formula(spreadsheet, \"Sheet1\", \"B1\")\n    false","ref":"UmyaSpreadsheet.FormulaFunctions.html#is_formula/3-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.set_array_formula/4","doc":"Sets an array formula for a range of cells. Array formulas can return multiple values\nacross a range of cells.","ref":"UmyaSpreadsheet.FormulaFunctions.html#set_array_formula/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.set_array_formula/4","doc":"* `spreadsheet` - The spreadsheet struct\n* `sheet_name` - Name of the worksheet\n* `range` - Cell range in A1 notation (e.g., \"A1:B5\")\n* `formula` - Formula string (without leading =)","ref":"UmyaSpreadsheet.FormulaFunctions.html#set_array_formula/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.set_array_formula/4","doc":"iex> UmyaSpreadsheet.set_array_formula(spreadsheet, \"Sheet1\", \"A1:A3\", \"ROW(1:3)\")\n    :ok","ref":"UmyaSpreadsheet.FormulaFunctions.html#set_array_formula/4-examples"},{"type":"function","title":"UmyaSpreadsheet.FormulaFunctions.set_formula/4","doc":"Sets a regular formula in a cell.","ref":"UmyaSpreadsheet.FormulaFunctions.html#set_formula/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.FormulaFunctions.set_formula/4","doc":"* `spreadsheet` - The spreadsheet struct\n* `sheet_name` - Name of the worksheet\n* `cell_address` - Cell address in A1 notation (e.g., \"A1\", \"B2\")\n* `formula` - Formula string (without leading =)","ref":"UmyaSpreadsheet.FormulaFunctions.html#set_formula/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.FormulaFunctions.set_formula/4","doc":"iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"SUM(B1:B10)\")\n    :ok","ref":"UmyaSpreadsheet.FormulaFunctions.html#set_formula/4-examples"},{"type":"module","title":"UmyaSpreadsheet.Hyperlink","doc":"Functions for managing hyperlinks in Excel spreadsheets.\n\nThis module provides a comprehensive API for working with hyperlinks in Excel cells,\nincluding support for:\n- Web URLs (http/https)\n- File paths (local files)\n- Internal worksheet references\n- Email addresses (mailto links)\n- Custom tooltip text\n- Complete hyperlink lifecycle management (add, get, update, remove)","ref":"UmyaSpreadsheet.Hyperlink.html"},{"type":"module","title":"Examples - UmyaSpreadsheet.Hyperlink","doc":"# Add a web URL hyperlink\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.add_hyperlink(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1\",\n      \"https://example.com\",\n      \"Visit Example.com\"\n    )\n\n    # Add an internal worksheet reference\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.add_hyperlink(\n      spreadsheet,\n      \"Sheet1\",\n      \"B1\",\n      \"Sheet2!A1\",\n      \"Go to Sheet2\",\n      true\n    )\n\n    # Get hyperlink information\n    {:ok, hyperlink_info} = UmyaSpreadsheet.Hyperlink.get_hyperlink(spreadsheet, \"Sheet1\", \"A1\")\n\n    # Check if cell has hyperlink\n    true = UmyaSpreadsheet.Hyperlink.has_hyperlink?(spreadsheet, \"Sheet1\", \"A1\")\n\n    # Get all hyperlinks in worksheet\n    {:ok, hyperlinks} = UmyaSpreadsheet.Hyperlink.get_all_hyperlinks(spreadsheet, \"Sheet1\")\n\n    # Update existing hyperlink\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.update_hyperlink(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1\",\n      \"https://newexample.com\",\n      \"Updated tooltip\"\n    )\n\n    # Remove hyperlink\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.remove_hyperlink(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.Hyperlink.html#module-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.add_bulk_hyperlinks/3","doc":"Bulk adds multiple hyperlinks to a worksheet.","ref":"UmyaSpreadsheet.Hyperlink.html#add_bulk_hyperlinks/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.add_bulk_hyperlinks/3","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet\n- `hyperlinks`: List of hyperlink specifications as tuples or maps","ref":"UmyaSpreadsheet.Hyperlink.html#add_bulk_hyperlinks/3-parameters"},{"type":"function","title":"Hyperlink specifications - UmyaSpreadsheet.Hyperlink.add_bulk_hyperlinks/3","doc":"Each hyperlink can be specified as:\n- `{cell_address, url}` - Basic hyperlink without tooltip\n- `{cell_address, url, tooltip}` - Hyperlink with tooltip\n- `{cell_address, url, tooltip, is_internal}` - Full specification\n- `%{cell: cell_address, url: url, tooltip: tooltip, is_internal: is_internal}` - Map format","ref":"UmyaSpreadsheet.Hyperlink.html#add_bulk_hyperlinks/3-hyperlink-specifications"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.add_bulk_hyperlinks/3","doc":"- `{:ok, spreadsheet}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#add_bulk_hyperlinks/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.add_bulk_hyperlinks/3","doc":"hyperlinks = [\n      {\"A1\", \"https://example.com\", \"Website\"},\n      {\"B1\", \"mailto:test@example.com\", \"Email\"},\n      {\"C1\", \"Sheet2!A1\", \"Internal link\", true}\n    ]\n\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.add_bulk_hyperlinks(\n      spreadsheet,\n      \"Sheet1\",\n      hyperlinks\n    )","ref":"UmyaSpreadsheet.Hyperlink.html#add_bulk_hyperlinks/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.add_hyperlink/6","doc":"Adds a hyperlink to a cell.","ref":"UmyaSpreadsheet.Hyperlink.html#add_hyperlink/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.add_hyperlink/6","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")\n- `url`: The hyperlink URL or reference\n- `tooltip`: Optional tooltip text (default: nil)\n- `is_internal`: Whether this is an internal worksheet reference (default: false)","ref":"UmyaSpreadsheet.Hyperlink.html#add_hyperlink/6-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.add_hyperlink/6","doc":"- `{:ok, spreadsheet}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#add_hyperlink/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.add_hyperlink/6","doc":"# Web URL\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.add_hyperlink(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1\",\n      \"https://example.com\",\n      \"Visit our website\"\n    )\n\n    # Email link\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.add_hyperlink(\n      spreadsheet,\n      \"Sheet1\",\n      \"B1\",\n      \"mailto:contact@example.com\",\n      \"Send email\"\n    )\n\n    # File path\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.add_hyperlink(\n      spreadsheet,\n      \"Sheet1\",\n      \"C1\",\n      \"file:///path/to/document.pdf\",\n      \"Open document\"\n    )\n\n    # Internal reference\n    {:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.add_hyperlink(\n      spreadsheet,\n      \"Sheet1\",\n      \"D1\",\n      \"Sheet2!A1\",\n      \"Go to Sheet2\",\n      true\n    )","ref":"UmyaSpreadsheet.Hyperlink.html#add_hyperlink/6-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.count_hyperlinks/2","doc":"Counts the number of hyperlinks in a worksheet.","ref":"UmyaSpreadsheet.Hyperlink.html#count_hyperlinks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.count_hyperlinks/2","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet","ref":"UmyaSpreadsheet.Hyperlink.html#count_hyperlinks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.count_hyperlinks/2","doc":"- `{:ok, count}` where count is the number of hyperlinks\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#count_hyperlinks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.count_hyperlinks/2","doc":"{:ok, 5} = UmyaSpreadsheet.Hyperlink.count_hyperlinks(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.Hyperlink.html#count_hyperlinks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.get_all_hyperlinks/2","doc":"Gets all hyperlinks from a worksheet.","ref":"UmyaSpreadsheet.Hyperlink.html#get_all_hyperlinks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.get_all_hyperlinks/2","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet","ref":"UmyaSpreadsheet.Hyperlink.html#get_all_hyperlinks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.get_all_hyperlinks/2","doc":"- `{:ok, hyperlinks}` where hyperlinks is a list of hyperlink_info maps\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#get_all_hyperlinks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.get_all_hyperlinks/2","doc":"{:ok, hyperlinks} = UmyaSpreadsheet.Hyperlink.get_all_hyperlinks(spreadsheet, \"Sheet1\")\n    # Returns: [\n    #   %{url: \"https://example.com\", tooltip: \"Website\", is_internal: false, cell: \"A1\"},\n    #   %{url: \"Sheet2!A1\", tooltip: \"Internal link\", is_internal: true, cell: \"B1\"}\n    # ]","ref":"UmyaSpreadsheet.Hyperlink.html#get_all_hyperlinks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.get_hyperlink/3","doc":"Gets hyperlink information from a cell.","ref":"UmyaSpreadsheet.Hyperlink.html#get_hyperlink/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.get_hyperlink/3","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.Hyperlink.html#get_hyperlink/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.get_hyperlink/3","doc":"- `{:ok, hyperlink_info}` if hyperlink exists\n- `{:error, :not_found}` if no hyperlink exists\n- `{:error, reason}` on other failures","ref":"UmyaSpreadsheet.Hyperlink.html#get_hyperlink/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.get_hyperlink/3","doc":"{:ok, info} = UmyaSpreadsheet.Hyperlink.get_hyperlink(spreadsheet, \"Sheet1\", \"A1\")\n    # Returns: %{url: \"https://example.com\", tooltip: \"Visit our website\", is_internal: false, cell: \"A1\"}","ref":"UmyaSpreadsheet.Hyperlink.html#get_hyperlink/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.has_hyperlink?/3","doc":"Checks if a specific cell has a hyperlink.","ref":"UmyaSpreadsheet.Hyperlink.html#has_hyperlink?/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.has_hyperlink?/3","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.Hyperlink.html#has_hyperlink?/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.has_hyperlink?/3","doc":"- `true` if the cell has a hyperlink\n- `false` if the cell doesn't have a hyperlink\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#has_hyperlink?/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.has_hyperlink?/3","doc":"true = UmyaSpreadsheet.Hyperlink.has_hyperlink?(spreadsheet, \"Sheet1\", \"A1\")\n    false = UmyaSpreadsheet.Hyperlink.has_hyperlink?(spreadsheet, \"Sheet1\", \"B1\")","ref":"UmyaSpreadsheet.Hyperlink.html#has_hyperlink?/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.has_hyperlinks?/2","doc":"Checks if a worksheet contains any hyperlinks.","ref":"UmyaSpreadsheet.Hyperlink.html#has_hyperlinks?/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.has_hyperlinks?/2","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet","ref":"UmyaSpreadsheet.Hyperlink.html#has_hyperlinks?/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.has_hyperlinks?/2","doc":"- `true` if the worksheet has any hyperlinks\n- `false` if the worksheet has no hyperlinks\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#has_hyperlinks?/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.has_hyperlinks?/2","doc":"true = UmyaSpreadsheet.Hyperlink.has_hyperlinks?(spreadsheet, \"Sheet1\")\n    false = UmyaSpreadsheet.Hyperlink.has_hyperlinks?(spreadsheet, \"EmptySheet\")","ref":"UmyaSpreadsheet.Hyperlink.html#has_hyperlinks?/2-examples"},{"type":"type","title":"UmyaSpreadsheet.Hyperlink.hyperlink_info/0","doc":"","ref":"UmyaSpreadsheet.Hyperlink.html#t:hyperlink_info/0"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.remove_all_hyperlinks/2","doc":"Removes all hyperlinks from a worksheet.\n\nCell values and formatting are preserved, only hyperlinks are removed.","ref":"UmyaSpreadsheet.Hyperlink.html#remove_all_hyperlinks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.remove_all_hyperlinks/2","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet","ref":"UmyaSpreadsheet.Hyperlink.html#remove_all_hyperlinks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.remove_all_hyperlinks/2","doc":"- `{:ok, spreadsheet}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#remove_all_hyperlinks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.remove_all_hyperlinks/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.remove_all_hyperlinks(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.Hyperlink.html#remove_all_hyperlinks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.remove_hyperlink/3","doc":"Removes a hyperlink from a cell.\n\nThe cell value and formatting are preserved, only the hyperlink is removed.","ref":"UmyaSpreadsheet.Hyperlink.html#remove_hyperlink/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.remove_hyperlink/3","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")","ref":"UmyaSpreadsheet.Hyperlink.html#remove_hyperlink/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.remove_hyperlink/3","doc":"- `{:ok, spreadsheet}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#remove_hyperlink/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.remove_hyperlink/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.remove_hyperlink(spreadsheet, \"Sheet1\", \"A1\")","ref":"UmyaSpreadsheet.Hyperlink.html#remove_hyperlink/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Hyperlink.update_hyperlink/6","doc":"Updates an existing hyperlink in a cell.\n\nIf no hyperlink exists in the cell, this function will add a new one.","ref":"UmyaSpreadsheet.Hyperlink.html#update_hyperlink/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Hyperlink.update_hyperlink/6","doc":"- `spreadsheet`: The spreadsheet reference\n- `sheet_name`: Name of the worksheet\n- `cell_address`: Cell address (e.g., \"A1\", \"B2\")\n- `url`: The new hyperlink URL or reference\n- `tooltip`: Optional new tooltip text (default: nil)\n- `is_internal`: Whether this is an internal worksheet reference (default: false)","ref":"UmyaSpreadsheet.Hyperlink.html#update_hyperlink/6-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Hyperlink.update_hyperlink/6","doc":"- `{:ok, spreadsheet}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.Hyperlink.html#update_hyperlink/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Hyperlink.update_hyperlink/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.Hyperlink.update_hyperlink(\n      spreadsheet,\n      \"Sheet1\",\n      \"A1\",\n      \"https://newexample.com\",\n      \"Updated website link\"\n    )","ref":"UmyaSpreadsheet.Hyperlink.html#update_hyperlink/6-examples"},{"type":"module","title":"UmyaSpreadsheet.ImageFunctions","doc":"Functions for working with images in a spreadsheet.","ref":"UmyaSpreadsheet.ImageFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.ImageFunctions.add_image/4","doc":"Adds an image to a spreadsheet.","ref":"UmyaSpreadsheet.ImageFunctions.html#add_image/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ImageFunctions.add_image/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\") where the top-left corner of the image should be placed\n- `image_path` - The path to the image file","ref":"UmyaSpreadsheet.ImageFunctions.html#add_image/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ImageFunctions.add_image/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ImageFunctions.html#add_image/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ImageFunctions.add_image/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ImageFunctions.add_image(spreadsheet, \"Sheet1\", \"C5\", \"path/to/image.png\")","ref":"UmyaSpreadsheet.ImageFunctions.html#add_image/4-examples"},{"type":"function","title":"UmyaSpreadsheet.ImageFunctions.change_image/4","doc":"Changes an existing image in a spreadsheet to a new image.","ref":"UmyaSpreadsheet.ImageFunctions.html#change_image/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ImageFunctions.change_image/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\") where the image is located\n- `new_image_path` - The path to the new image file","ref":"UmyaSpreadsheet.ImageFunctions.html#change_image/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ImageFunctions.change_image/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ImageFunctions.html#change_image/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ImageFunctions.change_image/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ImageFunctions.change_image(spreadsheet, \"Sheet1\", \"C5\", \"path/to/new_image.png\")","ref":"UmyaSpreadsheet.ImageFunctions.html#change_image/4-examples"},{"type":"function","title":"UmyaSpreadsheet.ImageFunctions.download_image/4","doc":"Extracts an image from a spreadsheet and saves it to a file.","ref":"UmyaSpreadsheet.ImageFunctions.html#download_image/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ImageFunctions.download_image/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\") where the image is located\n- `output_path` - The path where the image should be saved","ref":"UmyaSpreadsheet.ImageFunctions.html#download_image/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ImageFunctions.download_image/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ImageFunctions.html#download_image/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ImageFunctions.download_image/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.ImageFunctions.download_image(spreadsheet, \"Sheet1\", \"C5\", \"extracted_image.png\")","ref":"UmyaSpreadsheet.ImageFunctions.html#download_image/4-examples"},{"type":"function","title":"UmyaSpreadsheet.ImageFunctions.get_image_dimensions/3","doc":"Gets the dimensions (width, height) of an image in a cell.","ref":"UmyaSpreadsheet.ImageFunctions.html#get_image_dimensions/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ImageFunctions.get_image_dimensions/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\") where the image is located","ref":"UmyaSpreadsheet.ImageFunctions.html#get_image_dimensions/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ImageFunctions.get_image_dimensions/3","doc":"- `{:ok, {width, height}}` where width and height are in pixels\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ImageFunctions.html#get_image_dimensions/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ImageFunctions.get_image_dimensions/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, {width, height}} = UmyaSpreadsheet.ImageFunctions.get_image_dimensions(spreadsheet, \"Sheet1\", \"C5\")","ref":"UmyaSpreadsheet.ImageFunctions.html#get_image_dimensions/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ImageFunctions.get_image_info/3","doc":"Gets comprehensive information about an image in a spreadsheet.","ref":"UmyaSpreadsheet.ImageFunctions.html#get_image_info/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ImageFunctions.get_image_info/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\") where the image is located","ref":"UmyaSpreadsheet.ImageFunctions.html#get_image_info/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ImageFunctions.get_image_info/3","doc":"- `{:ok, {name, position, width, height}}` with the image details\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ImageFunctions.html#get_image_info/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ImageFunctions.get_image_info/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, {name, pos, width, height}} = UmyaSpreadsheet.ImageFunctions.get_image_info(spreadsheet, \"Sheet1\", \"C5\")\n\n    # Print the image information\n    IO.puts(\"Image '\" <> name <>\"' at position \" <> pos <>\", dimensions: \"<>width{}\"x\"<>height<>\" pixels\")","ref":"UmyaSpreadsheet.ImageFunctions.html#get_image_info/3-examples"},{"type":"function","title":"UmyaSpreadsheet.ImageFunctions.list_images/2","doc":"Lists all images in a sheet with their positions and names.","ref":"UmyaSpreadsheet.ImageFunctions.html#list_images/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.ImageFunctions.list_images/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.ImageFunctions.html#list_images/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.ImageFunctions.list_images/2","doc":"- `{:ok, [{coordinate, image_name}, ...]}` with a list of image coordinates and names\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.ImageFunctions.html#list_images/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.ImageFunctions.list_images/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, images} = UmyaSpreadsheet.ImageFunctions.list_images(spreadsheet, \"Sheet1\")\n\n    # Print all images in the sheet\n    Enum.each(images, fn {coord, img_name} ->\n      IO.puts(\"Image '#{img_name}' at position #{coord}\")\n    end)","ref":"UmyaSpreadsheet.ImageFunctions.html#list_images/2-examples"},{"type":"module","title":"UmyaSpreadsheet.OleObjects","doc":"Functions for working with OLE (Object Linking and Embedding) objects in a spreadsheet.\n\nOLE objects allow you to embed documents and files from other applications into your\nExcel spreadsheets, such as Word documents, PowerPoint presentations, PDF files, and more.","ref":"UmyaSpreadsheet.OleObjects.html"},{"type":"module","title":"Overview - UmyaSpreadsheet.OleObjects","doc":"This module provides functionality to:\n- Create and manage collections of OLE objects\n- Add embedded objects to worksheets\n- Load and save OLE object data\n- Configure object properties and settings\n- Check object formats and requirements","ref":"UmyaSpreadsheet.OleObjects.html#module-overview"},{"type":"module","title":"Examples - UmyaSpreadsheet.OleObjects","doc":"# Create a new OLE objects collection\n    {:ok, ole_objects} = UmyaSpreadsheet.OleObjects.new_ole_objects()\n\n    # Add the collection to a worksheet\n    :ok = UmyaSpreadsheet.OleObjects.set_ole_objects(spreadsheet, \"Sheet1\", ole_objects)\n\n    # Create an OLE object from a file\n    {:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")\n\n    # Add the object to the collection\n    :ok = UmyaSpreadsheet.OleObjects.add_ole_object(ole_objects, ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#module-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.add_ole_object/2","doc":"Adds an OLE object to a collection.","ref":"UmyaSpreadsheet.OleObjects.html#add_ole_object/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.add_ole_object/2","doc":"- `ole_objects` - The OLE objects collection\n- `ole_object` - The OLE object to add","ref":"UmyaSpreadsheet.OleObjects.html#add_ole_object/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.add_ole_object/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#add_ole_object/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.add_ole_object/2","doc":"{:ok, ole_objects} = UmyaSpreadsheet.OleObjects.new_ole_objects()\n    {:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")\n    :ok = UmyaSpreadsheet.OleObjects.add_ole_object(ole_objects, ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#add_ole_object/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.determine_prog_id/1","doc":"Determines the ProgID from a file extension.","ref":"UmyaSpreadsheet.OleObjects.html#determine_prog_id/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.determine_prog_id/1","doc":"- `extension` - The file extension (without the dot)","ref":"UmyaSpreadsheet.OleObjects.html#determine_prog_id/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.determine_prog_id/1","doc":"- `string` - The appropriate ProgID for the extension","ref":"UmyaSpreadsheet.OleObjects.html#determine_prog_id/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.determine_prog_id/1","doc":"\"Word.Document.12\" = UmyaSpreadsheet.OleObjects.determine_prog_id(\"docx\")\n    \"Excel.Sheet.12\" = UmyaSpreadsheet.OleObjects.determine_prog_id(\"xlsx\")","ref":"UmyaSpreadsheet.OleObjects.html#determine_prog_id/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_embedded_object_prog_id/1","doc":"Gets the ProgID from embedded object properties.","ref":"UmyaSpreadsheet.OleObjects.html#get_embedded_object_prog_id/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_embedded_object_prog_id/1","doc":"- `properties` - The embedded object properties resource","ref":"UmyaSpreadsheet.OleObjects.html#get_embedded_object_prog_id/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_embedded_object_prog_id/1","doc":"- `{:ok, prog_id}` - The ProgID string value\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_embedded_object_prog_id/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_embedded_object_prog_id/1","doc":"{:ok, properties} = UmyaSpreadsheet.OleObjects.get_ole_object_properties(ole_object)\n    {:ok, prog_id} = UmyaSpreadsheet.OleObjects.get_embedded_object_prog_id(properties)","ref":"UmyaSpreadsheet.OleObjects.html#get_embedded_object_prog_id/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_embedded_object_shape_id/1","doc":"Gets the shape ID from embedded object properties.","ref":"UmyaSpreadsheet.OleObjects.html#get_embedded_object_shape_id/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_embedded_object_shape_id/1","doc":"- `properties` - The embedded object properties resource","ref":"UmyaSpreadsheet.OleObjects.html#get_embedded_object_shape_id/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_embedded_object_shape_id/1","doc":"- `{:ok, shape_id}` - The shape ID number\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_embedded_object_shape_id/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_embedded_object_shape_id/1","doc":"{:ok, properties} = UmyaSpreadsheet.OleObjects.get_ole_object_properties(ole_object)\n    {:ok, shape_id} = UmyaSpreadsheet.OleObjects.get_embedded_object_shape_id(properties)","ref":"UmyaSpreadsheet.OleObjects.html#get_embedded_object_shape_id/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_ole_object_data/1","doc":"Gets the binary data from an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_data/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_ole_object_data/1","doc":"- `ole_object` - The OLE object resource","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_data/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_ole_object_data/1","doc":"- `{:ok, data}` - The binary data\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_data/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_ole_object_data/1","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")\n    {:ok, data} = UmyaSpreadsheet.OleObjects.get_ole_object_data(ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_data/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_ole_object_extension/1","doc":"Gets the file extension from an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_extension/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_ole_object_extension/1","doc":"- `ole_object` - The OLE object resource","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_extension/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_ole_object_extension/1","doc":"- `{:ok, extension}` - The file extension string\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_extension/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_ole_object_extension/1","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")\n    {:ok, extension} = UmyaSpreadsheet.OleObjects.get_ole_object_extension(ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_extension/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_ole_object_prog_id/1","doc":"Gets the ProgID from an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_prog_id/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_ole_object_prog_id/1","doc":"- `ole_object` - The OLE object resource","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_prog_id/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_ole_object_prog_id/1","doc":"- `{:ok, prog_id}` - The ProgID string value\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_prog_id/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_ole_object_prog_id/1","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")\n    {:ok, prog_id} = UmyaSpreadsheet.OleObjects.get_ole_object_prog_id(ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_prog_id/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_ole_object_properties/1","doc":"Gets the properties of an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_properties/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_ole_object_properties/1","doc":"- `ole_object` - The OLE object resource","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_properties/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_ole_object_properties/1","doc":"- `{:ok, properties}` - The embedded object properties resource\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_properties/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_ole_object_properties/1","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")\n    {:ok, properties} = UmyaSpreadsheet.OleObjects.get_ole_object_properties(ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_properties/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_ole_object_requires/1","doc":"Gets the 'requires' attribute from an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_requires/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_ole_object_requires/1","doc":"- `ole_object` - The OLE object resource","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_requires/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_ole_object_requires/1","doc":"- `{:ok, requires}` - The requires string value\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_requires/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_ole_object_requires/1","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")\n    {:ok, requires} = UmyaSpreadsheet.OleObjects.get_ole_object_requires(ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_object_requires/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_ole_objects_count/1","doc":"Gets the count of OLE objects in a collection.","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_objects_count/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_ole_objects_count/1","doc":"- `ole_objects` - The OLE objects collection","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_objects_count/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_ole_objects_count/1","doc":"- `{:ok, count}` - Number of OLE objects in the collection\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_objects_count/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_ole_objects_count/1","doc":"{:ok, ole_objects} = UmyaSpreadsheet.OleObjects.get_ole_objects_from_worksheet(spreadsheet, \"Sheet1\")\n    {:ok, count} = UmyaSpreadsheet.OleObjects.get_ole_objects_count(ole_objects)","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_objects_count/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.get_ole_objects_from_worksheet/2","doc":"Gets the OLE objects collection from a worksheet.","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_objects_from_worksheet/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.get_ole_objects_from_worksheet/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the worksheet","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_objects_from_worksheet/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.get_ole_objects_from_worksheet/2","doc":"- `{:ok, ole_objects}` - The OLE objects collection from the worksheet\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_objects_from_worksheet/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.get_ole_objects_from_worksheet/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, ole_objects} = UmyaSpreadsheet.OleObjects.get_ole_objects_from_worksheet(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.OleObjects.html#get_ole_objects_from_worksheet/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.has_ole_objects/1","doc":"Checks if an OLE objects collection has any objects.","ref":"UmyaSpreadsheet.OleObjects.html#has_ole_objects/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.has_ole_objects/1","doc":"- `ole_objects` - The OLE objects collection","ref":"UmyaSpreadsheet.OleObjects.html#has_ole_objects/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.has_ole_objects/1","doc":"- `{:ok, boolean}` - true if collection has objects, false otherwise\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#has_ole_objects/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.has_ole_objects/1","doc":"{:ok, ole_objects} = UmyaSpreadsheet.OleObjects.get_ole_objects_from_worksheet(spreadsheet, \"Sheet1\")\n    {:ok, has_objects} = UmyaSpreadsheet.OleObjects.has_ole_objects(ole_objects)","ref":"UmyaSpreadsheet.OleObjects.html#has_ole_objects/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.is_ole_object_binary_format/1","doc":"Checks if an OLE object is in binary format.","ref":"UmyaSpreadsheet.OleObjects.html#is_ole_object_binary_format/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.is_ole_object_binary_format/1","doc":"- `ole_object` - The OLE object resource","ref":"UmyaSpreadsheet.OleObjects.html#is_ole_object_binary_format/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.is_ole_object_binary_format/1","doc":"- `{:ok, boolean}` - true if in binary format, false otherwise\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#is_ole_object_binary_format/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.is_ole_object_binary_format/1","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")\n    {:ok, is_binary} = UmyaSpreadsheet.OleObjects.is_ole_object_binary_format(ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#is_ole_object_binary_format/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.is_ole_object_excel_format/1","doc":"Checks if an OLE object is in Excel format.","ref":"UmyaSpreadsheet.OleObjects.html#is_ole_object_excel_format/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.is_ole_object_excel_format/1","doc":"- `ole_object` - The OLE object resource","ref":"UmyaSpreadsheet.OleObjects.html#is_ole_object_excel_format/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.is_ole_object_excel_format/1","doc":"- `{:ok, boolean}` - true if in Excel format, false otherwise\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#is_ole_object_excel_format/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.is_ole_object_excel_format/1","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"spreadsheet.xlsx\")\n    {:ok, is_excel} = UmyaSpreadsheet.OleObjects.is_ole_object_excel_format(ole_object)","ref":"UmyaSpreadsheet.OleObjects.html#is_ole_object_excel_format/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.list_ole_objects/1","doc":"Lists all OLE objects in a collection.","ref":"UmyaSpreadsheet.OleObjects.html#list_ole_objects/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.list_ole_objects/1","doc":"- `ole_objects` - The OLE objects collection","ref":"UmyaSpreadsheet.OleObjects.html#list_ole_objects/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.list_ole_objects/1","doc":"- `{:ok, objects_list}` - List of OLE object resources\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#list_ole_objects/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.list_ole_objects/1","doc":"{:ok, ole_objects} = UmyaSpreadsheet.OleObjects.get_ole_objects_from_worksheet(spreadsheet, \"Sheet1\")\n    {:ok, objects_list} = UmyaSpreadsheet.OleObjects.list_ole_objects(ole_objects)","ref":"UmyaSpreadsheet.OleObjects.html#list_ole_objects/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.load_ole_object_from_file/2","doc":"Loads an OLE object from a file.\nNote: This function signature differs from the underlying NIF which takes (file_path, prog_id).","ref":"UmyaSpreadsheet.OleObjects.html#load_ole_object_from_file/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.load_ole_object_from_file/2","doc":"- `ole_object` - This parameter is ignored for this function\n- `file_path` - Path to the file to load","ref":"UmyaSpreadsheet.OleObjects.html#load_ole_object_from_file/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.load_ole_object_from_file/2","doc":"- `{:ok, ole_object}` - A new OLE object with file data loaded\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#load_ole_object_from_file/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.load_ole_object_from_file/2","doc":"# This creates a new OLE object rather than loading into an existing one\n    {:ok, ole_object} = UmyaSpreadsheet.OleObjects.load_ole_object_from_file(nil, \"document.docx\")","ref":"UmyaSpreadsheet.OleObjects.html#load_ole_object_from_file/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.new_embedded_object_properties/0","doc":"Creates new embedded object properties.","ref":"UmyaSpreadsheet.OleObjects.html#new_embedded_object_properties/0"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.new_embedded_object_properties/0","doc":"- `{:ok, properties}` - A new embedded object properties resource\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#new_embedded_object_properties/0-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.new_embedded_object_properties/0","doc":"{:ok, properties} = UmyaSpreadsheet.OleObjects.new_embedded_object_properties()","ref":"UmyaSpreadsheet.OleObjects.html#new_embedded_object_properties/0-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.new_ole_object/0","doc":"Creates a new OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object/0"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.new_ole_object/0","doc":"- `{:ok, ole_object}` - A new OLE object resource\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object/0-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.new_ole_object/0","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object()","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object/0-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.new_ole_object_from_file/1","doc":"Creates a new OLE object and loads data from a file.","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object_from_file/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.new_ole_object_from_file/1","doc":"- `file_path` - Path to the file to embed","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object_from_file/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.new_ole_object_from_file/1","doc":"- `{:ok, ole_object}` - A new OLE object with file data loaded\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object_from_file/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.new_ole_object_from_file/1","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"document.docx\")","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object_from_file/1-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.new_ole_object_with_data/2","doc":"Creates a new OLE object with binary data.","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object_with_data/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.new_ole_object_with_data/2","doc":"- `data` - Binary data to embed\n- `file_extension` - File extension (e.g., \"docx\", \"pptx\")","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object_with_data/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.new_ole_object_with_data/2","doc":"- `{:ok, ole_object}` - A new OLE object with the provided data\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object_with_data/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.new_ole_object_with_data/2","doc":"data = File.read!(\"document.docx\")\n    {:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_with_data(data, \"docx\")","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_object_with_data/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.new_ole_objects/0","doc":"Creates a new OLE objects collection.","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_objects/0"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.new_ole_objects/0","doc":"- `{:ok, ole_objects}` - A new OLE objects collection resource\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_objects/0-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.new_ole_objects/0","doc":"{:ok, ole_objects} = UmyaSpreadsheet.OleObjects.new_ole_objects()","ref":"UmyaSpreadsheet.OleObjects.html#new_ole_objects/0-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.save_ole_object_to_file/2","doc":"Saves an OLE object to a file.","ref":"UmyaSpreadsheet.OleObjects.html#save_ole_object_to_file/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.save_ole_object_to_file/2","doc":"- `ole_object` - The OLE object resource\n- `file_path` - Path where the file should be saved","ref":"UmyaSpreadsheet.OleObjects.html#save_ole_object_to_file/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.save_ole_object_to_file/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#save_ole_object_to_file/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.save_ole_object_to_file/2","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object_from_file(\"input.docx\")\n    :ok = UmyaSpreadsheet.OleObjects.save_ole_object_to_file(ole_object, \"output.docx\")","ref":"UmyaSpreadsheet.OleObjects.html#save_ole_object_to_file/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.set_embedded_object_prog_id/2","doc":"Sets the ProgID for embedded object properties.","ref":"UmyaSpreadsheet.OleObjects.html#set_embedded_object_prog_id/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.set_embedded_object_prog_id/2","doc":"- `properties` - The embedded object properties resource\n- `prog_id` - The ProgID string value","ref":"UmyaSpreadsheet.OleObjects.html#set_embedded_object_prog_id/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.set_embedded_object_prog_id/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#set_embedded_object_prog_id/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.set_embedded_object_prog_id/2","doc":"{:ok, properties} = UmyaSpreadsheet.OleObjects.new_embedded_object_properties()\n    :ok = UmyaSpreadsheet.OleObjects.set_embedded_object_prog_id(properties, \"Word.Document.12\")","ref":"UmyaSpreadsheet.OleObjects.html#set_embedded_object_prog_id/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.set_embedded_object_shape_id/2","doc":"Sets the shape ID for embedded object properties.","ref":"UmyaSpreadsheet.OleObjects.html#set_embedded_object_shape_id/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.set_embedded_object_shape_id/2","doc":"- `properties` - The embedded object properties resource\n- `shape_id` - The shape ID number","ref":"UmyaSpreadsheet.OleObjects.html#set_embedded_object_shape_id/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.set_embedded_object_shape_id/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#set_embedded_object_shape_id/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.set_embedded_object_shape_id/2","doc":"{:ok, properties} = UmyaSpreadsheet.OleObjects.new_embedded_object_properties()\n    :ok = UmyaSpreadsheet.OleObjects.set_embedded_object_shape_id(properties, 1)","ref":"UmyaSpreadsheet.OleObjects.html#set_embedded_object_shape_id/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.set_ole_object_data/2","doc":"Sets the binary data for an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_data/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.set_ole_object_data/2","doc":"- `ole_object` - The OLE object resource\n- `data` - The binary data to set","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_data/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.set_ole_object_data/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_data/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.set_ole_object_data/2","doc":"data = File.read!(\"document.docx\")\n    {:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object()\n    :ok = UmyaSpreadsheet.OleObjects.set_ole_object_data(ole_object, data)","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_data/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.set_ole_object_extension/2","doc":"Sets the file extension for an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_extension/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.set_ole_object_extension/2","doc":"- `ole_object` - The OLE object resource\n- `extension` - The file extension string","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_extension/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.set_ole_object_extension/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_extension/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.set_ole_object_extension/2","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object()\n    :ok = UmyaSpreadsheet.OleObjects.set_ole_object_extension(ole_object, \"docx\")","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_extension/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.set_ole_object_prog_id/2","doc":"Sets the ProgID for an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_prog_id/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.set_ole_object_prog_id/2","doc":"- `ole_object` - The OLE object resource\n- `prog_id` - The ProgID string value","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_prog_id/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.set_ole_object_prog_id/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_prog_id/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.set_ole_object_prog_id/2","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object()\n    :ok = UmyaSpreadsheet.OleObjects.set_ole_object_prog_id(ole_object, \"Word.Document.12\")","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_prog_id/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.set_ole_object_properties/2","doc":"Sets the properties for an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_properties/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.set_ole_object_properties/2","doc":"- `ole_object` - The OLE object resource\n- `properties` - The embedded object properties resource","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_properties/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.set_ole_object_properties/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_properties/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.set_ole_object_properties/2","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object()\n    {:ok, properties} = UmyaSpreadsheet.OleObjects.new_embedded_object_properties()\n    :ok = UmyaSpreadsheet.OleObjects.set_ole_object_properties(ole_object, properties)","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_properties/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.set_ole_object_requires/2","doc":"Sets the 'requires' attribute for an OLE object.","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_requires/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.set_ole_object_requires/2","doc":"- `ole_object` - The OLE object resource\n- `requires` - The requires string value","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_requires/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.set_ole_object_requires/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_requires/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.set_ole_object_requires/2","doc":"{:ok, ole_object} = UmyaSpreadsheet.OleObjects.new_ole_object()\n    :ok = UmyaSpreadsheet.OleObjects.set_ole_object_requires(ole_object, \"application\")","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_object_requires/2-examples"},{"type":"function","title":"UmyaSpreadsheet.OleObjects.set_ole_objects_to_worksheet/3","doc":"Sets the OLE objects collection for a worksheet.","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_objects_to_worksheet/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.OleObjects.set_ole_objects_to_worksheet/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the worksheet\n- `ole_objects` - The OLE objects collection resource","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_objects_to_worksheet/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.OleObjects.set_ole_objects_to_worksheet/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_objects_to_worksheet/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.OleObjects.set_ole_objects_to_worksheet/3","doc":"{:ok, ole_objects} = UmyaSpreadsheet.OleObjects.new_ole_objects()\n    :ok = UmyaSpreadsheet.OleObjects.set_ole_objects_to_worksheet(spreadsheet, \"Sheet1\", ole_objects)","ref":"UmyaSpreadsheet.OleObjects.html#set_ole_objects_to_worksheet/3-examples"},{"type":"module","title":"UmyaSpreadsheet.PageBreaks","doc":"Functions for managing page breaks in worksheets.\n\nPage breaks control where pages split when printing or viewing in Page Break Preview.\nExcel supports both manual (user-defined) and automatic page breaks.","ref":"UmyaSpreadsheet.PageBreaks.html"},{"type":"module","title":"Manual vs Automatic Page Breaks - UmyaSpreadsheet.PageBreaks","doc":"- **Manual page breaks**: Explicitly set by the user and remain fixed\n- **Automatic page breaks**: Calculated by Excel based on page size and content\n\nManual page breaks have priority over automatic ones and are useful for:\n- Ensuring specific sections appear on separate pages\n- Creating consistent report layouts\n- Controlling print output formatting","ref":"UmyaSpreadsheet.PageBreaks.html#module-manual-vs-automatic-page-breaks"},{"type":"module","title":"Usage - UmyaSpreadsheet.PageBreaks","doc":"Page breaks are identified by row or column numbers:\n- Row page breaks: Insert a horizontal page break above the specified row\n- Column page breaks: Insert a vertical page break to the left of the specified column\n\nAll functions require a valid sheet name and will return `{:error, :sheet_not_found}`\nif the sheet doesn't exist.","ref":"UmyaSpreadsheet.PageBreaks.html#module-usage"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.add_column_page_break/4","doc":"Adds a manual column page break at the specified column number.\n\nA column page break creates a vertical line where pages split. The break is inserted\nto the left of the specified column, meaning content from that column onwards will\nappear on a new page.","ref":"UmyaSpreadsheet.PageBreaks.html#add_column_page_break/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.add_column_page_break/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column_number` - The column number where the page break should be inserted (1-based)\n- `manual` - Whether this is a manual page break (default: true)","ref":"UmyaSpreadsheet.PageBreaks.html#add_column_page_break/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.add_column_page_break/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#add_column_page_break/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.add_column_page_break/4","doc":"# Add a manual page break to the left of column 10 (column J)\n    :ok = UmyaSpreadsheet.PageBreaks.add_column_page_break(spreadsheet, \"Sheet1\", 10)\n\n    # Add an automatic page break to the left of column 15 (column O)\n    :ok = UmyaSpreadsheet.PageBreaks.add_column_page_break(spreadsheet, \"Sheet1\", 15, false)","ref":"UmyaSpreadsheet.PageBreaks.html#add_column_page_break/4-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.add_column_page_breaks/3","doc":"Adds multiple column page breaks in a single operation for better performance.\n\nThis function efficiently adds multiple column page breaks without needing separate\ncalls for each break. All breaks are added as manual page breaks.","ref":"UmyaSpreadsheet.PageBreaks.html#add_column_page_breaks/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.add_column_page_breaks/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column_numbers` - A list of column numbers where page breaks should be inserted (1-based)","ref":"UmyaSpreadsheet.PageBreaks.html#add_column_page_breaks/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.add_column_page_breaks/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#add_column_page_breaks/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.add_column_page_breaks/3","doc":"# Add page breaks before columns 5, 10, and 15\n    :ok = UmyaSpreadsheet.PageBreaks.add_column_page_breaks(spreadsheet, \"Sheet1\", [5, 10, 15])\n\n    # Add page breaks for different data sections\n    section_columns = [6, 12, 18, 24]\n    :ok = UmyaSpreadsheet.PageBreaks.add_column_page_breaks(spreadsheet, \"Data\", section_columns)","ref":"UmyaSpreadsheet.PageBreaks.html#add_column_page_breaks/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.add_row_page_break/4","doc":"Adds a manual row page break at the specified row number.\n\nA row page break creates a horizontal line where pages split. The break is inserted\nabove the specified row, meaning content from that row onwards will appear on a new page.","ref":"UmyaSpreadsheet.PageBreaks.html#add_row_page_break/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.add_row_page_break/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_number` - The row number where the page break should be inserted (1-based)\n- `manual` - Whether this is a manual page break (default: true)","ref":"UmyaSpreadsheet.PageBreaks.html#add_row_page_break/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.add_row_page_break/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#add_row_page_break/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.add_row_page_break/4","doc":"# Add a manual page break above row 25\n    :ok = UmyaSpreadsheet.PageBreaks.add_row_page_break(spreadsheet, \"Sheet1\", 25)\n\n    # Add an automatic page break above row 50\n    :ok = UmyaSpreadsheet.PageBreaks.add_row_page_break(spreadsheet, \"Sheet1\", 50, false)","ref":"UmyaSpreadsheet.PageBreaks.html#add_row_page_break/4-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.add_row_page_breaks/3","doc":"Adds multiple row page breaks in a single operation for better performance.\n\nThis function efficiently adds multiple row page breaks without needing separate\ncalls for each break. All breaks are added as manual page breaks.","ref":"UmyaSpreadsheet.PageBreaks.html#add_row_page_breaks/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.add_row_page_breaks/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_numbers` - A list of row numbers where page breaks should be inserted (1-based)","ref":"UmyaSpreadsheet.PageBreaks.html#add_row_page_breaks/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.add_row_page_breaks/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#add_row_page_breaks/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.add_row_page_breaks/3","doc":"# Add page breaks above rows 10, 20, and 30\n    :ok = UmyaSpreadsheet.PageBreaks.add_row_page_breaks(spreadsheet, \"Sheet1\", [10, 20, 30])\n\n    # Add page breaks for section headers\n    section_rows = [15, 45, 75, 105]\n    :ok = UmyaSpreadsheet.PageBreaks.add_row_page_breaks(spreadsheet, \"Reports\", section_rows)","ref":"UmyaSpreadsheet.PageBreaks.html#add_row_page_breaks/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.clear_all_page_breaks/2","doc":"Clears all page breaks (both row and column) from the specified sheet.\n\nThis is a convenience function that removes all manual page breaks from a worksheet,\neffectively resetting the page break layout to automatic only.","ref":"UmyaSpreadsheet.PageBreaks.html#clear_all_page_breaks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.clear_all_page_breaks/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PageBreaks.html#clear_all_page_breaks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.clear_all_page_breaks/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#clear_all_page_breaks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.clear_all_page_breaks/2","doc":"# Clear all page breaks from a sheet\n    :ok = UmyaSpreadsheet.PageBreaks.clear_all_page_breaks(spreadsheet, \"Sheet1\")\n\n    # Reset page breaks when reformatting a report\n    :ok = UmyaSpreadsheet.PageBreaks.clear_all_page_breaks(spreadsheet, \"Monthly Report\")","ref":"UmyaSpreadsheet.PageBreaks.html#clear_all_page_breaks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.clear_column_page_breaks/2","doc":"Clears all column page breaks for the specified sheet.\n\nThis removes both manual and automatic column page breaks.","ref":"UmyaSpreadsheet.PageBreaks.html#clear_column_page_breaks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.clear_column_page_breaks/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PageBreaks.html#clear_column_page_breaks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.clear_column_page_breaks/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#clear_column_page_breaks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.clear_column_page_breaks/2","doc":"# Clear all column page breaks\n    :ok = UmyaSpreadsheet.PageBreaks.clear_column_page_breaks(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PageBreaks.html#clear_column_page_breaks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.clear_row_page_breaks/2","doc":"Clears all row page breaks for the specified sheet.\n\nThis removes both manual and automatic row page breaks.","ref":"UmyaSpreadsheet.PageBreaks.html#clear_row_page_breaks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.clear_row_page_breaks/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PageBreaks.html#clear_row_page_breaks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.clear_row_page_breaks/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#clear_row_page_breaks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.clear_row_page_breaks/2","doc":"# Clear all row page breaks\n    :ok = UmyaSpreadsheet.PageBreaks.clear_row_page_breaks(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PageBreaks.html#clear_row_page_breaks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.count_column_page_breaks/2","doc":"Gets the count of column page breaks for the specified sheet.","ref":"UmyaSpreadsheet.PageBreaks.html#count_column_page_breaks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.count_column_page_breaks/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PageBreaks.html#count_column_page_breaks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.count_column_page_breaks/2","doc":"- `{:ok, count}` on success, where count is the number of column page breaks\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#count_column_page_breaks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.count_column_page_breaks/2","doc":"{:ok, count} = UmyaSpreadsheet.PageBreaks.count_column_page_breaks(spreadsheet, \"Sheet1\")\n    IO.puts(\"Total column page breaks: #{count}\")","ref":"UmyaSpreadsheet.PageBreaks.html#count_column_page_breaks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.count_row_page_breaks/2","doc":"Gets the count of row page breaks for the specified sheet.","ref":"UmyaSpreadsheet.PageBreaks.html#count_row_page_breaks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.count_row_page_breaks/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PageBreaks.html#count_row_page_breaks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.count_row_page_breaks/2","doc":"- `{:ok, count}` on success, where count is the number of row page breaks\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#count_row_page_breaks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.count_row_page_breaks/2","doc":"{:ok, count} = UmyaSpreadsheet.PageBreaks.count_row_page_breaks(spreadsheet, \"Sheet1\")\n    IO.puts(\"Total row page breaks: #{count}\")","ref":"UmyaSpreadsheet.PageBreaks.html#count_row_page_breaks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.get_all_page_breaks/2","doc":"Gets all page breaks (both row and column) for the specified sheet in a single result.\n\nThis convenience function retrieves both row and column page breaks, returning them\nin a structured format for easy access to all page break information.","ref":"UmyaSpreadsheet.PageBreaks.html#get_all_page_breaks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.get_all_page_breaks/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PageBreaks.html#get_all_page_breaks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.get_all_page_breaks/2","doc":"- `{:ok, %{row_breaks: [row_numbers], column_breaks: [column_numbers]}}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#get_all_page_breaks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.get_all_page_breaks/2","doc":"{:ok, %{row_breaks: rows, column_breaks: cols}} =\n      UmyaSpreadsheet.PageBreaks.get_all_page_breaks(spreadsheet, \"Sheet1\")\n\n    IO.puts(\"Row breaks at: #{inspect(rows)}\")\n    IO.puts(\"Column breaks at: #{inspect(cols)}\")\n\n    # Check if any page breaks exist\n    {:ok, breaks} = UmyaSpreadsheet.PageBreaks.get_all_page_breaks(spreadsheet, \"Report\")\n    has_breaks = length(breaks.row_breaks) > 0 or length(breaks.column_breaks) > 0","ref":"UmyaSpreadsheet.PageBreaks.html#get_all_page_breaks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.get_column_page_breaks/2","doc":"Gets all column page breaks for the specified sheet.\n\nReturns a list of tuples containing the column number and whether it's a manual page break.","ref":"UmyaSpreadsheet.PageBreaks.html#get_column_page_breaks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.get_column_page_breaks/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PageBreaks.html#get_column_page_breaks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.get_column_page_breaks/2","doc":"- `{:ok, breaks}` on success, where breaks is a list of `{column_number, is_manual}` tuples\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#get_column_page_breaks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.get_column_page_breaks/2","doc":"# Get all column page breaks\n    {:ok, breaks} = UmyaSpreadsheet.PageBreaks.get_column_page_breaks(spreadsheet, \"Sheet1\")\n    # breaks might be: [{10, true}, {20, false}]\n\n    # Get only manual column breaks\n    manual_breaks = Enum.filter(breaks, fn {_col, manual} -> manual end)","ref":"UmyaSpreadsheet.PageBreaks.html#get_column_page_breaks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.get_row_page_breaks/2","doc":"Gets all row page breaks for the specified sheet.\n\nReturns a list of tuples containing the row number and whether it's a manual page break.","ref":"UmyaSpreadsheet.PageBreaks.html#get_row_page_breaks/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.get_row_page_breaks/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PageBreaks.html#get_row_page_breaks/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.get_row_page_breaks/2","doc":"- `{:ok, breaks}` on success, where breaks is a list of `{row_number, is_manual}` tuples\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#get_row_page_breaks/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.get_row_page_breaks/2","doc":"# Get all row page breaks\n    {:ok, breaks} = UmyaSpreadsheet.PageBreaks.get_row_page_breaks(spreadsheet, \"Sheet1\")\n    # breaks might be: [{25, true}, {50, false}, {75, true}]\n\n    # Check if there are any manual breaks\n    manual_breaks = Enum.filter(breaks, fn {_row, manual} -> manual end)","ref":"UmyaSpreadsheet.PageBreaks.html#get_row_page_breaks/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.has_column_page_break/3","doc":"Checks if a column page break exists at the specified column number.","ref":"UmyaSpreadsheet.PageBreaks.html#has_column_page_break/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.has_column_page_break/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column_number` - The column number to check (1-based)","ref":"UmyaSpreadsheet.PageBreaks.html#has_column_page_break/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.has_column_page_break/3","doc":"- `{:ok, true}` if a page break exists at the column\n- `{:ok, false}` if no page break exists at the column\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#has_column_page_break/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.has_column_page_break/3","doc":"# Check if there's a page break to the left of column 10\n    {:ok, has_break} = UmyaSpreadsheet.PageBreaks.has_column_page_break(spreadsheet, \"Sheet1\", 10)\n\n    if has_break do\n      IO.puts(\"Page break found at column 10\")\n    end","ref":"UmyaSpreadsheet.PageBreaks.html#has_column_page_break/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.has_row_page_break/3","doc":"Checks if a row page break exists at the specified row number.","ref":"UmyaSpreadsheet.PageBreaks.html#has_row_page_break/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.has_row_page_break/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_number` - The row number to check (1-based)","ref":"UmyaSpreadsheet.PageBreaks.html#has_row_page_break/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.has_row_page_break/3","doc":"- `{:ok, true}` if a page break exists at the row\n- `{:ok, false}` if no page break exists at the row\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#has_row_page_break/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.has_row_page_break/3","doc":"# Check if there's a page break above row 25\n    {:ok, has_break} = UmyaSpreadsheet.PageBreaks.has_row_page_break(spreadsheet, \"Sheet1\", 25)\n\n    if has_break do\n      IO.puts(\"Page break found at row 25\")\n    end","ref":"UmyaSpreadsheet.PageBreaks.html#has_row_page_break/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.remove_column_page_break/3","doc":"Removes a column page break at the specified column number.","ref":"UmyaSpreadsheet.PageBreaks.html#remove_column_page_break/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.remove_column_page_break/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column_number` - The column number where the page break should be removed (1-based)","ref":"UmyaSpreadsheet.PageBreaks.html#remove_column_page_break/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.remove_column_page_break/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#remove_column_page_break/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.remove_column_page_break/3","doc":"# Remove page break to the left of column 10\n    :ok = UmyaSpreadsheet.PageBreaks.remove_column_page_break(spreadsheet, \"Sheet1\", 10)","ref":"UmyaSpreadsheet.PageBreaks.html#remove_column_page_break/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.remove_column_page_breaks/3","doc":"Removes multiple column page breaks efficiently in a single operation.\n\nThis function efficiently removes multiple column page breaks without needing separate\ncalls for each break removal.","ref":"UmyaSpreadsheet.PageBreaks.html#remove_column_page_breaks/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.remove_column_page_breaks/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column_numbers` - A list of column numbers where page breaks should be removed (1-based)","ref":"UmyaSpreadsheet.PageBreaks.html#remove_column_page_breaks/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.remove_column_page_breaks/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#remove_column_page_breaks/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.remove_column_page_breaks/3","doc":"# Remove page breaks from specific columns\n    :ok = UmyaSpreadsheet.PageBreaks.remove_column_page_breaks(spreadsheet, \"Sheet1\", [5, 10, 15])\n\n    # Remove page breaks from old column positions\n    old_columns = [8, 16, 24]\n    :ok = UmyaSpreadsheet.PageBreaks.remove_column_page_breaks(spreadsheet, \"Data\", old_columns)","ref":"UmyaSpreadsheet.PageBreaks.html#remove_column_page_breaks/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.remove_row_page_break/3","doc":"Removes a row page break at the specified row number.","ref":"UmyaSpreadsheet.PageBreaks.html#remove_row_page_break/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.remove_row_page_break/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_number` - The row number where the page break should be removed (1-based)","ref":"UmyaSpreadsheet.PageBreaks.html#remove_row_page_break/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.remove_row_page_break/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#remove_row_page_break/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.remove_row_page_break/3","doc":"# Remove page break above row 25\n    :ok = UmyaSpreadsheet.PageBreaks.remove_row_page_break(spreadsheet, \"Sheet1\", 25)","ref":"UmyaSpreadsheet.PageBreaks.html#remove_row_page_break/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PageBreaks.remove_row_page_breaks/3","doc":"Removes multiple row page breaks efficiently in a single operation.\n\nThis function efficiently removes multiple row page breaks without needing separate\ncalls for each break removal.","ref":"UmyaSpreadsheet.PageBreaks.html#remove_row_page_breaks/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PageBreaks.remove_row_page_breaks/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_numbers` - A list of row numbers where page breaks should be removed (1-based)","ref":"UmyaSpreadsheet.PageBreaks.html#remove_row_page_breaks/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PageBreaks.remove_row_page_breaks/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PageBreaks.html#remove_row_page_breaks/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PageBreaks.remove_row_page_breaks/3","doc":"# Remove page breaks from specific rows\n    :ok = UmyaSpreadsheet.PageBreaks.remove_row_page_breaks(spreadsheet, \"Sheet1\", [10, 20, 30])\n\n    # Remove page breaks from old section positions\n    old_sections = [25, 50, 75]\n    :ok = UmyaSpreadsheet.PageBreaks.remove_row_page_breaks(spreadsheet, \"Reports\", old_sections)","ref":"UmyaSpreadsheet.PageBreaks.html#remove_row_page_breaks/3-examples"},{"type":"module","title":"UmyaSpreadsheet.PerformanceFunctions","doc":"Functions for optimized file writing with reduced memory usage.","ref":"UmyaSpreadsheet.PerformanceFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.PerformanceFunctions.write_light/2","doc":"Writes a spreadsheet to a file with reduced memory consumption.\n\nThis variant is suitable for very large spreadsheets that would otherwise\nexceed memory limits when written with the standard `write/2` function.","ref":"UmyaSpreadsheet.PerformanceFunctions.html#write_light/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PerformanceFunctions.write_light/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `path` - Path where the file should be written","ref":"UmyaSpreadsheet.PerformanceFunctions.html#write_light/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PerformanceFunctions.write_light/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PerformanceFunctions.html#write_light/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PerformanceFunctions.write_light/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.write_light(spreadsheet, \"large_file.xlsx\")","ref":"UmyaSpreadsheet.PerformanceFunctions.html#write_light/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PerformanceFunctions.write_with_password_light/3","doc":"Writes a password-protected spreadsheet to a file with reduced memory consumption.\n\nThis variant is suitable for very large spreadsheets that would otherwise\nexceed memory limits when written with the standard `write_with_password/3` function.","ref":"UmyaSpreadsheet.PerformanceFunctions.html#write_with_password_light/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PerformanceFunctions.write_with_password_light/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `path` - Path where the file should be written\n- `password` - Password to protect the file with","ref":"UmyaSpreadsheet.PerformanceFunctions.html#write_with_password_light/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PerformanceFunctions.write_with_password_light/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.PerformanceFunctions.html#write_with_password_light/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PerformanceFunctions.write_with_password_light/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.write_with_password_light(spreadsheet, \"protected_large_file.xlsx\", \"secret123\")","ref":"UmyaSpreadsheet.PerformanceFunctions.html#write_with_password_light/3-examples"},{"type":"module","title":"UmyaSpreadsheet.PivotTable","doc":"Functions for creating and manipulating pivot tables.\n\nPivot tables allow you to summarize and analyze large datasets quickly.\nThis module provides functions to:\n\n* Create pivot tables from data ranges\n* Configure row, column, and data fields\n* Apply formatting to pivot tables\n* Refresh pivot table data","ref":"UmyaSpreadsheet.PivotTable.html"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.add_pivot_table/9","doc":"Adds a new pivot table to a spreadsheet.","ref":"UmyaSpreadsheet.PivotTable.html#add_pivot_table/9"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.add_pivot_table/9","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet where the pivot table will be placed\n  * `name` - Name of the pivot table\n  * `source_sheet` - Name of the sheet containing the source data\n  * `source_range` - Range of cells containing the source data in A1 notation (e.g., \"A1:D10\")\n  * `target_cell` - Top-left cell for the pivot table placement\n  * `row_fields` - List of field indices (0-based) to use as row fields\n  * `column_fields` - List of field indices (0-based) to use as column fields\n  * `data_fields` - List of data field configs in the format [{field_index, \"Function\", \"Custom Name\"}]\n    where function is one of \"sum\", \"count\", \"average\", \"max\", \"min\", \"product\", \"count_nums\", \"stddev\", \"stddevp\", \"var\", \"varp\"","ref":"UmyaSpreadsheet.PivotTable.html#add_pivot_table/9-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.add_pivot_table/9","doc":"```elixir\n# Create a simple pivot table from data in sheet \"Data\"\nPivotTable.add_pivot_table(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Sales Analysis\",\n  \"Data\",\n  \"A1:D100\",\n  \"A3\",\n  [0], # Use first column (Region) as row field\n  [1], # Use second column (Product) as column field\n  [{2, \"sum\", \"Total Sales\"}] # Sum the third column (Sales) as data field\n)\n```","ref":"UmyaSpreadsheet.PivotTable.html#add_pivot_table/9-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.add_pivot_table_data_field/7","doc":"Adds a new data field to an existing pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#add_pivot_table_data_field/7"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.add_pivot_table_data_field/7","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table\n  * `field_name` - Name for the new data field\n  * `field_id` - Index of the source field (0-based)\n  * `base_field_id` - Optional base field ID for calculated fields\n  * `base_item` - Optional base item for calculated fields","ref":"UmyaSpreadsheet.PivotTable.html#add_pivot_table_data_field/7-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.add_pivot_table_data_field/7","doc":"* `:ok` - Field was added successfully\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#add_pivot_table_data_field/7-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.add_pivot_table_data_field/7","doc":"# Add a new data field for \"Sum of Sales\"\n    :ok = PivotTable.add_pivot_table_data_field(\n      spreadsheet,\n      \"PivotSheet\",\n      \"Sales Analysis\",\n      \"Sum of Sales\",\n      2,  # Field index 2 (Sales column)\n      nil,\n      nil\n    )","ref":"UmyaSpreadsheet.PivotTable.html#add_pivot_table_data_field/7-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.count_pivot_tables/2","doc":"Gets the number of pivot tables in a sheet.","ref":"UmyaSpreadsheet.PivotTable.html#count_pivot_tables/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.count_pivot_tables/2","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet to check","ref":"UmyaSpreadsheet.PivotTable.html#count_pivot_tables/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.count_pivot_tables/2","doc":"```elixir\n# Get number of pivot tables\ncount = PivotTable.count_pivot_tables(spreadsheet, \"Sheet1\")\n```","ref":"UmyaSpreadsheet.PivotTable.html#count_pivot_tables/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_cache_field/4","doc":"Gets detailed information about a specific cache field in a pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_field/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_field/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table\n  * `field_index` - Index of the field to get (0-based)","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_field/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_field/4","doc":"* `{:ok, {name, format_id, shared_items}}` - Details for the requested field\n    * `name` - Field name\n    * `format_id` - Number format ID for the field\n    * `shared_items` - List of unique values in this field\n  * `{:error, atom()}` - Error if sheet, pivot table, or field doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_field/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_field/4","doc":"# Get details for the first cache field\n    case PivotTable.get_pivot_table_cache_field(spreadsheet, \"Sheet1\", \"Sales Analysis\", 0) do\n      {:ok, {name, _, items}} ->\n        IO.puts(\"Field: \" <> name)\n        IO.puts(\"Unique values: \" <> inspect(items))\n      {:error, reason} ->\n        IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_field/4-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_cache_fields/3","doc":"Gets all cache fields from a pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_fields/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_fields/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_fields/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_fields/3","doc":"* `{:ok, fields}` - List of cache fields with their details\n    * Each field is a tuple: {name, format_id, has_shared_items}\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_fields/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_fields/3","doc":"# Get all cache fields for a pivot table\n    case PivotTable.get_pivot_table_cache_fields(spreadsheet, \"Sheet1\", \"Sales Analysis\") do\n      {:ok, fields} ->\n        fields |> Enum.each(fn {name, _, has_items} ->\n          IO.puts(\"Field: \" <> name <> (if has_items, do: \" (has items)\", else: \"\"))\n        end)\n      {:error, reason} ->\n        IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_fields/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_cache_source/3","doc":"Gets the cache source configuration for a pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_source/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_source/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_source/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_source/3","doc":"* `{:ok, {source_type, worksheet_source}}` - Cache source details\n    * `source_type` - String describing the source type (worksheet, external, etc.)\n    * `worksheet_source` - Optional tuple of {sheet_name, range} or nil if not a worksheet source\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_source/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_cache_source/3","doc":"# Get the cache source for a pivot table\n    case PivotTable.get_pivot_table_cache_source(spreadsheet, \"Sheet1\", \"Sales Analysis\") do\n      {:ok, {\"worksheet\", {sheet, range}}} ->\n        IO.puts(\"Source data: \" <> sheet <> \"!\" <> range)\n      {:ok, {source_type, _}} ->\n        IO.puts(\"Non-worksheet source: \" <> source_type)\n      {:error, reason} ->\n        IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_cache_source/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_data_fields/3","doc":"Gets all data fields from a pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_data_fields/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_data_fields/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_data_fields/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_data_fields/3","doc":"* `{:ok, fields}` - List of data fields with their details\n    * Each field is a tuple: {name, field_id, base_field_id, base_item}\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_data_fields/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_data_fields/3","doc":"# Get all data fields for a pivot table\n    case PivotTable.get_pivot_table_data_fields(spreadsheet, \"Sheet1\", \"Sales Analysis\") do\n      {:ok, fields} ->\n        fields |> Enum.each(fn {name, field_id, _, _} ->\n          IO.puts(\"Data field: \" <> name <> \" (field: \" <> to_string(field_id) <> \")\")\n        end)\n      {:error, reason} ->\n        IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_data_fields/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_fields/3","doc":"Gets the field configuration for a pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_fields/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_fields/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_fields/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_fields/3","doc":"* `{:ok, {row_fields, column_fields, data_fields}}` - Tuple containing field configurations\n    * `row_fields` - List of field indices used as row fields\n    * `column_fields` - List of field indices used as column fields\n    * `data_fields` - List of data field configs in format [{field_index, function, custom_name}]\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_fields/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_fields/3","doc":"# Get field configuration for a pivot table\n    case PivotTable.get_pivot_table_fields(spreadsheet, \"Sheet1\", \"Sales Analysis\") do\n      {:ok, {row_fields, column_fields, data_fields}} ->\n        IO.puts(\"Row fields: \" <> inspect(row_fields))\n        IO.puts(\"Column fields: \" <> inspect(column_fields))\n        IO.puts(\"Data fields: \" <> inspect(data_fields))\n      {:error, reason} ->\n        IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_fields/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_info/3","doc":"Gets detailed information about a specific pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_info/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_info/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_info/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_info/3","doc":"* `{:ok, {name, location, source_range, cache_id}}` - Tuple containing pivot table details\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_info/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_info/3","doc":"# Get detailed info about a pivot table\n    case PivotTable.get_pivot_table_info(spreadsheet, \"Sheet1\", \"Sales Analysis\") do\n      {:ok, {name, location, source_range, cache_id}} ->\n        IO.puts(\"Name: \" <> name <> \", Location: \" <> location)\n      {:error, reason} ->\n        IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_info/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_names/2","doc":"Gets a list of all pivot table names in a sheet.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_names/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_names/2","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet to check","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_names/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_names/2","doc":"* `{:ok, [String.t()]}` - List of pivot table names\n  * `{:error, atom()}` - Error if sheet doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_names/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_names/2","doc":"# Get all pivot table names in a sheet\n    case PivotTable.get_pivot_table_names(spreadsheet, \"Sheet1\") do\n      {:ok, names} -> IO.inspect(names)\n      {:error, reason} -> IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_names/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_source_range/3","doc":"Gets the source data range for a pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_source_range/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_source_range/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_source_range/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_source_range/3","doc":"* `{:ok, {source_sheet, source_range}}` - Tuple containing source sheet name and range\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_source_range/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_source_range/3","doc":"# Get source range for a pivot table\n    case PivotTable.get_pivot_table_source_range(spreadsheet, \"Sheet1\", \"Sales Analysis\") do\n      {:ok, {source_sheet, source_range}} ->\n        IO.puts(\"Source: \" <> source_sheet <> \"!\" <> source_range)\n      {:error, reason} ->\n        IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_source_range/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.get_pivot_table_target_cell/3","doc":"Gets the target cell (top-left placement) for a pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_target_cell/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.get_pivot_table_target_cell/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_target_cell/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.get_pivot_table_target_cell/3","doc":"* `{:ok, String.t()}` - Target cell reference (e.g., \"A3\")\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_target_cell/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.get_pivot_table_target_cell/3","doc":"# Get target cell for a pivot table\n    case PivotTable.get_pivot_table_target_cell(spreadsheet, \"Sheet1\", \"Sales Analysis\") do\n      {:ok, target_cell} ->\n        IO.puts(\"Pivot table starts at: \" <> target_cell)\n      {:error, reason} ->\n        IO.puts(\"Error: \" <> inspect(reason))\n    end","ref":"UmyaSpreadsheet.PivotTable.html#get_pivot_table_target_cell/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.has_pivot_tables?/2","doc":"Checks if a sheet contains any pivot tables.","ref":"UmyaSpreadsheet.PivotTable.html#has_pivot_tables?/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.has_pivot_tables?/2","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet to check","ref":"UmyaSpreadsheet.PivotTable.html#has_pivot_tables?/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.has_pivot_tables?/2","doc":"```elixir\n# Check if a sheet has pivot tables\nif PivotTable.has_pivot_tables?(spreadsheet, \"Sheet1\") do\n  # Handle sheet with pivot tables\nend\n```","ref":"UmyaSpreadsheet.PivotTable.html#has_pivot_tables?/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.refresh_all_pivot_tables/1","doc":"Refreshes all pivot tables in a spreadsheet.","ref":"UmyaSpreadsheet.PivotTable.html#refresh_all_pivot_tables/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.refresh_all_pivot_tables/1","doc":"* `spreadsheet` - A spreadsheet struct","ref":"UmyaSpreadsheet.PivotTable.html#refresh_all_pivot_tables/1-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.refresh_all_pivot_tables/1","doc":"```elixir\n# Refresh all pivot tables\nPivotTable.refresh_all_pivot_tables(spreadsheet)\n```","ref":"UmyaSpreadsheet.PivotTable.html#refresh_all_pivot_tables/1-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.remove_pivot_table/3","doc":"Removes a pivot table from a sheet by name.","ref":"UmyaSpreadsheet.PivotTable.html#remove_pivot_table/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.remove_pivot_table/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table to remove","ref":"UmyaSpreadsheet.PivotTable.html#remove_pivot_table/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.remove_pivot_table/3","doc":"```elixir\n# Remove a specific pivot table\nPivotTable.remove_pivot_table(spreadsheet, \"Sheet1\", \"Sales Analysis\")\n```","ref":"UmyaSpreadsheet.PivotTable.html#remove_pivot_table/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PivotTable.update_pivot_table_cache/5","doc":"Updates the cache source configuration for a pivot table.","ref":"UmyaSpreadsheet.PivotTable.html#update_pivot_table_cache/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PivotTable.update_pivot_table_cache/5","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the pivot table\n  * `pivot_table_name` - Name of the pivot table\n  * `source_sheet` - Name of the sheet containing the source data\n  * `source_range` - Range of cells containing the source data (e.g., \"A1:D10\")","ref":"UmyaSpreadsheet.PivotTable.html#update_pivot_table_cache/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PivotTable.update_pivot_table_cache/5","doc":"* `:ok` - Cache was updated successfully\n  * `{:error, atom()}` - Error if sheet or pivot table doesn't exist","ref":"UmyaSpreadsheet.PivotTable.html#update_pivot_table_cache/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PivotTable.update_pivot_table_cache/5","doc":"# Update the source range for a pivot table\n    :ok = PivotTable.update_pivot_table_cache(\n      spreadsheet,\n      \"PivotSheet\",\n      \"Sales Analysis\",\n      \"DataSheet\",\n      \"A1:D20\"  # Extended range\n    )","ref":"UmyaSpreadsheet.PivotTable.html#update_pivot_table_cache/5-examples"},{"type":"module","title":"UmyaSpreadsheet.PrintSettings","doc":"Functions for configuring print settings in worksheets.","ref":"UmyaSpreadsheet.PrintSettings.html"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_fit_to_page/2","doc":"Gets the fit to page settings for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_fit_to_page/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_fit_to_page/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_fit_to_page/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_fit_to_page/2","doc":"Returns `{:ok, {fit_width, fit_height}}` where fit_width and fit_height\nare the number of pages to fit to, or `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_fit_to_page/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_fit_to_page/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, {width, height}} = UmyaSpreadsheet.get_fit_to_page(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_fit_to_page/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_footer/2","doc":"Gets the footer text for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_footer/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_footer/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_footer/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_footer/2","doc":"Returns `{:ok, footer_text}` where footer_text is the footer string,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_footer/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_footer/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, footer} = UmyaSpreadsheet.get_footer(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_footer/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_header/2","doc":"Gets the header text for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_header/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_header/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_header/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_header/2","doc":"Returns `{:ok, header_text}` where header_text is the header string,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_header/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_header/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, header} = UmyaSpreadsheet.get_header(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_header/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_header_footer_margins/2","doc":"Gets the header and footer margins for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_header_footer_margins/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_header_footer_margins/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_header_footer_margins/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_header_footer_margins/2","doc":"Returns `{:ok, {header_margin, footer_margin}}` where each value is the margin in inches,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_header_footer_margins/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_header_footer_margins/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, {header, footer}} = UmyaSpreadsheet.get_header_footer_margins(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_header_footer_margins/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_page_margins/2","doc":"Gets the page margins for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_margins/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_page_margins/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_margins/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_page_margins/2","doc":"Returns `{:ok, {top, right, bottom, left}}` where each value is the margin in inches,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_margins/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_page_margins/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, {top, right, bottom, left}} = UmyaSpreadsheet.get_page_margins(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_margins/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_page_orientation/2","doc":"Gets the page orientation for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_orientation/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_page_orientation/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_orientation/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_page_orientation/2","doc":"Returns `{:ok, orientation}` where orientation is \"portrait\" or \"landscape\",\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_orientation/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_page_orientation/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, orientation} = UmyaSpreadsheet.get_page_orientation(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_orientation/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_page_scale/2","doc":"Gets the page scale for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_scale/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_page_scale/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_scale/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_page_scale/2","doc":"Returns `{:ok, scale}` where scale is the scaling percentage,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_scale/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_page_scale/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, scale} = UmyaSpreadsheet.get_page_scale(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_page_scale/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_paper_size/2","doc":"Gets the paper size for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_paper_size/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_paper_size/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_paper_size/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_paper_size/2","doc":"Returns `{:ok, paper_size}` where paper_size is the paper size code,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_paper_size/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_paper_size/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, paper_size} = UmyaSpreadsheet.get_paper_size(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_paper_size/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_print_area/2","doc":"Gets the print area for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_area/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_print_area/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_area/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_print_area/2","doc":"Returns `{:ok, print_area}` where print_area is the range string,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_area/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_print_area/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, print_area} = UmyaSpreadsheet.get_print_area(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_area/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_print_centered/2","doc":"Gets the print centered settings for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_centered/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_print_centered/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_centered/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_print_centered/2","doc":"Returns `{:ok, {horizontal, vertical}}` where each value is a boolean\nindicating whether the sheet is centered horizontally/vertically,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_centered/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_print_centered/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, {horizontal, vertical}} = UmyaSpreadsheet.get_print_centered(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_centered/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.get_print_titles/2","doc":"Gets the print titles for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_titles/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.get_print_titles/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_titles/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.PrintSettings.get_print_titles/2","doc":"Returns `{:ok, {row_titles, column_titles}}` where each value is a range string,\nor `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_titles/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.get_print_titles/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, {rows, cols}} = UmyaSpreadsheet.get_print_titles(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.PrintSettings.html#get_print_titles/2-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_fit_to_page/4","doc":"Sets the fit-to-page options for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_fit_to_page/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_fit_to_page/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `width` - The number of pages wide to fit the content\n- `height` - The number of pages tall to fit the content","ref":"UmyaSpreadsheet.PrintSettings.html#set_fit_to_page/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_fit_to_page/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_fit_to_page(spreadsheet, \"Sheet1\", 1, 2)","ref":"UmyaSpreadsheet.PrintSettings.html#set_fit_to_page/4-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_footer/3","doc":"Sets the footer text for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_footer/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_footer/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `footer` - The footer text, which can include special formatting codes","ref":"UmyaSpreadsheet.PrintSettings.html#set_footer/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_footer/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_footer(spreadsheet, \"Sheet1\", \"&RPage &P of &N\")","ref":"UmyaSpreadsheet.PrintSettings.html#set_footer/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_header/3","doc":"Sets the header text for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_header/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_header/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `header` - The header text, which can include special formatting codes","ref":"UmyaSpreadsheet.PrintSettings.html#set_header/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_header/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_header(spreadsheet, \"Sheet1\", \"&C&\\\"Arial,Bold\\\"Confidential\")","ref":"UmyaSpreadsheet.PrintSettings.html#set_header/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_header_footer_margins/4","doc":"Sets the header and footer margins for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_header_footer_margins/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_header_footer_margins/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `header` - The header margin in inches\n- `footer` - The footer margin in inches","ref":"UmyaSpreadsheet.PrintSettings.html#set_header_footer_margins/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_header_footer_margins/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_header_footer_margins(spreadsheet, \"Sheet1\", 0.5, 0.5)","ref":"UmyaSpreadsheet.PrintSettings.html#set_header_footer_margins/4-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_page_margins/6","doc":"Sets the page margins for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_margins/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_page_margins/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `top` - The top margin in inches\n- `right` - The right margin in inches\n- `bottom` - The bottom margin in inches\n- `left` - The left margin in inches","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_margins/6-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_page_margins/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_page_margins(spreadsheet, \"Sheet1\", 1.0, 0.75, 1.0, 0.75)","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_margins/6-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_page_orientation/3","doc":"Sets the page orientation for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_orientation/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_page_orientation/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `orientation` - The orientation type: \"portrait\" or \"landscape\"","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_orientation/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_page_orientation/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_page_orientation(spreadsheet, \"Sheet1\", \"landscape\")","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_orientation/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_page_scale/3","doc":"Sets the page scale percentage for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_scale/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_page_scale/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `scale` - The scale percentage (e.g., 100 for 100%, 80 for 80%)","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_scale/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_page_scale/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_page_scale(spreadsheet, \"Sheet1\", 80)","ref":"UmyaSpreadsheet.PrintSettings.html#set_page_scale/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_paper_size/3","doc":"Sets the paper size for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_paper_size/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_paper_size/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `paper_size` - The paper size code (e.g., 9 for A4)","ref":"UmyaSpreadsheet.PrintSettings.html#set_paper_size/3-parameters"},{"type":"function","title":"Paper Size Codes - UmyaSpreadsheet.PrintSettings.set_paper_size/3","doc":"1 = Letter (8.5 x 11 in)\n   5 = Legal (8.5 x 14 in)\n   9 = A4 (210 x 297 mm)\n   8 = A3 (297 x 420 mm)\n   7 = A5 (148 x 210 mm)","ref":"UmyaSpreadsheet.PrintSettings.html#set_paper_size/3-paper-size-codes"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_paper_size/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_paper_size(spreadsheet, \"Sheet1\", 9)","ref":"UmyaSpreadsheet.PrintSettings.html#set_paper_size/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_print_area/3","doc":"Sets the print area for a specific sheet.","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_area/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_print_area/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `print_area` - The range to be printed (e.g., \"A1:H20\")","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_area/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_print_area/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_print_area(spreadsheet, \"Sheet1\", \"A1:H20\")","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_area/3-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_print_centered/4","doc":"Sets whether to center the print horizontally and/or vertically.","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_centered/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_print_centered/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `horizontal` - Whether to center horizontally\n- `vertical` - Whether to center vertically","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_centered/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_print_centered/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_print_centered(spreadsheet, \"Sheet1\", true, false)","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_centered/4-examples"},{"type":"function","title":"UmyaSpreadsheet.PrintSettings.set_print_titles/4","doc":"Sets the rows and columns to repeat on each printed page (print titles).","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_titles/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.PrintSettings.set_print_titles/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `rows` - The rows to repeat (e.g., \"1:2\")\n- `columns` - The columns to repeat (e.g., \"A:B\")","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_titles/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.PrintSettings.set_print_titles/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.set_print_titles(spreadsheet, \"Sheet1\", \"1:2\", \"A:B\")","ref":"UmyaSpreadsheet.PrintSettings.html#set_print_titles/4-examples"},{"type":"module","title":"UmyaSpreadsheet.RichText","doc":"Rich Text functionality for UmyaSpreadsheet.\n\nThis module provides support for formatted text within cells, allowing multiple\nfont styles, colors, and formatting within a single cell.","ref":"UmyaSpreadsheet.RichText.html"},{"type":"module","title":"Examples - UmyaSpreadsheet.RichText","doc":"# Create a simple rich text\n    rich_text = UmyaSpreadsheet.RichText.create()\n\n    # Add formatted text\n    UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"Bold text\", %{bold: true})\n    UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \" and normal text\", %{})\n\n    # Set rich text to a cell\n    UmyaSpreadsheet.RichText.set_cell_rich_text(spreadsheet, \"Sheet1\", \"A1\", rich_text)\n\n    # Create rich text from HTML\n    rich_text = UmyaSpreadsheet.RichText.create_from_html(\" Bold  and  italic  text\")","ref":"UmyaSpreadsheet.RichText.html#module-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.add_formatted_text/3","doc":"Adds formatted text directly to a RichText object.\n\nThis is a convenience function that creates a TextElement and adds it in one step.","ref":"UmyaSpreadsheet.RichText.html#add_formatted_text/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.add_formatted_text/3","doc":"- `rich_text` - RichText resource\n- `text` - Text content to add\n- `font_props` - Map of font properties (optional)","ref":"UmyaSpreadsheet.RichText.html#add_formatted_text/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.add_formatted_text/3","doc":"iex> rich_text = UmyaSpreadsheet.RichText.create()\n    iex> UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"Bold text\", %{bold: true})\n    :ok\n    iex> UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \" normal text\", %{})\n    :ok","ref":"UmyaSpreadsheet.RichText.html#add_formatted_text/3-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.add_text_element/2","doc":"Adds a TextElement to a RichText object.","ref":"UmyaSpreadsheet.RichText.html#add_text_element/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.add_text_element/2","doc":"- `rich_text` - RichText resource\n- `text_element` - TextElement resource to add","ref":"UmyaSpreadsheet.RichText.html#add_text_element/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.add_text_element/2","doc":"iex> rich_text = UmyaSpreadsheet.RichText.create()\n    iex> element = UmyaSpreadsheet.RichText.create_text_element(\"Test\", %{bold: true})\n    iex> UmyaSpreadsheet.RichText.add_text_element(rich_text, element)\n    :ok","ref":"UmyaSpreadsheet.RichText.html#add_text_element/2-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.create/0","doc":"Creates a new empty RichText object.\n\nReturns a Rich Text resource that can be used to build formatted text.","ref":"UmyaSpreadsheet.RichText.html#create/0"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.create/0","doc":"iex> rich_text = UmyaSpreadsheet.RichText.create()\n    iex> is_reference(rich_text)\n    true","ref":"UmyaSpreadsheet.RichText.html#create/0-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.create_from_html/1","doc":"Creates a RichText object from an HTML string.\n\nParses HTML to create formatted rich text with font styling.","ref":"UmyaSpreadsheet.RichText.html#create_from_html/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.create_from_html/1","doc":"- `html` - HTML string to parse","ref":"UmyaSpreadsheet.RichText.html#create_from_html/1-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.create_from_html/1","doc":"iex> html = \" Bold  and  italic  text\"\n    iex> rich_text = UmyaSpreadsheet.RichText.create_from_html(html)\n    iex> is_reference(rich_text)\n    true","ref":"UmyaSpreadsheet.RichText.html#create_from_html/1-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.create_text_element/2","doc":"Creates a TextElement with text and optional font properties.\n\nA TextElement represents a portion of text with consistent formatting.","ref":"UmyaSpreadsheet.RichText.html#create_text_element/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.create_text_element/2","doc":"- `text` - The text content\n- `font_props` - Map of font properties (optional)","ref":"UmyaSpreadsheet.RichText.html#create_text_element/2-parameters"},{"type":"function","title":"Font Properties - UmyaSpreadsheet.RichText.create_text_element/2","doc":"- `:bold` - Boolean for bold text\n- `:italic` - Boolean for italic text\n- `:underline` - Boolean for underlined text\n- `:strikethrough` - Boolean for strikethrough text\n- `:size` - Font size (number)\n- `:name` - Font name (string)\n- `:color` - Color (hex string like \"#FF0000\" or color name)","ref":"UmyaSpreadsheet.RichText.html#create_text_element/2-font-properties"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.create_text_element/2","doc":"iex> element = UmyaSpreadsheet.RichText.create_text_element(\"Bold text\", %{bold: true, color: \"#FF0000\"})\n    iex> is_reference(element)\n    true","ref":"UmyaSpreadsheet.RichText.html#create_text_element/2-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.get_cell_rich_text/3","doc":"Gets rich text from a specific cell.","ref":"UmyaSpreadsheet.RichText.html#get_cell_rich_text/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.get_cell_rich_text/3","doc":"- `spreadsheet` - UmyaSpreadsheet resource\n- `sheet_name` - Name of the worksheet\n- `coordinate` - Cell coordinate (e.g., \"A1\")","ref":"UmyaSpreadsheet.RichText.html#get_cell_rich_text/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RichText.get_cell_rich_text/3","doc":"Returns a RichText resource. If the cell doesn't contain rich text, returns an empty RichText.","ref":"UmyaSpreadsheet.RichText.html#get_cell_rich_text/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.get_cell_rich_text/3","doc":"iex> spreadsheet = UmyaSpreadsheet.new_file()\n    iex> rich_text = UmyaSpreadsheet.RichText.get_cell_rich_text(spreadsheet, \"Sheet1\", \"A1\")\n    iex> is_reference(rich_text)\n    true","ref":"UmyaSpreadsheet.RichText.html#get_cell_rich_text/3-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.get_element_font_properties/1","doc":"Gets font properties from a TextElement.","ref":"UmyaSpreadsheet.RichText.html#get_element_font_properties/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.get_element_font_properties/1","doc":"- `text_element` - TextElement resource","ref":"UmyaSpreadsheet.RichText.html#get_element_font_properties/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RichText.get_element_font_properties/1","doc":"`{:ok, %{}}` - Map of font properties including name, size, bold, italic, strikethrough, underline, and color.","ref":"UmyaSpreadsheet.RichText.html#get_element_font_properties/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.get_element_font_properties/1","doc":"iex> element = UmyaSpreadsheet.RichText.create_text_element(\"Test\", %{bold: true, size: 12})\n    iex> {:ok, props} = UmyaSpreadsheet.RichText.get_element_font_properties(element)\n    iex> props[:bold]\n    \"true\"","ref":"UmyaSpreadsheet.RichText.html#get_element_font_properties/1-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.get_element_text/1","doc":"Gets text content from a TextElement.","ref":"UmyaSpreadsheet.RichText.html#get_element_text/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.get_element_text/1","doc":"- `text_element` - TextElement resource","ref":"UmyaSpreadsheet.RichText.html#get_element_text/1-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.get_element_text/1","doc":"iex> element = UmyaSpreadsheet.RichText.create_text_element(\"Test\", %{})\n    iex> UmyaSpreadsheet.RichText.get_element_text(element)\n    \"Test\"","ref":"UmyaSpreadsheet.RichText.html#get_element_text/1-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.get_elements/1","doc":"Gets all text elements from a RichText object.","ref":"UmyaSpreadsheet.RichText.html#get_elements/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.get_elements/1","doc":"- `rich_text` - RichText resource","ref":"UmyaSpreadsheet.RichText.html#get_elements/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RichText.get_elements/1","doc":"List of TextElement resources.","ref":"UmyaSpreadsheet.RichText.html#get_elements/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.get_elements/1","doc":"iex> rich_text = UmyaSpreadsheet.RichText.create()\n    iex> UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"Test\", %{bold: true})\n    iex> elements = UmyaSpreadsheet.RichText.get_elements(rich_text)\n    iex> is_list(elements)\n    true","ref":"UmyaSpreadsheet.RichText.html#get_elements/1-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.get_plain_text/1","doc":"Gets plain text from a RichText object.\n\nExtracts all text content without formatting.","ref":"UmyaSpreadsheet.RichText.html#get_plain_text/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.get_plain_text/1","doc":"- `rich_text` - RichText resource","ref":"UmyaSpreadsheet.RichText.html#get_plain_text/1-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.get_plain_text/1","doc":"iex> rich_text = UmyaSpreadsheet.RichText.create()\n    iex> UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"Test\", %{bold: true})\n    iex> UmyaSpreadsheet.RichText.get_plain_text(rich_text)\n    \"Test\"","ref":"UmyaSpreadsheet.RichText.html#get_plain_text/1-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.set_cell_rich_text/4","doc":"Sets rich text to a specific cell.","ref":"UmyaSpreadsheet.RichText.html#set_cell_rich_text/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.set_cell_rich_text/4","doc":"- `spreadsheet` - UmyaSpreadsheet resource\n- `sheet_name` - Name of the worksheet\n- `coordinate` - Cell coordinate (e.g., \"A1\")\n- `rich_text` - RichText resource to set","ref":"UmyaSpreadsheet.RichText.html#set_cell_rich_text/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.set_cell_rich_text/4","doc":"iex> spreadsheet = UmyaSpreadsheet.new_file()\n    iex> rich_text = UmyaSpreadsheet.RichText.create()\n    iex> UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"Test\", %{bold: true})\n    iex> UmyaSpreadsheet.RichText.set_cell_rich_text(spreadsheet, \"Sheet1\", \"A1\", rich_text)\n    :ok","ref":"UmyaSpreadsheet.RichText.html#set_cell_rich_text/4-examples"},{"type":"function","title":"UmyaSpreadsheet.RichText.to_html/1","doc":"Converts RichText to HTML representation.","ref":"UmyaSpreadsheet.RichText.html#to_html/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RichText.to_html/1","doc":"- `rich_text` - RichText resource","ref":"UmyaSpreadsheet.RichText.html#to_html/1-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.RichText.to_html/1","doc":"iex> rich_text = UmyaSpreadsheet.RichText.create()\n    iex> UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"Bold\", %{bold: true})\n    iex> UmyaSpreadsheet.RichText.to_html(rich_text)\n    \" Bold \"","ref":"UmyaSpreadsheet.RichText.html#to_html/1-examples"},{"type":"module","title":"UmyaSpreadsheet.RowColumnFunctions","doc":"Functions for manipulating rows and columns in a spreadsheet.","ref":"UmyaSpreadsheet.RowColumnFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.copy_column_styling/6","doc":"Copies styling from one column to another.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#copy_column_styling/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.copy_column_styling/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `source_column` - The source column index (1-based)\n- `target_column` - The target column index (1-based)\n- `start_row` - Optional starting row index (1-based)\n- `end_row` - Optional ending row index (1-based)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#copy_column_styling/6-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.copy_column_styling/6","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#copy_column_styling/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.copy_column_styling/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Copy styling for all cells in column A to column B\n    :ok = UmyaSpreadsheet.RowColumnFunctions.copy_column_styling(spreadsheet, \"Sheet1\", 1, 2, nil, nil)\n\n    # Copy styling only for rows 1 through 10\n    :ok = UmyaSpreadsheet.RowColumnFunctions.copy_column_styling(spreadsheet, \"Sheet1\", 1, 2, 1, 10)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#copy_column_styling/6-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.copy_row_styling/6","doc":"Copies styling from one row to another.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#copy_row_styling/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.copy_row_styling/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `source_row` - The source row number (1-based)\n- `target_row` - The target row number (1-based)\n- `start_column` - Optional starting column index (1-based)\n- `end_column` - Optional ending column index (1-based)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#copy_row_styling/6-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.copy_row_styling/6","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#copy_row_styling/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.copy_row_styling/6","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Copy styling for all cells in row 1 to row 2\n    :ok = UmyaSpreadsheet.RowColumnFunctions.copy_row_styling(spreadsheet, \"Sheet1\", 1, 2, nil, nil)\n\n    # Copy styling only for columns A through C (columns 1-3)\n    :ok = UmyaSpreadsheet.RowColumnFunctions.copy_row_styling(spreadsheet, \"Sheet1\", 1, 2, 1, 3)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#copy_row_styling/6-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.get_column_auto_width/3","doc":"Gets whether a column width is automatically adjusted.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_auto_width/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.get_column_auto_width/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column` - The column letter (e.g., \"A\", \"B\")","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_auto_width/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.get_column_auto_width/3","doc":"- `{:ok, auto_width}` on success where auto_width is a boolean\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_auto_width/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.get_column_auto_width/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, auto_width} = UmyaSpreadsheet.RowColumnFunctions.get_column_auto_width(spreadsheet, \"Sheet1\", \"A\")","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_auto_width/3-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.get_column_hidden/3","doc":"Gets whether a column is hidden.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_hidden/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.get_column_hidden/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column` - The column letter (e.g., \"A\", \"B\")","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_hidden/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.get_column_hidden/3","doc":"- `{:ok, hidden}` on success where hidden is a boolean\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_hidden/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.get_column_hidden/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, hidden} = UmyaSpreadsheet.RowColumnFunctions.get_column_hidden(spreadsheet, \"Sheet1\", \"A\")","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_hidden/3-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.get_column_width/3","doc":"Gets the width of a column.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_width/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.get_column_width/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column` - The column letter (e.g., \"A\", \"B\")","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_width/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.get_column_width/3","doc":"- `{:ok, width}` on success where width is a float\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_width/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.get_column_width/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, width} = UmyaSpreadsheet.RowColumnFunctions.get_column_width(spreadsheet, \"Sheet1\", \"A\")","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_column_width/3-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.get_row_height/3","doc":"Gets the height of a row.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_row_height/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.get_row_height/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_number` - The row number (1-based)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_row_height/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.get_row_height/3","doc":"- `{:ok, height}` on success where height is a float\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_row_height/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.get_row_height/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, height} = UmyaSpreadsheet.RowColumnFunctions.get_row_height(spreadsheet, \"Sheet1\", 1)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_row_height/3-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.get_row_hidden/3","doc":"Gets whether a row is hidden.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_row_hidden/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.get_row_hidden/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_number` - The row number (1-based)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_row_hidden/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.get_row_hidden/3","doc":"- `{:ok, hidden}` on success where hidden is a boolean\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_row_hidden/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.get_row_hidden/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, hidden} = UmyaSpreadsheet.RowColumnFunctions.get_row_hidden(spreadsheet, \"Sheet1\", 1)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#get_row_hidden/3-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.set_column_auto_width/4","doc":"Sets whether a column width should be automatically adjusted.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_column_auto_width/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.set_column_auto_width/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column` - The column letter (e.g., \"A\", \"B\")\n- `auto_width` - Boolean indicating whether auto-width should be enabled","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_column_auto_width/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.set_column_auto_width/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_column_auto_width/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.set_column_auto_width/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.RowColumnFunctions.set_column_auto_width(spreadsheet, \"Sheet1\", \"A\", true)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_column_auto_width/4-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.set_column_width/4","doc":"Sets the width of a column.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_column_width/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.set_column_width/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column` - The column letter (e.g., \"A\", \"B\")\n- `width` - The width value","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_column_width/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.set_column_width/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_column_width/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.set_column_width/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.RowColumnFunctions.set_column_width(spreadsheet, \"Sheet1\", \"A\", 15.5)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_column_width/4-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.set_row_height/4","doc":"Sets the height of a row.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_row_height/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.set_row_height/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_number` - The row number (1-based)\n- `height` - The height value (in points)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_row_height/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.set_row_height/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_row_height/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.set_row_height/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.RowColumnFunctions.set_row_height(spreadsheet, \"Sheet1\", 1, 20.5)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_row_height/4-examples"},{"type":"function","title":"UmyaSpreadsheet.RowColumnFunctions.set_row_style/5","doc":"Sets styles for an entire row.","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_row_style/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.RowColumnFunctions.set_row_style/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_number` - The row number (1-based)\n- `bg_color` - The background color code (e.g., \"#FF0000\" for red)\n- `font_color` - The font color code (e.g., \"#FFFFFF\" for white)","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_row_style/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.RowColumnFunctions.set_row_style/5","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_row_style/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.RowColumnFunctions.set_row_style/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Set row background to red and text to white\n    :ok = UmyaSpreadsheet.RowColumnFunctions.set_row_style(spreadsheet, \"Sheet1\", 1, \"#FF0000\", \"#FFFFFF\")","ref":"UmyaSpreadsheet.RowColumnFunctions.html#set_row_style/5-examples"},{"type":"module","title":"UmyaSpreadsheet.SheetFunctions","doc":"Functions for manipulating sheets in a spreadsheet.","ref":"UmyaSpreadsheet.SheetFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.add_merge_cells/3","doc":"Merges cells in a specified range.","ref":"UmyaSpreadsheet.SheetFunctions.html#add_merge_cells/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.add_merge_cells/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The range to merge (e.g., \"A1:B5\")","ref":"UmyaSpreadsheet.SheetFunctions.html#add_merge_cells/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.add_merge_cells/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#add_merge_cells/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.add_merge_cells/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetFunctions.add_merge_cells(spreadsheet, \"Sheet1\", \"A1:B2\")","ref":"UmyaSpreadsheet.SheetFunctions.html#add_merge_cells/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.add_sheet/2","doc":"Adds a new sheet to the spreadsheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#add_sheet/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.add_sheet/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name for the new sheet","ref":"UmyaSpreadsheet.SheetFunctions.html#add_sheet/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.add_sheet/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#add_sheet/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.add_sheet/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetFunctions.add_sheet(spreadsheet, \"NewSheet\")","ref":"UmyaSpreadsheet.SheetFunctions.html#add_sheet/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.clone_sheet/3","doc":"Clones an existing sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#clone_sheet/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.clone_sheet/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `source_sheet_name` - The name of the sheet to clone\n- `new_sheet_name` - The name for the new sheet","ref":"UmyaSpreadsheet.SheetFunctions.html#clone_sheet/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.clone_sheet/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#clone_sheet/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.clone_sheet/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetFunctions.clone_sheet(spreadsheet, \"Sheet1\", \"Sheet1 Copy\")","ref":"UmyaSpreadsheet.SheetFunctions.html#clone_sheet/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.get_active_sheet/1","doc":"Gets the currently active sheet tab index.","ref":"UmyaSpreadsheet.SheetFunctions.html#get_active_sheet/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.get_active_sheet/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.SheetFunctions.html#get_active_sheet/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.get_active_sheet/1","doc":"- `{:ok, index}` on success where index is the 0-based active tab index\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#get_active_sheet/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.get_active_sheet/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, 0} = UmyaSpreadsheet.SheetFunctions.get_active_sheet(spreadsheet)","ref":"UmyaSpreadsheet.SheetFunctions.html#get_active_sheet/1-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.get_merge_cells/2","doc":"Gets the list of merged cell ranges in a sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#get_merge_cells/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.get_merge_cells/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.SheetFunctions.html#get_merge_cells/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.get_merge_cells/2","doc":"- `{:ok, ranges}` on success where ranges is a list of range strings\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#get_merge_cells/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.get_merge_cells/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, [\"A1:B2\", \"C3:D4\"]} = UmyaSpreadsheet.SheetFunctions.get_merge_cells(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.SheetFunctions.html#get_merge_cells/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.get_sheet_count/1","doc":"Gets the total number of sheets in the spreadsheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_count/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.get_sheet_count/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_count/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.get_sheet_count/1","doc":"- The number of sheets as an integer","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_count/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.get_sheet_count/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    3 = UmyaSpreadsheet.SheetFunctions.get_sheet_count(spreadsheet)","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_count/1-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.get_sheet_names/1","doc":"Gets a list of all sheet names in the spreadsheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_names/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.get_sheet_names/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_names/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.get_sheet_names/1","doc":"- A list of sheet names","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_names/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.get_sheet_names/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    [\"Sheet1\", \"Sheet2\"] = UmyaSpreadsheet.SheetFunctions.get_sheet_names(spreadsheet)","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_names/1-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.get_sheet_protection/2","doc":"Checks if a sheet is protected and gets protection details.","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_protection/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.get_sheet_protection/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_protection/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.get_sheet_protection/2","doc":"- `{:ok, %{protected: boolean, details: map}}` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_protection/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.get_sheet_protection/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, %{protected: true, details: %{}}} = UmyaSpreadsheet.SheetFunctions.get_sheet_protection(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_protection/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.get_sheet_state/2","doc":"Gets the visibility state of a sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_state/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.get_sheet_state/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_state/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.get_sheet_state/2","doc":"- `{:ok, state}` on success where state is \"visible\", \"hidden\", or \"veryhidden\"\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_state/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.get_sheet_state/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, \"visible\"} = UmyaSpreadsheet.SheetFunctions.get_sheet_state(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.SheetFunctions.html#get_sheet_state/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.insert_new_column/4","doc":"Inserts new columns into a sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_column/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.insert_new_column/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column` - The column letter where columns should be inserted (e.g., \"C\")\n- `amount` - The number of columns to insert","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_column/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.insert_new_column/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_column/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.insert_new_column/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Insert 2 new columns at column C\n    :ok = UmyaSpreadsheet.SheetFunctions.insert_new_column(spreadsheet, \"Sheet1\", \"C\", 2)","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_column/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.insert_new_column_by_index/4","doc":"Inserts new columns into a sheet using column index.","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_column_by_index/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.insert_new_column_by_index/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column_index` - The column index (1-based) where columns should be inserted\n- `amount` - The number of columns to insert","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_column_by_index/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.insert_new_column_by_index/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_column_by_index/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.insert_new_column_by_index/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Insert 2 new columns at column index 3 (column C)\n    :ok = UmyaSpreadsheet.SheetFunctions.insert_new_column_by_index(spreadsheet, \"Sheet1\", 3, 2)","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_column_by_index/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.insert_new_row/4","doc":"Inserts new rows into a sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_row/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.insert_new_row/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_index` - The index where rows should be inserted\n- `amount` - The number of rows to insert","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_row/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.insert_new_row/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_row/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.insert_new_row/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Insert 2 new rows at row 3\n    :ok = UmyaSpreadsheet.SheetFunctions.insert_new_row(spreadsheet, \"Sheet1\", 3, 2)","ref":"UmyaSpreadsheet.SheetFunctions.html#insert_new_row/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.move_range/5","doc":"Moves a range of cells to a new position.","ref":"UmyaSpreadsheet.SheetFunctions.html#move_range/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.move_range/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `range` - The range to move (e.g., \"A1:B5\")\n- `rows` - Number of rows to move (positive for down, negative for up)\n- `columns` - Number of columns to move (positive for right, negative for left)","ref":"UmyaSpreadsheet.SheetFunctions.html#move_range/5-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.move_range/5","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#move_range/5-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.move_range/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Move range down 2 rows and right 3 columns\n    :ok = UmyaSpreadsheet.SheetFunctions.move_range(spreadsheet, \"Sheet1\", \"A1:B5\", 2, 3)","ref":"UmyaSpreadsheet.SheetFunctions.html#move_range/5-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.remove_column/4","doc":"Removes columns from a sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_column/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.remove_column/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column` - The column letter where columns should be removed from (e.g., \"C\")\n- `amount` - The number of columns to remove","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_column/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.remove_column/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_column/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.remove_column/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Remove 2 columns starting from column C\n    :ok = UmyaSpreadsheet.SheetFunctions.remove_column(spreadsheet, \"Sheet1\", \"C\", 2)","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_column/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.remove_column_by_index/4","doc":"Removes columns from a sheet using column index.","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_column_by_index/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.remove_column_by_index/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `column_index` - The column index (1-based) where columns should be removed from\n- `amount` - The number of columns to remove","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_column_by_index/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.remove_column_by_index/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_column_by_index/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.remove_column_by_index/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Remove 2 columns starting from column index 3 (column C)\n    :ok = UmyaSpreadsheet.SheetFunctions.remove_column_by_index(spreadsheet, \"Sheet1\", 3, 2)","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_column_by_index/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.remove_row/4","doc":"Removes rows from a sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_row/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.remove_row/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `row_index` - The index where rows should be removed from\n- `amount` - The number of rows to remove","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_row/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.remove_row/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_row/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.remove_row/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Remove 2 rows starting from row 3\n    :ok = UmyaSpreadsheet.SheetFunctions.remove_row(spreadsheet, \"Sheet1\", 3, 2)","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_row/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.remove_sheet/2","doc":"Removes a sheet from the spreadsheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_sheet/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.remove_sheet/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet to remove","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_sheet/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.remove_sheet/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_sheet/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.remove_sheet/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetFunctions.remove_sheet(spreadsheet, \"Sheet3\")","ref":"UmyaSpreadsheet.SheetFunctions.html#remove_sheet/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.rename_sheet/3","doc":"Renames an existing sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#rename_sheet/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.rename_sheet/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `old_sheet_name` - The current name of the sheet\n- `new_sheet_name` - The new name for the sheet","ref":"UmyaSpreadsheet.SheetFunctions.html#rename_sheet/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.rename_sheet/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#rename_sheet/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.rename_sheet/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetFunctions.rename_sheet(spreadsheet, \"Sheet1\", \"Updated Sheet\")","ref":"UmyaSpreadsheet.SheetFunctions.html#rename_sheet/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.set_sheet_protection/4","doc":"Sets the protection for a sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#set_sheet_protection/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.set_sheet_protection/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `password` - Optional password for the protection\n- `is_protected` - Boolean indicating whether the sheet should be protected","ref":"UmyaSpreadsheet.SheetFunctions.html#set_sheet_protection/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.set_sheet_protection/4","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#set_sheet_protection/4-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.set_sheet_protection/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Protect with password\n    :ok = UmyaSpreadsheet.SheetFunctions.set_sheet_protection(spreadsheet, \"Sheet1\", \"password\", true)\n    # Remove protection\n    :ok = UmyaSpreadsheet.SheetFunctions.set_sheet_protection(spreadsheet, \"Sheet1\", nil, false)","ref":"UmyaSpreadsheet.SheetFunctions.html#set_sheet_protection/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetFunctions.set_sheet_state/3","doc":"Sets the visibility state of a sheet.","ref":"UmyaSpreadsheet.SheetFunctions.html#set_sheet_state/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetFunctions.set_sheet_state/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `state` - The visibility state (\"visible\", \"hidden\", \"veryhidden\")","ref":"UmyaSpreadsheet.SheetFunctions.html#set_sheet_state/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetFunctions.set_sheet_state/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetFunctions.html#set_sheet_state/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetFunctions.set_sheet_state/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetFunctions.set_sheet_state(spreadsheet, \"Sheet1\", \"hidden\")","ref":"UmyaSpreadsheet.SheetFunctions.html#set_sheet_state/3-examples"},{"type":"module","title":"UmyaSpreadsheet.SheetViewFunctions","doc":"Functions for configuring how sheets are displayed in the Excel application.","ref":"UmyaSpreadsheet.SheetViewFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.freeze_panes/4","doc":"Freezes panes at the specified row and column.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#freeze_panes/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.freeze_panes/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `rows` - The number of rows to freeze\n- `cols` - The number of columns to freeze","ref":"UmyaSpreadsheet.SheetViewFunctions.html#freeze_panes/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.freeze_panes/4","doc":"# Freeze the top row\n    {:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.freeze_panes(spreadsheet, \"Sheet1\", 1, 0)\n\n    # Freeze the left column\n    :ok = UmyaSpreadsheet.SheetViewFunctions.freeze_panes(spreadsheet, \"Sheet1\", 0, 1)\n\n    # Freeze both top row and left column\n    :ok = UmyaSpreadsheet.SheetViewFunctions.freeze_panes(spreadsheet, \"Sheet1\", 1, 1)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#freeze_panes/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.get_selection/2","doc":"Gets the active selection in a worksheet.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_selection/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.get_selection/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_selection/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetViewFunctions.get_selection/2","doc":"- `{:ok, selection}` where `selection` is a map with \"active_cell\" and \"sqref\" keys\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_selection/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.get_selection/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, selection} = UmyaSpreadsheet.SheetViewFunctions.get_selection(spreadsheet, \"Sheet1\")\n    # selection = %{\"active_cell\" => \"A1\", \"sqref\" => \"A1:B5\"}","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_selection/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.get_sheet_view/2","doc":"Gets the sheet view type.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_sheet_view/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.get_sheet_view/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_sheet_view/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetViewFunctions.get_sheet_view/2","doc":"- `{:ok, view_type}` where `view_type` is one of \"normal\", \"page_layout\", or \"page_break_preview\"\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_sheet_view/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.get_sheet_view/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, view_type} = UmyaSpreadsheet.SheetViewFunctions.get_sheet_view(spreadsheet, \"Sheet1\")\n    # view_type = \"normal\"","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_sheet_view/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.get_show_grid_lines/2","doc":"Gets whether gridlines are shown in a sheet.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_show_grid_lines/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.get_show_grid_lines/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_show_grid_lines/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetViewFunctions.get_show_grid_lines/2","doc":"- `{:ok, boolean}` where `boolean` indicates whether gridlines are shown\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_show_grid_lines/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.get_show_grid_lines/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, show_gridlines} = UmyaSpreadsheet.SheetViewFunctions.get_show_grid_lines(spreadsheet, \"Sheet1\")\n    # show_gridlines = true","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_show_grid_lines/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.get_tab_color/2","doc":"Gets the tab color for a worksheet.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_tab_color/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.get_tab_color/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_tab_color/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetViewFunctions.get_tab_color/2","doc":"- `{:ok, color}` where `color` is a string with the color code (e.g., \"#FF0000\" for red)\n  or an empty string if no color is set\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_tab_color/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.get_tab_color/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, color} = UmyaSpreadsheet.SheetViewFunctions.get_tab_color(spreadsheet, \"Sheet1\")\n    # color = \"#FF0000\"","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_tab_color/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.get_zoom_scale/2","doc":"Gets the zoom scale for a sheet view.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_zoom_scale/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.get_zoom_scale/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_zoom_scale/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.SheetViewFunctions.get_zoom_scale/2","doc":"- `{:ok, integer}` where `integer` is the zoom scale percentage\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_zoom_scale/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.get_zoom_scale/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, zoom_scale} = UmyaSpreadsheet.SheetViewFunctions.get_zoom_scale(spreadsheet, \"Sheet1\")\n    # zoom_scale = 100","ref":"UmyaSpreadsheet.SheetViewFunctions.html#get_zoom_scale/2-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_selection/4","doc":"Sets the active selection in a worksheet.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_selection/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_selection/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `active_cell` - The active cell address (e.g., \"A1\", \"B5\")\n- `sqref` - The selection range reference (e.g., \"A1:B5\")","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_selection/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_selection/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_selection(spreadsheet, \"Sheet1\", \"C3\", \"C3:D5\")","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_selection/4-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_sheet_view/3","doc":"Sets the sheet view type.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_sheet_view/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_sheet_view/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `view_type` - The type of view: \"normal\", \"page_layout\", or \"page_break_preview\"","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_sheet_view/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_sheet_view/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n\n    # Set to normal view\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_sheet_view(spreadsheet, \"Sheet1\", \"normal\")\n\n    # Set to page layout view\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_sheet_view(spreadsheet, \"Sheet1\", \"page_layout\")\n\n    # Set to page break preview\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_sheet_view(spreadsheet, \"Sheet1\", \"page_break_preview\")","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_sheet_view/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_show_grid_lines/3","doc":"Sets whether to show gridlines in a sheet.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_show_grid_lines/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_show_grid_lines/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `show_gridlines` - Boolean indicating whether to show gridlines","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_show_grid_lines/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_show_grid_lines/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_show_grid_lines(spreadsheet, \"Sheet1\", false)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_show_grid_lines/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_tab_color/3","doc":"Sets the tab color for a worksheet.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_tab_color/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_tab_color/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `color` - The color code (e.g., \"#FF0000\" for red)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_tab_color/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_tab_color/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Set sheet tab to red\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_tab_color(spreadsheet, \"Sheet1\", \"#FF0000\")","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_tab_color/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_tab_selected/3","doc":"Sets whether a sheet tab is selected (active) when the workbook is opened.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_tab_selected/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_tab_selected/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `selected` - Boolean indicating whether the sheet tab should be selected","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_tab_selected/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_tab_selected/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_tab_selected(spreadsheet, \"Sheet1\", true)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_tab_selected/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_top_left_cell/3","doc":"Sets the top-left cell in the sheet view (the first visible cell).","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_top_left_cell/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_top_left_cell/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `cell_address` - The cell address (e.g., \"A1\", \"B5\") to set as the top-left cell","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_top_left_cell/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_top_left_cell/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_top_left_cell(spreadsheet, \"Sheet1\", \"B5\")","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_top_left_cell/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale/3","doc":"Sets the zoom scale for a sheet view.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `scale` - The zoom scale percentage (e.g., 100 for 100%, 150 for 150%)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale(spreadsheet, \"Sheet1\", 150)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_normal/3","doc":"Sets the zoom scale for the normal view.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_normal/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_normal/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `scale` - The zoom scale percentage (e.g., 100 for 100%, 150 for 150%)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_normal/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_normal/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_normal(spreadsheet, \"Sheet1\", 75)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_normal/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_break/3","doc":"Sets the zoom scale for the page break preview view.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_page_break/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_break/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `scale` - The zoom scale percentage (e.g., 100 for 100%, 150 for 150%)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_page_break/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_break/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_break(spreadsheet, \"Sheet1\", 80)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_page_break/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_layout/3","doc":"Sets the zoom scale for the page layout view.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_page_layout/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_layout/3","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `scale` - The zoom scale percentage (e.g., 100 for 100%, 150 for 150%)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_page_layout/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_layout/3","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_layout(spreadsheet, \"Sheet1\", 120)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#set_zoom_scale_page_layout/3-examples"},{"type":"function","title":"UmyaSpreadsheet.SheetViewFunctions.split_panes/4","doc":"Splits panes at the specified row and column.","ref":"UmyaSpreadsheet.SheetViewFunctions.html#split_panes/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.SheetViewFunctions.split_panes/4","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet\n- `height` - The height of the split in pixels\n- `width` - The width of the split in pixels","ref":"UmyaSpreadsheet.SheetViewFunctions.html#split_panes/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.SheetViewFunctions.split_panes/4","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.SheetViewFunctions.split_panes(spreadsheet, \"Sheet1\", 2000, 2000)","ref":"UmyaSpreadsheet.SheetViewFunctions.html#split_panes/4-examples"},{"type":"module","title":"UmyaSpreadsheet.StylingFunctions","doc":"Functions for styling and formatting cells, columns, and rows.","ref":"UmyaSpreadsheet.StylingFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.StylingFunctions.copy_column_styling/6","doc":"Copies styling from one column to another within the same sheet.","ref":"UmyaSpreadsheet.StylingFunctions.html#copy_column_styling/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.StylingFunctions.copy_column_styling/6","doc":"- `spreadsheet` - The spreadsheet struct\n- `sheet_name` - The name of the sheet containing both columns\n- `source_column` - The index of the source column (1-based)\n- `target_column` - The index of the target column (1-based)\n- `start_row` - Optional starting row (1-based, defaults to 1)\n- `end_row` - Optional ending row (1-based, defaults to include all rows)","ref":"UmyaSpreadsheet.StylingFunctions.html#copy_column_styling/6-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.StylingFunctions.copy_column_styling/6","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.StylingFunctions.html#copy_column_styling/6-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.StylingFunctions.copy_column_styling/6","doc":"# Copy all styling from column A to column B\n    :ok = UmyaSpreadsheet.copy_column_styling(spreadsheet, \"Sheet1\", 1, 2)\n\n    # Copy styling from column A to column B, but only for rows 3-10\n    :ok = UmyaSpreadsheet.copy_column_styling(spreadsheet, \"Sheet1\", 1, 2, 3, 10)","ref":"UmyaSpreadsheet.StylingFunctions.html#copy_column_styling/6-examples"},{"type":"module","title":"UmyaSpreadsheet.Table","doc":"Functions for creating and managing Excel tables.\n\nExcel tables are structured data ranges that provide built-in filtering, sorting,\nand formatting capabilities. This module provides functions to:\n\n* Create tables from data ranges\n* Configure table columns and styling\n* Manage table filters and totals rows\n* Modify existing table structures","ref":"UmyaSpreadsheet.Table.html"},{"type":"function","title":"UmyaSpreadsheet.Table.add_table/8","doc":"Adds a new table to a spreadsheet.","ref":"UmyaSpreadsheet.Table.html#add_table/8"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.add_table/8","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet where the table will be created\n  * `table_name` - Internal name of the table (must be unique within the workbook)\n  * `display_name` - Display name shown to users\n  * `start_cell` - Top-left cell of the table range (e.g., \"A1\")\n  * `end_cell` - Bottom-right cell of the table range (e.g., \"D10\")\n  * `columns` - List of column names for the table headers\n  * `has_totals_row` - Optional boolean indicating if the table should include a totals row","ref":"UmyaSpreadsheet.Table.html#add_table/8-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.add_table/8","doc":"```elixir\n# Create a sales data table\n{:ok, :ok} = Table.add_table(\n  spreadsheet,\n  \"Sheet1\",\n  \"SalesTable\",\n  \"Sales Data\",\n  \"A1\",\n  \"D10\",\n  [\"Region\", \"Product\", \"Sales\", \"Date\"],\n  true  # Include totals row\n)\n```\n\nReturns `{:ok, :ok}` on success or `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.Table.html#add_table/8-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.add_table_column/6","doc":"Adds a new column to an existing table.","ref":"UmyaSpreadsheet.Table.html#add_table_column/6"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.add_table_column/6","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table to modify\n  * `column_name` - Name of the new column\n  * `totals_row_function` - Optional function for the totals row (\"sum\", \"count\", \"average\", etc.)\n  * `totals_row_label` - Optional custom label for the totals row","ref":"UmyaSpreadsheet.Table.html#add_table_column/6-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.add_table_column/6","doc":"```elixir\nTable.add_table_column(\n  spreadsheet,\n  \"Sheet1\",\n  \"SalesTable\",\n  \"Total\",\n  \"sum\",\n  \"Grand Total\"\n)\n```\n\nReturns `:ok` on success or `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.Table.html#add_table_column/6-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.count_tables/2","doc":"Counts the number of tables in a worksheet.","ref":"UmyaSpreadsheet.Table.html#count_tables/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.count_tables/2","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet to count tables in","ref":"UmyaSpreadsheet.Table.html#count_tables/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.count_tables/2","doc":"```elixir\n{:ok, count} = Table.count_tables(spreadsheet, \"Sheet1\")\n# count = 3\n```\n\nReturns `{:ok, integer}` with the number of tables on success.","ref":"UmyaSpreadsheet.Table.html#count_tables/2-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.get_table/3","doc":"Gets a specific table by name from a worksheet.","ref":"UmyaSpreadsheet.Table.html#get_table/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.get_table/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table to retrieve","ref":"UmyaSpreadsheet.Table.html#get_table/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Table.get_table/3","doc":"A map containing table information with keys:\n- `\"name\"` - Internal table name\n- `\"display_name\"` - Display name\n- `\"start_cell\"` - Top-left cell reference\n- `\"end_cell\"` - Bottom-right cell reference\n- `\"columns\"` - List of column names\n- `\"has_totals_row\"` - Boolean indicating if totals row is enabled\n- `\"style_info\"` - Map with styling information (if table has custom styling)","ref":"UmyaSpreadsheet.Table.html#get_table/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.get_table/3","doc":"```elixir\n{:ok, table} = Table.get_table(spreadsheet, \"Sheet1\", \"SalesTable\")\n# table = %{\"name\" => \"SalesTable\", \"display_name\" => \"Sales Data\", ...}\n```","ref":"UmyaSpreadsheet.Table.html#get_table/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.get_table_columns/3","doc":"Gets column information for a specific table.","ref":"UmyaSpreadsheet.Table.html#get_table_columns/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.get_table_columns/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table","ref":"UmyaSpreadsheet.Table.html#get_table_columns/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Table.get_table_columns/3","doc":"A list of maps, each containing column information with keys:\n- `\"name\"` - Column name\n- `\"totals_row_label\"` - Custom label for totals row (if set)\n- `\"totals_row_function\"` - Function used in totals row (e.g., \"sum\", \"count\")","ref":"UmyaSpreadsheet.Table.html#get_table_columns/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.get_table_columns/3","doc":"```elixir\n{:ok, columns} = Table.get_table_columns(spreadsheet, \"Sheet1\", \"SalesTable\")\n# columns = [%{\"name\" => \"Region\", \"totals_row_function\" => \"none\"}, ...]\n```","ref":"UmyaSpreadsheet.Table.html#get_table_columns/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.get_table_style/3","doc":"Gets table style information for a specific table.","ref":"UmyaSpreadsheet.Table.html#get_table_style/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.get_table_style/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table","ref":"UmyaSpreadsheet.Table.html#get_table_style/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Table.get_table_style/3","doc":"A map containing style information with keys:\n- `\"name\"` - Style name (e.g., \"TableStyleLight1\")\n- `\"show_first_column\"` - Boolean indicating if first column is highlighted\n- `\"show_last_column\"` - Boolean indicating if last column is highlighted\n- `\"show_row_stripes\"` - Boolean indicating if row stripes are shown\n- `\"show_column_stripes\"` - Boolean indicating if column stripes are shown","ref":"UmyaSpreadsheet.Table.html#get_table_style/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.get_table_style/3","doc":"```elixir\n{:ok, style} = Table.get_table_style(spreadsheet, \"Sheet1\", \"SalesTable\")\n# style = %{\"name\" => \"TableStyleLight1\", \"show_first_column\" => \"true\", ...}\n```","ref":"UmyaSpreadsheet.Table.html#get_table_style/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.get_table_totals_row/3","doc":"Gets the totals row visibility status for a specific table.","ref":"UmyaSpreadsheet.Table.html#get_table_totals_row/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.get_table_totals_row/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table","ref":"UmyaSpreadsheet.Table.html#get_table_totals_row/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.get_table_totals_row/3","doc":"```elixir\n{:ok, has_totals_row?} = Table.get_table_totals_row(spreadsheet, \"Sheet1\", \"SalesTable\")\n# has_totals_row? = true or false\n```\n\nReturns `{:ok, boolean}` if successful, `{:error, reason}` otherwise.","ref":"UmyaSpreadsheet.Table.html#get_table_totals_row/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.get_tables/2","doc":"Gets all tables from a worksheet.","ref":"UmyaSpreadsheet.Table.html#get_tables/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.get_tables/2","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet to get tables from","ref":"UmyaSpreadsheet.Table.html#get_tables/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.Table.get_tables/2","doc":"A list of maps, each containing table information with keys:\n- `\"name\"` - Internal table name\n- `\"display_name\"` - Display name\n- `\"start_cell\"` - Top-left cell reference\n- `\"end_cell\"` - Bottom-right cell reference\n- `\"columns\"` - List of column names\n- `\"has_totals_row\"` - Boolean indicating if totals row is enabled\n- `\"style_info\"` - Map with styling information (if table has custom styling)","ref":"UmyaSpreadsheet.Table.html#get_tables/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.get_tables/2","doc":"```elixir\n{:ok, tables} = Table.get_tables(spreadsheet, \"Sheet1\")\n# tables = [%{\"name\" => \"SalesTable\", \"display_name\" => \"Sales Data\", ...}]\n```","ref":"UmyaSpreadsheet.Table.html#get_tables/2-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.has_tables/2","doc":"Checks if a worksheet has any tables.","ref":"UmyaSpreadsheet.Table.html#has_tables/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.has_tables/2","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet to check","ref":"UmyaSpreadsheet.Table.html#has_tables/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.has_tables/2","doc":"```elixir\n{:ok, has_tables?} = Table.has_tables(spreadsheet, \"Sheet1\")\n# has_tables? = true or false\n```\n\nReturns `{:ok, boolean}` if successful, `{:error, reason}` otherwise.","ref":"UmyaSpreadsheet.Table.html#has_tables/2-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.modify_table_column/7","doc":"Modifies an existing table column.","ref":"UmyaSpreadsheet.Table.html#modify_table_column/7"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.modify_table_column/7","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table to modify\n  * `old_column_name` - Current name of the column to modify\n  * `new_column_name` - Optional new name for the column\n  * `totals_row_function` - Optional function for the totals row\n  * `totals_row_label` - Optional custom label for the totals row","ref":"UmyaSpreadsheet.Table.html#modify_table_column/7-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.modify_table_column/7","doc":"```elixir\n# Rename a column and change its totals function\nTable.modify_table_column(\n  spreadsheet,\n  \"Sheet1\",\n  \"SalesTable\",\n  \"Sales\",\n  \"Revenue\",\n  \"sum\",\n  \"Total Revenue\"\n)\n```\n\nReturns `:ok` on success or `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.Table.html#modify_table_column/7-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.remove_table/3","doc":"Removes a table from a worksheet by name.","ref":"UmyaSpreadsheet.Table.html#remove_table/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.remove_table/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table to remove","ref":"UmyaSpreadsheet.Table.html#remove_table/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.remove_table/3","doc":"```elixir\nTable.remove_table(spreadsheet, \"Sheet1\", \"SalesTable\")\n```\n\nReturns `:ok` on success or `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.Table.html#remove_table/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.remove_table_style/3","doc":"Removes table style information, reverting to default styling.","ref":"UmyaSpreadsheet.Table.html#remove_table_style/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.remove_table_style/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table to remove styling from","ref":"UmyaSpreadsheet.Table.html#remove_table_style/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.remove_table_style/3","doc":"```elixir\nTable.remove_table_style(spreadsheet, \"Sheet1\", \"SalesTable\")\n```\n\nReturns `:ok` on success or `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.Table.html#remove_table_style/3-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.set_table_style/8","doc":"Sets table style information.","ref":"UmyaSpreadsheet.Table.html#set_table_style/8"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.set_table_style/8","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table to style\n  * `style_name` - Name of the table style to apply\n  * `show_first_col` - Boolean to highlight the first column\n  * `show_last_col` - Boolean to highlight the last column\n  * `show_row_stripes` - Boolean to show alternating row colors\n  * `show_col_stripes` - Boolean to show alternating column colors","ref":"UmyaSpreadsheet.Table.html#set_table_style/8-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.set_table_style/8","doc":"```elixir\nTable.set_table_style(\n  spreadsheet,\n  \"Sheet1\",\n  \"SalesTable\",\n  \"TableStyleLight1\",\n  true,   # Highlight first column\n  true,   # Highlight last column\n  true,   # Show row stripes\n  false   # Don't show column stripes\n)\n```\n\nReturns `:ok` on success or `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.Table.html#set_table_style/8-examples"},{"type":"function","title":"UmyaSpreadsheet.Table.set_table_totals_row/4","doc":"Sets the visibility of the totals row for a table.","ref":"UmyaSpreadsheet.Table.html#set_table_totals_row/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.Table.set_table_totals_row/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - Name of the sheet containing the table\n  * `table_name` - Internal name of the table to modify\n  * `show_totals_row` - Boolean indicating whether to show the totals row","ref":"UmyaSpreadsheet.Table.html#set_table_totals_row/4-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.Table.set_table_totals_row/4","doc":"```elixir\n# Show the totals row\nTable.set_table_totals_row(spreadsheet, \"Sheet1\", \"SalesTable\", true)\n\n# Hide the totals row\nTable.set_table_totals_row(spreadsheet, \"Sheet1\", \"SalesTable\", false)\n```\n\nReturns `:ok` on success or `{:error, reason}` on failure.","ref":"UmyaSpreadsheet.Table.html#set_table_totals_row/4-examples"},{"type":"module","title":"UmyaSpreadsheet.VmlDrawing","doc":"Functions for working with VML (Vector Markup Language) drawings in Excel files.\n\nVML is a legacy format used in Excel for shapes, comments, and embedded objects.\nThis module allows you to create and manipulate VML shapes in Excel files.","ref":"UmyaSpreadsheet.VmlDrawing.html"},{"type":"module","title":"Examples - UmyaSpreadsheet.VmlDrawing","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.VmlDrawing.create_shape(spreadsheet, \"Sheet1\", \"shape1\")\n    :ok\n    iex> UmyaSpreadsheet.VmlDrawing.set_shape_style(spreadsheet, \"Sheet1\", \"shape1\", \"position:absolute;left:100pt;top:150pt;width:200pt;height:100pt\")\n    :ok","ref":"UmyaSpreadsheet.VmlDrawing.html#module-examples"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.create_shape/3","doc":"Creates a new VML shape in the specified worksheet.","ref":"UmyaSpreadsheet.VmlDrawing.html#create_shape/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.create_shape/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape","ref":"UmyaSpreadsheet.VmlDrawing.html#create_shape/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.create_shape/3","doc":"* `:ok` on success\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#create_shape/3-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.get_shape_fill_color/3","doc":"Gets the fill color of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_fill_color/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.get_shape_fill_color/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_fill_color/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.get_shape_fill_color/3","doc":"* `{:ok, fill_color}` on success where fill_color is a color string (e.g. \"#FF0000\")\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_fill_color/3-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.get_shape_filled/3","doc":"Gets whether a VML shape is filled.","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_filled/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.get_shape_filled/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_filled/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.get_shape_filled/3","doc":"* `{:ok, filled}` on success where filled is a boolean\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_filled/3-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.get_shape_stroke_color/3","doc":"Gets the stroke (outline) color of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroke_color/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.get_shape_stroke_color/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroke_color/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.get_shape_stroke_color/3","doc":"* `{:ok, stroke_color}` on success where stroke_color is a color string (e.g. \"#0000FF\")\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroke_color/3-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.get_shape_stroke_weight/3","doc":"Gets the stroke (outline) weight/thickness of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroke_weight/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.get_shape_stroke_weight/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroke_weight/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.get_shape_stroke_weight/3","doc":"* `{:ok, stroke_weight}` on success where stroke_weight is a string (e.g. \"2pt\")\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroke_weight/3-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.get_shape_stroked/3","doc":"Gets whether a VML shape has a stroke (outline).","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroked/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.get_shape_stroked/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroked/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.get_shape_stroked/3","doc":"* `{:ok, stroked}` on success where stroked is a boolean\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_stroked/3-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.get_shape_style/3","doc":"Gets the CSS style of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_style/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.get_shape_style/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_style/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.get_shape_style/3","doc":"* `{:ok, style}` on success where style is a CSS style string\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_style/3-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.get_shape_type/3","doc":"Gets the type of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_type/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.get_shape_type/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_type/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.get_shape_type/3","doc":"* `{:ok, shape_type}` on success where shape_type is the type (e.g. \"rect\", \"oval\", etc.)\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#get_shape_type/3-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.set_shape_fill_color/4","doc":"Sets the fill color of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_fill_color/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.set_shape_fill_color/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape\n  * `fill_color` - The fill color (e.g. \"#FF0000\" for red)","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_fill_color/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.set_shape_fill_color/4","doc":"* `:ok` on success\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_fill_color/4-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.set_shape_filled/4","doc":"Sets whether a VML shape is filled.","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_filled/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.set_shape_filled/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape\n  * `filled` - Whether the shape should be filled (boolean)","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_filled/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.set_shape_filled/4","doc":"* `:ok` on success\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_filled/4-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.set_shape_stroke_color/4","doc":"Sets the stroke (outline) color of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroke_color/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.set_shape_stroke_color/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape\n  * `stroke_color` - The stroke color (e.g. \"#0000FF\" for blue)","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroke_color/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.set_shape_stroke_color/4","doc":"* `:ok` on success\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroke_color/4-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.set_shape_stroke_weight/4","doc":"Sets the stroke (outline) weight/thickness of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroke_weight/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.set_shape_stroke_weight/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape\n  * `stroke_weight` - The stroke weight (e.g. \"2pt\")","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroke_weight/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.set_shape_stroke_weight/4","doc":"* `:ok` on success\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroke_weight/4-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.set_shape_stroked/4","doc":"Sets whether a VML shape has a stroke (outline).","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroked/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.set_shape_stroked/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape\n  * `stroked` - Whether the shape should have a stroke (boolean)","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroked/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.set_shape_stroked/4","doc":"* `:ok` on success\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_stroked/4-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.set_shape_style/4","doc":"Sets the CSS style for a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_style/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.set_shape_style/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape\n  * `style` - CSS style string (e.g. \"position:absolute;left:100pt;top:150pt;width:200pt;height:100pt\")","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_style/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.set_shape_style/4","doc":"* `:ok` on success\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_style/4-returns"},{"type":"function","title":"UmyaSpreadsheet.VmlDrawing.set_shape_type/4","doc":"Sets the type of a VML shape.","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_type/4"},{"type":"function","title":"Parameters - UmyaSpreadsheet.VmlDrawing.set_shape_type/4","doc":"* `spreadsheet` - A spreadsheet struct\n  * `sheet_name` - The name of the worksheet\n  * `shape_id` - Unique identifier for the shape\n  * `shape_type` - The shape type (e.g. \"rect\", \"oval\", \"line\", etc.)","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_type/4-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.VmlDrawing.set_shape_type/4","doc":"* `:ok` on success\n  * `{:error, reason}` on failure","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_type/4-returns"},{"type":"function","title":"Shape Types - UmyaSpreadsheet.VmlDrawing.set_shape_type/4","doc":"Common shape types include:\n\n* `\"rect\"` - Rectangle\n* `\"oval\"` - Oval or circle\n* `\"line\"` - Line\n* `\"polyline\"` - Polyline\n* `\"roundrect\"` - Rounded rectangle\n* `\"arc\"` - Arc","ref":"UmyaSpreadsheet.VmlDrawing.html#set_shape_type/4-shape-types"},{"type":"module","title":"UmyaSpreadsheet.WorkbookFunctions","doc":"Functions for manipulating workbook properties and security.","ref":"UmyaSpreadsheet.WorkbookFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.WorkbookFunctions.set_password/3","doc":"Sets password protection for an existing Excel file.\n\nThis function adds password protection to an existing file without loading it into memory.","ref":"UmyaSpreadsheet.WorkbookFunctions.html#set_password/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.WorkbookFunctions.set_password/3","doc":"- `input_path` - Path to the input Excel file\n- `output_path` - Path where the protected file should be saved\n- `password` - The password to protect the file with","ref":"UmyaSpreadsheet.WorkbookFunctions.html#set_password/3-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.WorkbookFunctions.set_password/3","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.WorkbookFunctions.html#set_password/3-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.WorkbookFunctions.set_password/3","doc":":ok = UmyaSpreadsheet.WorkbookFunctions.set_password(\"input.xlsx\", \"protected.xlsx\", \"password123\")","ref":"UmyaSpreadsheet.WorkbookFunctions.html#set_password/3-examples"},{"type":"function","title":"UmyaSpreadsheet.WorkbookFunctions.set_workbook_protection/2","doc":"Sets workbook protection with a password.","ref":"UmyaSpreadsheet.WorkbookFunctions.html#set_workbook_protection/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.WorkbookFunctions.set_workbook_protection/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `password` - The password to protect the workbook with","ref":"UmyaSpreadsheet.WorkbookFunctions.html#set_workbook_protection/2-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.WorkbookFunctions.set_workbook_protection/2","doc":"- `:ok` on success\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.WorkbookFunctions.html#set_workbook_protection/2-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.WorkbookFunctions.set_workbook_protection/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    :ok = UmyaSpreadsheet.WorkbookFunctions.set_workbook_protection(spreadsheet, \"password123\")","ref":"UmyaSpreadsheet.WorkbookFunctions.html#set_workbook_protection/2-examples"},{"type":"module","title":"UmyaSpreadsheet.WorkbookProtectionFunctions","doc":"Functions for managing workbook protection settings and retrieving protection status.\n\nExcel workbooks can be protected to prevent structural changes, window modifications, or revision tracking.\nThis module provides functions to:\n* Check if workbook protection is enabled\n* Retrieve protection settings and status\n* Enable/disable various protection features","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.WorkbookProtectionFunctions.get_workbook_protection_details/1","doc":"Gets detailed information about workbook protection settings.","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html#get_workbook_protection_details/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.WorkbookProtectionFunctions.get_workbook_protection_details/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html#get_workbook_protection_details/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.WorkbookProtectionFunctions.get_workbook_protection_details/1","doc":"- `{:ok, protection_details}` where protection_details is a map containing protection settings:\n  - `\"lock_structure\"` - \"true\" if structure changes are prevented\n  - `\"lock_windows\"` - \"true\" if window changes are prevented\n  - `\"lock_revision\"` - \"true\" if revision tracking is enabled\n- `{:error, reason}` if the workbook is not protected or on failure","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html#get_workbook_protection_details/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.WorkbookProtectionFunctions.get_workbook_protection_details/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"protected.xlsx\")\n    {:ok, details} = UmyaSpreadsheet.WorkbookProtectionFunctions.get_workbook_protection_details(spreadsheet)\n    # details = %{\n    #   \"lock_structure\" => \"true\",\n    #   \"lock_windows\" => \"true\",\n    #   \"lock_revision\" => \"false\"\n    # }","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html#get_workbook_protection_details/1-examples"},{"type":"function","title":"UmyaSpreadsheet.WorkbookProtectionFunctions.is_workbook_protected/1","doc":"Checks if the workbook has protection enabled.","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html#is_workbook_protected/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.WorkbookProtectionFunctions.is_workbook_protected/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html#is_workbook_protected/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.WorkbookProtectionFunctions.is_workbook_protected/1","doc":"- `{:ok, is_protected}` where is_protected is a boolean indicating if protection is enabled\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html#is_workbook_protected/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.WorkbookProtectionFunctions.is_workbook_protected/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, protected} = UmyaSpreadsheet.WorkbookProtectionFunctions.is_workbook_protected(spreadsheet)\n    # protected = true (if workbook is protected)","ref":"UmyaSpreadsheet.WorkbookProtectionFunctions.html#is_workbook_protected/1-examples"},{"type":"module","title":"UmyaSpreadsheet.WorkbookViewFunctions","doc":"Functions for configuring how the workbook is displayed in the Excel application.\nThese settings affect the overall workbook window rather than individual sheet views.\n\nThis module provides functions to:\n* Get and set the active tab (worksheet) when the workbook is opened\n* Get and set the position and size of the Excel application window","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html"},{"type":"function","title":"UmyaSpreadsheet.WorkbookViewFunctions.get_active_tab/1","doc":"Gets the index of the active tab (worksheet) when the workbook is opened.\n\nTab indices are zero-based, meaning the first tab has index 0, the second has index 1, etc.","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#get_active_tab/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.WorkbookViewFunctions.get_active_tab/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#get_active_tab/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.WorkbookViewFunctions.get_active_tab/1","doc":"- `{:ok, tab_index}` where tab_index is the zero-based index of the active tab\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#get_active_tab/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.WorkbookViewFunctions.get_active_tab/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, active_tab} = UmyaSpreadsheet.WorkbookViewFunctions.get_active_tab(spreadsheet)\n    # active_tab = 2 (third worksheet is active)","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#get_active_tab/1-examples"},{"type":"function","title":"UmyaSpreadsheet.WorkbookViewFunctions.get_workbook_window_position/1","doc":"Gets the position and size settings for the workbook window in Excel.","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#get_workbook_window_position/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.WorkbookViewFunctions.get_workbook_window_position/1","doc":"- `spreadsheet` - The spreadsheet struct","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#get_workbook_window_position/1-parameters"},{"type":"function","title":"Returns - UmyaSpreadsheet.WorkbookViewFunctions.get_workbook_window_position/1","doc":"- `{:ok, window_info}` where window_info is a map containing position and size information\n  with keys `:x_position`, `:y_position`, `:width`, and `:height`\n- `{:error, reason}` on failure","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#get_workbook_window_position/1-returns"},{"type":"function","title":"Examples - UmyaSpreadsheet.WorkbookViewFunctions.get_workbook_window_position/1","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    {:ok, window_info} = UmyaSpreadsheet.WorkbookViewFunctions.get_workbook_window_position(spreadsheet)\n    # window_info = %{\"x_position\" => \"240\", \"y_position\" => \"105\", \"width\" => \"14805\", \"height\" => \"8010\"}","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#get_workbook_window_position/1-examples"},{"type":"function","title":"UmyaSpreadsheet.WorkbookViewFunctions.set_active_tab/2","doc":"Sets which tab (worksheet) is active when the workbook is opened.","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#set_active_tab/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.WorkbookViewFunctions.set_active_tab/2","doc":"- `spreadsheet` - The spreadsheet struct\n- `tab_index` - The zero-based index of the tab to make active","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#set_active_tab/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.WorkbookViewFunctions.set_active_tab/2","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Make the second tab active when opening the file\n    :ok = UmyaSpreadsheet.WorkbookViewFunctions.set_active_tab(spreadsheet, 1)\n\n    # Make the first tab active\n    :ok = UmyaSpreadsheet.WorkbookViewFunctions.set_active_tab(spreadsheet, 0)","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#set_active_tab/2-examples"},{"type":"function","title":"UmyaSpreadsheet.WorkbookViewFunctions.set_workbook_window_position/5","doc":"Sets the position and size of the workbook window when opened in Excel.","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#set_workbook_window_position/5"},{"type":"function","title":"Parameters - UmyaSpreadsheet.WorkbookViewFunctions.set_workbook_window_position/5","doc":"- `spreadsheet` - The spreadsheet struct\n- `x_position` - The horizontal position of the window in pixels\n- `y_position` - The vertical position of the window in pixels\n- `window_width` - The width of the window in pixels\n- `window_height` - The height of the window in pixels","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#set_workbook_window_position/5-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.WorkbookViewFunctions.set_workbook_window_position/5","doc":"{:ok, spreadsheet} = UmyaSpreadsheet.read_file(\"input.xlsx\")\n    # Set the workbook to open at position (100, 50) with a size of 800x600\n    :ok = UmyaSpreadsheet.WorkbookViewFunctions.set_workbook_window_position(spreadsheet, 100, 50, 800, 600)","ref":"UmyaSpreadsheet.WorkbookViewFunctions.html#set_workbook_window_position/5-examples"},{"type":"module","title":"UmyaSpreadsheetEx.CustomStructs.CustomColor","doc":"Struct for representing colors with ARGB values.","ref":"UmyaSpreadsheetEx.CustomStructs.CustomColor.html"},{"type":"function","title":"UmyaSpreadsheetEx.CustomStructs.CustomColor.from_hex/1","doc":"Creates a new CustomColor struct from a hex color string.","ref":"UmyaSpreadsheetEx.CustomStructs.CustomColor.html#from_hex/1"},{"type":"function","title":"Examples - UmyaSpreadsheetEx.CustomStructs.CustomColor.from_hex/1","doc":"iex> UmyaSpreadsheetEx.CustomStructs.CustomColor.from_hex(\"#FF0000\")\n    %UmyaSpreadsheetEx.CustomStructs.CustomColor{argb: \"FFFF0000\"}\n\n    iex> UmyaSpreadsheetEx.CustomStructs.CustomColor.from_hex(\"00FF00\")\n    %UmyaSpreadsheetEx.CustomStructs.CustomColor{argb: \"FF00FF00\"}","ref":"UmyaSpreadsheetEx.CustomStructs.CustomColor.html#from_hex/1-examples"},{"type":"module","title":"UmyaSpreadsheet","doc":"UmyaSpreadsheet is an Elixir wrapper for the Rust `umya-spreadsheet` library,\nwhich provides Excel (.xlsx, .xlsm) file manipulation capabilities with the\nperformance benefits of Rust.","ref":"UmyaSpreadsheet.html"},{"type":"module","title":"Overview - UmyaSpreadsheet","doc":"This library allows you to:\n- Create new spreadsheets from scratch\n- Read/write Excel files with full formatting support\n- Manipulate cell values, formulas, and styles\n- Move and organize ranges of data\n- Add and manage multiple worksheets\n- Create charts, images, and visual elements\n- Embed OLE objects (Word documents, PowerPoint presentations, etc.)\n- Add data validation and conditional formatting\n- Export to CSV with performance optimizations\n- Apply advanced formatting and styling options","ref":"UmyaSpreadsheet.html#module-overview"},{"type":"module","title":"Architecture - UmyaSpreadsheet","doc":"UmyaSpreadsheet follows a modular architecture with specialized function modules:","ref":"UmyaSpreadsheet.html#module-architecture"},{"type":"module","title":"Core Architecture - UmyaSpreadsheet","doc":"```\nUmyaSpreadsheet (Main Module)\n├── UmyaNative (Rust NIF Interface)\n│   ├── Spreadsheet Operations (new, read, write)\n│   ├── Cell Operations (get/set values, formatting)\n│   ├── Sheet Management (add, remove, rename)\n│   └── Native Rust Library (umya-spreadsheet)\n│\n└── Specialized Function Modules:\n    ├── AdvancedFillFunctions - Advanced gradient and pattern fills\n    ├── AutoFilterFunctions - Data filtering and sorting\n    ├── BackgroundFunctions - Cell background colors and patterns\n    ├── BorderFunctions - Cell border styling and formatting\n    ├── CellFunctions - Cell value manipulation and retrieval\n    ├── ChartFunctions - Chart creation and customization\n    ├── CommentFunctions - Cell comment management\n    ├── ConditionalFormatting - Advanced conditional formatting rules\n    ├── CSVFunctions - CSV export and import operations\n    ├── DataValidation - Input validation and dropdown lists\n    ├── Drawing - Shapes, connectors, and drawing objects\n    ├── FileFormatOptions - File format and compression options\n    ├── FontFunctions - Font styling and text formatting\n    ├── FormulaFunctions - Formula creation and named ranges\n    ├── Hyperlink - Hyperlink management and navigation\n    ├── ImageFunctions - Image insertion and positioning\n    ├── OleObjects - Object Linking and Embedding (OLE) objects\n    ├── PerformanceFunctions - Memory-optimized operations\n    ├── PivotTable - Pivot table creation and management\n    ├── RichText - Formatted text within cells with styling\n    ├── Table - Excel table creation and management\n    ├── PrintSettings - Page setup and print configuration\n    ├── ProtectionFunctions - Security and access control\n    ├── RowColumnFunctions - Row and column operations\n    ├── SheetFunctions - Worksheet management and properties\n    ├── StyleFunctions - Cell styling and number formatting\n    └── WindowFunctions - View settings and window management\n```","ref":"UmyaSpreadsheet.html#module-core-architecture"},{"type":"module","title":"Data Flow - UmyaSpreadsheet","doc":"1. **NIF Layer**: All operations go through the native interface which interfaces with Rust\n2. **Spreadsheet Reference**: Operations work on a Rust-managed spreadsheet reference\n3. **Function Modules**: Specialized modules provide domain-specific functionality\n4. **Error Handling**: Comprehensive error handling with descriptive messages\n5. **Memory Management**: Rust handles memory management for performance","ref":"UmyaSpreadsheet.html#module-data-flow"},{"type":"module","title":"Thread Safety - UmyaSpreadsheet","doc":"The library is designed for concurrent operations:\n- Each spreadsheet maintains its own Rust reference\n- Multiple spreadsheets can be operated on simultaneously\n- Thread-safe patterns are documented in the guides","ref":"UmyaSpreadsheet.html#module-thread-safety"},{"type":"module","title":"Performance Characteristics - UmyaSpreadsheet","doc":"- **Memory Efficient**: Rust memory management with minimal Elixir overhead\n- **Fast I/O**: Native Rust file operations for reading/writing\n- **Lazy Loading**: Optional lazy reading for large files\n- **Light Writers**: Memory-optimized writers for simple operations\n- **Concurrent Safe**: Multiple processes can work with different spreadsheets","ref":"UmyaSpreadsheet.html#module-performance-characteristics"},{"type":"module","title":"Compatibility - UmyaSpreadsheet","doc":"- **Excel Versions**: Full support for Excel 2007+ (.xlsx, .xlsm formats)\n- **Elixir Versions**: Compatible with Elixir 1.12+\n- **OTP Versions**: Compatible with OTP 24+\n- **Platforms**: Linux, macOS, Windows (via precompiled NIFs)","ref":"UmyaSpreadsheet.html#module-compatibility"},{"type":"module","title":"Guides - UmyaSpreadsheet","doc":"For detailed guides on specific features, see:\n\n- [Charts](charts.html) - Creating and customizing various chart types\n- [CSV Export & Performance](csv_export_and_performance.html) - CSV export and optimized writers\n- [Image Handling](image_handling.html) - Working with images in spreadsheets\n- [Sheet Operations](sheet_operations.html) - Managing worksheets effectively\n- [Styling and Formatting](styling_and_formatting.html) - Making your spreadsheets look professional\n\nSee the [Guide Index](guides.html) for a complete list of available guides.","ref":"UmyaSpreadsheet.html#module-guides"},{"type":"module","title":"Quick Start - UmyaSpreadsheet","doc":"# Create a new spreadsheet\n    {:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n    # Set some cell values\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Hello\")\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"World\")\n\n    # Apply formatting\n    UmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\n    UmyaSpreadsheet.set_background_color(spreadsheet, \"Sheet1\", \"A1\", \"#FF0000\")\n\n    # Write to file\n    UmyaSpreadsheet.write(spreadsheet, \"example.xlsx\")","ref":"UmyaSpreadsheet.html#module-quick-start"},{"type":"module","title":"Error Handling - UmyaSpreadsheet","doc":"Most functions return either `:ok` or `{:error, reason}` tuples. Common error patterns:\n\n    case UmyaSpreadsheet.set_cell_value(spreadsheet, \"NonExistent\", \"A1\", \"value\") do\n      :ok -> IO.puts(\"Success!\")\n      {:error, reason} -> IO.puts(\"Error: #{inspect(reason)}\")\n    end","ref":"UmyaSpreadsheet.html#module-error-handling"},{"type":"function","title":"UmyaSpreadsheet.add_above_below_average_rule/6","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_above_below_average_rule/6 .","ref":"UmyaSpreadsheet.html#add_above_below_average_rule/6"},{"type":"function","title":"UmyaSpreadsheet.add_cell_is_rule/7","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_cell_is_rule/7 .","ref":"UmyaSpreadsheet.html#add_cell_is_rule/7"},{"type":"function","title":"UmyaSpreadsheet.add_cell_value_rule/7","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_cell_value_rule/7 .","ref":"UmyaSpreadsheet.html#add_cell_value_rule/7"},{"type":"function","title":"UmyaSpreadsheet.add_chart/9","doc":"See  UmyaSpreadsheet.ChartFunctions.add_chart/9 .","ref":"UmyaSpreadsheet.html#add_chart/9"},{"type":"function","title":"UmyaSpreadsheet.add_chart_with_options/15","doc":"See  UmyaSpreadsheet.ChartFunctions.add_chart_with_options/15 .","ref":"UmyaSpreadsheet.html#add_chart_with_options/15"},{"type":"function","title":"UmyaSpreadsheet.add_chart_with_options/16","doc":"See  UmyaSpreadsheet.ChartFunctions.add_chart_with_options/16 .","ref":"UmyaSpreadsheet.html#add_chart_with_options/16"},{"type":"function","title":"UmyaSpreadsheet.add_color_scale/9","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_color_scale/9 .","ref":"UmyaSpreadsheet.html#add_color_scale/9"},{"type":"function","title":"UmyaSpreadsheet.add_color_scale/12","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_color_scale/12 .","ref":"UmyaSpreadsheet.html#add_color_scale/12"},{"type":"function","title":"UmyaSpreadsheet.add_comment/5","doc":"Adds a comment to a cell.","ref":"UmyaSpreadsheet.html#add_comment/5"},{"type":"function","title":"UmyaSpreadsheet.add_connector/6","doc":"See  UmyaSpreadsheet.Drawing.add_connector/6 .","ref":"UmyaSpreadsheet.html#add_connector/6"},{"type":"function","title":"UmyaSpreadsheet.add_custom_validation/4","doc":"See  UmyaSpreadsheet.DataValidation.add_custom_validation/4 .","ref":"UmyaSpreadsheet.html#add_custom_validation/4"},{"type":"function","title":"UmyaSpreadsheet.add_custom_validation/5","doc":"See  UmyaSpreadsheet.DataValidation.add_custom_validation/5 .","ref":"UmyaSpreadsheet.html#add_custom_validation/5"},{"type":"function","title":"UmyaSpreadsheet.add_custom_validation/9","doc":"See  UmyaSpreadsheet.DataValidation.add_custom_validation/9 .","ref":"UmyaSpreadsheet.html#add_custom_validation/9"},{"type":"function","title":"UmyaSpreadsheet.add_data_bar/6","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_data_bar/6 .","ref":"UmyaSpreadsheet.html#add_data_bar/6"},{"type":"function","title":"UmyaSpreadsheet.add_date_validation/5","doc":"See  UmyaSpreadsheet.DataValidation.add_date_validation/5 .","ref":"UmyaSpreadsheet.html#add_date_validation/5"},{"type":"function","title":"UmyaSpreadsheet.add_date_validation/6","doc":"See  UmyaSpreadsheet.DataValidation.add_date_validation/6 .","ref":"UmyaSpreadsheet.html#add_date_validation/6"},{"type":"function","title":"UmyaSpreadsheet.add_date_validation/7","doc":"See  UmyaSpreadsheet.DataValidation.add_date_validation/7 .","ref":"UmyaSpreadsheet.html#add_date_validation/7"},{"type":"function","title":"UmyaSpreadsheet.add_date_validation/11","doc":"See  UmyaSpreadsheet.DataValidation.add_date_validation/11 .","ref":"UmyaSpreadsheet.html#add_date_validation/11"},{"type":"function","title":"UmyaSpreadsheet.add_formatted_text_to_rich_text/3","doc":"Adds formatted text directly to a RichText object.","ref":"UmyaSpreadsheet.html#add_formatted_text_to_rich_text/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.add_formatted_text_to_rich_text/3","doc":"iex> rich_text = UmyaSpreadsheet.create_rich_text()\n    iex> UmyaSpreadsheet.add_formatted_text_to_rich_text(rich_text, \"Bold text\", %{bold: true})\n    :ok","ref":"UmyaSpreadsheet.html#add_formatted_text_to_rich_text/3-examples"},{"type":"function","title":"UmyaSpreadsheet.add_hyperlink/6","doc":"Adds a hyperlink to a cell.","ref":"UmyaSpreadsheet.html#add_hyperlink/6"},{"type":"function","title":"UmyaSpreadsheet.add_icon_set/5","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_icon_set/5 .","ref":"UmyaSpreadsheet.html#add_icon_set/5"},{"type":"function","title":"UmyaSpreadsheet.add_image/4","doc":"See  UmyaSpreadsheet.ImageFunctions.add_image/4 .","ref":"UmyaSpreadsheet.html#add_image/4"},{"type":"function","title":"UmyaSpreadsheet.add_list_validation/4","doc":"See  UmyaSpreadsheet.DataValidation.add_list_validation/4 .","ref":"UmyaSpreadsheet.html#add_list_validation/4"},{"type":"function","title":"UmyaSpreadsheet.add_list_validation/5","doc":"See  UmyaSpreadsheet.DataValidation.add_list_validation/5 .","ref":"UmyaSpreadsheet.html#add_list_validation/5"},{"type":"function","title":"UmyaSpreadsheet.add_list_validation/6","doc":"See  UmyaSpreadsheet.DataValidation.add_list_validation/6 .","ref":"UmyaSpreadsheet.html#add_list_validation/6"},{"type":"function","title":"UmyaSpreadsheet.add_list_validation/9","doc":"See  UmyaSpreadsheet.DataValidation.add_list_validation/9 .","ref":"UmyaSpreadsheet.html#add_list_validation/9"},{"type":"function","title":"UmyaSpreadsheet.add_merge_cells/3","doc":"See  UmyaSpreadsheet.SheetFunctions.add_merge_cells/3 .","ref":"UmyaSpreadsheet.html#add_merge_cells/3"},{"type":"function","title":"UmyaSpreadsheet.add_number_validation/5","doc":"See  UmyaSpreadsheet.DataValidation.add_number_validation/5 .","ref":"UmyaSpreadsheet.html#add_number_validation/5"},{"type":"function","title":"UmyaSpreadsheet.add_number_validation/6","doc":"See  UmyaSpreadsheet.DataValidation.add_number_validation/6 .","ref":"UmyaSpreadsheet.html#add_number_validation/6"},{"type":"function","title":"UmyaSpreadsheet.add_number_validation/7","doc":"See  UmyaSpreadsheet.DataValidation.add_number_validation/7 .","ref":"UmyaSpreadsheet.html#add_number_validation/7"},{"type":"function","title":"UmyaSpreadsheet.add_number_validation/11","doc":"See  UmyaSpreadsheet.DataValidation.add_number_validation/11 .","ref":"UmyaSpreadsheet.html#add_number_validation/11"},{"type":"function","title":"UmyaSpreadsheet.add_ole_object/2","doc":"Adds an OLE object to a collection.","ref":"UmyaSpreadsheet.html#add_ole_object/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.add_ole_object/2","doc":"iex> {:ok, ole_objects} = UmyaSpreadsheet.new_ole_objects()\n    iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> UmyaSpreadsheet.add_ole_object(ole_objects, ole_object)\n    :ok","ref":"UmyaSpreadsheet.html#add_ole_object/2-examples"},{"type":"function","title":"UmyaSpreadsheet.add_pivot_table/9","doc":"See  UmyaSpreadsheet.PivotTable.add_pivot_table/9 .","ref":"UmyaSpreadsheet.html#add_pivot_table/9"},{"type":"function","title":"UmyaSpreadsheet.add_shape/9","doc":"See  UmyaSpreadsheet.Drawing.add_shape/9 .","ref":"UmyaSpreadsheet.html#add_shape/9"},{"type":"function","title":"UmyaSpreadsheet.add_sheet/2","doc":"See  UmyaSpreadsheet.SheetFunctions.add_sheet/2 .","ref":"UmyaSpreadsheet.html#add_sheet/2"},{"type":"function","title":"UmyaSpreadsheet.add_table/8","doc":"See  UmyaSpreadsheet.Table.add_table/8 .","ref":"UmyaSpreadsheet.html#add_table/8"},{"type":"function","title":"UmyaSpreadsheet.add_table_column/6","doc":"See  UmyaSpreadsheet.Table.add_table_column/6 .","ref":"UmyaSpreadsheet.html#add_table_column/6"},{"type":"function","title":"UmyaSpreadsheet.add_text_box/10","doc":"See  UmyaSpreadsheet.Drawing.add_text_box/10 .","ref":"UmyaSpreadsheet.html#add_text_box/10"},{"type":"function","title":"UmyaSpreadsheet.add_text_element_to_rich_text/2","doc":"Adds a TextElement to a RichText object.","ref":"UmyaSpreadsheet.html#add_text_element_to_rich_text/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.add_text_element_to_rich_text/2","doc":"iex> rich_text = UmyaSpreadsheet.create_rich_text()\n    iex> element = UmyaSpreadsheet.create_text_element(\"Test\", %{bold: true})\n    iex> UmyaSpreadsheet.add_text_element_to_rich_text(rich_text, element)\n    :ok","ref":"UmyaSpreadsheet.html#add_text_element_to_rich_text/2-examples"},{"type":"function","title":"UmyaSpreadsheet.add_text_length_validation/5","doc":"See  UmyaSpreadsheet.DataValidation.add_text_length_validation/5 .","ref":"UmyaSpreadsheet.html#add_text_length_validation/5"},{"type":"function","title":"UmyaSpreadsheet.add_text_length_validation/6","doc":"See  UmyaSpreadsheet.DataValidation.add_text_length_validation/6 .","ref":"UmyaSpreadsheet.html#add_text_length_validation/6"},{"type":"function","title":"UmyaSpreadsheet.add_text_length_validation/7","doc":"See  UmyaSpreadsheet.DataValidation.add_text_length_validation/7 .","ref":"UmyaSpreadsheet.html#add_text_length_validation/7"},{"type":"function","title":"UmyaSpreadsheet.add_text_length_validation/11","doc":"See  UmyaSpreadsheet.DataValidation.add_text_length_validation/11 .","ref":"UmyaSpreadsheet.html#add_text_length_validation/11"},{"type":"function","title":"UmyaSpreadsheet.add_text_rule/6","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_text_rule/6 .","ref":"UmyaSpreadsheet.html#add_text_rule/6"},{"type":"function","title":"UmyaSpreadsheet.add_top_bottom_rule/7","doc":"See  UmyaSpreadsheet.ConditionalFormatting.add_top_bottom_rule/7 .","ref":"UmyaSpreadsheet.html#add_top_bottom_rule/7"},{"type":"function","title":"UmyaSpreadsheet.change_image/4","doc":"See  UmyaSpreadsheet.ImageFunctions.change_image/4 .","ref":"UmyaSpreadsheet.html#change_image/4"},{"type":"function","title":"UmyaSpreadsheet.clear_fill/3","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.clear_fill/3 .","ref":"UmyaSpreadsheet.html#clear_fill/3"},{"type":"function","title":"UmyaSpreadsheet.clone_sheet/3","doc":"See  UmyaSpreadsheet.SheetFunctions.clone_sheet/3 .","ref":"UmyaSpreadsheet.html#clone_sheet/3"},{"type":"function","title":"UmyaSpreadsheet.copy_column_styling/4","doc":"See  UmyaSpreadsheet.StylingFunctions.copy_column_styling/4 .","ref":"UmyaSpreadsheet.html#copy_column_styling/4"},{"type":"function","title":"UmyaSpreadsheet.copy_column_styling/6","doc":"See  UmyaSpreadsheet.StylingFunctions.copy_column_styling/6 .","ref":"UmyaSpreadsheet.html#copy_column_styling/6"},{"type":"function","title":"UmyaSpreadsheet.copy_row_styling/4","doc":"See  UmyaSpreadsheet.RowColumnFunctions.copy_row_styling/4 .","ref":"UmyaSpreadsheet.html#copy_row_styling/4"},{"type":"function","title":"UmyaSpreadsheet.copy_row_styling/6","doc":"See  UmyaSpreadsheet.RowColumnFunctions.copy_row_styling/6 .","ref":"UmyaSpreadsheet.html#copy_row_styling/6"},{"type":"function","title":"UmyaSpreadsheet.count_pivot_tables/2","doc":"See  UmyaSpreadsheet.PivotTable.count_pivot_tables/2 .","ref":"UmyaSpreadsheet.html#count_pivot_tables/2"},{"type":"function","title":"UmyaSpreadsheet.count_tables/2","doc":"See  UmyaSpreadsheet.Table.count_tables/2 .","ref":"UmyaSpreadsheet.html#count_tables/2"},{"type":"function","title":"UmyaSpreadsheet.create_defined_name/4","doc":"Creates a defined name in the spreadsheet with an associated formula.","ref":"UmyaSpreadsheet.html#create_defined_name/4"},{"type":"function","title":"Examples - UmyaSpreadsheet.create_defined_name/4","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.create_defined_name(spreadsheet, \"TaxRate\", \"0.15\")\n    :ok\n\n    iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.create_defined_name(spreadsheet, \"Department\", \"Sales\", \"Sheet1\")\n    :ok","ref":"UmyaSpreadsheet.html#create_defined_name/4-examples"},{"type":"function","title":"UmyaSpreadsheet.create_named_range/4","doc":"Creates a named range in the spreadsheet.","ref":"UmyaSpreadsheet.html#create_named_range/4"},{"type":"function","title":"Examples - UmyaSpreadsheet.create_named_range/4","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.create_named_range(spreadsheet, \"MyRange\", \"Sheet1\", \"A1:B10\")\n    :ok","ref":"UmyaSpreadsheet.html#create_named_range/4-examples"},{"type":"function","title":"UmyaSpreadsheet.create_rich_text/0","doc":"Creates a new empty RichText object for building formatted text.","ref":"UmyaSpreadsheet.html#create_rich_text/0"},{"type":"function","title":"Examples - UmyaSpreadsheet.create_rich_text/0","doc":"iex> rich_text = UmyaSpreadsheet.create_rich_text()\n    iex> is_reference(rich_text)\n    true","ref":"UmyaSpreadsheet.html#create_rich_text/0-examples"},{"type":"function","title":"UmyaSpreadsheet.create_rich_text_from_html/1","doc":"Creates a RichText object from an HTML string with formatting.","ref":"UmyaSpreadsheet.html#create_rich_text_from_html/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.create_rich_text_from_html/1","doc":"iex> html = \" Bold  and  italic  text\"\n    iex> rich_text = UmyaSpreadsheet.create_rich_text_from_html(html)\n    iex> is_reference(rich_text)\n    true","ref":"UmyaSpreadsheet.html#create_rich_text_from_html/1-examples"},{"type":"function","title":"UmyaSpreadsheet.create_text_element/2","doc":"Creates a TextElement with text and optional font properties.","ref":"UmyaSpreadsheet.html#create_text_element/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.create_text_element/2","doc":"iex> element = UmyaSpreadsheet.create_text_element(\"Bold text\", %{bold: true, color: \"#FF0000\"})\n    iex> is_reference(element)\n    true","ref":"UmyaSpreadsheet.html#create_text_element/2-examples"},{"type":"function","title":"UmyaSpreadsheet.download_image/4","doc":"See  UmyaSpreadsheet.ImageFunctions.download_image/4 .","ref":"UmyaSpreadsheet.html#download_image/4"},{"type":"function","title":"UmyaSpreadsheet.freeze_panes/4","doc":"See  UmyaSpreadsheet.SheetViewFunctions.freeze_panes/4 .","ref":"UmyaSpreadsheet.html#freeze_panes/4"},{"type":"function","title":"UmyaSpreadsheet.get_active_tab/1","doc":"See  UmyaSpreadsheet.WorkbookViewFunctions.get_active_tab/1 .","ref":"UmyaSpreadsheet.html#get_active_tab/1"},{"type":"function","title":"UmyaSpreadsheet.get_all_hyperlinks/2","doc":"Gets all hyperlinks from a worksheet.","ref":"UmyaSpreadsheet.html#get_all_hyperlinks/2"},{"type":"function","title":"UmyaSpreadsheet.get_auto_filter_range/2","doc":"Gets the range of an auto filter in a worksheet.","ref":"UmyaSpreadsheet.html#get_auto_filter_range/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_auto_filter_range/2","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E10\")\n    iex> UmyaSpreadsheet.get_auto_filter_range(spreadsheet, \"Sheet1\")\n    {:ok, \"A1:E10\"}","ref":"UmyaSpreadsheet.html#get_auto_filter_range/2-examples"},{"type":"function","title":"UmyaSpreadsheet.get_border_color/4","doc":"See  UmyaSpreadsheet.CellFunctions.get_border_color/4 .","ref":"UmyaSpreadsheet.html#get_border_color/4"},{"type":"function","title":"UmyaSpreadsheet.get_border_style/4","doc":"See  UmyaSpreadsheet.CellFunctions.get_border_style/4 .","ref":"UmyaSpreadsheet.html#get_border_style/4"},{"type":"function","title":"UmyaSpreadsheet.get_bx/3","doc":"Gets the bx property of a formula.\n\nThe bx property indicates whether the formula calculation\nshould be done on exit from the cell.","ref":"UmyaSpreadsheet.html#get_bx/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_bx/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_bx(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_bx/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_cell_background_color/3","doc":"See  UmyaSpreadsheet.BackgroundFunctions.get_cell_background_color/3 .","ref":"UmyaSpreadsheet.html#get_cell_background_color/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_foreground_color/3","doc":"See  UmyaSpreadsheet.BackgroundFunctions.get_cell_foreground_color/3 .","ref":"UmyaSpreadsheet.html#get_cell_foreground_color/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_format_code/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_format_code/3 .","ref":"UmyaSpreadsheet.html#get_cell_format_code/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_hidden/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_hidden/3 .","ref":"UmyaSpreadsheet.html#get_cell_hidden/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_horizontal_alignment/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_horizontal_alignment/3 .","ref":"UmyaSpreadsheet.html#get_cell_horizontal_alignment/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_locked/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_locked/3 .","ref":"UmyaSpreadsheet.html#get_cell_locked/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_number_format_id/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_number_format_id/3 .","ref":"UmyaSpreadsheet.html#get_cell_number_format_id/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_pattern_type/3","doc":"See  UmyaSpreadsheet.BackgroundFunctions.get_cell_pattern_type/3 .","ref":"UmyaSpreadsheet.html#get_cell_pattern_type/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_rich_text/3","doc":"Gets rich text from a specific cell.","ref":"UmyaSpreadsheet.html#get_cell_rich_text/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_cell_rich_text/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> rich_text = UmyaSpreadsheet.get_cell_rich_text(spreadsheet, \"Sheet1\", \"A1\")\n    iex> is_reference(rich_text)\n    true","ref":"UmyaSpreadsheet.html#get_cell_rich_text/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_cell_text_rotation/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_text_rotation/3 .","ref":"UmyaSpreadsheet.html#get_cell_text_rotation/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_value/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_value/3 .","ref":"UmyaSpreadsheet.html#get_cell_value/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_vertical_alignment/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_vertical_alignment/3 .","ref":"UmyaSpreadsheet.html#get_cell_vertical_alignment/3"},{"type":"function","title":"UmyaSpreadsheet.get_cell_wrap_text/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_cell_wrap_text/3 .","ref":"UmyaSpreadsheet.html#get_cell_wrap_text/3"},{"type":"function","title":"UmyaSpreadsheet.get_color_scales/3","doc":"See  UmyaSpreadsheet.ConditionalFormatting.get_color_scales/3 .","ref":"UmyaSpreadsheet.html#get_color_scales/3"},{"type":"function","title":"UmyaSpreadsheet.get_column_auto_width/3","doc":"See  UmyaSpreadsheet.RowColumnFunctions.get_column_auto_width/3 .","ref":"UmyaSpreadsheet.html#get_column_auto_width/3"},{"type":"function","title":"UmyaSpreadsheet.get_column_hidden/3","doc":"See  UmyaSpreadsheet.RowColumnFunctions.get_column_hidden/3 .","ref":"UmyaSpreadsheet.html#get_column_hidden/3"},{"type":"function","title":"UmyaSpreadsheet.get_column_width/3","doc":"See  UmyaSpreadsheet.RowColumnFunctions.get_column_width/3 .","ref":"UmyaSpreadsheet.html#get_column_width/3"},{"type":"function","title":"UmyaSpreadsheet.get_comment/3","doc":"Gets the comment text and author from a cell.","ref":"UmyaSpreadsheet.html#get_comment/3"},{"type":"function","title":"UmyaSpreadsheet.get_comments_count/2","doc":"Gets the number of comments in a sheet.","ref":"UmyaSpreadsheet.html#get_comments_count/2"},{"type":"function","title":"UmyaSpreadsheet.get_data_bars/3","doc":"See  UmyaSpreadsheet.ConditionalFormatting.get_data_bars/3 .","ref":"UmyaSpreadsheet.html#get_data_bars/3"},{"type":"function","title":"UmyaSpreadsheet.get_data_table_2d/3","doc":"Gets the data table 2D property of a formula.","ref":"UmyaSpreadsheet.html#get_data_table_2d/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_data_table_2d/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_data_table_2d(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_data_table_2d/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_data_table_row/3","doc":"Gets the data table row property of a formula.","ref":"UmyaSpreadsheet.html#get_data_table_row/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_data_table_row/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_data_table_row(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_data_table_row/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_defined_names/1","doc":"Gets all defined names in the spreadsheet.","ref":"UmyaSpreadsheet.html#get_defined_names/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_defined_names/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.create_named_range(spreadsheet, \"MyRange\", \"Sheet1\", \"A1:B10\")\n    iex> UmyaSpreadsheet.create_defined_name(spreadsheet, \"TaxRate\", \"0.15\")\n    iex> defined_names = UmyaSpreadsheet.get_defined_names(spreadsheet)\n    iex> is_list(defined_names)\n    true","ref":"UmyaSpreadsheet.html#get_defined_names/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_embedded_object_prog_id/1","doc":"Gets the ProgID from embedded object properties.","ref":"UmyaSpreadsheet.html#get_embedded_object_prog_id/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_embedded_object_prog_id/1","doc":"iex> {:ok, properties} = UmyaSpreadsheet.new_embedded_object_properties()\n    iex> :ok = UmyaSpreadsheet.set_embedded_object_prog_id(properties, \"Word.Document.12\")\n    iex> {:ok, \"Word.Document.12\"} = UmyaSpreadsheet.get_embedded_object_prog_id(properties)","ref":"UmyaSpreadsheet.html#get_embedded_object_prog_id/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_embedded_object_shape_id/1","doc":"Gets the shape ID from embedded object properties.","ref":"UmyaSpreadsheet.html#get_embedded_object_shape_id/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_embedded_object_shape_id/1","doc":"iex> {:ok, properties} = UmyaSpreadsheet.new_embedded_object_properties()\n    iex> :ok = UmyaSpreadsheet.set_embedded_object_shape_id(properties, 123)\n    iex> {:ok, 123} = UmyaSpreadsheet.get_embedded_object_shape_id(properties)","ref":"UmyaSpreadsheet.html#get_embedded_object_shape_id/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_fit_to_page/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_fit_to_page/2 .","ref":"UmyaSpreadsheet.html#get_fit_to_page/2"},{"type":"function","title":"UmyaSpreadsheet.get_font_bold/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_bold/3 .","ref":"UmyaSpreadsheet.html#get_font_bold/3"},{"type":"function","title":"UmyaSpreadsheet.get_font_color/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_color/3 .","ref":"UmyaSpreadsheet.html#get_font_color/3"},{"type":"function","title":"UmyaSpreadsheet.get_font_family/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_family/3 .","ref":"UmyaSpreadsheet.html#get_font_family/3"},{"type":"function","title":"UmyaSpreadsheet.get_font_italic/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_italic/3 .","ref":"UmyaSpreadsheet.html#get_font_italic/3"},{"type":"function","title":"UmyaSpreadsheet.get_font_name/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_name/3 .","ref":"UmyaSpreadsheet.html#get_font_name/3"},{"type":"function","title":"UmyaSpreadsheet.get_font_scheme/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_scheme/3 .","ref":"UmyaSpreadsheet.html#get_font_scheme/3"},{"type":"function","title":"UmyaSpreadsheet.get_font_size/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_size/3 .","ref":"UmyaSpreadsheet.html#get_font_size/3"},{"type":"function","title":"UmyaSpreadsheet.get_font_strikethrough/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_strikethrough/3 .","ref":"UmyaSpreadsheet.html#get_font_strikethrough/3"},{"type":"function","title":"UmyaSpreadsheet.get_font_underline/3","doc":"See  UmyaSpreadsheet.FontFunctions.get_font_underline/3 .","ref":"UmyaSpreadsheet.html#get_font_underline/3"},{"type":"function","title":"UmyaSpreadsheet.get_footer/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_footer/2 .","ref":"UmyaSpreadsheet.html#get_footer/2"},{"type":"function","title":"UmyaSpreadsheet.get_formatted_value/3","doc":"See  UmyaSpreadsheet.CellFunctions.get_formatted_value/3 .","ref":"UmyaSpreadsheet.html#get_formatted_value/3"},{"type":"function","title":"UmyaSpreadsheet.get_formula/3","doc":"Gets the formula text from a cell.","ref":"UmyaSpreadsheet.html#get_formula/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_formula/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_formula(spreadsheet, \"Sheet1\", \"A1\")\n    \"=SUM(B1:B10)\"","ref":"UmyaSpreadsheet.html#get_formula/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_formula_obj/3","doc":"Gets the complete formula object from a cell, returning detailed information.","ref":"UmyaSpreadsheet.html#get_formula_obj/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_formula_obj/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> {text, type, _shared_index, _reference} = UmyaSpreadsheet.get_formula_obj(spreadsheet, \"Sheet1\", \"A1\")\n    iex> text\n    \"=SUM(B1:B10)\"\n    iex> type\n    \"Normal\"","ref":"UmyaSpreadsheet.html#get_formula_obj/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_formula_shared_index/3","doc":"Gets the shared index of a formula in a cell.","ref":"UmyaSpreadsheet.html#get_formula_shared_index/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_formula_shared_index/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_formula_shared_index(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_formula_shared_index/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_formula_type/3","doc":"Gets the formula type of a cell.","ref":"UmyaSpreadsheet.html#get_formula_type/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_formula_type/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_formula_type(spreadsheet, \"Sheet1\", \"A1\")\n    \"Normal\"","ref":"UmyaSpreadsheet.html#get_formula_type/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_gradient_fill/3","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.get_gradient_fill/3 .","ref":"UmyaSpreadsheet.html#get_gradient_fill/3"},{"type":"function","title":"UmyaSpreadsheet.get_header/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_header/2 .","ref":"UmyaSpreadsheet.html#get_header/2"},{"type":"function","title":"UmyaSpreadsheet.get_header_footer_margins/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_header_footer_margins/2 .","ref":"UmyaSpreadsheet.html#get_header_footer_margins/2"},{"type":"function","title":"UmyaSpreadsheet.get_hyperlink/3","doc":"Gets hyperlink information from a cell.","ref":"UmyaSpreadsheet.html#get_hyperlink/3"},{"type":"function","title":"UmyaSpreadsheet.get_hyperlinks/2","doc":"Gets all hyperlinks from a worksheet (alias for get_all_hyperlinks).","ref":"UmyaSpreadsheet.html#get_hyperlinks/2"},{"type":"function","title":"UmyaSpreadsheet.get_icon_sets/3","doc":"See  UmyaSpreadsheet.ConditionalFormatting.get_icon_sets/3 .","ref":"UmyaSpreadsheet.html#get_icon_sets/3"},{"type":"function","title":"UmyaSpreadsheet.get_image_dimensions/3","doc":"See  UmyaSpreadsheet.ImageFunctions.get_image_dimensions/3 .","ref":"UmyaSpreadsheet.html#get_image_dimensions/3"},{"type":"function","title":"UmyaSpreadsheet.get_image_info/3","doc":"See  UmyaSpreadsheet.ImageFunctions.get_image_info/3 .","ref":"UmyaSpreadsheet.html#get_image_info/3"},{"type":"function","title":"UmyaSpreadsheet.get_input_1deleted/3","doc":"Gets the input 1 deleted property of a formula.","ref":"UmyaSpreadsheet.html#get_input_1deleted/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_input_1deleted/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_input_1deleted(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_input_1deleted/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_input_2deleted/3","doc":"Gets the input 2 deleted property of a formula.","ref":"UmyaSpreadsheet.html#get_input_2deleted/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_input_2deleted/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_input_2deleted(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_input_2deleted/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_ole_object_data/1","doc":"Gets the binary data from an OLE object.","ref":"UmyaSpreadsheet.html#get_ole_object_data/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_ole_object_data/1","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> {:ok, _data} = UmyaSpreadsheet.get_ole_object_data(ole_object)","ref":"UmyaSpreadsheet.html#get_ole_object_data/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_ole_object_extension/1","doc":"Gets the file extension from an OLE object.","ref":"UmyaSpreadsheet.html#get_ole_object_extension/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_ole_object_extension/1","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> :ok = UmyaSpreadsheet.set_ole_object_extension(ole_object, \"xlsx\")\n    iex> {:ok, \"xlsx\"} = UmyaSpreadsheet.get_ole_object_extension(ole_object)","ref":"UmyaSpreadsheet.html#get_ole_object_extension/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_ole_object_prog_id/1","doc":"Gets the ProgID from an OLE object.","ref":"UmyaSpreadsheet.html#get_ole_object_prog_id/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_ole_object_prog_id/1","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> :ok = UmyaSpreadsheet.set_ole_object_prog_id(ole_object, \"Excel.Sheet.12\")\n    iex> {:ok, \"Excel.Sheet.12\"} = UmyaSpreadsheet.get_ole_object_prog_id(ole_object)","ref":"UmyaSpreadsheet.html#get_ole_object_prog_id/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_ole_object_properties/1","doc":"Gets the properties of an OLE object.","ref":"UmyaSpreadsheet.html#get_ole_object_properties/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_ole_object_properties/1","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> {:ok, _properties} = UmyaSpreadsheet.get_ole_object_properties(ole_object)","ref":"UmyaSpreadsheet.html#get_ole_object_properties/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_ole_object_requires/1","doc":"Gets the 'requires' attribute from an OLE object.","ref":"UmyaSpreadsheet.html#get_ole_object_requires/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_ole_object_requires/1","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> :ok = UmyaSpreadsheet.set_ole_object_requires(ole_object, \"xl\")\n    iex> {:ok, \"xl\"} = UmyaSpreadsheet.get_ole_object_requires(ole_object)","ref":"UmyaSpreadsheet.html#get_ole_object_requires/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_ole_objects_count/1","doc":"Gets the count of OLE objects in a collection.","ref":"UmyaSpreadsheet.html#get_ole_objects_count/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_ole_objects_count/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> {:ok, ole_objects} = UmyaSpreadsheet.get_ole_objects_from_worksheet(spreadsheet, \"Sheet1\")\n    iex> {:ok, _count} = UmyaSpreadsheet.get_ole_objects_count(ole_objects)","ref":"UmyaSpreadsheet.html#get_ole_objects_count/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_ole_objects_from_worksheet/2","doc":"Gets the OLE objects collection from a worksheet.","ref":"UmyaSpreadsheet.html#get_ole_objects_from_worksheet/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_ole_objects_from_worksheet/2","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> {:ok, _ole_objects} = UmyaSpreadsheet.get_ole_objects_from_worksheet(spreadsheet, \"Sheet1\")","ref":"UmyaSpreadsheet.html#get_ole_objects_from_worksheet/2-examples"},{"type":"function","title":"UmyaSpreadsheet.get_page_margins/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_page_margins/2 .","ref":"UmyaSpreadsheet.html#get_page_margins/2"},{"type":"function","title":"UmyaSpreadsheet.get_page_orientation/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_page_orientation/2 .","ref":"UmyaSpreadsheet.html#get_page_orientation/2"},{"type":"function","title":"UmyaSpreadsheet.get_page_scale/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_page_scale/2 .","ref":"UmyaSpreadsheet.html#get_page_scale/2"},{"type":"function","title":"UmyaSpreadsheet.get_paper_size/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_paper_size/2 .","ref":"UmyaSpreadsheet.html#get_paper_size/2"},{"type":"function","title":"UmyaSpreadsheet.get_pattern_fill/3","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.get_pattern_fill/3 .","ref":"UmyaSpreadsheet.html#get_pattern_fill/3"},{"type":"function","title":"UmyaSpreadsheet.get_pivot_table_fields/3","doc":"See  UmyaSpreadsheet.PivotTable.get_pivot_table_fields/3 .","ref":"UmyaSpreadsheet.html#get_pivot_table_fields/3"},{"type":"function","title":"UmyaSpreadsheet.get_pivot_table_info/3","doc":"See  UmyaSpreadsheet.PivotTable.get_pivot_table_info/3 .","ref":"UmyaSpreadsheet.html#get_pivot_table_info/3"},{"type":"function","title":"UmyaSpreadsheet.get_pivot_table_names/2","doc":"See  UmyaSpreadsheet.PivotTable.get_pivot_table_names/2 .","ref":"UmyaSpreadsheet.html#get_pivot_table_names/2"},{"type":"function","title":"UmyaSpreadsheet.get_pivot_table_source_range/3","doc":"See  UmyaSpreadsheet.PivotTable.get_pivot_table_source_range/3 .","ref":"UmyaSpreadsheet.html#get_pivot_table_source_range/3"},{"type":"function","title":"UmyaSpreadsheet.get_pivot_table_target_cell/3","doc":"See  UmyaSpreadsheet.PivotTable.get_pivot_table_target_cell/3 .","ref":"UmyaSpreadsheet.html#get_pivot_table_target_cell/3"},{"type":"function","title":"UmyaSpreadsheet.get_print_area/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_print_area/2 .","ref":"UmyaSpreadsheet.html#get_print_area/2"},{"type":"function","title":"UmyaSpreadsheet.get_print_centered/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_print_centered/2 .","ref":"UmyaSpreadsheet.html#get_print_centered/2"},{"type":"function","title":"UmyaSpreadsheet.get_print_titles/2","doc":"See  UmyaSpreadsheet.PrintSettings.get_print_titles/2 .","ref":"UmyaSpreadsheet.html#get_print_titles/2"},{"type":"function","title":"UmyaSpreadsheet.get_r1/3","doc":"Gets the R1 property of a formula.\n\nThe R1 property is used in data table formulas to specify\nthe first input cell reference.","ref":"UmyaSpreadsheet.html#get_r1/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_r1/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_r1(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_r1/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_r2/3","doc":"Gets the R2 property of a formula.\n\nThe R2 property is used in data table formulas to specify\nthe second input cell reference.","ref":"UmyaSpreadsheet.html#get_r2/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_r2/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_r2(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_r2/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_reference/3","doc":"Gets the reference of a formula.","ref":"UmyaSpreadsheet.html#get_reference/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_reference/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_array_formula(spreadsheet, \"Sheet1\", \"A1:A3\", \"ROW(1:3)\")\n    iex> UmyaSpreadsheet.get_reference(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_reference/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_rich_text_elements/1","doc":"Gets all text elements from a RichText object.","ref":"UmyaSpreadsheet.html#get_rich_text_elements/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_rich_text_elements/1","doc":"iex> rich_text = UmyaSpreadsheet.create_rich_text()\n    iex> UmyaSpreadsheet.add_formatted_text_to_rich_text(rich_text, \"Test\", %{bold: true})\n    iex> elements = UmyaSpreadsheet.get_rich_text_elements(rich_text)\n    iex> is_list(elements)\n    true","ref":"UmyaSpreadsheet.html#get_rich_text_elements/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_rich_text_plain_text/1","doc":"Gets plain text from a RichText object without formatting.","ref":"UmyaSpreadsheet.html#get_rich_text_plain_text/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_rich_text_plain_text/1","doc":"iex> rich_text = UmyaSpreadsheet.create_rich_text()\n    iex> UmyaSpreadsheet.add_formatted_text_to_rich_text(rich_text, \"Test\", %{bold: true})\n    iex> UmyaSpreadsheet.get_rich_text_plain_text(rich_text)\n    \"Test\"","ref":"UmyaSpreadsheet.html#get_rich_text_plain_text/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_row_height/3","doc":"See  UmyaSpreadsheet.RowColumnFunctions.get_row_height/3 .","ref":"UmyaSpreadsheet.html#get_row_height/3"},{"type":"function","title":"UmyaSpreadsheet.get_row_hidden/3","doc":"See  UmyaSpreadsheet.RowColumnFunctions.get_row_hidden/3 .","ref":"UmyaSpreadsheet.html#get_row_hidden/3"},{"type":"function","title":"UmyaSpreadsheet.get_selection/2","doc":"See  UmyaSpreadsheet.SheetViewFunctions.get_selection/2 .","ref":"UmyaSpreadsheet.html#get_selection/2"},{"type":"function","title":"UmyaSpreadsheet.get_shared_index/3","doc":"Gets the shared index of a formula.","ref":"UmyaSpreadsheet.html#get_shared_index/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_shared_index/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=A1+1\")\n    iex> UmyaSpreadsheet.get_shared_index(spreadsheet, \"Sheet1\", \"A1\")\n    nil","ref":"UmyaSpreadsheet.html#get_shared_index/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_sheet_names/1","doc":"See  UmyaSpreadsheet.SheetFunctions.get_sheet_names/1 .","ref":"UmyaSpreadsheet.html#get_sheet_names/1"},{"type":"function","title":"UmyaSpreadsheet.get_sheet_view/2","doc":"See  UmyaSpreadsheet.SheetViewFunctions.get_sheet_view/2 .","ref":"UmyaSpreadsheet.html#get_sheet_view/2"},{"type":"function","title":"UmyaSpreadsheet.get_show_grid_lines/2","doc":"See  UmyaSpreadsheet.SheetViewFunctions.get_show_grid_lines/2 .","ref":"UmyaSpreadsheet.html#get_show_grid_lines/2"},{"type":"function","title":"UmyaSpreadsheet.get_tab_color/2","doc":"See  UmyaSpreadsheet.SheetViewFunctions.get_tab_color/2 .","ref":"UmyaSpreadsheet.html#get_tab_color/2"},{"type":"function","title":"UmyaSpreadsheet.get_table/3","doc":"See  UmyaSpreadsheet.Table.get_table/3 .","ref":"UmyaSpreadsheet.html#get_table/3"},{"type":"function","title":"UmyaSpreadsheet.get_table_columns/3","doc":"See  UmyaSpreadsheet.Table.get_table_columns/3 .","ref":"UmyaSpreadsheet.html#get_table_columns/3"},{"type":"function","title":"UmyaSpreadsheet.get_table_style/3","doc":"See  UmyaSpreadsheet.Table.get_table_style/3 .","ref":"UmyaSpreadsheet.html#get_table_style/3"},{"type":"function","title":"UmyaSpreadsheet.get_table_totals_row/3","doc":"See  UmyaSpreadsheet.Table.get_table_totals_row/3 .","ref":"UmyaSpreadsheet.html#get_table_totals_row/3"},{"type":"function","title":"UmyaSpreadsheet.get_tables/2","doc":"See  UmyaSpreadsheet.Table.get_tables/2 .","ref":"UmyaSpreadsheet.html#get_tables/2"},{"type":"function","title":"UmyaSpreadsheet.get_text/3","doc":"Gets the text content of a formula in a cell.","ref":"UmyaSpreadsheet.html#get_text/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_text/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.get_text(spreadsheet, \"Sheet1\", \"A1\")\n    \"=SUM(B1:B10)\"","ref":"UmyaSpreadsheet.html#get_text/3-examples"},{"type":"function","title":"UmyaSpreadsheet.get_text_element_font_properties/1","doc":"Gets font properties from a TextElement as a map.","ref":"UmyaSpreadsheet.html#get_text_element_font_properties/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_text_element_font_properties/1","doc":"iex> element = UmyaSpreadsheet.create_text_element(\"Test\", %{bold: true})\n    iex> {:ok, props} = UmyaSpreadsheet.get_text_element_font_properties(element)\n    iex> props[:bold]\n    \"true\"","ref":"UmyaSpreadsheet.html#get_text_element_font_properties/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_text_element_text/1","doc":"Gets text content from a TextElement.","ref":"UmyaSpreadsheet.html#get_text_element_text/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.get_text_element_text/1","doc":"iex> element = UmyaSpreadsheet.create_text_element(\"Test\", %{})\n    iex> UmyaSpreadsheet.get_text_element_text(element)\n    \"Test\"","ref":"UmyaSpreadsheet.html#get_text_element_text/1-examples"},{"type":"function","title":"UmyaSpreadsheet.get_workbook_protection_details/1","doc":"See  UmyaSpreadsheet.WorkbookProtectionFunctions.get_workbook_protection_details/1 .","ref":"UmyaSpreadsheet.html#get_workbook_protection_details/1"},{"type":"function","title":"UmyaSpreadsheet.get_workbook_window_position/1","doc":"See  UmyaSpreadsheet.WorkbookViewFunctions.get_workbook_window_position/1 .","ref":"UmyaSpreadsheet.html#get_workbook_window_position/1"},{"type":"function","title":"UmyaSpreadsheet.get_zoom_scale/2","doc":"See  UmyaSpreadsheet.SheetViewFunctions.get_zoom_scale/2 .","ref":"UmyaSpreadsheet.html#get_zoom_scale/2"},{"type":"function","title":"UmyaSpreadsheet.has_auto_filter/2","doc":"Checks if a worksheet has an auto filter.","ref":"UmyaSpreadsheet.html#has_auto_filter/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.has_auto_filter/2","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E10\")\n    iex> UmyaSpreadsheet.has_auto_filter(spreadsheet, \"Sheet1\")\n    {:ok, true}","ref":"UmyaSpreadsheet.html#has_auto_filter/2-examples"},{"type":"function","title":"UmyaSpreadsheet.has_comments/2","doc":"Checks if a sheet has any comments.","ref":"UmyaSpreadsheet.html#has_comments/2"},{"type":"function","title":"UmyaSpreadsheet.has_hyperlink/3","doc":"Checks if a specific cell has a hyperlink (alias for has_hyperlink?).","ref":"UmyaSpreadsheet.html#has_hyperlink/3"},{"type":"function","title":"UmyaSpreadsheet.has_hyperlink?/3","doc":"Checks if a specific cell has a hyperlink.","ref":"UmyaSpreadsheet.html#has_hyperlink?/3"},{"type":"function","title":"UmyaSpreadsheet.has_hyperlinks/2","doc":"Checks if a worksheet contains any hyperlinks (alias for has_hyperlinks?).","ref":"UmyaSpreadsheet.html#has_hyperlinks/2"},{"type":"function","title":"UmyaSpreadsheet.has_hyperlinks?/2","doc":"Checks if a worksheet contains any hyperlinks.","ref":"UmyaSpreadsheet.html#has_hyperlinks?/2"},{"type":"function","title":"UmyaSpreadsheet.has_ole_objects/1","doc":"Checks if an OLE objects collection has any objects.","ref":"UmyaSpreadsheet.html#has_ole_objects/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.has_ole_objects/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> {:ok, ole_objects} = UmyaSpreadsheet.get_ole_objects_from_worksheet(spreadsheet, \"Sheet1\")\n    iex> {:ok, _has_objects} = UmyaSpreadsheet.has_ole_objects(ole_objects)","ref":"UmyaSpreadsheet.html#has_ole_objects/1-examples"},{"type":"function","title":"UmyaSpreadsheet.has_pivot_tables?/2","doc":"See  UmyaSpreadsheet.PivotTable.has_pivot_tables?/2 .","ref":"UmyaSpreadsheet.html#has_pivot_tables?/2"},{"type":"function","title":"UmyaSpreadsheet.has_tables/2","doc":"See  UmyaSpreadsheet.Table.has_tables/2 .","ref":"UmyaSpreadsheet.html#has_tables/2"},{"type":"function","title":"UmyaSpreadsheet.insert_new_column/4","doc":"See  UmyaSpreadsheet.SheetFunctions.insert_new_column/4 .","ref":"UmyaSpreadsheet.html#insert_new_column/4"},{"type":"function","title":"UmyaSpreadsheet.insert_new_column_by_index/4","doc":"See  UmyaSpreadsheet.SheetFunctions.insert_new_column_by_index/4 .","ref":"UmyaSpreadsheet.html#insert_new_column_by_index/4"},{"type":"function","title":"UmyaSpreadsheet.insert_new_row/4","doc":"See  UmyaSpreadsheet.SheetFunctions.insert_new_row/4 .","ref":"UmyaSpreadsheet.html#insert_new_row/4"},{"type":"function","title":"UmyaSpreadsheet.is_formula/3","doc":"Checks if a cell contains a formula.","ref":"UmyaSpreadsheet.html#is_formula/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.is_formula/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\n    iex> UmyaSpreadsheet.is_formula(spreadsheet, \"Sheet1\", \"A1\")\n    true\n    iex> UmyaSpreadsheet.is_formula(spreadsheet, \"Sheet1\", \"B1\")\n    false","ref":"UmyaSpreadsheet.html#is_formula/3-examples"},{"type":"function","title":"UmyaSpreadsheet.is_ole_object_binary_format/1","doc":"Checks if an OLE object is in binary format.","ref":"UmyaSpreadsheet.html#is_ole_object_binary_format/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.is_ole_object_binary_format/1","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> {:ok, _is_binary} = UmyaSpreadsheet.is_ole_object_binary_format(ole_object)","ref":"UmyaSpreadsheet.html#is_ole_object_binary_format/1-examples"},{"type":"function","title":"UmyaSpreadsheet.is_ole_object_excel_format/1","doc":"Checks if an OLE object is in Excel format.","ref":"UmyaSpreadsheet.html#is_ole_object_excel_format/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.is_ole_object_excel_format/1","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> {:ok, _is_excel} = UmyaSpreadsheet.is_ole_object_excel_format(ole_object)","ref":"UmyaSpreadsheet.html#is_ole_object_excel_format/1-examples"},{"type":"function","title":"UmyaSpreadsheet.is_workbook_protected/1","doc":"See  UmyaSpreadsheet.WorkbookProtectionFunctions.is_workbook_protected/1 .","ref":"UmyaSpreadsheet.html#is_workbook_protected/1"},{"type":"function","title":"UmyaSpreadsheet.lazy_read/1","doc":"Reads an Excel (.xlsx, .xlsm) file from the given path using lazy loading.\nWorksheet contents are only loaded when accessed, which can improve\nperformance for large files.","ref":"UmyaSpreadsheet.html#lazy_read/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.lazy_read/1","doc":"* `path` - Path to the Excel file","ref":"UmyaSpreadsheet.html#lazy_read/1-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.lazy_read/1","doc":"iex> result = UmyaSpreadsheet.lazy_read(\"path/to/file.xlsx\")\n    iex> is_tuple(result)\n    true","ref":"UmyaSpreadsheet.html#lazy_read/1-examples"},{"type":"function","title":"UmyaSpreadsheet.list_images/2","doc":"See  UmyaSpreadsheet.ImageFunctions.list_images/2 .","ref":"UmyaSpreadsheet.html#list_images/2"},{"type":"function","title":"UmyaSpreadsheet.list_ole_objects/1","doc":"Lists all OLE objects in a collection.","ref":"UmyaSpreadsheet.html#list_ole_objects/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.list_ole_objects/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> {:ok, ole_objects} = UmyaSpreadsheet.get_ole_objects_from_worksheet(spreadsheet, \"Sheet1\")\n    iex> {:ok, _objects_list} = UmyaSpreadsheet.list_ole_objects(ole_objects)","ref":"UmyaSpreadsheet.html#list_ole_objects/1-examples"},{"type":"function","title":"UmyaSpreadsheet.load_ole_object_from_file/2","doc":"Loads an OLE object from a file.","ref":"UmyaSpreadsheet.html#load_ole_object_from_file/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.load_ole_object_from_file/2","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> {:error, \"File not found\"} = UmyaSpreadsheet.load_ole_object_from_file(ole_object, \"nonexistent.docx\")","ref":"UmyaSpreadsheet.html#load_ole_object_from_file/2-examples"},{"type":"function","title":"UmyaSpreadsheet.modify_table_column/7","doc":"See  UmyaSpreadsheet.Table.modify_table_column/7 .","ref":"UmyaSpreadsheet.html#modify_table_column/7"},{"type":"function","title":"UmyaSpreadsheet.move_range/5","doc":"See  UmyaSpreadsheet.SheetFunctions.move_range/5 .","ref":"UmyaSpreadsheet.html#move_range/5"},{"type":"function","title":"UmyaSpreadsheet.new/0","doc":"Creates a new empty spreadsheet with a default sheet.","ref":"UmyaSpreadsheet.html#new/0"},{"type":"function","title":"Examples - UmyaSpreadsheet.new/0","doc":"iex> spreadsheet = UmyaSpreadsheet.new()\n    iex> match?({:ok, %UmyaSpreadsheet.Spreadsheet{}}, spreadsheet)\n    true","ref":"UmyaSpreadsheet.html#new/0-examples"},{"type":"function","title":"UmyaSpreadsheet.new_embedded_object_properties/0","doc":"Creates new embedded object properties.","ref":"UmyaSpreadsheet.html#new_embedded_object_properties/0"},{"type":"function","title":"Examples - UmyaSpreadsheet.new_embedded_object_properties/0","doc":"iex> {:ok, _properties} = UmyaSpreadsheet.new_embedded_object_properties()","ref":"UmyaSpreadsheet.html#new_embedded_object_properties/0-examples"},{"type":"function","title":"UmyaSpreadsheet.new_empty/0","doc":"Creates a new empty spreadsheet without any default sheets.","ref":"UmyaSpreadsheet.html#new_empty/0"},{"type":"function","title":"Examples - UmyaSpreadsheet.new_empty/0","doc":"iex> spreadsheet = UmyaSpreadsheet.new_empty()\n    iex> match?({:ok, %UmyaSpreadsheet.Spreadsheet{}}, spreadsheet)\n    true","ref":"UmyaSpreadsheet.html#new_empty/0-examples"},{"type":"function","title":"UmyaSpreadsheet.new_ole_object/0","doc":"Creates a new OLE object.","ref":"UmyaSpreadsheet.html#new_ole_object/0"},{"type":"function","title":"Examples - UmyaSpreadsheet.new_ole_object/0","doc":"iex> {:ok, _ole_object} = UmyaSpreadsheet.new_ole_object()","ref":"UmyaSpreadsheet.html#new_ole_object/0-examples"},{"type":"function","title":"UmyaSpreadsheet.new_ole_object_from_file/1","doc":"Creates a new OLE object and loads data from a file.","ref":"UmyaSpreadsheet.html#new_ole_object_from_file/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.new_ole_object_from_file/1","doc":"iex> {:ok, _ole_object} = UmyaSpreadsheet.new_ole_object()","ref":"UmyaSpreadsheet.html#new_ole_object_from_file/1-examples"},{"type":"function","title":"UmyaSpreadsheet.new_ole_object_with_data/2","doc":"Creates a new OLE object with binary data.","ref":"UmyaSpreadsheet.html#new_ole_object_with_data/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.new_ole_object_with_data/2","doc":"iex> _data = \"test data\"\n    iex> {:ok, _ole_object} = UmyaSpreadsheet.new_ole_object()","ref":"UmyaSpreadsheet.html#new_ole_object_with_data/2-examples"},{"type":"function","title":"UmyaSpreadsheet.new_ole_objects/0","doc":"Creates a new OLE objects collection.","ref":"UmyaSpreadsheet.html#new_ole_objects/0"},{"type":"function","title":"Examples - UmyaSpreadsheet.new_ole_objects/0","doc":"iex> {:ok, _ole_objects} = UmyaSpreadsheet.new_ole_objects()","ref":"UmyaSpreadsheet.html#new_ole_objects/0-examples"},{"type":"function","title":"UmyaSpreadsheet.read/1","doc":"Reads an Excel (.xlsx, .xlsm) file from the given path.","ref":"UmyaSpreadsheet.html#read/1"},{"type":"function","title":"Parameters - UmyaSpreadsheet.read/1","doc":"* `path` - Path to the Excel file","ref":"UmyaSpreadsheet.html#read/1-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.read/1","doc":"iex> result = UmyaSpreadsheet.read(\"path/to/file.xlsx\")\n    iex> is_tuple(result)\n    true","ref":"UmyaSpreadsheet.html#read/1-examples"},{"type":"function","title":"UmyaSpreadsheet.refresh_all_pivot_tables/1","doc":"See  UmyaSpreadsheet.PivotTable.refresh_all_pivot_tables/1 .","ref":"UmyaSpreadsheet.html#refresh_all_pivot_tables/1"},{"type":"function","title":"UmyaSpreadsheet.remove_auto_filter/2","doc":"Removes an auto filter from a worksheet.","ref":"UmyaSpreadsheet.html#remove_auto_filter/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.remove_auto_filter/2","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E10\")\n    iex> UmyaSpreadsheet.remove_auto_filter(spreadsheet, \"Sheet1\")\n    :ok","ref":"UmyaSpreadsheet.html#remove_auto_filter/2-examples"},{"type":"function","title":"UmyaSpreadsheet.remove_cell/3","doc":"See  UmyaSpreadsheet.CellFunctions.remove_cell/3 .","ref":"UmyaSpreadsheet.html#remove_cell/3"},{"type":"function","title":"UmyaSpreadsheet.remove_column/4","doc":"See  UmyaSpreadsheet.SheetFunctions.remove_column/4 .","ref":"UmyaSpreadsheet.html#remove_column/4"},{"type":"function","title":"UmyaSpreadsheet.remove_column_by_index/4","doc":"See  UmyaSpreadsheet.SheetFunctions.remove_column_by_index/4 .","ref":"UmyaSpreadsheet.html#remove_column_by_index/4"},{"type":"function","title":"UmyaSpreadsheet.remove_comment/3","doc":"Removes a comment from a cell.","ref":"UmyaSpreadsheet.html#remove_comment/3"},{"type":"function","title":"UmyaSpreadsheet.remove_data_validation/3","doc":"See  UmyaSpreadsheet.DataValidation.remove_data_validation/3 .","ref":"UmyaSpreadsheet.html#remove_data_validation/3"},{"type":"function","title":"UmyaSpreadsheet.remove_hyperlink/3","doc":"Removes a hyperlink from a cell.","ref":"UmyaSpreadsheet.html#remove_hyperlink/3"},{"type":"function","title":"UmyaSpreadsheet.remove_pivot_table/3","doc":"See  UmyaSpreadsheet.PivotTable.remove_pivot_table/3 .","ref":"UmyaSpreadsheet.html#remove_pivot_table/3"},{"type":"function","title":"UmyaSpreadsheet.remove_row/4","doc":"See  UmyaSpreadsheet.SheetFunctions.remove_row/4 .","ref":"UmyaSpreadsheet.html#remove_row/4"},{"type":"function","title":"UmyaSpreadsheet.remove_sheet/2","doc":"See  UmyaSpreadsheet.SheetFunctions.remove_sheet/2 .","ref":"UmyaSpreadsheet.html#remove_sheet/2"},{"type":"function","title":"UmyaSpreadsheet.remove_table/3","doc":"See  UmyaSpreadsheet.Table.remove_table/3 .","ref":"UmyaSpreadsheet.html#remove_table/3"},{"type":"function","title":"UmyaSpreadsheet.remove_table_style/3","doc":"See  UmyaSpreadsheet.Table.remove_table_style/3 .","ref":"UmyaSpreadsheet.html#remove_table_style/3"},{"type":"function","title":"UmyaSpreadsheet.rename_sheet/3","doc":"See  UmyaSpreadsheet.SheetFunctions.rename_sheet/3 .","ref":"UmyaSpreadsheet.html#rename_sheet/3"},{"type":"function","title":"UmyaSpreadsheet.rich_text_to_html/1","doc":"Converts RichText to HTML representation.","ref":"UmyaSpreadsheet.html#rich_text_to_html/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.rich_text_to_html/1","doc":"iex> rich_text = UmyaSpreadsheet.create_rich_text()\n    iex> UmyaSpreadsheet.add_formatted_text_to_rich_text(rich_text, \"Bold\", %{bold: true})\n    iex> UmyaSpreadsheet.rich_text_to_html(rich_text)\n    \" Bold \"","ref":"UmyaSpreadsheet.html#rich_text_to_html/1-examples"},{"type":"function","title":"UmyaSpreadsheet.save_ole_object_to_file/2","doc":"Saves an OLE object to a file.","ref":"UmyaSpreadsheet.html#save_ole_object_to_file/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.save_ole_object_to_file/2","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> {:error, \"No object data to save\"} = UmyaSpreadsheet.save_ole_object_to_file(ole_object, \"output.docx\")","ref":"UmyaSpreadsheet.html#save_ole_object_to_file/2-examples"},{"type":"function","title":"UmyaSpreadsheet.set_active_tab/2","doc":"See  UmyaSpreadsheet.WorkbookViewFunctions.set_active_tab/2 .","ref":"UmyaSpreadsheet.html#set_active_tab/2"},{"type":"function","title":"UmyaSpreadsheet.set_array_formula/4","doc":"Sets an array formula for a range of cells. Array formulas can return multiple values\nacross a range of cells.","ref":"UmyaSpreadsheet.html#set_array_formula/4"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_array_formula/4","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_array_formula(spreadsheet, \"Sheet1\", \"A1:A3\", \"ROW(1:3)\")\n    :ok","ref":"UmyaSpreadsheet.html#set_array_formula/4-examples"},{"type":"function","title":"UmyaSpreadsheet.set_auto_filter/3","doc":"Sets an auto filter for a range of cells in a worksheet.\n\nAuto filters allow users to filter data in Excel by adding dropdown menus to column headers.","ref":"UmyaSpreadsheet.html#set_auto_filter/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_auto_filter/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E10\")\n    :ok","ref":"UmyaSpreadsheet.html#set_auto_filter/3-examples"},{"type":"function","title":"UmyaSpreadsheet.set_background_color/4","doc":"See  UmyaSpreadsheet.BackgroundFunctions.set_background_color/4 .","ref":"UmyaSpreadsheet.html#set_background_color/4"},{"type":"function","title":"UmyaSpreadsheet.set_border_style/5","doc":"See  UmyaSpreadsheet.BorderFunctions.set_border_style/5 .","ref":"UmyaSpreadsheet.html#set_border_style/5"},{"type":"function","title":"UmyaSpreadsheet.set_cell_alignment/5","doc":"See  UmyaSpreadsheet.CellFunctions.set_cell_alignment/5 .","ref":"UmyaSpreadsheet.html#set_cell_alignment/5"},{"type":"function","title":"UmyaSpreadsheet.set_cell_indent/4","doc":"See  UmyaSpreadsheet.CellFunctions.set_cell_indent/4 .","ref":"UmyaSpreadsheet.html#set_cell_indent/4"},{"type":"function","title":"UmyaSpreadsheet.set_cell_rich_text/4","doc":"Sets rich text to a specific cell.","ref":"UmyaSpreadsheet.html#set_cell_rich_text/4"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_cell_rich_text/4","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> rich_text = UmyaSpreadsheet.create_rich_text()\n    iex> UmyaSpreadsheet.add_formatted_text_to_rich_text(rich_text, \"Test\", %{bold: true})\n    iex> UmyaSpreadsheet.set_cell_rich_text(spreadsheet, \"Sheet1\", \"A1\", rich_text)\n    :ok","ref":"UmyaSpreadsheet.html#set_cell_rich_text/4-examples"},{"type":"function","title":"UmyaSpreadsheet.set_cell_rotation/4","doc":"See  UmyaSpreadsheet.CellFunctions.set_cell_rotation/4 .","ref":"UmyaSpreadsheet.html#set_cell_rotation/4"},{"type":"function","title":"UmyaSpreadsheet.set_cell_value/4","doc":"See  UmyaSpreadsheet.CellFunctions.set_cell_value/4 .","ref":"UmyaSpreadsheet.html#set_cell_value/4"},{"type":"function","title":"UmyaSpreadsheet.set_chart_3d_view/7","doc":"See  UmyaSpreadsheet.ChartFunctions.set_chart_3d_view/7 .","ref":"UmyaSpreadsheet.html#set_chart_3d_view/7"},{"type":"function","title":"UmyaSpreadsheet.set_chart_axis_titles/5","doc":"See  UmyaSpreadsheet.ChartFunctions.set_chart_axis_titles/5 .","ref":"UmyaSpreadsheet.html#set_chart_axis_titles/5"},{"type":"function","title":"UmyaSpreadsheet.set_chart_data_labels/8","doc":"See  UmyaSpreadsheet.ChartFunctions.set_chart_data_labels/8 .","ref":"UmyaSpreadsheet.html#set_chart_data_labels/8"},{"type":"function","title":"UmyaSpreadsheet.set_chart_legend_position/5","doc":"See  UmyaSpreadsheet.ChartFunctions.set_chart_legend_position/5 .","ref":"UmyaSpreadsheet.html#set_chart_legend_position/5"},{"type":"function","title":"UmyaSpreadsheet.set_chart_style/4","doc":"See  UmyaSpreadsheet.ChartFunctions.set_chart_style/4 .","ref":"UmyaSpreadsheet.html#set_chart_style/4"},{"type":"function","title":"UmyaSpreadsheet.set_column_auto_width/4","doc":"See  UmyaSpreadsheet.RowColumnFunctions.set_column_auto_width/4 .","ref":"UmyaSpreadsheet.html#set_column_auto_width/4"},{"type":"function","title":"UmyaSpreadsheet.set_column_width/4","doc":"See  UmyaSpreadsheet.RowColumnFunctions.set_column_width/4 .","ref":"UmyaSpreadsheet.html#set_column_width/4"},{"type":"function","title":"UmyaSpreadsheet.set_custom_gradient_fill/5","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_custom_gradient_fill/5 .","ref":"UmyaSpreadsheet.html#set_custom_gradient_fill/5"},{"type":"function","title":"UmyaSpreadsheet.set_custom_gradient_fill/6","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_custom_gradient_fill/6 .","ref":"UmyaSpreadsheet.html#set_custom_gradient_fill/6"},{"type":"function","title":"UmyaSpreadsheet.set_embedded_object_prog_id/2","doc":"Sets the ProgID for embedded object properties.","ref":"UmyaSpreadsheet.html#set_embedded_object_prog_id/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_embedded_object_prog_id/2","doc":"iex> {:ok, properties} = UmyaSpreadsheet.new_embedded_object_properties()\n    iex> UmyaSpreadsheet.set_embedded_object_prog_id(properties, \"Word.Document.12\")\n    :ok","ref":"UmyaSpreadsheet.html#set_embedded_object_prog_id/2-examples"},{"type":"function","title":"UmyaSpreadsheet.set_embedded_object_shape_id/2","doc":"Sets the shape ID for embedded object properties.","ref":"UmyaSpreadsheet.html#set_embedded_object_shape_id/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_embedded_object_shape_id/2","doc":"iex> {:ok, properties} = UmyaSpreadsheet.new_embedded_object_properties()\n    iex> UmyaSpreadsheet.set_embedded_object_shape_id(properties, 123)\n    :ok","ref":"UmyaSpreadsheet.html#set_embedded_object_shape_id/2-examples"},{"type":"function","title":"UmyaSpreadsheet.set_fit_to_page/4","doc":"See  UmyaSpreadsheet.PrintSettings.set_fit_to_page/4 .","ref":"UmyaSpreadsheet.html#set_fit_to_page/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_bold/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_bold/4 .","ref":"UmyaSpreadsheet.html#set_font_bold/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_color/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_color/4 .","ref":"UmyaSpreadsheet.html#set_font_color/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_family/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_family/4 .","ref":"UmyaSpreadsheet.html#set_font_family/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_italic/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_italic/4 .","ref":"UmyaSpreadsheet.html#set_font_italic/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_name/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_name/4 .","ref":"UmyaSpreadsheet.html#set_font_name/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_scheme/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_scheme/4 .","ref":"UmyaSpreadsheet.html#set_font_scheme/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_size/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_size/4 .","ref":"UmyaSpreadsheet.html#set_font_size/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_strikethrough/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_strikethrough/4 .","ref":"UmyaSpreadsheet.html#set_font_strikethrough/4"},{"type":"function","title":"UmyaSpreadsheet.set_font_underline/4","doc":"See  UmyaSpreadsheet.FontFunctions.set_font_underline/4 .","ref":"UmyaSpreadsheet.html#set_font_underline/4"},{"type":"function","title":"UmyaSpreadsheet.set_footer/3","doc":"See  UmyaSpreadsheet.PrintSettings.set_footer/3 .","ref":"UmyaSpreadsheet.html#set_footer/3"},{"type":"function","title":"UmyaSpreadsheet.set_formula/4","doc":"Sets a regular formula in a cell.","ref":"UmyaSpreadsheet.html#set_formula/4"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_formula/4","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> UmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"A1\", \"SUM(B1:B10)\")\n    :ok","ref":"UmyaSpreadsheet.html#set_formula/4-examples"},{"type":"function","title":"UmyaSpreadsheet.set_gradient_fill/5","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_gradient_fill/5 .","ref":"UmyaSpreadsheet.html#set_gradient_fill/5"},{"type":"function","title":"UmyaSpreadsheet.set_header/3","doc":"See  UmyaSpreadsheet.PrintSettings.set_header/3 .","ref":"UmyaSpreadsheet.html#set_header/3"},{"type":"function","title":"UmyaSpreadsheet.set_header_footer_margins/4","doc":"See  UmyaSpreadsheet.PrintSettings.set_header_footer_margins/4 .","ref":"UmyaSpreadsheet.html#set_header_footer_margins/4"},{"type":"function","title":"UmyaSpreadsheet.set_linear_gradient_fill/5","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_linear_gradient_fill/5 .","ref":"UmyaSpreadsheet.html#set_linear_gradient_fill/5"},{"type":"function","title":"UmyaSpreadsheet.set_linear_gradient_fill/6","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_linear_gradient_fill/6 .","ref":"UmyaSpreadsheet.html#set_linear_gradient_fill/6"},{"type":"function","title":"UmyaSpreadsheet.set_number_format/4","doc":"See  UmyaSpreadsheet.CellFunctions.set_number_format/4 .","ref":"UmyaSpreadsheet.html#set_number_format/4"},{"type":"function","title":"UmyaSpreadsheet.set_ole_object_data/2","doc":"Sets the binary data for an OLE object.","ref":"UmyaSpreadsheet.html#set_ole_object_data/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_ole_object_data/2","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> :ok = UmyaSpreadsheet.set_ole_object_data(ole_object, \"test data\")","ref":"UmyaSpreadsheet.html#set_ole_object_data/2-examples"},{"type":"function","title":"UmyaSpreadsheet.set_ole_object_extension/2","doc":"Sets the file extension for an OLE object.","ref":"UmyaSpreadsheet.html#set_ole_object_extension/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_ole_object_extension/2","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> UmyaSpreadsheet.set_ole_object_extension(ole_object, \"xlsx\")\n    :ok","ref":"UmyaSpreadsheet.html#set_ole_object_extension/2-examples"},{"type":"function","title":"UmyaSpreadsheet.set_ole_object_prog_id/2","doc":"Sets the ProgID for an OLE object.","ref":"UmyaSpreadsheet.html#set_ole_object_prog_id/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_ole_object_prog_id/2","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> UmyaSpreadsheet.set_ole_object_prog_id(ole_object, \"Excel.Sheet.12\")\n    :ok","ref":"UmyaSpreadsheet.html#set_ole_object_prog_id/2-examples"},{"type":"function","title":"UmyaSpreadsheet.set_ole_object_properties/2","doc":"Sets the properties for an OLE object.","ref":"UmyaSpreadsheet.html#set_ole_object_properties/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_ole_object_properties/2","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> {:ok, properties} = UmyaSpreadsheet.new_embedded_object_properties()\n    iex> UmyaSpreadsheet.set_ole_object_properties(ole_object, properties)\n    :ok","ref":"UmyaSpreadsheet.html#set_ole_object_properties/2-examples"},{"type":"function","title":"UmyaSpreadsheet.set_ole_object_requires/2","doc":"Sets the 'requires' attribute for an OLE object.","ref":"UmyaSpreadsheet.html#set_ole_object_requires/2"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_ole_object_requires/2","doc":"iex> {:ok, ole_object} = UmyaSpreadsheet.new_ole_object()\n    iex> UmyaSpreadsheet.set_ole_object_requires(ole_object, \"xl\")\n    :ok","ref":"UmyaSpreadsheet.html#set_ole_object_requires/2-examples"},{"type":"function","title":"UmyaSpreadsheet.set_ole_objects_to_worksheet/3","doc":"Sets the OLE objects collection for a worksheet.","ref":"UmyaSpreadsheet.html#set_ole_objects_to_worksheet/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.set_ole_objects_to_worksheet/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> {:ok, ole_objects} = UmyaSpreadsheet.new_ole_objects()\n    iex> UmyaSpreadsheet.set_ole_objects_to_worksheet(spreadsheet, \"Sheet1\", ole_objects)\n    :ok","ref":"UmyaSpreadsheet.html#set_ole_objects_to_worksheet/3-examples"},{"type":"function","title":"UmyaSpreadsheet.set_page_margins/6","doc":"See  UmyaSpreadsheet.PrintSettings.set_page_margins/6 .","ref":"UmyaSpreadsheet.html#set_page_margins/6"},{"type":"function","title":"UmyaSpreadsheet.set_page_orientation/3","doc":"See  UmyaSpreadsheet.PrintSettings.set_page_orientation/3 .","ref":"UmyaSpreadsheet.html#set_page_orientation/3"},{"type":"function","title":"UmyaSpreadsheet.set_page_scale/3","doc":"See  UmyaSpreadsheet.PrintSettings.set_page_scale/3 .","ref":"UmyaSpreadsheet.html#set_page_scale/3"},{"type":"function","title":"UmyaSpreadsheet.set_paper_size/3","doc":"See  UmyaSpreadsheet.PrintSettings.set_paper_size/3 .","ref":"UmyaSpreadsheet.html#set_paper_size/3"},{"type":"function","title":"UmyaSpreadsheet.set_password/3","doc":"See  UmyaSpreadsheet.WorkbookFunctions.set_password/3 .","ref":"UmyaSpreadsheet.html#set_password/3"},{"type":"function","title":"UmyaSpreadsheet.set_pattern_fill/5","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill/5 .","ref":"UmyaSpreadsheet.html#set_pattern_fill/5"},{"type":"function","title":"UmyaSpreadsheet.set_pattern_fill/6","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_pattern_fill/6 .","ref":"UmyaSpreadsheet.html#set_pattern_fill/6"},{"type":"function","title":"UmyaSpreadsheet.set_print_area/3","doc":"See  UmyaSpreadsheet.PrintSettings.set_print_area/3 .","ref":"UmyaSpreadsheet.html#set_print_area/3"},{"type":"function","title":"UmyaSpreadsheet.set_print_centered/4","doc":"See  UmyaSpreadsheet.PrintSettings.set_print_centered/4 .","ref":"UmyaSpreadsheet.html#set_print_centered/4"},{"type":"function","title":"UmyaSpreadsheet.set_print_titles/4","doc":"See  UmyaSpreadsheet.PrintSettings.set_print_titles/4 .","ref":"UmyaSpreadsheet.html#set_print_titles/4"},{"type":"function","title":"UmyaSpreadsheet.set_radial_gradient_fill/5","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_radial_gradient_fill/5 .","ref":"UmyaSpreadsheet.html#set_radial_gradient_fill/5"},{"type":"function","title":"UmyaSpreadsheet.set_row_height/4","doc":"See  UmyaSpreadsheet.RowColumnFunctions.set_row_height/4 .","ref":"UmyaSpreadsheet.html#set_row_height/4"},{"type":"function","title":"UmyaSpreadsheet.set_row_style/5","doc":"See  UmyaSpreadsheet.RowColumnFunctions.set_row_style/5 .","ref":"UmyaSpreadsheet.html#set_row_style/5"},{"type":"function","title":"UmyaSpreadsheet.set_selection/4","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_selection/4 .","ref":"UmyaSpreadsheet.html#set_selection/4"},{"type":"function","title":"UmyaSpreadsheet.set_sheet_protection/4","doc":"See  UmyaSpreadsheet.SheetFunctions.set_sheet_protection/4 .","ref":"UmyaSpreadsheet.html#set_sheet_protection/4"},{"type":"function","title":"UmyaSpreadsheet.set_sheet_state/3","doc":"See  UmyaSpreadsheet.SheetFunctions.set_sheet_state/3 .","ref":"UmyaSpreadsheet.html#set_sheet_state/3"},{"type":"function","title":"UmyaSpreadsheet.set_sheet_view/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_sheet_view/3 .","ref":"UmyaSpreadsheet.html#set_sheet_view/3"},{"type":"function","title":"UmyaSpreadsheet.set_show_grid_lines/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_show_grid_lines/3 .","ref":"UmyaSpreadsheet.html#set_show_grid_lines/3"},{"type":"function","title":"UmyaSpreadsheet.set_tab_color/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_tab_color/3 .","ref":"UmyaSpreadsheet.html#set_tab_color/3"},{"type":"function","title":"UmyaSpreadsheet.set_tab_selected/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_tab_selected/3 .","ref":"UmyaSpreadsheet.html#set_tab_selected/3"},{"type":"function","title":"UmyaSpreadsheet.set_table_style/8","doc":"See  UmyaSpreadsheet.Table.set_table_style/8 .","ref":"UmyaSpreadsheet.html#set_table_style/8"},{"type":"function","title":"UmyaSpreadsheet.set_table_totals_row/4","doc":"See  UmyaSpreadsheet.Table.set_table_totals_row/4 .","ref":"UmyaSpreadsheet.html#set_table_totals_row/4"},{"type":"function","title":"UmyaSpreadsheet.set_three_color_gradient_fill/6","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_three_color_gradient_fill/6 .","ref":"UmyaSpreadsheet.html#set_three_color_gradient_fill/6"},{"type":"function","title":"UmyaSpreadsheet.set_three_color_gradient_fill/7","doc":"See  UmyaSpreadsheet.AdvancedFillFunctions.set_three_color_gradient_fill/7 .","ref":"UmyaSpreadsheet.html#set_three_color_gradient_fill/7"},{"type":"function","title":"UmyaSpreadsheet.set_top_left_cell/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_top_left_cell/3 .","ref":"UmyaSpreadsheet.html#set_top_left_cell/3"},{"type":"function","title":"UmyaSpreadsheet.set_workbook_protection/2","doc":"See  UmyaSpreadsheet.WorkbookFunctions.set_workbook_protection/2 .","ref":"UmyaSpreadsheet.html#set_workbook_protection/2"},{"type":"function","title":"UmyaSpreadsheet.set_workbook_window_position/5","doc":"See  UmyaSpreadsheet.WorkbookViewFunctions.set_workbook_window_position/5 .","ref":"UmyaSpreadsheet.html#set_workbook_window_position/5"},{"type":"function","title":"UmyaSpreadsheet.set_wrap_text/4","doc":"See  UmyaSpreadsheet.CellFunctions.set_wrap_text/4 .","ref":"UmyaSpreadsheet.html#set_wrap_text/4"},{"type":"function","title":"UmyaSpreadsheet.set_zoom_scale/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale/3 .","ref":"UmyaSpreadsheet.html#set_zoom_scale/3"},{"type":"function","title":"UmyaSpreadsheet.set_zoom_scale_normal/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_normal/3 .","ref":"UmyaSpreadsheet.html#set_zoom_scale_normal/3"},{"type":"function","title":"UmyaSpreadsheet.set_zoom_scale_page_break/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_break/3 .","ref":"UmyaSpreadsheet.html#set_zoom_scale_page_break/3"},{"type":"function","title":"UmyaSpreadsheet.set_zoom_scale_page_layout/3","doc":"See  UmyaSpreadsheet.SheetViewFunctions.set_zoom_scale_page_layout/3 .","ref":"UmyaSpreadsheet.html#set_zoom_scale_page_layout/3"},{"type":"function","title":"UmyaSpreadsheet.split_panes/4","doc":"See  UmyaSpreadsheet.SheetViewFunctions.split_panes/4 .","ref":"UmyaSpreadsheet.html#split_panes/4"},{"type":"function","title":"UmyaSpreadsheet.to_binary_xlsx/1","doc":"Converts a spreadsheet to binary XLSX format without writing to disk.\n\nThis is useful for serving Excel files directly in web applications.","ref":"UmyaSpreadsheet.html#to_binary_xlsx/1"},{"type":"function","title":"Examples - UmyaSpreadsheet.to_binary_xlsx/1","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> binary = UmyaSpreadsheet.to_binary_xlsx(spreadsheet)\n    iex> is_binary(binary)\n    true","ref":"UmyaSpreadsheet.html#to_binary_xlsx/1-examples"},{"type":"function","title":"UmyaSpreadsheet.unwrap_ref/1","doc":"Unwraps the reference from a Spreadsheet struct.\nThis is an internal function used by other modules.","ref":"UmyaSpreadsheet.html#unwrap_ref/1"},{"type":"function","title":"UmyaSpreadsheet.update_comment/5","doc":"Updates an existing comment in a cell.","ref":"UmyaSpreadsheet.html#update_comment/5"},{"type":"function","title":"UmyaSpreadsheet.update_hyperlink/6","doc":"Updates an existing hyperlink in a cell.","ref":"UmyaSpreadsheet.html#update_hyperlink/6"},{"type":"function","title":"UmyaSpreadsheet.write/2","doc":"Writes a spreadsheet to the specified path.","ref":"UmyaSpreadsheet.html#write/2"},{"type":"function","title":"Parameters - UmyaSpreadsheet.write/2","doc":"* `spreadsheet` - A spreadsheet struct\n  * `path` - The path where to save the Excel file","ref":"UmyaSpreadsheet.html#write/2-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.write/2","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> result = UmyaSpreadsheet.write(spreadsheet, \"path/to/output.xlsx\")\n    iex> is_atom(result) or is_tuple(result)\n    true","ref":"UmyaSpreadsheet.html#write/2-examples"},{"type":"function","title":"UmyaSpreadsheet.write_csv/3","doc":"See  UmyaSpreadsheet.CSVFunctions.write_csv/3 .","ref":"UmyaSpreadsheet.html#write_csv/3"},{"type":"function","title":"UmyaSpreadsheet.write_csv/4","doc":"See  UmyaSpreadsheet.CSVFunctions.write_csv/4 .","ref":"UmyaSpreadsheet.html#write_csv/4"},{"type":"function","title":"UmyaSpreadsheet.write_csv_with_options/4","doc":"See  UmyaSpreadsheet.CSVFunctions.write_csv_with_options/4 .","ref":"UmyaSpreadsheet.html#write_csv_with_options/4"},{"type":"function","title":"UmyaSpreadsheet.write_light/2","doc":"See  UmyaSpreadsheet.PerformanceFunctions.write_light/2 .","ref":"UmyaSpreadsheet.html#write_light/2"},{"type":"function","title":"UmyaSpreadsheet.write_with_compression/3","doc":"Writes a spreadsheet to disk with a specified compression level.\n\nCompression levels range from 0 (no compression) to 9 (maximum compression).\nHigher compression levels result in smaller files but take longer to create.","ref":"UmyaSpreadsheet.html#write_with_compression/3"},{"type":"function","title":"Examples - UmyaSpreadsheet.write_with_compression/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> unique_id = :crypto.strong_rand_bytes(4) |> Base.encode16() |> String.downcase()\n    iex> file_path = \"test/result_files/high_compression_\" <> unique_id <> \".xlsx\"\n    iex> File.mkdir_p!(Path.dirname(file_path))\n    iex> if File.exists?(file_path), do: File.rm!(file_path)\n    iex> UmyaSpreadsheet.write_with_compression(spreadsheet, file_path, 9)\n    :ok\n    iex> File.exists?(file_path)\n    true\n    iex> File.rm!(file_path)\n    :ok","ref":"UmyaSpreadsheet.html#write_with_compression/3-examples"},{"type":"function","title":"UmyaSpreadsheet.write_with_encryption_options/6","doc":"Writes a spreadsheet to disk with enhanced encryption options.\n\nThis function provides more control over the encryption process than the standard\n`write_with_password` function, allowing you to specify encryption algorithm,\nsalt values, and spin counts for enhanced security.","ref":"UmyaSpreadsheet.html#write_with_encryption_options/6"},{"type":"function","title":"Examples - UmyaSpreadsheet.write_with_encryption_options/6","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> unique_id = :crypto.strong_rand_bytes(4) |> Base.encode16() |> String.downcase()\n    iex> file_path = \"test/result_files/secure_options_\" <> unique_id <> \".xlsx\"\n    iex> File.mkdir_p!(Path.dirname(file_path))\n    iex> if File.exists?(file_path), do: File.rm!(file_path)\n    iex> UmyaSpreadsheet.write_with_encryption_options(spreadsheet, file_path, \"secret\", \"AES256\")\n    :ok\n    iex> File.exists?(file_path)\n    true\n    iex> File.rm!(file_path)\n    :ok","ref":"UmyaSpreadsheet.html#write_with_encryption_options/6-examples"},{"type":"function","title":"UmyaSpreadsheet.write_with_password/3","doc":"Writes a spreadsheet to the specified path with password protection.","ref":"UmyaSpreadsheet.html#write_with_password/3"},{"type":"function","title":"Parameters - UmyaSpreadsheet.write_with_password/3","doc":"* `spreadsheet` - A spreadsheet struct\n  * `path` - The path where to save the Excel file\n  * `password` - Password for the Excel file","ref":"UmyaSpreadsheet.html#write_with_password/3-parameters"},{"type":"function","title":"Examples - UmyaSpreadsheet.write_with_password/3","doc":"iex> {:ok, spreadsheet} = UmyaSpreadsheet.new()\n    iex> unique_id = :crypto.strong_rand_bytes(4) |> Base.encode16() |> String.downcase()\n    iex> file_path = \"test/result_files/secure_password_\" <> unique_id <> \".xlsx\"\n    iex> File.mkdir_p!(Path.dirname(file_path))\n    iex> if File.exists?(file_path), do: File.rm!(file_path)\n    iex> UmyaSpreadsheet.write_with_password(spreadsheet, file_path, \"password123\")\n    :ok\n    iex> File.exists?(file_path)\n    true\n    iex> File.rm!(file_path)\n    :ok","ref":"UmyaSpreadsheet.html#write_with_password/3-examples"},{"type":"function","title":"UmyaSpreadsheet.write_with_password_light/3","doc":"See  UmyaSpreadsheet.PerformanceFunctions.write_with_password_light/3 .","ref":"UmyaSpreadsheet.html#write_with_password_light/3"},{"type":"module","title":"UmyaSpreadsheet.Spreadsheet","doc":"Represents a spreadsheet object in memory.","ref":"UmyaSpreadsheet.Spreadsheet.html"},{"type":"type","title":"UmyaSpreadsheet.Spreadsheet.t/0","doc":"A spreadsheet object containing a reference to the underlying Rust data structure.","ref":"UmyaSpreadsheet.Spreadsheet.html#t:t/0"},{"type":"extras","title":"UmyaSpreadsheet","doc":"# UmyaSpreadsheet\n\n[![CI](https://github.com/alexiob/umya_spreadsheet_ex/actions/workflows/ci.yml/badge.svg)](https://github.com/alexiob/umya_spreadsheet_ex/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/umya_spreadsheet_ex.svg)](https://hex.pm/packages/umya_spreadsheet_ex)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/umya_spreadsheet_ex/)\n[![License](https://img.shields.io/badge/license-MIT-blue.svg)](LICENSE)\n\n![UmyaSpreadsheetEx Logo](assets/logo.png)\n\nEverything you ever needed (and probably more) to work with Excel files in Elixir, powered by Rust!\n\nAn Elixir NIF wrapper for the amazing [umya-spreadsheet](https://github.com/MathNya/umya-spreadsheet) Rust library, providing comprehensive Excel file (.xlsx, .xlsm) manipulation capabilities with the performance benefits of Rust.","ref":"readme.html"},{"type":"extras","title":"Features - UmyaSpreadsheet","doc":"- **Create & Manipulate Spreadsheets**\n\n  - Create new spreadsheets from scratch\n  - Read and write existing Excel files\n  - Support for both .xlsx and .xlsm file formats\n  - CSV export functionality\n  - Lightweight writer options for better memory usage\n\n- **Cell Operations**\n\n  - Get and set cell values\n  - Retrieve formatted values (numbers, currencies, dates, etc.)\n  - Move ranges of cells\n  - Merge cells\n  - Remove cells\n  - Add and manage comments with author info\n\n- **Styling & Formatting**\n\n  - Apply colors (background, font)\n  - Set font properties (size, bold, italic, underline, strikethrough, name)\n  - Advanced typography with font family and font scheme support\n  - Theme-aware font control for consistent document styling\n  - Advanced text formatting (various underline styles, text rotation, indentation)\n  - Enhanced border styling (dashed, dotted, double, etc.)\n  - Apply number formats (currency, percentage, dates, etc.)\n  - Enable text wrapping\n  - Define column widths and row heights\n  - Rich text support with mixed formatting within cells\n  - Create and manipulate formatted text elements\n  - Convert rich text to/from HTML\n  - Conditional formatting (cell value rules, color scales, data bars, top/bottom rules, text rules)\n  - Data validation (dropdown lists, number ranges, date constraints, text length limits, custom formulas)\n\n- **Sheet Management**\n\n  - Add, clone, and remove sheets\n  - Hide/show sheets\n  - Set grid lines visibility\n  - Move and reorder sheets\n  - Configure window settings and active tab\n  - Set cell selection and worksheet view\n\n- **Security**\n\n  - Password protection for workbooks\n  - Worksheet level protection\n  - Light writer options for password protection\n\n- **Row & Column Operations**\n\n  - Insert and remove rows and columns\n  - Adjust row heights and column widths\n  - Apply styling to entire rows/columns\n\n- **Print Settings & Page Setup**\n\n  - Control page orientation (portrait/landscape)\n  - Configure paper size and scaling\n  - Set page margins and headers/footers\n  - Define print areas and titles (repeating rows/columns)\n  - Control print centering and fit-to-page options\n\n- **Formula Support**\n  - Set regular formulas in individual cells\n  - Create array formulas across multiple cells\n  - Define named ranges for easier formula references\n  - Create defined names for constants and formulas\n  - List defined names in workbooks\n\n- **Data Organization & Analysis**\n  - Add auto filters to column headers for interactive filtering\n  - Enable/disable and manage auto filters in worksheets\n  - Query auto filter ranges and states\n  - Create worksheets with filtered views for easier data analysis\n\n- **Visual Elements**\n  - Add images (PNG, JPEG)\n  - Create charts (Line, Bar, Pie, and more)\n  - Add shapes (rectangles, circles, arrows, etc.)\n  - Create text boxes for annotations\n  - Connect cells with connector lines\n  - Position visual elements precisely\n\n- **Concurrent Operations**\n  - Thread-safe creation of multiple spreadsheets\n  - Support for parallel read/write operations\n  - Guidelines for concurrent spreadsheet manipulation\n  - Examples of thread-safe patterns\n\n- **Hyperlinks**\n  - Add web URLs, email addresses, file paths, and internal references\n  - Get, update, and remove hyperlinks from cells\n  - Bulk hyperlink operations for efficient management\n  - Integration with cell values and custom tooltips\n\n- **Data Analysis**\n  - Create and manage pivot tables\n  - Configure row, column, and data fields\n  - Refresh pivot table data\n  - Position pivot tables on worksheets\n\n- **Excel Tables**\n  - Create structured tables with headers and data ranges\n  - Apply built-in table styles with customization options\n  - Add, modify, and remove table columns dynamically\n  - Configure totals rows with various calculation functions\n  - Manage table filtering and sorting capabilities\n  - Support for table metadata and column properties","ref":"readme.html#features"},{"type":"extras","title":"Version Information - UmyaSpreadsheet","doc":"This package is built on:\n\n- **umya-spreadsheet**: v2.3.0 - Robust Rust Excel library\n- **Rustler**: v0.36.1 - Seamless Rust/Elixir interop with excellent performance","ref":"readme.html#version-information"},{"type":"extras","title":"Documentation - UmyaSpreadsheet","doc":"UmyaSpreadsheet has comprehensive guides for all major features:","ref":"readme.html#documentation"},{"type":"extras","title":"Online Documentation - UmyaSpreadsheet","doc":"- [**Guides Index**](https://hexdocs.pm/umya_spreadsheet_ex/guides.html) - Starting point for all documentation\n- [**Formula Functions**](https://hexdocs.pm/umya_spreadsheet_ex/formula_functions.html) - Working with formulas and named references\n- [**Auto Filters**](https://hexdocs.pm/umya_spreadsheet_ex/auto_filters.html) - Creating and managing Excel filter controls\n- [**Window Settings**](https://hexdocs.pm/umya_spreadsheet_ex/window_settings.html) - Control how Excel displays your workbooks\n- [**Comments**](https://hexdocs.pm/umya_spreadsheet_ex/comments.html) - Adding and managing cell comments\n- [**Charts**](https://hexdocs.pm/umya_spreadsheet_ex/charts.html) - Creating and customizing charts\n- [**Data Validation**](https://hexdocs.pm/umya_spreadsheet_ex/data_validation.html) - Setting input rules for cells\n- [**File Format Options**](https://hexdocs.pm/umya_spreadsheet_ex/file_format_options.html) - Control compression, encryption, and binary format generation","ref":"readme.html#online-documentation"},{"type":"extras","title":"Reference Documentation - UmyaSpreadsheet","doc":"- [**Troubleshooting Guide**](docs/troubleshooting.md) - Solutions for common issues and problems\n- [**Limitations & Compatibility**](docs/limitations.md) - Known limitations, compatibility matrix, and workarounds","ref":"readme.html#reference-documentation"},{"type":"extras","title":"Installation - UmyaSpreadsheet","doc":"You can install using [igniter](https://hexdocs.pm/igniter) for the most comfortable experience:\n\n```sh\n# install igniter if you haven't already\nmix archive.install hex igniter_new\n# then install umya_spreadsheet_ex\nmix igniter.install umya_spreadsheet_ex\n```\n\nOr add `umya_spreadsheet_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:umya_spreadsheet_ex, \"~> 0.7.0\"}\n  ]\nend\n```\n\nThe package includes precompiled NIF files for common platforms, but will compile from source if needed.\n\nTo force NIF compilation, set the `UMYA_SPREADSHEET_BUILD` environment variable to `true`:\n\n```bash\nexport UMYA_SPREADSHEET_BUILD=true\n\nmix clean;\nmix compile;\n```","ref":"readme.html#installation"},{"type":"extras","title":"Quick Start Guide - UmyaSpreadsheet","doc":"```elixir\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Write data to cells\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Hello\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"World\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C1\", \"42\")\n\n# Format your data\n:ok = UmyaSpreadsheet.set_background_color(spreadsheet, \"Sheet1\", \"A1\", \"FF0000\") # Red\n:ok = UmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\n:ok = UmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"C1\", \"#,##0.00\")\n\n# Save your spreadsheet\n:ok = UmyaSpreadsheet.write(spreadsheet, \"hello_world.xlsx\")\n\n# Read it back\n{:ok, loaded_spreadsheet} = UmyaSpreadsheet.read(\"hello_world.xlsx\")\n{:ok, value} = UmyaSpreadsheet.get_cell_value(loaded_spreadsheet, \"Sheet1\", \"A1\")\n# => {:ok, \"Hello\"}\n```","ref":"readme.html#quick-start-guide"},{"type":"extras","title":"Documentation and Guides - UmyaSpreadsheet","doc":"For more detailed examples and complete API documentation, visit:\n[https://hexdocs.pm/umya_spreadsheet_ex](https://hexdocs.pm/umya_spreadsheet_ex)\n\nWe provide detailed guides for specific features:\n\n- [**Charts**](https://hexdocs.pm/umya_spreadsheet_ex/charts.html) - Creating and customizing various chart types\n- [**CSV Export & Performance**](https://hexdocs.pm/umya_spreadsheet_ex/csv_export_and_performance.html) - CSV export and optimized writers\n- [**Data Validation**](https://hexdocs.pm/umya_spreadsheet_ex/data_validation.html) - Control and validate cell input values\n- [**Excel Tables**](https://hexdocs.pm/umya_spreadsheet_ex/excel_tables.html) - Create, style, and manage structured Excel tables\n- [**File Format Options**](https://hexdocs.pm/umya_spreadsheet_ex/file_format_options.html) - Control compression, encryption, and binary Excel generation\n- [**Image Handling**](https://hexdocs.pm/umya_spreadsheet_ex/image_handling.html) - Working with images in spreadsheets\n- [**Pivot Tables**](https://hexdocs.pm/umya_spreadsheet_ex/pivot_tables.html) - Create and manage data analysis pivot tables\n- [**Print Settings**](https://hexdocs.pm/umya_spreadsheet_ex/print_settings.html) - Configure page setup and print options\n- [**Sheet Operations**](https://hexdocs.pm/umya_spreadsheet_ex/sheet_operations.html) - Managing worksheets effectively\n- [**Styling and Formatting**](https://hexdocs.pm/umya_spreadsheet_ex/styling_and_formatting.html) - Making your spreadsheets look professional\n\nYou can find all guides in our [Guide Index](https://hexdocs.pm/umya_spreadsheet_ex/guides.html).","ref":"readme.html#documentation-and-guides"},{"type":"extras","title":"Complete Usage Examples - UmyaSpreadsheet","doc":"","ref":"readme.html#complete-usage-examples"},{"type":"extras","title":"Styling and Formatting - UmyaSpreadsheet","doc":"```elixir\n# Create a styled spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Apply various styling options\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Styled Title\")\n:ok = UmyaSpreadsheet.set_font_size(spreadsheet, \"Sheet1\", \"A1\", 16)\n:ok = UmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\n:ok = UmyaSpreadsheet.set_background_color(spreadsheet, \"Sheet1\", \"A1\", \"CCFFCC\") # Light green\n\n# Add numbers with specific formats\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B3\", \"1234.56\")\n:ok = UmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"B3\", \"#,##0.00\")\n\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B4\", \"0.42\")\n:ok = UmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"B4\", \"0.00%\")\n\n# Currency formatting\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B5\", \"9999.99\")\n:ok = UmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"B5\", \"$#,##0.00\")\n\n# Date formatting\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B6\", \"44500\") # Excel date serial\n:ok = UmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"B6\", \"yyyy-mm-dd\")\n\n# Save the spreadsheet\n:ok = UmyaSpreadsheet.write(spreadsheet, \"formatted_spreadsheet.xlsx\")\n```","ref":"readme.html#styling-and-formatting"},{"type":"extras","title":"Rich Text Formatting - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Create a rich text object\nrich_text = UmyaSpreadsheet.RichText.create()\n\n# Add formatted text with different styles\n:ok = UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"Bold text\", %{bold: true})\n:ok = UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \" and \", %{})\n:ok = UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"italic text\", %{italic: true})\n:ok = UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \" with \", %{})\n:ok = UmyaSpreadsheet.RichText.add_formatted_text(rich_text, \"colored text\", %{color: \"#FF0000\"})\n\n# Set the rich text to a cell\n:ok = UmyaSpreadsheet.RichText.set_cell_rich_text(spreadsheet, \"Sheet1\", \"A1\", rich_text)\n\n# Alternative: Create rich text from HTML\nhtml_rich_text = UmyaSpreadsheet.RichText.create_from_html(\" Bold  and  italic  text\")\n:ok = UmyaSpreadsheet.RichText.set_cell_rich_text(spreadsheet, \"Sheet1\", \"A2\", html_rich_text)\n\n# Create individual text elements for more control\nelement1 = UmyaSpreadsheet.RichText.create_text_element(\"Large text\", %{size: 18, bold: true})\nelement2 = UmyaSpreadsheet.RichText.create_text_element(\" and small text\", %{size: 10})\n\n# Add elements to rich text\nrich_text2 = UmyaSpreadsheet.RichText.create()\n:ok = UmyaSpreadsheet.RichText.add_text_element(rich_text2, element1)\n:ok = UmyaSpreadsheet.RichText.add_text_element(rich_text2, element2)\n:ok = UmyaSpreadsheet.RichText.set_cell_rich_text(spreadsheet, \"Sheet1\", \"A3\", rich_text2)\n\n# Generate HTML from rich text\nhtml_output = UmyaSpreadsheet.RichText.to_html(rich_text)\n# => \" Bold text  and  italic text  with  colored text \"\n\n# Get font properties from text elements\n{:ok, props} = UmyaSpreadsheet.RichText.get_element_font_properties(element1)\n# props[:bold] => \"true\"\n# props[:size] => \"18\"\n\n:ok = UmyaSpreadsheet.write(spreadsheet, \"rich_text_example.xlsx\")\n```","ref":"readme.html#rich-text-formatting"},{"type":"extras","title":"Sheet Operations - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add a new sheet\n:ok = UmyaSpreadsheet.add_sheet(spreadsheet, \"Data\")\n\n# Clone a sheet\n:ok = UmyaSpreadsheet.clone_sheet(spreadsheet, \"Sheet1\", \"Sheet1 Copy\")\n\n# Get all sheet names\nsheet_names = UmyaSpreadsheet.get_sheet_names(spreadsheet)\n# => [\"Sheet1\", \"Data\", \"Sheet1 Copy\"]\n\n# Hide a sheet\n:ok = UmyaSpreadsheet.set_sheet_state(spreadsheet, \"Data\", \"hidden\")\n\n# Remove a sheet\n:ok = UmyaSpreadsheet.remove_sheet(spreadsheet, \"Sheet1 Copy\")\n\n# Turn off grid lines\n:ok = UmyaSpreadsheet.set_show_grid_lines(spreadsheet, \"Sheet1\", false)\n```","ref":"readme.html#sheet-operations"},{"type":"extras","title":"Working with Charts - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Prepare some data for the chart\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Month\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"Sales\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"January\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B2\", \"1200\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A3\", \"February\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B3\", \"1500\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A4\", \"March\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B4\", \"2200\")\n\n# Define data series for the chart\ndata_series = [\"Sheet1!$B$2:$B$4\"]\ncategories = \"Sheet1!$A$2:$A$4\"\ntitle = \"Quarterly Sales\"\n\n# Add a column chart\n:ok = UmyaSpreadsheet.add_chart(\n  spreadsheet,\n  \"Sheet1\",\n  \"ColumnChart\",  # Other options: LineChart, PieChart, BarChart\n  \"D2\",           # Top-left position of chart\n  \"J10\",          # Bottom-right position of chart\n  title,          # Chart title\n  data_series,    # Data series\n  categories      # Categories (optional)\n)\n```","ref":"readme.html#working-with-charts"},{"type":"extras","title":"Export to CSV - UmyaSpreadsheet","doc":"```elixir\n# Read an existing spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"sales_report.xlsx\")\n\n# Export just one sheet to CSV\n:ok = UmyaSpreadsheet.write_csv(spreadsheet, \"Sheet1\", \"sheet1_data.csv\")\n```","ref":"readme.html#export-to-csv"},{"type":"extras","title":"Data Validation - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add a dropdown list to cells\n:ok = UmyaSpreadsheet.add_list_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  [\"Option 1\", \"Option 2\", \"Option 3\"],\n  true,  # Allow blank values\n  \"Invalid Selection\",  # Error title\n  \"Please select from the list\",  # Error message\n  \"Selection Required\",  # Prompt title\n  \"Choose an option from the dropdown\"  # Prompt message\n)\n\n# Add number validation (between 1 and 100)\n:ok = UmyaSpreadsheet.add_number_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"B1:B10\",\n  \"between\",  # Operator: between, greaterThan, lessThan, etc.\n  1.0,  # Minimum value\n  100.0,  # Maximum value\n  true,  # Allow blank values\n  \"Invalid Number\",  # Error title\n  \"Please enter a number between 1 and 100\"  # Error message\n)\n\n# Add date validation (future dates only)\n# Option 1: Using Date struct directly\n:ok = UmyaSpreadsheet.add_date_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"C1:C10\",\n  \"greaterThan\",  # Operator\n  Date.utc_today(),  # Compare date as Date struct\n  nil,  # Second date (for between operator)\n  true,  # Allow blank values\n  \"Invalid Date\",  # Error title\n  \"Please enter a future date\"  # Error message\n)\n\n# Option 2: Using ISO string format\ntoday_string = Date.utc_today() |> Date.to_iso8601()\n:ok = UmyaSpreadsheet.add_date_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"D1:D10\",\n  \"greaterThan\",\n  today_string,  # Compare date as string\n  nil,\n  true,\n  \"Invalid Date\",\n  \"Please enter a future date\"\n)\n\n# Add text length validation (max 10 characters)\n:ok = UmyaSpreadsheet.add_text_length_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"D1:D10\",\n  \"lessThanOrEqual\",  # Operator\n  10,  # Character limit\n  nil,  # Second value (for between operator)\n  true  # Allow blank values\n)\n\n# Remove validation from a range\n:ok = UmyaSpreadsheet.remove_data_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A5:A10\"\n)\n```","ref":"readme.html#data-validation"},{"type":"extras","title":"Improved Memory Usage with Light Writers - UmyaSpreadsheet","doc":"```elixir\n# Create a large spreadsheet with many sheets\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# [... add lots of data ...]\n\n# Use the light writer for better memory efficiency\n:ok = UmyaSpreadsheet.write_light(spreadsheet, \"large_file.xlsx\")\n\n# Or with password protection\n:ok = UmyaSpreadsheet.write_with_password_light(spreadsheet, \"secure_large_file.xlsx\", \"password123\")\n```","ref":"readme.html#improved-memory-usage-with-light-writers"},{"type":"extras","title":"Working with Pivot Tables - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Create some sample data for the pivot table\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Region\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"Product\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C1\", \"Sales\")\n\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"North\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B2\", \"Apples\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C2\", \"10000\")\n\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A3\", \"North\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B3\", \"Oranges\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C3\", \"8000\")\n\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A4\", \"South\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B4\", \"Apples\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C4\", \"12000\")\n\n# Add a sheet for the pivot table\n:ok = UmyaSpreadsheet.add_sheet(spreadsheet, \"Pivot\")\n\n# Create a pivot table\n:ok = UmyaSpreadsheet.add_pivot_table(\n  spreadsheet,                      # Spreadsheet object\n  \"Pivot\",                          # Destination sheet\n  \"Sales Analysis\",                 # Pivot table name\n  \"Sheet1\",                         # Source sheet\n  \"A1:C4\",                          # Source data range\n  \"A3\",                             # Pivot table top-left position\n  [0],                              # Row fields (Region - column index 0)\n  [1],                              # Column fields (Product - column index 1)\n  [{2, \"sum\", \"Total Sales\"}]       # Data fields (Sum of Sales)\n)\n\n# Check if a sheet has pivot tables\nhas_pivots = UmyaSpreadsheet.has_pivot_tables?(spreadsheet, \"Pivot\")\n# => true\n\n# Count pivot tables on a sheet\ncount = UmyaSpreadsheet.count_pivot_tables(spreadsheet, \"Pivot\")\n# => 1\n\n# Refresh all pivot tables\n:ok = UmyaSpreadsheet.refresh_all_pivot_tables(spreadsheet)\n\n# Remove a pivot table\n:ok = UmyaSpreadsheet.remove_pivot_table(spreadsheet, \"Pivot\", \"Sales Analysis\")\n```","ref":"readme.html#working-with-pivot-tables"},{"type":"extras","title":"Working with Excel Tables - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add some sample data for the table\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Product\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"Category\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C1\", \"Price\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"D1\", \"Stock\")\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"Laptop\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B2\", \"Electronics\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C2\", 999.99)\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"D2\", 50)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A3\", \"Mouse\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B3\", \"Electronics\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C3\", 29.99)\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"D3\", 100)\n\n# Create a table with the data\n{:ok, :ok} = UmyaSpreadsheet.add_table(\n  spreadsheet,\n  \"Sheet1\",\n  \"ProductTable\",\n  \"Product Inventory\",\n  \"A1\",\n  \"D3\",\n  [\"Product\", \"Category\", \"Price\", \"Stock\"],\n  true  # Show totals row\n)\n\n# Apply a table style\n{:ok, :ok} = UmyaSpreadsheet.set_table_style(\n  spreadsheet,\n  \"Sheet1\",\n  \"ProductTable\",\n  \"TableStyleMedium9\",\n  true,   # Show first column\n  false,  # Show last column\n  true,   # Show banded rows\n  false   # Show banded columns\n)\n\n# Add a new column to the table\n{:ok, :ok} = UmyaSpreadsheet.add_table_column(\n  spreadsheet,\n  \"Sheet1\",\n  \"ProductTable\",\n  \"Total Value\",\n  \"sum\",\n  \"Grand Total\"\n)\n\n# Check if sheet has tables\n{:ok, true} = UmyaSpreadsheet.has_tables?(spreadsheet, \"Sheet1\")\n\n# Get all tables from the sheet\n{:ok, tables} = UmyaSpreadsheet.get_tables(spreadsheet, \"Sheet1\")\n[table | _] = tables\n# table[\"name\"] => \"ProductTable\"\n# table[\"display_name\"] => \"Product Inventory\"\n\n# Remove the table\n{:ok, :ok} = UmyaSpreadsheet.remove_table(spreadsheet, \"Sheet1\", \"ProductTable\")\n```","ref":"readme.html#working-with-excel-tables"},{"type":"extras","title":"Advanced Features - UmyaSpreadsheet","doc":"","ref":"readme.html#advanced-features"},{"type":"extras","title":"Row and Column Operations - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Insert 2 new rows at index 3\n:ok = UmyaSpreadsheet.insert_new_row(spreadsheet, \"Sheet1\", 3, 2)\n\n# Insert 1 new column at column C\n:ok = UmyaSpreadsheet.insert_new_column(spreadsheet, \"Sheet1\", \"C\", 1)\n\n# Remove row at index 5\n:ok = UmyaSpreadsheet.remove_row(spreadsheet, \"Sheet1\", 5, 1)\n\n# Set column width\n:ok = UmyaSpreadsheet.set_column_width(spreadsheet, \"Sheet1\", \"A\", 15.5)\n\n# Auto-fit column width based on content\n:ok = UmyaSpreadsheet.set_column_auto_width(spreadsheet, \"Sheet1\", \"B\", true)\n\n# Set row height\n:ok = UmyaSpreadsheet.set_row_height(spreadsheet, \"Sheet1\", 1, 30.0)\n\n# Apply styling to entire row\n:ok = UmyaSpreadsheet.set_row_style(spreadsheet, \"Sheet1\", 1, \"EEEEEE\", \"000000\")\n```","ref":"readme.html#row-and-column-operations"},{"type":"extras","title":"Security and Protection - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add data to the spreadsheet\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Confidential Data\")\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"Employee Salaries\")\n\n# Protect the entire workbook\n:ok = UmyaSpreadsheet.set_workbook_protection(spreadsheet, true)\n\n# Protect a specific worksheet\n:ok = UmyaSpreadsheet.set_sheet_protection(\n  spreadsheet,\n  \"Sheet1\",\n  true,\n  \"This sheet is protected\"  # Optional message\n)\n\n# Save with password protection\n:ok = UmyaSpreadsheet.write_with_password(spreadsheet, \"confidential.xlsx\", \"secret123\")\n\n# Apply password to an existing file\n:ok = UmyaSpreadsheet.set_password(\"original.xlsx\", \"protected_copy.xlsx\", \"secret123\")\n```","ref":"readme.html#security-and-protection"},{"type":"extras","title":"Print Settings and Page Setup - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add some content to the spreadsheet\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Report Title\")\n:ok = UmyaSpreadsheet.set_font_size(spreadsheet, \"Sheet1\", \"A1\", 16)\n:ok = UmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\n\n# Configure print settings\n# Set to landscape orientation\n:ok = UmyaSpreadsheet.set_page_orientation(spreadsheet, \"Sheet1\", \"landscape\")\n\n# Set to A4 paper size\n:ok = UmyaSpreadsheet.set_paper_size(spreadsheet, \"Sheet1\", 9)\n\n# Set page margins (in inches)\n:ok = UmyaSpreadsheet.set_page_margins(spreadsheet, \"Sheet1\", 1.0, 0.75, 1.0, 0.75)\n\n# Set header and footer margins\n:ok = UmyaSpreadsheet.set_header_footer_margins(spreadsheet, \"Sheet1\", 0.5, 0.5)\n\n# Add a custom header\n:ok = UmyaSpreadsheet.set_header(spreadsheet, \"Sheet1\", \"&C&\\\"Arial,Bold\\\"Confidential Report\")\n\n# Add a footer with page numbers\n:ok = UmyaSpreadsheet.set_footer(spreadsheet, \"Sheet1\", \"&RPage &P of &N\")\n\n# Define a specific print area\n:ok = UmyaSpreadsheet.set_print_area(spreadsheet, \"Sheet1\", \"A1:H20\")\n\n# Set rows 1-2 to repeat at the top of each printed page\n:ok = UmyaSpreadsheet.set_print_titles(spreadsheet, \"Sheet1\", \"1:2\", \"\")\n\n# Center the printout horizontally on the page\n:ok = UmyaSpreadsheet.set_print_centered(spreadsheet, \"Sheet1\", true, false)\n\n# Save the spreadsheet\n:ok = UmyaSpreadsheet.write(spreadsheet, \"print_ready_report.xlsx\")\n```","ref":"readme.html#print-settings-and-page-setup"},{"type":"extras","title":"Working with Images - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add an image to cell A1\n:ok = UmyaSpreadsheet.add_image(spreadsheet, \"Sheet1\", \"A1\", \"path/to/logo.png\")\n\n# When reading a spreadsheet with images, you can download them\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"report_with_images.xlsx\")\n:ok = UmyaSpreadsheet.download_image(spreadsheet, \"Sheet1\", \"A1\", \"downloaded_image.png\")\n\n# Replace an existing image\n:ok = UmyaSpreadsheet.change_image(spreadsheet, \"Sheet1\", \"A1\", \"path/to/new_logo.png\")\n```","ref":"readme.html#working-with-images"},{"type":"extras","title":"Working with Drawing Objects - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add a shape\n:ok = UmyaSpreadsheet.add_shape(spreadsheet, \"Sheet1\", \"D3\", \"rectangle\", 200, 100, \"blue\", \"black\", 1.0)\n\n# Add a text box\n:ok = UmyaSpreadsheet.add_text_box(spreadsheet, \"Sheet1\", \"D5\", \"Important Note\", 200, 100, \"yellow\", \"black\", \"gray\", 1.0)\n\n# Add a connector between cells\n:ok = UmyaSpreadsheet.add_connector(spreadsheet, \"Sheet1\", \"A1\", \"D3\", \"green\", 1.5)\n```","ref":"readme.html#working-with-drawing-objects"},{"type":"extras","title":"Testing and Development - UmyaSpreadsheet","doc":"The library includes comprehensive test cases. To run them:\n\n```bash\nmix test\n```\n\nTest files are created in the `test/result_files` directory and are automatically ignored by git.\n\nFor more details on development, check out the [DEVELOPMENT.md](DEVELOPMENT.md) file.","ref":"readme.html#testing-and-development"},{"type":"extras","title":"Advanced File Format Options - UmyaSpreadsheet","doc":"```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n# Add data to the spreadsheet...\n\n# Control the compression level (0-9)\n:ok = UmyaSpreadsheet.write_with_compression(spreadsheet, \"optimized.xlsx\", 8)\n\n# Enhanced encryption with AES256\n:ok = UmyaSpreadsheet.write_with_encryption_options(\n  spreadsheet,\n  \"secure.xlsx\",\n  \"myPassword\",\n  \"AES256\",        # Algorithm\n  \"customSaltValue\", # Optional salt value\n  100000           # Optional spin count\n)\n\n# Generate binary XLSX for web responses\nxlsx_binary = UmyaSpreadsheet.to_binary_xlsx(spreadsheet)\n\n# In a Phoenix controller:\nconn\n|> put_resp_content_type(\"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet\")\n|> put_resp_header(\"content-disposition\", ~s[attachment; filename=\"report.xlsx\"])\n|> send_resp(200, xlsx_binary)\n```","ref":"readme.html#advanced-file-format-options"},{"type":"extras","title":"Performance Considerations - UmyaSpreadsheet","doc":"- Use `lazy_read/1` for large spreadsheets to load sheets only when accessed\n- Use `write_light/2` and `write_with_password_light/3` for better memory efficiency with large files\n- For spreadsheets with many sheets, consider using `new_empty/0` and adding only the sheets you need","ref":"readme.html#performance-considerations"},{"type":"extras","title":"License - UmyaSpreadsheet","doc":"UmyaSpreadsheetEx is available under the MIT License. See the LICENSE file for more info.","ref":"readme.html#license"},{"type":"extras","title":"Acknowledgements - UmyaSpreadsheet","doc":"This library is a wrapper around the excellent [umya-spreadsheet](https://github.com/MathNya/umya-spreadsheet) Rust library.","ref":"readme.html#acknowledgements"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2024 Alessandro Iob\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"UmyaSpreadsheet Documentation","doc":"# UmyaSpreadsheet Documentation\n\nWelcome to the UmyaSpreadsheet documentation. This collection of guides provides comprehensive information on using the UmyaSpreadsheet library to create, read, and manipulate Excel files in Elixir.","ref":"guides.html"},{"type":"extras","title":"Available Guides - UmyaSpreadsheet Documentation","doc":"- [**Charts**](charts.html): Learn how to create and customize various chart types\n\n  - Line charts, pie charts, bar charts, scatter plots, and more\n  - Customizing chart appearance with styles and options\n  - Advanced 3D chart customization\n\n- [**Comments**](comments.html): Working with cell comments\n\n  - Adding comments to cells with author information\n  - Retrieving and updating existing comments\n  - Removing comments and counting comments in worksheets\n\n- [**Conditional Formatting**](conditional_formatting.html): Apply dynamic formatting based on cell contents\n\n  - Cell value rules (greater than, less than, equal to, etc.)\n  - Color scales and data bars for visual data representation\n  - Top/bottom ranking and text-based formatting rules\n\n- [**CSV Export & Performance**](csv_export_and_performance.html): Optimize your spreadsheet operations\n\n  - Converting Excel sheets to CSV format\n  - Using light writer functions for improved memory usage\n  - Performance recommendations for large spreadsheets\n\n- [**Data Validation**](data_validation.html): Control and restrict cell input values\n\n  - Dropdown lists for predefined options\n  - Number, date, and text length validation\n  - Custom formula-based validation rules\n  - Input messages and error alerts\n\n- [**Document Properties**](document_properties.html): Add and manage document metadata\n\n  - Core document properties (title, author, description, etc.)\n  - Custom properties for application-specific metadata\n  - Reading, writing and removing properties\n  - Best practices for date handling and Unicode support\n\n- [**Excel Tables**](excel_tables.html): Create, style, and manage structured Excel tables\n\n  - Creating tables with headers and data ranges\n  - Applying built-in table styles and customization options\n  - Adding, modifying, and removing table columns dynamically\n  - Configuring totals rows with calculation functions\n  - Managing table metadata and column properties\n\n- [**Formula Functions**](formula_functions.html): Work with formulas and named references\n\n  - Setting regular cell formulas\n  - Creating array formulas that span multiple cells\n  - Defining named ranges and defined names\n  - Listing and managing defined names\n\n- [**Hyperlinks**](hyperlinks.html): Manage hyperlinks in Excel spreadsheets\n\n  - Adding web URLs, email addresses, file paths, and internal references\n  - Getting, updating, and removing hyperlinks from cells\n  - Bulk hyperlink operations and worksheet-level management\n  - Integration with cell values and advanced error handling\n\n- [**File Format Options**](file_format_options.html): Control compression, encryption, and delivery\n\n  - Adjusting compression levels for Excel files\n  - Advanced encryption and security options\n  - Generating binary Excel files for web applications\n  - Performance optimizations for different scenarios\n\n- [**Auto Filters**](auto_filters.html): Enable Excel's filtering capability\n\n  - Adding filter dropdown buttons to data ranges\n  - Checking and removing auto filters\n  - Getting filter range information\n  - Best practices for using auto filters\n\n- [**Image Handling**](image_handling.html): Working with images in spreadsheets\n\n  - Adding images to cells\n  - Downloading images from spreadsheets\n  - Changing existing images\n\n- [**OLE Objects**](ole_objects.html): Embed documents and files in Excel spreadsheets\n\n  - Embedding Word documents, PowerPoint presentations, PDF files, and text files\n  - Creating and managing OLE object collections\n  - Loading objects from files or binary data\n  - Extracting embedded objects and managing properties\n  - Working with ProgIDs and file format detection\n\n- [**Page Breaks**](page_breaks.html): Control print layout and page breaking\n\n  - Manual page break insertion with row and column controls\n  - Managing print layout for consistent document formatting\n  - Row breaks and column breaks for precise pagination\n  - Bulk operations and advanced page break management\n\n- [**Pivot Tables**](pivot_tables.html): Create and manage data analysis tools\n\n  - Creating pivot tables from data ranges\n  - Configuring row, column, and data fields\n  - Refreshing pivot table data\n\n- [**Shapes and Drawing**](shapes_and_drawing.html): Add shapes and drawing elements\n\n  - Creating basic shapes (rectangles, ellipses, etc.)\n  - Adding text boxes with formatted text\n  - Creating connectors between cells\n  - Building diagrams and flowcharts\n\n- [**VML Drawings**](vml_drawings.html): Work with Vector Markup Language (VML) shapes\n\n  - Creating VML shapes for legacy compatibility\n  - Shape types (rectangles, ovals, lines, rounded rectangles)\n  - Style properties for positioning and sizing\n  - Fill and stroke properties for appearance customization\n  - Best practices for VML shape management\n\n- [**Sheet View Settings**](sheet_view.html): Control individual worksheet appearance and behavior\n\n  - Zoom levels for different Excel view modes (Normal, Page Layout, Page Break)\n  - Grid line visibility controls for cleaner presentations\n  - Pane freezing and splitting for large dataset navigation\n  - Tab colors for visual organization and categorization\n  - Cell selection management and user focus control\n\n- [**Window Settings**](window_settings.html): Control Excel viewing experience\n\n  - Setting active sheet selection and focus\n  - Configuring which tab is active when opening the workbook\n  - Setting the Excel application window position and size\n\n- [**Thread Safety**](thread_safety.html): Using UmyaSpreadsheet in concurrent environments\n\n  - Thread safety guidelines and considerations\n  - Best practices for concurrent operations\n  - Examples of safe concurrent patterns\n  - Avoiding race conditions with shared spreadsheets\n\n- [**Sheet Operations**](sheet_operations.html): Managing worksheets effectively\n\n  - Adding, removing, and cloning sheets\n  - Sheet protection and visibility settings\n  - Inspecting sheet properties and metadata (count, state, protection details, merged cells)\n  - Working with sheet properties\n\n- [**Styling and Formatting**](styling_and_formatting.html): Making your spreadsheets look professional\n  - Font styling (size, color, bold)\n  - Cell background colors\n  - Number formats and cell alignment\n  - Borders and other visual elements\n\n- [**Rich Text Formatting**](rich_text.html): Create cells with multiple formatting styles\n\n  - Multiple font styles within a single cell (bold, italic, underline, strikethrough)\n  - Custom colors and font sizes for different text segments\n  - HTML import and export for complex formatting\n  - Comprehensive font property management with idiomatic Elixir API\n\n- [**Advanced Cell Formatting**](advanced_cell_formatting.html): Enhanced visual styling options\n  - Rich text styling (italic, strikethrough, multiple underline styles)\n  - Advanced border customization (dashed, dotted, double borders)\n  - Text rotation and orientation control\n  - Cell text indentation for hierarchical displays\n\n- [**Limitations & Compatibility**](limitations.html): Understanding constraints and compatibility\n  - File format support matrix and limitations\n  - Excel feature support levels and workarounds\n  - Platform and version compatibility information\n  - Performance limitations and guidelines\n  - Known issues and future roadmap\n\n- [**Troubleshooting Guide**](troubleshooting.html): Solutions for common issues and problems\n  - Installation and compilation issues\n  - Runtime errors and debugging techniques\n  - Performance optimization strategies\n  - File format and memory management issues\n  - Platform-specific solutions and best practices","ref":"guides.html#available-guides"},{"type":"extras","title":"Getting Started - UmyaSpreadsheet Documentation","doc":"For a quick introduction to UmyaSpreadsheet, visit the [README](../readme.html).\n\nFor development information, including contribution guidelines and future improvements,\nsee the [Development Guide](../DEVELOPMENT.html).","ref":"guides.html#getting-started"},{"type":"extras","title":"CSV Export and Performance Options","doc":"# CSV Export and Performance Options\n\nThis document covers the CSV export functionality and the performance-optimized writer options in UmyaSpreadsheet.","ref":"csv_export_and_performance.html"},{"type":"extras","title":"CSV Export - CSV Export and Performance Options","doc":"The CSV export feature allows you to export individual sheets from an Excel file to CSV format for easier data interchange.","ref":"csv_export_and_performance.html#csv-export"},{"type":"extras","title":"Usage - CSV Export and Performance Options","doc":"```elixir\n# Read an existing spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"sales_data.xlsx\")\n\n# Export Sheet1 to a CSV file\n:ok = UmyaSpreadsheet.write_csv(spreadsheet, \"Sheet1\", \"sales_data.csv\")\n```","ref":"csv_export_and_performance.html#usage"},{"type":"extras","title":"Options and Limitations - CSV Export and Performance Options","doc":"- Each export creates a single CSV file from a single sheet\n- The export uses default CSV settings (comma-separated, quoted strings when needed)\n- All cell values will be represented as strings in the CSV output\n- Formatting and styling is not preserved in the CSV export","ref":"csv_export_and_performance.html#options-and-limitations"},{"type":"extras","title":"Light Writer Functions - CSV Export and Performance Options","doc":"These functions offer memory-efficient alternatives to the standard `write` functions, which is especially useful for large spreadsheets.","ref":"csv_export_and_performance.html#light-writer-functions"},{"type":"extras","title":"Available Light Writer Functions - CSV Export and Performance Options","doc":"1. `write_light/2` - Writes a spreadsheet to a file using less memory\n2. `write_with_password_light/3` - Writes a password-protected spreadsheet using less memory","ref":"csv_export_and_performance.html#available-light-writer-functions"},{"type":"extras","title":"Usage - CSV Export and Performance Options","doc":"```elixir\n# Create a large spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add lots of data...\n# ...\n\n# Use light writer to save with less memory usage\n:ok = UmyaSpreadsheet.write_light(spreadsheet, \"large_spreadsheet.xlsx\")\n\n# Or with password protection\n:ok = UmyaSpreadsheet.write_with_password_light(spreadsheet, \"protected_large.xlsx\", \"secret123\")\n```","ref":"csv_export_and_performance.html#usage-1"},{"type":"extras","title":"When to Use Light Writers - CSV Export and Performance Options","doc":"- When working with very large spreadsheets (thousands of rows/columns)\n- When running in memory-constrained environments\n- When maximum performance is needed and some advanced features aren't required","ref":"csv_export_and_performance.html#when-to-use-light-writers"},{"type":"extras","title":"Limitations of Light Writers - CSV Export and Performance Options","doc":"The light writer functions have some trade-offs to achieve their memory efficiency:\n\n- May not preserve all complex cell styles\n- Some advanced chart features might be simplified\n- Drawing and image handling might be slightly different","ref":"csv_export_and_performance.html#limitations-of-light-writers"},{"type":"extras","title":"Creating Empty Spreadsheets - CSV Export and Performance Options","doc":"The `new_empty/0` function allows you to create a spreadsheet without any default worksheets, which can be useful when you want to entirely customize your spreadsheet structure.\n\n```elixir\n# Create an empty spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new_empty()\n\n# Add your own sheet\n:ok = UmyaSpreadsheet.add_sheet(spreadsheet, \"CustomSheet\")\n\n# Now work with your custom sheet\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"CustomSheet\", \"A1\", \"Custom data\")\n```","ref":"csv_export_and_performance.html#creating-empty-spreadsheets"},{"type":"extras","title":"Performance Recommendations - CSV Export and Performance Options","doc":"For the best performance when working with large Excel files:\n\n1. Use `lazy_read/1` instead of `read/1` when you only need to access certain sheets\n2. Use `write_light/2` when saving large files\n3. Use `new_empty/0` when you need to create highly customized spreadsheets\n4. Remove unnecessary sheets before saving large files\n5. Consider exporting individual sheets to CSV if the recipient only needs the data, not the formatting","ref":"csv_export_and_performance.html#performance-recommendations"},{"type":"extras","title":"File Format Options","doc":"# File Format Options\n\nThis guide covers the advanced file format options available in UmyaSpreadsheet, providing you with more control over XLSX file generation, compression, encryption, and delivery methods.","ref":"file_format_options.html"},{"type":"extras","title":"Compression Control - File Format Options","doc":"Excel files (.xlsx) are essentially ZIP archives containing XML files. UmyaSpreadsheet allows you to control the compression level of these files, balancing between file size and generation speed.","ref":"file_format_options.html#compression-control"},{"type":"extras","title":"Compression Levels - File Format Options","doc":"Compression levels range from 0 (no compression) to 9 (maximum compression):\n\n- **Level 0**: No compression, fastest creation time, largest file size\n- **Level 1-3**: Light compression, good speed, moderate file size reduction\n- **Level 4-6**: Balanced compression (Excel default is around level 6)\n- **Level 7-9**: Maximum compression, slower creation time, smallest file size","ref":"file_format_options.html#compression-levels"},{"type":"extras","title":"Getting the Default Compression Level - File Format Options","doc":"You can check what compression level is being used by default:\n\n```elixir\nalias UmyaSpreadsheet\n\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\nlevel = UmyaSpreadsheet.FileFormatOptions.get_compression_level(spreadsheet)\nIO.puts(\"Default compression level: #{level}\")\n# => Default compression level: 6\n```","ref":"file_format_options.html#getting-the-default-compression-level"},{"type":"extras","title":"Setting Custom Compression - File Format Options","doc":"```elixir\nalias UmyaSpreadsheet\n\n# Create a spreadsheet with a lot of data\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n# ... add data to the spreadsheet ...\n\n# Save with no compression - fastest creation, largest file size\nUmyaSpreadsheet.FileFormatOptions.write_with_compression(spreadsheet, \"uncompressed.xlsx\", 0)\n\n# Save with default compression\nUmyaSpreadsheet.write(spreadsheet, \"default_compression.xlsx\")\n\n# Save with maximum compression - smallest file size, slower creation\nUmyaSpreadsheet.FileFormatOptions.write_with_compression(spreadsheet, \"max_compressed.xlsx\", 9)\n```","ref":"file_format_options.html#setting-custom-compression"},{"type":"extras","title":"When to Use Different Compression Levels - File Format Options","doc":"- **No compression (0)**: When generation speed is critical and file size doesn't matter\n- **Light compression (1-3)**: For large files where you need a balance of speed and size\n- **Default compression**: For most use cases\n- **Maximum compression (7-9)**: When storage space or network bandwidth is limited","ref":"file_format_options.html#when-to-use-different-compression-levels"},{"type":"extras","title":"Enhanced Encryption Options - File Format Options","doc":"UmyaSpreadsheet provides advanced encryption options for securing Excel files with passwords.","ref":"file_format_options.html#enhanced-encryption-options"},{"type":"extras","title":"Checking Encryption Status - File Format Options","doc":"You can check if a spreadsheet has encryption enabled:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Check if a spreadsheet is encrypted\n{:ok, spreadsheet} = UmyaSpreadsheet.read_xlsx(\"document.xlsx\")\nif UmyaSpreadsheet.FileFormatOptions.is_encrypted(spreadsheet) do\n  IO.puts(\"The spreadsheet has encryption enabled\")\nelse\n  IO.puts(\"The spreadsheet is not encrypted\")\nend\n\n# Get the encryption algorithm used\nalgorithm = UmyaSpreadsheet.FileFormatOptions.get_encryption_algorithm(spreadsheet)\nIO.puts(\"Encryption algorithm: #{algorithm || \"None\"}\")\n# => Encryption algorithm: AES256\n```","ref":"file_format_options.html#checking-encryption-status"},{"type":"extras","title":"Basic Password Protection - File Format Options","doc":"For simple password protection, use the standard function:\n\n```elixir\nUmyaSpreadsheet.write_with_password(spreadsheet, \"protected.xlsx\", \"myPassword\")\n```","ref":"file_format_options.html#basic-password-protection"},{"type":"extras","title":"Advanced Encryption Options - File Format Options","doc":"For more control over the encryption process:\n\n```elixir\n# Use AES256 encryption with custom parameters\nUmyaSpreadsheet.write_with_encryption_options(\n  spreadsheet,\n  \"highly_secure.xlsx\",\n  \"myPassword\",\n  \"AES256\",         # Algorithm\n  \"customSaltValue\", # Optional salt value\n  100000            # Optional spin count\n)\n```","ref":"file_format_options.html#advanced-encryption-options"},{"type":"extras","title":"Available Encryption Algorithms - File Format Options","doc":"- **\"default\"**: Uses Excel's default encryption (typically AES128)\n- **\"AES128\"**: 128-bit AES encryption\n- **\"AES256\"**: 256-bit AES encryption (stronger than AES128)","ref":"file_format_options.html#available-encryption-algorithms"},{"type":"extras","title":"Security Considerations - File Format Options","doc":"- Using a custom salt value can make password cracking more difficult\n- Higher spin counts increase the computational effort needed to decrypt files\n- AES256 provides stronger encryption than AES128 but may not be necessary for all use cases","ref":"file_format_options.html#security-considerations"},{"type":"extras","title":"Binary Excel Files - File Format Options","doc":"Sometimes you need to generate Excel files without writing them to disk, such as sending them directly in HTTP responses or storing them in a database.","ref":"file_format_options.html#binary-excel-files"},{"type":"extras","title":"Converting a Spreadsheet to Binary - File Format Options","doc":"```elixir\n# Create and populate a spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Hello World\")\n\n# Convert to binary\nxlsx_binary = UmyaSpreadsheet.to_binary_xlsx(spreadsheet)\n```","ref":"file_format_options.html#converting-a-spreadsheet-to-binary"},{"type":"extras","title":"Web Application Example (Phoenix) - File Format Options","doc":"```elixir\ndef download_report(conn, _params) do\n  # Create spreadsheet\n  {:ok, spreadsheet} = UmyaSpreadsheet.new()\n  # ... add data to the spreadsheet ...\n\n  # Convert to binary\n  xlsx_data = UmyaSpreadsheet.to_binary_xlsx(spreadsheet)\n\n  # Send as download\n  conn\n  |> put_resp_content_type(\"application/vnd.openxmlformats-officedocument.spreadsheetml.sheet\")\n  |> put_resp_header(\"content-disposition\", ~s[attachment; filename=\"report.xlsx\"])\n  |> send_resp(200, xlsx_data)\nend\n```","ref":"file_format_options.html#web-application-example-phoenix"},{"type":"extras","title":"Choosing the Right Options - File Format Options","doc":"Here's a guide to help you choose the right file format options for different scenarios:","ref":"file_format_options.html#choosing-the-right-options"},{"type":"extras","title":"For Large Spreadsheets - File Format Options","doc":"```elixir\n# Use light writer with moderate compression\nUmyaSpreadsheet.write_light(spreadsheet, \"large_file.xlsx\")\n\n# Or with custom compression level\nUmyaSpreadsheet.write_with_compression(spreadsheet, \"large_file.xlsx\", 4)\n```","ref":"file_format_options.html#for-large-spreadsheets"},{"type":"extras","title":"For Secure Files - File Format Options","doc":"```elixir\n# Basic password protection\nUmyaSpreadsheet.write_with_password(spreadsheet, \"secure.xlsx\", \"password123\")\n\n# More secure encryption\nUmyaSpreadsheet.write_with_encryption_options(\n  spreadsheet,\n  \"highly_secure.xlsx\",\n  \"strongPassword\",\n  \"AES256\"\n)\n```","ref":"file_format_options.html#for-secure-files"},{"type":"extras","title":"For Web Applications - File Format Options","doc":"```elixir\n# Generate binary for HTTP responses\nxlsx_data = UmyaSpreadsheet.to_binary_xlsx(spreadsheet)\n\n# Or compress it first (pseudo-code)\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n# ... add data ...\ntemp_path = \"/tmp/temp_#{System.unique_integer()}.xlsx\"\nUmyaSpreadsheet.write_with_compression(spreadsheet, temp_path, 9)\nxlsx_data = File.read!(temp_path)\nFile.rm!(temp_path)\n```","ref":"file_format_options.html#for-web-applications"},{"type":"extras","title":"Performance Considerations - File Format Options","doc":"- Higher compression levels take more time to generate but produce smaller files\n- The `write_light` function uses less memory but doesn't support all features\n- Binary generation (`to_binary_xlsx`) keeps the entire file in memory\n- For very large files, consider using CSV export or creating XLSX files with minimal formatting","ref":"file_format_options.html#performance-considerations"},{"type":"extras","title":"Sheet Operations","doc":"# Sheet Operations\n\nThis guide covers comprehensive operations for managing worksheets, rows, columns, and cells in the UmyaSpreadsheet library.","ref":"sheet_operations.html"},{"type":"extras","title":"Overview - Sheet Operations","doc":"UmyaSpreadsheet provides a complete set of functions to:\n\n- Create, copy, and remove worksheets\n- Control sheet visibility and protection settings\n- Inspect sheet properties and retrieve metadata\n- Manage rows and columns (insert, remove, resize)\n- Apply styles to rows and columns\n- Work with merged cells and grid lines","ref":"sheet_operations.html#overview"},{"type":"extras","title":"Basic Sheet Operations - Sheet Operations","doc":"","ref":"sheet_operations.html#basic-sheet-operations"},{"type":"extras","title":"Adding a Sheet - Sheet Operations","doc":"Add a new worksheet to a spreadsheet:\n\n```elixir\nUmyaSpreadsheet.add_sheet(spreadsheet, \"NewSheet\")\n```","ref":"sheet_operations.html#adding-a-sheet"},{"type":"extras","title":"Getting Sheet Names - Sheet Operations","doc":"Retrieve a list of all sheet names in the spreadsheet:\n\n```elixir\nsheet_names = UmyaSpreadsheet.get_sheet_names(spreadsheet)\n# => [\"Sheet1\", \"NewSheet\"]\n```","ref":"sheet_operations.html#getting-sheet-names"},{"type":"extras","title":"Cloning a Sheet - Sheet Operations","doc":"Create a copy of an existing sheet with a new name:\n\n```elixir\nUmyaSpreadsheet.clone_sheet(spreadsheet, \"Sheet1\", \"Sheet1 Copy\")\n```","ref":"sheet_operations.html#cloning-a-sheet"},{"type":"extras","title":"Removing a Sheet - Sheet Operations","doc":"Remove a worksheet from the spreadsheet:\n\n```elixir\nUmyaSpreadsheet.remove_sheet(spreadsheet, \"Sheet1 Copy\")\n```","ref":"sheet_operations.html#removing-a-sheet"},{"type":"extras","title":"Sheet Visibility - Sheet Operations","doc":"Control which sheets are visible to users in Excel or other applications:\n\n```elixir\n# Hide a sheet (can be unhidden by user in Excel)\nUmyaSpreadsheet.set_sheet_state(spreadsheet, \"Sheet2\", \"hidden\")\n\n# Make a sheet very hidden (can only be unhidden programmatically)\nUmyaSpreadsheet.set_sheet_state(spreadsheet, \"Sheet3\", \"very_hidden\")\n\n# Make a sheet visible\nUmyaSpreadsheet.set_sheet_state(spreadsheet, \"Sheet2\", \"visible\")\n```\n\nAvailable sheet states:\n\n- `\"visible\"` - Normal visibility (default)\n- `\"hidden\"` - Hidden but can be unhidden by users in Excel\n- `\"very_hidden\"` - Hidden and cannot be unhidden through the Excel UI","ref":"sheet_operations.html#sheet-visibility"},{"type":"extras","title":"Sheet Protection - Sheet Operations","doc":"Protect worksheets from editing with optional password protection:\n\n```elixir\n# Protect without password\nUmyaSpreadsheet.set_sheet_protection(spreadsheet, \"Sheet1\", nil, true)\n\n# Protect with password\nUmyaSpreadsheet.set_sheet_protection(spreadsheet, \"Sheet1\", \"password123\", true)\n\n# Remove protection\nUmyaSpreadsheet.set_sheet_protection(spreadsheet, \"Sheet1\", nil, false)\n```\n\nThe protection settings determine what users can modify while the sheet is protected.","ref":"sheet_operations.html#sheet-protection"},{"type":"extras","title":"Sheet Information and Inspection - Sheet Operations","doc":"Retrieve comprehensive information about sheets and their properties using the new getter functions:","ref":"sheet_operations.html#sheet-information-and-inspection"},{"type":"extras","title":"Getting Sheet Count - Sheet Operations","doc":"Get the total number of sheets in a spreadsheet:\n\n```elixir\ncount = UmyaSpreadsheet.SheetFunctions.get_sheet_count(spreadsheet)\n# => 3 (returns direct integer value)\n```\n\nNote: `get_sheet_count` returns a direct integer value rather than a tuple, as it cannot fail for valid spreadsheet references.","ref":"sheet_operations.html#getting-sheet-count"},{"type":"extras","title":"Getting Active Sheet - Sheet Operations","doc":"Get the index of the currently active sheet:\n\n```elixir\n{:ok, active_index} = UmyaSpreadsheet.SheetFunctions.get_active_sheet(spreadsheet)\n# => {:ok, 0} (zero-based index, meaning first sheet is active)\n```","ref":"sheet_operations.html#getting-active-sheet"},{"type":"extras","title":"Getting Sheet Visibility State - Sheet Operations","doc":"Check the visibility state of a specific sheet:\n\n```elixir\n{:ok, state} = UmyaSpreadsheet.SheetFunctions.get_sheet_state(spreadsheet, \"Sheet1\")\n# => {:ok, \"visible\"} or {:ok, \"hidden\"} or {:ok, \"veryhidden\"}\n```\n\nThis is useful for checking the current state before modifying it or for auditing sheet visibility in your application.","ref":"sheet_operations.html#getting-sheet-visibility-state"},{"type":"extras","title":"Getting Sheet Protection Details - Sheet Operations","doc":"Retrieve detailed protection settings for a sheet:\n\n```elixir\n{:ok, protection} = UmyaSpreadsheet.SheetFunctions.get_sheet_protection(spreadsheet, \"Sheet1\")\n# => {:ok, %{\n#   \"protected\" => \"true\",\n#   \"objects\" => \"false\",\n#   \"scenarios\" => \"false\",\n#   \"format_cells\" => \"true\",\n#   \"format_columns\" => \"true\",\n#   \"format_rows\" => \"true\",\n#   \"insert_columns\" => \"true\",\n#   \"insert_rows\" => \"true\",\n#   \"insert_hyperlinks\" => \"true\",\n#   \"delete_columns\" => \"true\",\n#   \"delete_rows\" => \"true\",\n#   \"select_locked_cells\" => \"true\",\n#   \"select_unlocked_cells\" => \"true\",\n#   \"sort\" => \"true\",\n#   \"auto_filter\" => \"true\",\n#   \"pivot_tables\" => \"true\"\n# }}\n```","ref":"sheet_operations.html#getting-sheet-protection-details"},{"type":"extras","title":"Getting Merged Cells - Sheet Operations","doc":"Get a list of all merged cell ranges in a sheet:\n\n```elixir\n{:ok, merged_cells} = UmyaSpreadsheet.SheetFunctions.get_merge_cells(spreadsheet, \"Sheet1\")\n# => {:ok, [\"A1:C3\", \"E5:F6\"]} (list of cell range strings)\n```\n\nThis is particularly useful for:\n\n- Auditing merged cell usage\n- Avoiding conflicts when adding new merged cells\n- Understanding the layout structure of existing spreadsheets","ref":"sheet_operations.html#getting-merged-cells"},{"type":"extras","title":"Error Handling for Getter Functions - Sheet Operations","doc":"All getter functions include proper error handling for invalid sheet names:\n\n```elixir\ncase UmyaSpreadsheet.SheetFunctions.get_sheet_state(spreadsheet, \"NonExistentSheet\") do\n  {:ok, state} -> IO.puts(\"Sheet state: #{state}\")\n  {:error, reason} -> IO.puts(\"Error: #{reason}\")\nend\n```\n\nThis ensures your application can gracefully handle cases where sheet names might not exist.","ref":"sheet_operations.html#error-handling-for-getter-functions"},{"type":"extras","title":"Row Operations - Sheet Operations","doc":"","ref":"sheet_operations.html#row-operations"},{"type":"extras","title":"Insert Rows - Sheet Operations","doc":"Add new rows to a worksheet at a specific position:\n\n```elixir\n# Insert 3 new rows starting at row 2\nUmyaSpreadsheet.insert_new_row(spreadsheet, \"Sheet1\", 2, 3)\n```\n\nThis shifts existing rows down, with all content and formatting preserved.","ref":"sheet_operations.html#insert-rows"},{"type":"extras","title":"Remove Rows - Sheet Operations","doc":"Delete rows from a worksheet at a specific position:\n\n```elixir\n# Remove 2 rows starting at row 5\nUmyaSpreadsheet.remove_row(spreadsheet, \"Sheet1\", 5, 2)\n```\n\nThis shifts remaining rows up, with all content and formatting preserved.","ref":"sheet_operations.html#remove-rows"},{"type":"extras","title":"Row Height - Sheet Operations","doc":"Adjust the height of a specific row:\n\n```elixir\n# Set row 1 height to 30 points\nUmyaSpreadsheet.set_row_height(spreadsheet, \"Sheet1\", 1, 30.0)\n```\n\nStandard Excel row height is 15.0 points.\n\nRetrieve row properties and settings:\n\n```elixir\n# Get the current height of row 1\n{:ok, height} = UmyaSpreadsheet.get_row_height(spreadsheet, \"Sheet1\", 1)\n# => {:ok, 30.0}\n\n# Check if row 2 is hidden\n{:ok, hidden} = UmyaSpreadsheet.get_row_hidden(spreadsheet, \"Sheet1\", 2)\n# => {:ok, false}\n```\n\nThese getter functions return default values when the row hasn't been explicitly configured:\n\n- Default row height: 15.0 points\n- Default hidden: false","ref":"sheet_operations.html#row-height"},{"type":"extras","title":"Row Styling - Sheet Operations","doc":"Apply styling to an entire row:\n\n```elixir\n# Set background and font color for a row\nUmyaSpreadsheet.set_row_style(spreadsheet, \"Sheet1\", 1, \"black\", \"white\")\n\n# Copy row styling from one row to another\nUmyaSpreadsheet.copy_row_styling(spreadsheet, \"Sheet1\", 1, 2)\n\n# Copy row styling for specific columns (from row 1 to row 2, columns 1-3 only)\nUmyaSpreadsheet.copy_row_styling(spreadsheet, \"Sheet1\", 1, 2, 1, 3)\n```","ref":"sheet_operations.html#row-styling"},{"type":"extras","title":"Column Operations - Sheet Operations","doc":"","ref":"sheet_operations.html#column-operations"},{"type":"extras","title":"Insert Columns - Sheet Operations","doc":"Add new columns to a worksheet at a specific position:\n\n```elixir\n# Insert 2 new columns starting at column B (using letter notation)\nUmyaSpreadsheet.insert_new_column(spreadsheet, \"Sheet1\", \"B\", 2)\n\n# Insert 2 new columns starting at column index 2 (B) (using numeric index)\nUmyaSpreadsheet.insert_new_column_by_index(spreadsheet, \"Sheet1\", 2, 2)\n```\n\nThis shifts existing columns to the right, with all content and formatting preserved.","ref":"sheet_operations.html#insert-columns"},{"type":"extras","title":"Remove Columns - Sheet Operations","doc":"Delete columns from a worksheet at a specific position:\n\n```elixir\n# Remove 1 column starting at column C (using letter notation)\nUmyaSpreadsheet.remove_column(spreadsheet, \"Sheet1\", \"C\", 1)\n\n# Remove 1 column starting at column index 3 (C) (using numeric index)\nUmyaSpreadsheet.remove_column_by_index(spreadsheet, \"Sheet1\", 3, 1)\n```\n\nThis shifts remaining columns to the left, with all content and formatting preserved.","ref":"sheet_operations.html#remove-columns"},{"type":"extras","title":"Column Width - Sheet Operations","doc":"Adjust the width of a specific column:\n\n```elixir\n# Set column A width to 15 points\nUmyaSpreadsheet.set_column_width(spreadsheet, \"Sheet1\", \"A\", 15.0)\n\n# Enable auto width for column B (adjusts to content width)\nUmyaSpreadsheet.set_column_auto_width(spreadsheet, \"Sheet1\", \"B\", true)\n```\n\nStandard Excel column width is 8.43 characters (approximately equivalent to 64 pixels).","ref":"sheet_operations.html#column-width"},{"type":"extras","title":"Column Width and Visibility Inspection - Sheet Operations","doc":"Retrieve column properties and settings:\n\n```elixir\n# Get the current width of column A\n{:ok, width} = UmyaSpreadsheet.get_column_width(spreadsheet, \"Sheet1\", \"A\")\n# => {:ok, 15.0}\n\n# Check if auto-width is enabled for column B\n{:ok, auto_width} = UmyaSpreadsheet.get_column_auto_width(spreadsheet, \"Sheet1\", \"B\")\n# => {:ok, true}\n\n# Check if column C is hidden\n{:ok, hidden} = UmyaSpreadsheet.get_column_hidden(spreadsheet, \"Sheet1\", \"C\")\n# => {:ok, false}\n```\n\nThese getter functions return default values when the column hasn't been explicitly configured:\n\n- Default column width: 8.43 characters\n- Default auto-width: false\n- Default hidden: false","ref":"sheet_operations.html#column-width-and-visibility-inspection"},{"type":"extras","title":"Column Width and Visibility Inspection - Sheet Operations","doc":"Retrieve column properties and settings:\n\n```elixir\n# Get the current width of column A\n{:ok, width} = UmyaSpreadsheet.get_column_width(spreadsheet, \"Sheet1\", \"A\")\n# => {:ok, 15.0}\n\n# Check if auto-width is enabled for column B\n{:ok, auto_width} = UmyaSpreadsheet.get_column_auto_width(spreadsheet, \"Sheet1\", \"B\")\n# => {:ok, true}\n\n# Check if column C is hidden\n{:ok, hidden} = UmyaSpreadsheet.get_column_hidden(spreadsheet, \"Sheet1\", \"C\")\n# => {:ok, false}\n```\n\nThese getter functions return default values when the column hasn't been explicitly configured:\n\n- Default column width: 8.43 characters\n- Default auto-width: false\n- Default hidden: false","ref":"sheet_operations.html#column-width-and-visibility-inspection-1"},{"type":"extras","title":"Column Styling - Sheet Operations","doc":"Copy styling from one column to another:\n\n```elixir\n# Copy all styling from column 1 to column 2\nUmyaSpreadsheet.copy_column_styling(spreadsheet, \"Sheet1\", 1, 2)\n\n# Copy column styling for specific rows (from column 1 to column 2, rows 1-5 only)\nUmyaSpreadsheet.copy_column_styling(spreadsheet, \"Sheet1\", 1, 2, 1, 5)\n```","ref":"sheet_operations.html#column-styling"},{"type":"extras","title":"Cell Merging - Sheet Operations","doc":"Merge multiple cells into a single larger cell:\n\n```elixir\n# Merge the cells from A1 to C3 (creating a 3x3 merged cell)\nUmyaSpreadsheet.add_merge_cells(spreadsheet, \"Sheet1\", \"A1:C3\")\n```\n\nWhen cells are merged:\n\n- Only the content in the top-left cell (A1 in this example) is preserved\n- Any content in other cells of the range will be lost\n- Styling from the top-left cell is applied to the entire merged range\n\nTo add content to a merged cell, always use the address of the top-left cell:\n\n```elixir\n# Set content for the merged cell\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Merged Cell Content\")\n```","ref":"sheet_operations.html#cell-merging"},{"type":"extras","title":"Grid Lines - Sheet Operations","doc":"Control the visibility of grid lines in the worksheet:\n\n```elixir\n# Hide grid lines in Sheet1\nUmyaSpreadsheet.set_show_grid_lines(spreadsheet, \"Sheet1\", false)\n\n# Show grid lines in Sheet1 (default)\nUmyaSpreadsheet.set_show_grid_lines(spreadsheet, \"Sheet1\", true)\n```\n\nHiding grid lines is often useful for presentation or print layouts. Note that this only affects the visual display and doesn't impact the actual structure of the sheet.","ref":"sheet_operations.html#grid-lines"},{"type":"extras","title":"Related Documentation - Sheet Operations","doc":"- [Styling and Formatting](styling_and_formatting.html) - For cell and worksheet styling options\n- [Data Validation](data_validation.html) - For adding validation rules to cells\n- [Image Handling](image_handling.html) - For adding images to worksheets\n- [Conditional Formatting](conditional_formatting.html) - For rules-based formatting","ref":"sheet_operations.html#related-documentation"},{"type":"extras","title":"Styling and Formatting","doc":"# Styling and Formatting\n\nThis guide covers the comprehensive styling and formatting capabilities of the UmyaSpreadsheet library for creating professional-looking Excel documents.","ref":"styling_and_formatting.html"},{"type":"extras","title":"Overview - Styling and Formatting","doc":"UmyaSpreadsheet provides a rich set of formatting options:\n\n- Number formats (currency, dates, percentages, etc.)\n- Text formatting (fonts, sizes, colors, alignment)\n- Cell styling (backgrounds, borders, etc.)\n- Row and column formatting\n- Alignment and text control\n\n> **Note:** For conditional formatting (data bars, color scales, value-based formatting, etc.), see the dedicated [Conditional Formatting](conditional_formatting.html) guide.","ref":"styling_and_formatting.html#overview"},{"type":"extras","title":"Cell Formatting - Styling and Formatting","doc":"","ref":"styling_and_formatting.html#cell-formatting"},{"type":"extras","title":"Number Formats - Styling and Formatting","doc":"Number formatting allows you to control how numbers appear in your Excel spreadsheet without changing their underlying values. This is essential for creating professional reports and financial documents.\n\n```elixir\n# Set a numeric value\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"1234.5678\")\n\n# Apply number formatting\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"A1\", \"#,##0.00\")\n\n# The value will now appear as \"1,234.57\" in Excel\n```\n\nCommon number formats:\n\n| Format Code       | Description                                        | Example    |\n| ----------------- | -------------------------------------------------- | ---------- |\n| `#,##0.00`        | Number with thousand separators and two decimals   | 1,234.57   |\n| `0.00%`           | Percentage with two decimals                       | 42.50%     |\n| `$#,##0.00`       | Currency with thousand separators and two decimals | $1,234.57  |\n| `[$€-x]#,##0.00`  | Euro currency with thousand separators             | €1,234.57  |\n| `yyyy-mm-dd`      | Date in year-month-day format                      | 2023-04-15 |\n| `d-mmm-yy`        | Date with abbreviated month                        | 15-Apr-23  |\n| `h:mm AM/PM`      | Time with AM/PM                                    | 2:30 PM    |\n| `h:mm:ss`         | Time with seconds                                  | 14:30:45   |\n| `@`               | Text format (treats numbers as text)               | 1234.5678  |","ref":"styling_and_formatting.html#number-formats"},{"type":"extras","title":"Getting Formatted Values - Styling and Formatting","doc":"You can retrieve the formatted string representation of a cell as it would appear in Excel. This is useful when you need to display the formatted value in your application:\n\n```elixir\n# Set a value with formatting\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"1234.5678\")\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"A1\", \"#,##0.00\")\n\n# Retrieve the formatted value\n{:ok, formatted_value} = UmyaSpreadsheet.get_formatted_value(spreadsheet, \"Sheet1\", \"A1\")\n# => \"1,234.57\"\n\n# You can still access the raw unformatted value if needed\n{:ok, raw_value} = UmyaSpreadsheet.get_cell_value(spreadsheet, \"Sheet1\", \"A1\")\n# => \"1234.5678\"\n```","ref":"styling_and_formatting.html#getting-formatted-values"},{"type":"extras","title":"Cell Formatting Inspection - Styling and Formatting","doc":"UmyaSpreadsheet provides comprehensive getter functions to inspect all aspects of cell formatting. This is essential for:\n\n- **Style Analysis** - Understanding existing formatting in spreadsheets\n- **Conditional Logic** - Making decisions based on current formatting\n- **Style Copying** - Programmatically copying formatting between cells\n- **Reporting** - Generating reports about document formatting\n- **Template Processing** - Analyzing and modifying template documents\n\n#### Font Property Inspection\n\nRetrieve complete font information from any cell:\n\n```elixir\n# Get font properties\n{:ok, font_name} = UmyaSpreadsheet.get_font_name(spreadsheet, \"Sheet1\", \"A1\")\n# => \"Arial\"\n\n{:ok, font_size} = UmyaSpreadsheet.get_font_size(spreadsheet, \"Sheet1\", \"A1\")\n# => 12.0\n\n{:ok, is_bold} = UmyaSpreadsheet.get_font_bold(spreadsheet, \"Sheet1\", \"A1\")\n# => true\n\n{:ok, is_italic} = UmyaSpreadsheet.get_font_italic(spreadsheet, \"Sheet1\", \"A1\")\n# => false\n\n{:ok, underline_style} = UmyaSpreadsheet.get_font_underline(spreadsheet, \"Sheet1\", \"A1\")\n# => \"single\"\n\n{:ok, has_strikethrough} = UmyaSpreadsheet.get_font_strikethrough(spreadsheet, \"Sheet1\", \"A1\")\n# => false\n\n{:ok, font_color} = UmyaSpreadsheet.get_font_color(spreadsheet, \"Sheet1\", \"A1\")\n# => \"FF000000\" (black)\n\n{:ok, font_family} = UmyaSpreadsheet.get_font_family(spreadsheet, \"Sheet1\", \"A1\")\n# => \"swiss\"\n\n{:ok, font_scheme} = UmyaSpreadsheet.get_font_scheme(spreadsheet, \"Sheet1\", \"A1\")\n# => \"minor\"\n```\n\n#### Alignment and Text Properties\n\nInspect text alignment and formatting properties:\n\n```elixir\n# Get alignment properties\n{:ok, h_align} = UmyaSpreadsheet.get_cell_horizontal_alignment(spreadsheet, \"Sheet1\", \"A1\")\n# => \"center\"\n\n{:ok, v_align} = UmyaSpreadsheet.get_cell_vertical_alignment(spreadsheet, \"Sheet1\", \"A1\")\n# => \"middle\"\n\n{:ok, wrap_text} = UmyaSpreadsheet.get_cell_wrap_text(spreadsheet, \"Sheet1\", \"A1\")\n# => true\n\n{:ok, rotation} = UmyaSpreadsheet.get_cell_text_rotation(spreadsheet, \"Sheet1\", \"A1\")\n# => 45\n```\n\n#### Border Inspection\n\nCheck border styles and colors for all border positions:\n\n```elixir\n# Get border styles\n{:ok, top_style} = UmyaSpreadsheet.get_border_style(spreadsheet, \"Sheet1\", \"A1\", \"top\")\n# => \"thin\"\n\n{:ok, bottom_style} = UmyaSpreadsheet.get_border_style(spreadsheet, \"Sheet1\", \"A1\", \"bottom\")\n# => \"medium\"\n\n{:ok, left_style} = UmyaSpreadsheet.get_border_style(spreadsheet, \"Sheet1\", \"A1\", \"left\")\n# => \"thick\"\n\n{:ok, right_style} = UmyaSpreadsheet.get_border_style(spreadsheet, \"Sheet1\", \"A1\", \"right\")\n# => \"dashed\"\n\n# Get border colors\n{:ok, top_color} = UmyaSpreadsheet.get_border_color(spreadsheet, \"Sheet1\", \"A1\", \"top\")\n# => \"FF000000\" (black - default when no specific color is set)\n\n{:ok, bottom_color} = UmyaSpreadsheet.get_border_color(spreadsheet, \"Sheet1\", \"A1\", \"bottom\")\n# => \"FFFF0000\" (red)\n```\n\nAvailable border positions: `\"top\"`, `\"bottom\"`, `\"left\"`, `\"right\"`, `\"diagonal\"`\n\n#### Fill and Background Inspection\n\nRetrieve cell background and pattern properties:\n\n```elixir\n# Get fill properties\n{:ok, bg_color} = UmyaSpreadsheet.get_cell_background_color(spreadsheet, \"Sheet1\", \"A1\")\n# => \"FFFFFF00\" (yellow)\n\n{:ok, fg_color} = UmyaSpreadsheet.get_cell_foreground_color(spreadsheet, \"Sheet1\", \"A1\")\n# => \"FFFFFFFF\" (white)\n\n{:ok, pattern_type} = UmyaSpreadsheet.get_cell_pattern_type(spreadsheet, \"Sheet1\", \"A1\")\n# => \"solid\"\n```\n\n#### Number Format Inspection\n\nCheck number formatting information:\n\n```elixir\n# Get number format details\n{:ok, format_id} = UmyaSpreadsheet.get_cell_number_format_id(spreadsheet, \"Sheet1\", \"A1\")\n# => 2\n\n{:ok, format_code} = UmyaSpreadsheet.get_cell_format_code(spreadsheet, \"Sheet1\", \"A1\")\n# => \"#,##0.00\"\n```\n\n#### Cell Protection Inspection\n\nCheck cell protection properties:\n\n```elixir\n# Get protection properties\n{:ok, is_locked} = UmyaSpreadsheet.get_cell_locked(spreadsheet, \"Sheet1\", \"A1\")\n# => true\n\n{:ok, is_hidden} = UmyaSpreadsheet.get_cell_hidden(spreadsheet, \"Sheet1\", \"A1\")\n# => false\n```\n\n#### Style Copying Example\n\nUse getter functions to copy formatting between cells:\n\n```elixir\n# Copy complete formatting from one cell to another\ndefmodule StyleCopier do\n  def copy_cell_style(spreadsheet, from_sheet, from_cell, to_sheet, to_cell) do\n    # Get all font properties\n    {:ok, font_name} = UmyaSpreadsheet.get_font_name(spreadsheet, from_sheet, from_cell)\n    {:ok, font_size} = UmyaSpreadsheet.get_font_size(spreadsheet, from_sheet, from_cell)\n    {:ok, is_bold} = UmyaSpreadsheet.get_font_bold(spreadsheet, from_sheet, from_cell)\n    {:ok, is_italic} = UmyaSpreadsheet.get_font_italic(spreadsheet, from_sheet, from_cell)\n    {:ok, font_color} = UmyaSpreadsheet.get_font_color(spreadsheet, from_sheet, from_cell)\n\n    # Get alignment properties\n    {:ok, h_align} = UmyaSpreadsheet.get_cell_horizontal_alignment(spreadsheet, from_sheet, from_cell)\n    {:ok, v_align} = UmyaSpreadsheet.get_cell_vertical_alignment(spreadsheet, from_sheet, from_cell)\n\n    # Get background color\n    {:ok, bg_color} = UmyaSpreadsheet.get_cell_background_color(spreadsheet, from_sheet, from_cell)\n\n    # Apply all properties to target cell\n    UmyaSpreadsheet.set_font_name(spreadsheet, to_sheet, to_cell, font_name)\n    UmyaSpreadsheet.set_font_size(spreadsheet, to_sheet, to_cell, font_size)\n    UmyaSpreadsheet.set_font_bold(spreadsheet, to_sheet, to_cell, is_bold)\n    UmyaSpreadsheet.set_font_italic(spreadsheet, to_sheet, to_cell, is_italic)\n    UmyaSpreadsheet.set_font_color(spreadsheet, to_sheet, to_cell, font_color)\n    UmyaSpreadsheet.set_cell_alignment(spreadsheet, to_sheet, to_cell, h_align, v_align)\n    UmyaSpreadsheet.set_background_color(spreadsheet, to_sheet, to_cell, bg_color)\n  end\nend\n\n# Usage\nStyleCopier.copy_cell_style(spreadsheet, \"Sheet1\", \"A1\", \"Sheet1\", \"B2\")\n```\n\n> **Error Handling**: All getter functions return `{:ok, value}` tuples on success or `{:error, reason}` tuples when the sheet doesn't exist. Non-existent cells return appropriate default values (e.g., `false` for boolean properties, `\"none\"` for styles, default colors for color properties).","ref":"styling_and_formatting.html#cell-formatting-inspection"},{"type":"extras","title":"Text Formatting - Styling and Formatting","doc":"","ref":"styling_and_formatting.html#text-formatting"},{"type":"extras","title":"Font Styling - Styling and Formatting","doc":"UmyaSpreadsheet offers comprehensive font styling options to create visually appealing and readable spreadsheets:\n\n```elixir\n# Set font bold\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\n\n# Set font italic\nUmyaSpreadsheet.set_font_italic(spreadsheet, \"Sheet1\", \"A1\", true)\n\n# Set font underline with different styles\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A1\", \"single\")  # Single underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A2\", \"double\")  # Double underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A3\", \"single_accounting\")  # Accounting underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A4\", \"double_accounting\")  # Double accounting underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A5\", \"none\")  # Remove underline\n\n# Set strikethrough text\nUmyaSpreadsheet.set_font_strikethrough(spreadsheet, \"Sheet1\", \"A1\", true)\n\n# Set font color\nUmyaSpreadsheet.set_font_color(spreadsheet, \"Sheet1\", \"A1\", \"red\")\n# Color can be a named color or hex code\nUmyaSpreadsheet.set_font_color(spreadsheet, \"Sheet1\", \"A2\", \"#FF0000\")\n\n# Set font size\nUmyaSpreadsheet.set_font_size(spreadsheet, \"Sheet1\", \"A1\", 14)\n\n# Set font name/family\nUmyaSpreadsheet.set_font_name(spreadsheet, \"Sheet1\", \"A1\", \"Arial\")\n\n# Combining multiple font styles\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A3\", \"Styled Text\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A3\", true)\nUmyaSpreadsheet.set_font_italic(spreadsheet, \"Sheet1\", \"A3\", true)\nUmyaSpreadsheet.set_font_size(spreadsheet, \"Sheet1\", \"A3\", 16)\nUmyaSpreadsheet.set_font_color(spreadsheet, \"Sheet1\", \"A3\", \"blue\")\n```","ref":"styling_and_formatting.html#font-styling"},{"type":"extras","title":"Text Wrapping and Rotation - Styling and Formatting","doc":"Control how text is displayed within cells with wrapping and rotation options:\n\n```elixir\n# Set multi-line text\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Line 1\\nLine 2\\nLine 3\")\n\n# Enable text wrapping (makes cell display multiple lines)\nUmyaSpreadsheet.set_wrap_text(spreadsheet, \"Sheet1\", \"A1\", true)\n\n# Set text rotation (value in degrees, 0-180)\nUmyaSpreadsheet.set_text_rotation(spreadsheet, \"Sheet1\", \"B1\", 45)\n\n# Set vertical text (creates top-to-bottom text)\nUmyaSpreadsheet.set_text_rotation(spreadsheet, \"Sheet1\", \"C1\", 90)\n```\n\nText wrapping automatically adjusts row height to fit the content, but you may still need to adjust column width manually if text lines are very long.","ref":"styling_and_formatting.html#text-wrapping-and-rotation"},{"type":"extras","title":"Cell and Row Styling - Styling and Formatting","doc":"","ref":"styling_and_formatting.html#cell-and-row-styling"},{"type":"extras","title":"Background Colors - Styling and Formatting","doc":"Apply background colors to make important data stand out or to create visual patterns:\n\n```elixir\n# Set cell background color using named color\nUmyaSpreadsheet.set_background_color(spreadsheet, \"Sheet1\", \"A1\", \"yellow\")\n\n# Set cell background color using hex code\nUmyaSpreadsheet.set_background_color(spreadsheet, \"Sheet1\", \"A2\", \"#FFFF00\")\n\n# Set background color for a range of cells\n[\"A3\", \"B3\", \"C3\", \"D3\"]\n|> Enum.each(fn cell ->\n  UmyaSpreadsheet.set_background_color(spreadsheet, \"Sheet1\", cell, \"lightblue\")\nend)\n```","ref":"styling_and_formatting.html#background-colors"},{"type":"extras","title":"Cell Borders - Styling and Formatting","doc":"Add borders to cells to create tables and visual structures:\n\n```elixir\n# Add a thin black border around cell A1\nUmyaSpreadsheet.set_border(spreadsheet, \"Sheet1\", \"A1\", \"thin\", \"black\")\n\n# Add a thick red border to the bottom of cell B2\nUmyaSpreadsheet.set_border_bottom(spreadsheet, \"Sheet1\", \"B2\", \"thick\", \"red\")\n\n# Add a medium blue border to the right of cell C3\nUmyaSpreadsheet.set_border_right(spreadsheet, \"Sheet1\", \"C3\", \"medium\", \"blue\")\n\n# Add borders to a range using top, right, bottom, left styles\nUmyaSpreadsheet.set_borders(spreadsheet, \"Sheet1\", \"D4:F6\", \"thin\", \"thin\", \"thin\", \"thin\", \"black\")\n\n# Advanced border styles\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A1\", \"top\", \"dashed\")\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A2\", \"left\", \"dotted\")\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A3\", \"bottom\", \"double\")\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A4\", \"right\", \"thick\")\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A5\", \"all\", \"medium\")\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A6\", \"diagonal\", \"thin\")\n```\n\n#### Available Border Styles\n\n| Style | Description |\n|-------|-------------|\n| `\"thin\"` | Thin border |\n| `\"medium\"` | Medium border |\n| `\"thick\"` | Thick border |\n| `\"dashed\"` | Dashed border |\n| `\"dotted\"` | Dotted border |\n| `\"double\"` | Double border |\n| `\"none\"` | No border |","ref":"styling_and_formatting.html#cell-borders"},{"type":"extras","title":"Row Styling - Styling and Formatting","doc":"Style an entire row with background and font colors:\n\n```elixir\n# Set row 1 with black background and white text\nUmyaSpreadsheet.set_row_style(spreadsheet, \"Sheet1\", 1, \"black\", \"white\")\n\n# Set row 3 with light gray background and dark blue text\nUmyaSpreadsheet.set_row_style(spreadsheet, \"Sheet1\", 3, \"#EEEEEE\", \"#000080\")\n```","ref":"styling_and_formatting.html#row-styling"},{"type":"extras","title":"Copying Styles - Styling and Formatting","doc":"UmyaSpreadsheet provides efficient ways to copy styles between rows or columns, which can save time when creating consistently formatted spreadsheets:\n\n```elixir\n# Copy all styles from row 1 to row 2\nUmyaSpreadsheet.copy_row_styling(spreadsheet, \"Sheet1\", 1, 2)\n\n# Copy styles from row 1 to row 2, but only for columns 3-5\nUmyaSpreadsheet.copy_row_styling(spreadsheet, \"Sheet1\", 1, 2, 3, 5)\n```\n\nSimilarly, you can copy styles between columns:\n\n```elixir\n# Copy all styles from column 1 to column 2\nUmyaSpreadsheet.copy_column_styling(spreadsheet, \"Sheet1\", 1, 2)\n\n# Copy styles from column 1 to column 2, but only for rows 3-5\nUmyaSpreadsheet.copy_column_styling(spreadsheet, \"Sheet1\", 1, 2, 3, 5)\n```\n\nThis is particularly useful when:\n\n- Creating tables with consistent header and data styling\n- Applying a consistent format across multiple sections of a spreadsheet\n- Quickly replicating complex styling patterns","ref":"styling_and_formatting.html#copying-styles"},{"type":"extras","title":"Row and Column Dimensions - Styling and Formatting","doc":"Controlling the height of rows and width of columns is essential for creating well-laid-out spreadsheets that are easy to read.","ref":"styling_and_formatting.html#row-and-column-dimensions"},{"type":"extras","title":"Row Height - Styling and Formatting","doc":"Set the height of rows to accommodate larger text, multi-line content, or to create visual spacing:\n\n```elixir\n# Set row 1 height to 30 points (approximately 2x the default height)\nUmyaSpreadsheet.set_row_height(spreadsheet, \"Sheet1\", 1, 30.0)\n\n# Set multiple row heights\n[2, 3, 4]\n|> Enum.each(fn row ->\n  UmyaSpreadsheet.set_row_height(spreadsheet, \"Sheet1\", row, 20.0)\nend)\n```\n\nThe default row height in Excel is approximately 15 points. Setting a row's height to 0 will hide the row.","ref":"styling_and_formatting.html#row-height"},{"type":"extras","title":"Column Width - Styling and Formatting","doc":"Control column width to fit content or create a specific layout:\n\n```elixir\n# Set column A width to 15 characters (approximately 2x the default width)\nUmyaSpreadsheet.set_column_width(spreadsheet, \"Sheet1\", \"A\", 15.0)\n\n# Set column C to be wider for longer text content\nUmyaSpreadsheet.set_column_width(spreadsheet, \"Sheet1\", \"C\", 25.0)\n\n# Enable auto width for column B (adjusts to fit the content)\nUmyaSpreadsheet.set_column_auto_width(spreadsheet, \"Sheet1\", \"B\", true)\n\n# Set multiple column widths\n[\"D\", \"E\", \"F\"]\n|> Enum.each(fn col ->\n  UmyaSpreadsheet.set_column_width(spreadsheet, \"Sheet1\", col, 12.0)\nend)\n```\n\nThe default column width in Excel is approximately 8.43 characters. Setting a column's width to 0 will hide the column.","ref":"styling_and_formatting.html#column-width"},{"type":"extras","title":"Cell Alignment - Styling and Formatting","doc":"Proper text alignment enhances readability and creates a professional look in your spreadsheets. UmyaSpreadsheet provides complete control over both horizontal and vertical alignment.","ref":"styling_and_formatting.html#cell-alignment"},{"type":"extras","title":"Horizontal and Vertical Alignment - Styling and Formatting","doc":"```elixir\n# Center text both horizontally and vertically\nUmyaSpreadsheet.set_cell_alignment(spreadsheet, \"Sheet1\", \"A1\", \"center\", \"center\")\n\n# Right-align text at the top of the cell\nUmyaSpreadsheet.set_cell_alignment(spreadsheet, \"Sheet1\", \"B2\", \"right\", \"top\")\n\n# Left-align text at the bottom of the cell\nUmyaSpreadsheet.set_cell_alignment(spreadsheet, \"Sheet1\", \"C3\", \"left\", \"bottom\")\n\n# Justify text with distributed vertical alignment\nUmyaSpreadsheet.set_cell_alignment(spreadsheet, \"Sheet1\", \"D4\", \"justify\", \"distributed\")\n\n# Create a header row with centered, bold text\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Header\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\nUmyaSpreadsheet.set_cell_alignment(spreadsheet, \"Sheet1\", \"A1\", \"center\", \"center\")\n```","ref":"styling_and_formatting.html#horizontal-and-vertical-alignment"},{"type":"extras","title":"Alignment Options - Styling and Formatting","doc":"UmyaSpreadsheet provides a comprehensive set of alignment options that match Excel's capabilities:\n\n#### Horizontal Alignment Options\n\n| Option             | Description                                         | Use Case                      |\n| ------------------ | --------------------------------------------------- | ----------------------------- |\n| `\"left\"`           | Align text to the left side of the cell             | Default for text              |\n| `\"center\"`         | Center text horizontally in the cell                | Headers, titles               |\n| `\"right\"`          | Align text to the right side of the cell            | Default for numbers           |\n| `\"justify\"`        | Spread text to fill width, aligned at both edges    | Paragraphs, notes             |\n| `\"distributed\"`    | Distribute text evenly across the cell width        | Special formatting            |\n| `\"fill\"`           | Repeat characters to fill the width of the cell     | Pattern creation              |\n| `\"centerContinuous\"` | Center across selection of cells                  | Merged-like appearance        |\n| `\"general\"`        | Use default alignment based on content type         | Mixed content                 |\n\n#### Vertical Alignment Options\n\n| Option           | Description                                         | Use Case                      |\n| ---------------- | --------------------------------------------------- | ----------------------------- |\n| `\"top\"`          | Align text to the top of the cell                   | Default for many layouts      |\n| `\"center\"`       | Center text vertically in the cell                  | Centered content, buttons     |\n| `\"middle\"`       | Same as `\"center\"`                                  | Alternative syntax            |\n| `\"bottom\"`       | Align text to the bottom of the cell                | Default in Excel              |\n| `\"justify\"`      | Distribute text evenly between top and bottom       | Multi-line text               |\n| `\"distributed\"`  | Distribute text with extra padding                  | Special formatting            |\n\n> **Tip:** For the best results with large amounts of text, combine appropriate alignment settings with text wrapping or row height adjustments.","ref":"styling_and_formatting.html#alignment-options"},{"type":"extras","title":"Text Rotation - Styling and Formatting","doc":"UmyaSpreadsheet allows you to rotate text within cells for improved readability in column headers or to fit more information in limited space:\n\n```elixir\n# Rotate text 45 degrees clockwise\nUmyaSpreadsheet.set_cell_rotation(spreadsheet, \"Sheet1\", \"A1\", 45)\n\n# Rotate text 90 degrees for vertical text\nUmyaSpreadsheet.set_cell_rotation(spreadsheet, \"Sheet1\", \"B1\", 90)\n\n# Rotate text counter-clockwise with negative angles\nUmyaSpreadsheet.set_cell_rotation(spreadsheet, \"Sheet1\", \"C1\", -45)\n```\n\nThe rotation angle can be set between -90 and 90 degrees.","ref":"styling_and_formatting.html#text-rotation"},{"type":"extras","title":"Text Indentation - Styling and Formatting","doc":"You can indent text within cells to create hierarchical displays or improve readability:\n\n```elixir\n# Basic indentation (1 level)\nUmyaSpreadsheet.set_cell_indent(spreadsheet, \"Sheet1\", \"A1\", 1)\n\n# Deeper indentation (2 levels)\nUmyaSpreadsheet.set_cell_indent(spreadsheet, \"Sheet1\", \"A2\", 2)\n\n# Even deeper indentation (5 levels)\nUmyaSpreadsheet.set_cell_indent(spreadsheet, \"Sheet1\", \"A3\", 5)\n```\n\nThe indent parameter accepts values from 0 to 255, with each level adding more space before the text.\n\n> **Note:** For more advanced cell formatting options, see the dedicated [Advanced Cell Formatting](advanced_cell_formatting.html) guide.","ref":"styling_and_formatting.html#text-indentation"},{"type":"extras","title":"Merging Cells - Styling and Formatting","doc":"Merging cells is useful for creating headers, titles, or emphasizing specific information across multiple cells:\n\n```elixir\n# Merge a range of cells (A1 through C3, creating a 3x3 merged cell)\nUmyaSpreadsheet.add_merge_cells(spreadsheet, \"Sheet1\", \"A1:C3\")\n\n# Add content to the merged cells (always use the top-left cell reference)\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Merged Cell Content\")\n\n# Style the merged cell\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\nUmyaSpreadsheet.set_font_size(spreadsheet, \"Sheet1\", \"A1\", 14)\nUmyaSpreadsheet.set_cell_alignment(spreadsheet, \"Sheet1\", \"A1\", \"center\", \"center\")\n```\n\n**Important notes about merged cells:**\n\n- Always use the top-left cell reference (A1 in this example) when setting values or styles\n- Any content in other cells within the merged range will be lost\n- Merging cells that already contain data will preserve only the top-left cell's content","ref":"styling_and_formatting.html#merging-cells"},{"type":"extras","title":"Sheet Protection and Visibility - Styling and Formatting","doc":"","ref":"styling_and_formatting.html#sheet-protection-and-visibility"},{"type":"extras","title":"Protect Sheets - Styling and Formatting","doc":"Protect worksheets to prevent accidental or unauthorized changes:\n\n```elixir\n# Protect sheet without password\nUmyaSpreadsheet.set_sheet_protection(spreadsheet, \"Sheet1\", nil, true)\n\n# Protect sheet with password\nUmyaSpreadsheet.set_sheet_protection(spreadsheet, \"Sheet1\", \"password123\", true)\n```","ref":"styling_and_formatting.html#protect-sheets"},{"type":"extras","title":"Protect Workbook - Styling and Formatting","doc":"Protect the entire workbook structure to prevent users from adding, deleting, or rearranging sheets:\n\n```elixir\nUmyaSpreadsheet.set_workbook_protection(spreadsheet, \"secure_password\")\n```","ref":"styling_and_formatting.html#protect-workbook"},{"type":"extras","title":"Sheet Visibility - Styling and Formatting","doc":"Control which sheets are visible to users in Excel:\n\n```elixir\n# Hide a sheet (can be unhidden by users through Excel UI)\nUmyaSpreadsheet.set_sheet_state(spreadsheet, \"Sheet2\", \"hidden\")\n\n# Make a sheet very hidden (cannot be unhidden through Excel UI)\nUmyaSpreadsheet.set_sheet_state(spreadsheet, \"Sheet3\", \"very_hidden\")\n\n# Make a hidden sheet visible again\nUmyaSpreadsheet.set_sheet_state(spreadsheet, \"Sheet2\", \"visible\")\n```\n\nAvailable sheet states:\n\n- `\"visible\"` - Sheet is normally visible (default)\n- `\"hidden\"` - Sheet is hidden but can be unhidden by users in Excel\n- `\"very_hidden\"` - Sheet is hidden and cannot be unhidden through the Excel UI","ref":"styling_and_formatting.html#sheet-visibility"},{"type":"extras","title":"Hide Gridlines - Styling and Formatting","doc":"Control the visibility of gridlines for presentation-quality spreadsheets:\n\n```elixir\n# Hide gridlines in Sheet1\nUmyaSpreadsheet.set_show_grid_lines(spreadsheet, \"Sheet1\", false)\n\n# Show gridlines in Sheet1 (default)\nUmyaSpreadsheet.set_show_grid_lines(spreadsheet, \"Sheet1\", true)\n```\n\nHiding gridlines is often useful for:\n\n- Presentation spreadsheets\n- Dashboard reports\n- Printable forms\n- Custom-styled tables where gridlines would be distracting","ref":"styling_and_formatting.html#hide-gridlines"},{"type":"extras","title":"Related Documentation - Styling and Formatting","doc":"- [Conditional Formatting](conditional_formatting.html) - Add data bars, color scales, and rule-based formatting\n- [Data Validation](data_validation.html) - Create dropdown lists and validation rules\n- [Sheet Operations](sheet_operations.html) - Comprehensive sheet management functions\n- [Image Handling](image_handling.html) - Add and manipulate images in spreadsheets\n- [Charts](charts.html) - Create visual data charts","ref":"styling_and_formatting.html#related-documentation"},{"type":"extras","title":"Best Practices - Styling and Formatting","doc":"1. **Consistent Styling** - Define and reuse style patterns for headers, data, and totals\n2. **Color Usage** - Use colors sparingly and consistently to highlight important information\n3. **Appropriate Formatting** - Choose number formats that match your data type (currency, dates, etc.)\n4. **Readability** - Set appropriate column widths and row heights for your content\n5. **Protection** - Use sheet protection for production spreadsheets to prevent accidental changes","ref":"styling_and_formatting.html#best-practices"},{"type":"extras","title":"Advanced Cell Formatting","doc":"# Advanced Cell Formatting\n\nUmyaSpreadsheet provides a rich set of features for advanced cell formatting in your Excel documents, including:\n\n- Italic text formatting\n- Underline styles (single, double, accounting)\n- Strikethrough text\n- Border styles (thin, medium, thick, dashed, dotted, double)\n- Cell rotation\n- Cell indentation\n- Font family control (Roman, Swiss, Modern, Script, Decorative)\n- Font scheme control (Major, Minor, None)","ref":"advanced_cell_formatting.html"},{"type":"extras","title":"Italic Formatting - Advanced Cell Formatting","doc":"You can make text in a cell italic:\n\n```elixir\nUmyaSpreadsheet.set_font_italic(spreadsheet, \"Sheet1\", \"A1\", true)\n```","ref":"advanced_cell_formatting.html#italic-formatting"},{"type":"extras","title":"Underline Styles - Advanced Cell Formatting","doc":"UmyaSpreadsheet supports multiple underline styles for cell text:\n\n```elixir\n# Single underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A1\", \"single\")\n\n# Double underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A2\", \"double\")\n\n# Single accounting underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A3\", \"single_accounting\")\n\n# Double accounting underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A4\", \"double_accounting\")\n\n# Remove underline\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A5\", \"none\")\n```","ref":"advanced_cell_formatting.html#underline-styles"},{"type":"extras","title":"Strikethrough Formatting - Advanced Cell Formatting","doc":"You can apply strikethrough formatting to text:\n\n```elixir\nUmyaSpreadsheet.set_font_strikethrough(spreadsheet, \"Sheet1\", \"A1\", true)\n```","ref":"advanced_cell_formatting.html#strikethrough-formatting"},{"type":"extras","title":"Border Styles - Advanced Cell Formatting","doc":"UmyaSpreadsheet allows you to set different border styles for cells:\n\n```elixir\n# Apply thin border to all sides\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A1\", \"all\", \"thin\")\n\n# Apply medium border to the left side\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A2\", \"left\", \"medium\")\n\n# Apply thick border to the top side\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A3\", \"top\", \"thick\")\n\n# Apply dashed border to the right side\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A4\", \"right\", \"dashed\")\n\n# Apply dotted border to the bottom side\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A5\", \"bottom\", \"dotted\")\n\n# Apply double border to the diagonal\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A6\", \"diagonal\", \"double\")\n\n# Remove border\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A7\", \"all\", \"none\")\n```\n\nAvailable border positions:\n\n- `\"top\"` - Top border\n- `\"right\"` - Right border\n- `\"bottom\"` - Bottom border\n- `\"left\"` - Left border\n- `\"diagonal\"` - Diagonal border\n- `\"all\"` - All borders\n\nAvailable border styles:\n\n- `\"thin\"` - Thin border\n- `\"medium\"` - Medium border\n- `\"thick\"` - Thick border\n- `\"dashed\"` - Dashed border\n- `\"dotted\"` - Dotted border\n- `\"double\"` - Double border\n- `\"none\"` - No border","ref":"advanced_cell_formatting.html#border-styles"},{"type":"extras","title":"Cell Rotation - Advanced Cell Formatting","doc":"You can rotate text within a cell:\n\n```elixir\n# Rotate text 45 degrees\nUmyaSpreadsheet.set_cell_rotation(spreadsheet, \"Sheet1\", \"A1\", 45)\n\n# Rotate text -45 degrees (counter-clockwise)\nUmyaSpreadsheet.set_cell_rotation(spreadsheet, \"Sheet1\", \"A2\", -45)\n\n# Vertical text (90 degrees)\nUmyaSpreadsheet.set_cell_rotation(spreadsheet, \"Sheet1\", \"A3\", 90)\n```\n\nThe angle parameter accepts values from -90 to 90 degrees.","ref":"advanced_cell_formatting.html#cell-rotation"},{"type":"extras","title":"Cell Indentation - Advanced Cell Formatting","doc":"You can set indentation for text within a cell:\n\n```elixir\n# Indent text by 1 level\nUmyaSpreadsheet.set_cell_indent(spreadsheet, \"Sheet1\", \"A1\", 1)\n\n# Indent text by 5 levels\nUmyaSpreadsheet.set_cell_indent(spreadsheet, \"Sheet1\", \"A2\", 5)\n```\n\nThe indent parameter accepts values from 0 to 255.","ref":"advanced_cell_formatting.html#cell-indentation"},{"type":"extras","title":"Font Family - Advanced Cell Formatting","doc":"You can set the font family type for cells. Excel uses a numbering system to categorize fonts into different families:\n\n```elixir\n# Set Roman/Serif font family (e.g., Times New Roman)\nUmyaSpreadsheet.set_font_family(spreadsheet, \"Sheet1\", \"A1\", \"roman\")\n\n# Set Swiss/Sans-Serif font family (e.g., Arial, Helvetica)\nUmyaSpreadsheet.set_font_family(spreadsheet, \"Sheet1\", \"A2\", \"swiss\")\n\n# Set Modern/Monospace font family (e.g., Courier)\nUmyaSpreadsheet.set_font_family(spreadsheet, \"Sheet1\", \"A3\", \"modern\")\n\n# Set Script font family (e.g., Brush Script)\nUmyaSpreadsheet.set_font_family(spreadsheet, \"Sheet1\", \"A4\", \"script\")\n\n# Set Decorative font family (e.g., Old English)\nUmyaSpreadsheet.set_font_family(spreadsheet, \"Sheet1\", \"A5\", \"decorative\")\n```\n\nAvailable font family types:\n\n- `\"roman\"` - Roman (Serif) fonts like Times New Roman\n- `\"swiss\"` - Swiss (Sans-Serif) fonts like Arial or Helvetica\n- `\"modern\"` - Modern (Monospace) fonts like Courier\n- `\"script\"` - Script fonts like Brush Script\n- `\"decorative\"` - Decorative fonts like Old English","ref":"advanced_cell_formatting.html#font-family"},{"type":"extras","title":"Font Scheme - Advanced Cell Formatting","doc":"Font schemes are part of Excel's theme system. They allow Excel to substitute appropriate fonts when a workbook is opened on a system that doesn't have the specified font:\n\n```elixir\n# Set Major font scheme (typically used for headings)\nUmyaSpreadsheet.set_font_scheme(spreadsheet, \"Sheet1\", \"A1\", \"major\")\n\n# Set Minor font scheme (typically used for body text)\nUmyaSpreadsheet.set_font_scheme(spreadsheet, \"Sheet1\", \"A2\", \"minor\")\n\n# Set No font scheme (font won't change with theme changes)\nUmyaSpreadsheet.set_font_scheme(spreadsheet, \"Sheet1\", \"A3\", \"none\")\n```\n\nAvailable font scheme values:\n\n- `\"major\"` - Major scheme (typically for headings)\n- `\"minor\"` - Minor scheme (typically for body text)\n- `\"none\"` - No scheme (font won't change with theme changes)","ref":"advanced_cell_formatting.html#font-scheme"},{"type":"extras","title":"Inspecting Cell Background Properties - Advanced Cell Formatting","doc":"UmyaSpreadsheet provides functions to inspect the background and fill properties of cells:\n\n```elixir\n# Get the background color of a cell\n{:ok, bg_color} = UmyaSpreadsheet.get_cell_background_color(spreadsheet, \"Sheet1\", \"A1\")\n# => {:ok, \"#FFFFFF\"} or {:ok, nil} if no background color is set\n\n# Get the foreground color of a cell (pattern color)\n{:ok, fg_color} = UmyaSpreadsheet.get_cell_foreground_color(spreadsheet, \"Sheet1\", \"A1\")\n# => {:ok, \"#000000\"} or {:ok, nil} if no foreground color is set\n\n# Get the pattern type of a cell\n{:ok, pattern} = UmyaSpreadsheet.get_cell_pattern_type(spreadsheet, \"Sheet1\", \"A1\")\n# => {:ok, \"solid\"} or {:ok, nil} if no pattern is set\n```","ref":"advanced_cell_formatting.html#inspecting-cell-background-properties"},{"type":"extras","title":"Available Pattern Types - Advanced Cell Formatting","doc":"Common pattern types include:\n\n- `\"solid\"` - Solid fill\n- `\"gray125\"` - 12.5% gray pattern\n- `\"gray0625\"` - 6.25% gray pattern\n- `\"horizontal\"` - Horizontal lines\n- `\"vertical\"` - Vertical lines\n- `\"diagonal\"` - Diagonal lines\n- `\"cross\"` - Cross pattern\n- `\"diagonal_cross\"` - Diagonal cross pattern","ref":"advanced_cell_formatting.html#available-pattern-types"},{"type":"extras","title":"Practical Background Inspection Example - Advanced Cell Formatting","doc":"```elixir\ndef inspect_cell_background(spreadsheet, sheet_name, cell_address) do\n  with {:ok, bg_color} <- UmyaSpreadsheet.get_cell_background_color(spreadsheet, sheet_name, cell_address),\n       {:ok, fg_color} <- UmyaSpreadsheet.get_cell_foreground_color(spreadsheet, sheet_name, cell_address),\n       {:ok, pattern} <- UmyaSpreadsheet.get_cell_pattern_type(spreadsheet, sheet_name, cell_address) do\n\n    IO.puts(\"=== Cell Background Details for #{cell_address} ===\")\n    IO.puts(\"Background Color: #{bg_color || \"None\"}\")\n    IO.puts(\"Foreground Color: #{fg_color || \"None\"}\")\n    IO.puts(\"Pattern Type: #{pattern || \"None\"}\")\n\n    case {bg_color, fg_color, pattern} do\n      {nil, nil, nil} ->\n        IO.puts(\"Cell has no background formatting\")\n\n      {bg, nil, \"solid\"} when not is_nil(bg) ->\n        IO.puts(\"Cell has solid background color: #{bg}\")\n\n      {bg, fg, pat} when not is_nil(bg) and not is_nil(fg) ->\n        IO.puts(\"Cell has patterned background - BG: #{bg}, FG: #{fg}, Pattern: #{pat}\")\n\n      _ ->\n        IO.puts(\"Cell has partial background formatting\")\n    end\n\n    {:ok, %{background: bg_color, foreground: fg_color, pattern: pattern}}\n  else\n    {:error, reason} ->\n      IO.puts(\"Error inspecting cell background: #{reason}\")\n      {:error, reason}\n  end\nend\n\n# Usage\ninspect_cell_background(spreadsheet, \"Sheet1\", \"A1\")\n```","ref":"advanced_cell_formatting.html#practical-background-inspection-example"},{"type":"extras","title":"Bulk Background Analysis - Advanced Cell Formatting","doc":"```elixir\ndef analyze_range_backgrounds(spreadsheet, sheet_name, start_cell, end_cell) do\n  # This would require implementing a range parser, but shows the concept\n  cells = parse_range(start_cell, end_cell)  # Helper function needed\n\n  background_summary =\n    Enum.map(cells, fn cell ->\n      with {:ok, bg} <- UmyaSpreadsheet.get_cell_background_color(spreadsheet, sheet_name, cell),\n           {:ok, fg} <- UmyaSpreadsheet.get_cell_foreground_color(spreadsheet, sheet_name, cell),\n           {:ok, pattern} <- UmyaSpreadsheet.get_cell_pattern_type(spreadsheet, sheet_name, cell) do\n        %{cell: cell, background: bg, foreground: fg, pattern: pattern}\n      else\n        _ -> %{cell: cell, background: nil, foreground: nil, pattern: nil}\n      end\n    end)\n\n  # Group by background properties\n  grouped = Enum.group_by(background_summary, fn entry ->\n    {entry.background, entry.foreground, entry.pattern}\n  end)\n\n  IO.puts(\"=== Background Analysis for #{start_cell}:#{end_cell} ===\")\n  Enum.each(grouped, fn {{bg, fg, pattern}, cells} ->\n    cell_list = Enum.map(cells, & &1.cell) |> Enum.join(\", \")\n    IO.puts(\"#{bg || \"No BG\"}/#{fg || \"No FG\"}/#{pattern || \"No Pattern\"}: #{cell_list}\")\n  end)\n\n  {:ok, background_summary}\nend\n```","ref":"advanced_cell_formatting.html#bulk-background-analysis"},{"type":"extras","title":"Combining Formatting Options - Advanced Cell Formatting","doc":"You can combine multiple formatting options to create richly formatted cells:\n\n```elixir\n# Create a cell with combined formatting\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Formatted Text\")\nUmyaSpreadsheet.set_font_italic(spreadsheet, \"Sheet1\", \"A1\", true)\nUmyaSpreadsheet.set_font_underline(spreadsheet, \"Sheet1\", \"A1\", \"single\")\nUmyaSpreadsheet.set_border_style(spreadsheet, \"Sheet1\", \"A1\", \"all\", \"double\")\nUmyaSpreadsheet.set_cell_rotation(spreadsheet, \"Sheet1\", \"A1\", 15)\n```","ref":"advanced_cell_formatting.html#combining-formatting-options"},{"type":"extras","title":"Advanced Typography Example - Advanced Cell Formatting","doc":"Here's an example that combines font family, font scheme, and other typography settings:\n\n```elixir\n# Create a heading with Major scheme Roman font\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Heading Text\")\nUmyaSpreadsheet.set_font_name(spreadsheet, \"Sheet1\", \"A1\", \"Cambria\")\nUmyaSpreadsheet.set_font_scheme(spreadsheet, \"Sheet1\", \"A1\", \"major\")\nUmyaSpreadsheet.set_font_family(spreadsheet, \"Sheet1\", \"A1\", \"roman\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\nUmyaSpreadsheet.set_font_size(spreadsheet, \"Sheet1\", \"A1\", 14)\n\n# Create body text with Minor scheme Swiss font\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"Body Text\")\nUmyaSpreadsheet.set_font_name(spreadsheet, \"Sheet1\", \"A2\", \"Calibri\")\nUmyaSpreadsheet.set_font_scheme(spreadsheet, \"Sheet1\", \"A2\", \"minor\")\nUmyaSpreadsheet.set_font_family(spreadsheet, \"Sheet1\", \"A2\", \"swiss\")\nUmyaSpreadsheet.set_font_size(spreadsheet, \"Sheet1\", \"A2\", 11)\n```","ref":"advanced_cell_formatting.html#advanced-typography-example"},{"type":"extras","title":"Advanced Sheet Features","doc":"# Advanced Sheet Features\n\nThis guide explores the advanced sheet-level features available in UmyaSpreadsheet for customizing how Excel sheets are displayed and interacted with.","ref":"advanced_sheet_features.html"},{"type":"extras","title":"Table of Contents - Advanced Sheet Features","doc":"- [Advanced Sheet Features](#advanced-sheet-features)\n  - [Table of Contents](#table-of-contents)\n  - [Tab Colors](#tab-colors)\n  - [Sheet Views](#sheet-views)\n  - [Zoom Settings](#zoom-settings)\n  - [Freeze Panes](#freeze-panes)\n  - [Split Panes](#split-panes)\n  - [Setting the Top-Left Cell](#setting-the-top-left-cell)\n  - [Showing/Hiding Gridlines](#showinghiding-gridlines)\n  - [Combining Features](#combining-features)\n  - [Sheet View Getter Functions Reference](#sheet-view-getter-functions-reference)\n    - [Tab Color Inspection](#tab-color-inspection)\n    - [Sheet View Type Inspection](#sheet-view-type-inspection)\n    - [Zoom Scale Inspection](#zoom-scale-inspection)\n    - [Grid Lines Visibility Inspection](#grid-lines-visibility-inspection)\n    - [Cell Selection Inspection](#cell-selection-inspection)\n    - [Practical Examples](#practical-examples)\n      - [Checking Sheet Configuration](#checking-sheet-configuration)\n      - [Copying Settings Between Sheets](#copying-settings-between-sheets)\n      - [Validating Sheet Settings](#validating-sheet-settings)\n    - [Default Values](#default-values)\n    - [Performance Notes](#performance-notes)","ref":"advanced_sheet_features.html#table-of-contents"},{"type":"extras","title":"Tab Colors - Advanced Sheet Features","doc":"You can set the color of worksheet tabs using the `set_tab_color/3` function:\n\n```elixir\n# Set the \"Sheet1\" tab color to red\nUmyaSpreadsheet.set_tab_color(spreadsheet, \"Sheet1\", \"#FF0000\")\n\n# Set the \"Sheet2\" tab color to green\nUmyaSpreadsheet.set_tab_color(spreadsheet, \"Sheet2\", \"#00FF00\")\n\n# Set the \"Sheet3\" tab color to blue\nUmyaSpreadsheet.set_tab_color(spreadsheet, \"Sheet3\", \"#0000FF\")\n```","ref":"advanced_sheet_features.html#tab-colors"},{"type":"extras","title":"Sheet Views - Advanced Sheet Features","doc":"Excel sheets can be displayed in different view modes. You can set the view mode using the `set_sheet_view/3` function:\n\n```elixir\n# Set to normal view\nUmyaSpreadsheet.set_sheet_view(spreadsheet, \"Sheet1\", \"normal\")\n\n# Set to page layout view\nUmyaSpreadsheet.set_sheet_view(spreadsheet, \"Sheet1\", \"page_layout\")\n\n# Set to page break preview\nUmyaSpreadsheet.set_sheet_view(spreadsheet, \"Sheet1\", \"page_break_preview\")\n```","ref":"advanced_sheet_features.html#sheet-views"},{"type":"extras","title":"Zoom Settings - Advanced Sheet Features","doc":"You can control the zoom level for different view modes:\n\n```elixir\n# Set zoom scale (applies to current view)\nUmyaSpreadsheet.set_zoom_scale(spreadsheet, \"Sheet1\", 150)\n\n# Set zoom scale for normal view\nUmyaSpreadsheet.set_zoom_scale_normal(spreadsheet, \"Sheet1\", 75)\n\n# Set zoom scale for page layout view\nUmyaSpreadsheet.set_zoom_scale_page_layout(spreadsheet, \"Sheet1\", 120)\n\n# Set zoom scale for page break preview\nUmyaSpreadsheet.set_zoom_scale_page_break(spreadsheet, \"Sheet1\", 80)\n```","ref":"advanced_sheet_features.html#zoom-settings"},{"type":"extras","title":"Freeze Panes - Advanced Sheet Features","doc":"Freeze panes keep rows and/or columns visible when scrolling through a worksheet:\n\n```elixir\n# Freeze the top row\nUmyaSpreadsheet.freeze_panes(spreadsheet, \"Sheet1\", 1, 0)\n\n# Freeze the leftmost column\nUmyaSpreadsheet.freeze_panes(spreadsheet, \"Sheet1\", 0, 1)\n\n# Freeze both top row and leftmost column\nUmyaSpreadsheet.freeze_panes(spreadsheet, \"Sheet1\", 1, 1)\n\n# Freeze the top 3 rows and first 2 columns\nUmyaSpreadsheet.freeze_panes(spreadsheet, \"Sheet1\", 3, 2)\n```","ref":"advanced_sheet_features.html#freeze-panes"},{"type":"extras","title":"Split Panes - Advanced Sheet Features","doc":"Split panes divide the worksheet into separate, independently scrollable regions:\n\n```elixir\n# Split the panes at horizontal and vertical position\nUmyaSpreadsheet.split_panes(spreadsheet, \"Sheet1\", 2000, 2000)\n\n# Split just horizontally\nUmyaSpreadsheet.split_panes(spreadsheet, \"Sheet1\", 2000, 0)\n\n# Split just vertically\nUmyaSpreadsheet.split_panes(spreadsheet, \"Sheet1\", 0, 2000)\n```","ref":"advanced_sheet_features.html#split-panes"},{"type":"extras","title":"Setting the Top-Left Cell - Advanced Sheet Features","doc":"You can set which cell will be the top-left visible cell in the sheet:\n\n```elixir\n# Set B5 as the top-left visible cell\nUmyaSpreadsheet.set_top_left_cell(spreadsheet, \"Sheet1\", \"B5\")\n```","ref":"advanced_sheet_features.html#setting-the-top-left-cell"},{"type":"extras","title":"Showing/Hiding Gridlines - Advanced Sheet Features","doc":"You can control whether gridlines are shown in a worksheet:\n\n```elixir\n# Hide gridlines\nUmyaSpreadsheet.set_show_grid_lines(spreadsheet, \"Sheet1\", false)\n\n# Show gridlines\nUmyaSpreadsheet.set_show_grid_lines(spreadsheet, \"Sheet1\", true)\n```","ref":"advanced_sheet_features.html#showing-hiding-gridlines"},{"type":"extras","title":"Combining Features - Advanced Sheet Features","doc":"These features can be combined to create a highly customized worksheet view:\n\n```elixir\n# Create a professional financial report view\nUmyaSpreadsheet.set_tab_color(spreadsheet, \"Financial Report\", \"#004080\")\nUmyaSpreadsheet.freeze_panes(spreadsheet, \"Financial Report\", 2, 1)\nUmyaSpreadsheet.set_sheet_view(spreadsheet, \"Financial Report\", \"page_layout\")\nUmyaSpreadsheet.set_zoom_scale(spreadsheet, \"Financial Report\", 100)\n```","ref":"advanced_sheet_features.html#combining-features"},{"type":"extras","title":"Sheet View Getter Functions Reference - Advanced Sheet Features","doc":"UmyaSpreadsheet provides comprehensive getter functions to retrieve current sheet view settings. These functions allow you to inspect and verify the current configuration of worksheets.","ref":"advanced_sheet_features.html#sheet-view-getter-functions-reference"},{"type":"extras","title":"Tab Color Inspection - Advanced Sheet Features","doc":"**Function:** `get_tab_color(spreadsheet, sheet_name)`\n\n```elixir\n# Get the current tab color\n{:ok, color} = UmyaSpreadsheet.get_tab_color(spreadsheet, \"Sheet1\")\n\ncase color do\n  \"\" -> IO.puts(\"No tab color set (default)\")\n  hex_color -> IO.puts(\"Tab color: #{hex_color}\")\nend\n```\n\n**Returns:**\n\n- `{:ok, color_string}` - The hex color code (e.g., \"#FF0000\") or empty string if no color is set\n- `{:error, reason}` - If the sheet doesn't exist or other error","ref":"advanced_sheet_features.html#tab-color-inspection"},{"type":"extras","title":"Sheet View Type Inspection - Advanced Sheet Features","doc":"**Function:** `get_sheet_view(spreadsheet, sheet_name)`\n\n```elixir\n# Get the current view mode\n{:ok, view_type} = UmyaSpreadsheet.get_sheet_view(spreadsheet, \"Sheet1\")\nIO.puts(\"Current view: #{view_type}\")  # \"normal\", \"page_layout\", or \"page_break_preview\"\n```\n\n**Returns:**\n\n- `{:ok, view_type}` - One of \"normal\", \"page_layout\", or \"page_break_preview\"\n- `{:error, reason}` - If the sheet doesn't exist or other error","ref":"advanced_sheet_features.html#sheet-view-type-inspection"},{"type":"extras","title":"Zoom Scale Inspection - Advanced Sheet Features","doc":"**Function:** `get_zoom_scale(spreadsheet, sheet_name)`\n\n```elixir\n# Get the current zoom level\n{:ok, zoom} = UmyaSpreadsheet.get_zoom_scale(spreadsheet, \"Sheet1\")\nIO.puts(\"Current zoom: #{zoom}%\")  # Default: 100\n```\n\n**Returns:**\n\n- `{:ok, zoom_percentage}` - Integer zoom percentage (10-400, default: 100)\n- `{:error, reason}` - If the sheet doesn't exist or other error","ref":"advanced_sheet_features.html#zoom-scale-inspection"},{"type":"extras","title":"Grid Lines Visibility Inspection - Advanced Sheet Features","doc":"**Function:** `get_show_grid_lines(spreadsheet, sheet_name)`\n\n```elixir\n# Check if grid lines are visible\n{:ok, grid_lines_visible} = UmyaSpreadsheet.get_show_grid_lines(spreadsheet, \"Sheet1\")\nIO.puts(\"Grid lines visible: #{grid_lines_visible}\")  # Default: true\n```\n\n**Returns:**\n\n- `{:ok, boolean}` - `true` if grid lines are visible, `false` if hidden\n- `{:error, reason}` - If the sheet doesn't exist or other error","ref":"advanced_sheet_features.html#grid-lines-visibility-inspection"},{"type":"extras","title":"Cell Selection Inspection - Advanced Sheet Features","doc":"**Function:** `get_selection(spreadsheet, sheet_name)`\n\n```elixir\n# Get the current cell selection\n{:ok, selection} = UmyaSpreadsheet.get_selection(spreadsheet, \"Sheet1\")\nIO.inspect(selection)\n# %{\"active_cell\" => \"A1\", \"sqref\" => \"A1:B5\"}\n```\n\n**Returns:**\n\n- `{:ok, selection_map}` - Map with \"active_cell\" and \"sqref\" keys\n  - `\"active_cell\"` - The currently active cell (e.g., \"A1\")\n  - `\"sqref\"` - The selected range (e.g., \"A1:B5\" for ranges, \"A1\" for single cell)\n- `{:error, reason}` - If the sheet doesn't exist or other error","ref":"advanced_sheet_features.html#cell-selection-inspection"},{"type":"extras","title":"Practical Examples - Advanced Sheet Features","doc":"#### Checking Sheet Configuration\n\n```elixir\ndefmodule SheetInspector do\n  def inspect_sheet_settings(spreadsheet, sheet_name) do\n    IO.puts(\"=== Sheet Settings for #{sheet_name} ===\")\n\n    # Check tab color\n    case UmyaSpreadsheet.get_tab_color(spreadsheet, sheet_name) do\n      {:ok, \"\"} -> IO.puts(\"Tab Color: Default (no color)\")\n      {:ok, color} -> IO.puts(\"Tab Color: #{color}\")\n      {:error, reason} -> IO.puts(\"Error getting tab color: #{reason}\")\n    end\n\n    # Check view type\n    case UmyaSpreadsheet.get_sheet_view(spreadsheet, sheet_name) do\n      {:ok, view} -> IO.puts(\"View Type: #{view}\")\n      {:error, reason} -> IO.puts(\"Error getting view: #{reason}\")\n    end\n\n    # Check zoom level\n    case UmyaSpreadsheet.get_zoom_scale(spreadsheet, sheet_name) do\n      {:ok, zoom} -> IO.puts(\"Zoom Scale: #{zoom}%\")\n      {:error, reason} -> IO.puts(\"Error getting zoom: #{reason}\")\n    end\n\n    # Check grid lines\n    case UmyaSpreadsheet.get_show_grid_lines(spreadsheet, sheet_name) do\n      {:ok, visible} -> IO.puts(\"Grid Lines: #{if visible, do: \"Visible\", else: \"Hidden\"}\")\n      {:error, reason} -> IO.puts(\"Error getting grid lines: #{reason}\")\n    end\n\n    # Check selection\n    case UmyaSpreadsheet.get_selection(spreadsheet, sheet_name) do\n      {:ok, selection} ->\n        IO.puts(\"Active Cell: #{selection[\"active_cell\"]}\")\n        IO.puts(\"Selected Range: #{selection[\"sqref\"]}\")\n      {:error, reason} -> IO.puts(\"Error getting selection: #{reason}\")\n    end\n  end\nend\n\n# Usage\nSheetInspector.inspect_sheet_settings(spreadsheet, \"Sheet1\")\n```\n\n#### Copying Settings Between Sheets\n\n```elixir\ndefmodule SheetSettingsCopier do\n  def copy_view_settings(spreadsheet, from_sheet, to_sheet) do\n    # Copy tab color\n    case UmyaSpreadsheet.get_tab_color(spreadsheet, from_sheet) do\n      {:ok, color} when color != \"\" ->\n        UmyaSpreadsheet.set_tab_color(spreadsheet, to_sheet, color)\n      _ -> :ok\n    end\n\n    # Copy view type\n    case UmyaSpreadsheet.get_sheet_view(spreadsheet, from_sheet) do\n      {:ok, view_type} ->\n        UmyaSpreadsheet.set_sheet_view(spreadsheet, to_sheet, view_type)\n      _ -> :ok\n    end\n\n    # Copy zoom level\n    case UmyaSpreadsheet.get_zoom_scale(spreadsheet, from_sheet) do\n      {:ok, zoom} ->\n        UmyaSpreadsheet.set_zoom_scale(spreadsheet, to_sheet, zoom)\n      _ -> :ok\n    end\n\n    # Copy grid lines setting\n    case UmyaSpreadsheet.get_show_grid_lines(spreadsheet, from_sheet) do\n      {:ok, show_grid} ->\n        UmyaSpreadsheet.set_show_grid_lines(spreadsheet, to_sheet, show_grid)\n      _ -> :ok\n    end\n\n    IO.puts(\"View settings copied from #{from_sheet} to #{to_sheet}\")\n  end\nend\n\n# Usage\nSheetSettingsCopier.copy_view_settings(spreadsheet, \"Template\", \"NewSheet\")\n```\n\n#### Validating Sheet Settings\n\n```elixir\ndefmodule SheetValidator do\n  def validate_standard_settings(spreadsheet, sheet_name) do\n    errors = []\n\n    # Check if zoom is within reasonable range\n    case UmyaSpreadsheet.get_zoom_scale(spreadsheet, sheet_name) do\n      {:ok, zoom} when zoom < 50 or zoom > 200 ->\n        errors = [\"Zoom level #{zoom}% may be too extreme\" | errors]\n      _ -> :ok\n    end\n\n    # Warn about unusual view types for data sheets\n    case UmyaSpreadsheet.get_sheet_view(spreadsheet, sheet_name) do\n      {:ok, \"page_break_preview\"} ->\n        errors = [\"Page break preview may not be ideal for data entry\" | errors]\n      _ -> :ok\n    end\n\n    if length(errors) > 0 do\n      IO.puts(\"Validation warnings for #{sheet_name}:\")\n      Enum.each(errors, &IO.puts(\"  - #{&1}\"))\n    else\n      IO.puts(\"Sheet #{sheet_name} has standard settings\")\n    end\n  end\nend\n\n# Usage\nSheetValidator.validate_standard_settings(spreadsheet, \"Sheet1\")\n```","ref":"advanced_sheet_features.html#practical-examples"},{"type":"extras","title":"Default Values - Advanced Sheet Features","doc":"When sheets are created, the following default values are applied:\n\n- **Tab Color**: No color (empty string)\n- **Sheet View**: \"normal\"\n- **Zoom Scale**: 100%\n- **Grid Lines**: Visible (true)\n- **Selection**: Cell A1 with range \"A1\"","ref":"advanced_sheet_features.html#default-values"},{"type":"extras","title":"Performance Notes - Advanced Sheet Features","doc":"- Getter functions are lightweight and can be called frequently\n- No performance impact from checking current settings before applying changes\n- All getter functions return immediately with cached values","ref":"advanced_sheet_features.html#performance-notes"},{"type":"extras","title":"Auto Filters","doc":"# Auto Filters\n\nThis guide covers auto filter functionality in UmyaSpreadsheet, allowing you to add Excel-style filtering to your spreadsheet data.","ref":"auto_filters.html"},{"type":"extras","title":"What Are Auto Filters? - Auto Filters","doc":"Auto filters add dropdown menus to column headers in your spreadsheet, allowing users to filter and sort data directly in Excel. When a user opens a spreadsheet with auto filters:\n\n1. Filter buttons appear in the header row\n2. Clicking a filter button shows options like:\n   - Sort A to Z / Sort Z to A\n   - Filter by specific values\n   - Filter by conditions (greater than, less than, etc.)\n   - Search for specific text\n\nAuto filters make large datasets more manageable by allowing users to focus on specific subsets of data.","ref":"auto_filters.html#what-are-auto-filters"},{"type":"extras","title":"Adding Auto Filters - Auto Filters","doc":"To add an auto filter to a range of data:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add some header data\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Name\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"Department\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C1\", \"Salary\")\n\n# Add some rows of data\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"John\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B2\", \"IT\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C2\", \"75000\")\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A3\", \"Sarah\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B3\", \"HR\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C3\", \"65000\")\n\n# Add an auto filter to the data range\nUmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:C3\")\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"employee_data.xlsx\")\n```\n\nWhen this spreadsheet is opened in Excel, filter buttons will appear in cells A1, B1, and C1, allowing users to filter and sort the data.","ref":"auto_filters.html#adding-auto-filters"},{"type":"extras","title":"Checking If Auto Filters Exist - Auto Filters","doc":"You can check if a worksheet already has auto filters:\n\n```elixir\n# Check if the worksheet has an auto filter\ncase UmyaSpreadsheet.has_auto_filter(spreadsheet, \"Sheet1\") do\n  true -> IO.puts(\"Sheet1 has an auto filter\")\n  false -> IO.puts(\"Sheet1 does not have an auto filter\")\n  {:error, reason} -> IO.puts(\"Error checking auto filter: #{reason}\")\nend\n```","ref":"auto_filters.html#checking-if-auto-filters-exist"},{"type":"extras","title":"Getting the Auto Filter Range - Auto Filters","doc":"To retrieve the range of cells that have auto filters applied:\n\n```elixir\n# Get the range of the auto filter\ncase UmyaSpreadsheet.get_auto_filter_range(spreadsheet, \"Sheet1\") do\n  nil -> IO.puts(\"No auto filter is set on Sheet1\")\n  range when is_binary(range) -> IO.puts(\"Auto filter range: #{range}\")\n  {:error, reason} -> IO.puts(\"Error getting auto filter range: #{reason}\")\nend\n```","ref":"auto_filters.html#getting-the-auto-filter-range"},{"type":"extras","title":"Removing Auto Filters - Auto Filters","doc":"To remove auto filters from a worksheet:\n\n```elixir\n# Remove the auto filter from Sheet1\nUmyaSpreadsheet.remove_auto_filter(spreadsheet, \"Sheet1\")\n```","ref":"auto_filters.html#removing-auto-filters"},{"type":"extras","title":"Best Practices - Auto Filters","doc":"1. **Include Headers**: Always include clear column headers in the first row of your auto filter range\n2. **Consistent Data Types**: For best filtering results, keep data types consistent within columns\n3. **Appropriate Range**: Ensure your filter range includes all data that should be filterable, but not empty rows\n4. **Format Headers**: Consider formatting header cells (bold, background color) to make them stand out\n5. **Test Filters**: Open your spreadsheet in Excel to verify filters work as expected","ref":"auto_filters.html#best-practices"},{"type":"extras","title":"Example: Financial Data with Auto Filters - Auto Filters","doc":"Here's a more complex example showing how to create a financial report with auto filters:\n\n```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Set up headers with formatting\nheaders = [\"Date\", \"Transaction\", \"Category\", \"Amount\", \"Balance\"]\nEnum.with_index(headers, fn header, idx ->\n  col = Enum.at(~w(A B C D E), idx)\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"#{col}1\", header)\n  UmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"#{col}1\", true)\n  UmyaSpreadsheet.set_background_color(spreadsheet, \"Sheet1\", \"#{col}1\", \"DDEBF7\")\nend)\n\n# Add some transaction data\ntransactions = [\n  [\"2025-05-01\", \"Salary\", \"Income\", 5000, 5000],\n  [\"2025-05-02\", \"Rent\", \"Housing\", -1200, 3800],\n  [\"2025-05-03\", \"Groceries\", \"Food\", -150, 3650],\n  [\"2025-05-04\", \"Restaurant\", \"Food\", -75, 3575],\n  [\"2025-05-05\", \"Gas\", \"Transportation\", -40, 3535],\n  [\"2025-05-06\", \"Internet\", \"Utilities\", -60, 3475],\n  [\"2025-05-07\", \"Movie Tickets\", \"Entertainment\", -30, 3445]\n]\n\nEnum.with_index(transactions, fn transaction, idx ->\n  row = idx + 2 # Start from row 2\n  Enum.with_index(transaction, fn value, col_idx ->\n    col = Enum.at(~w(A B C D E), col_idx)\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"#{col}#{row}\", value)\n\n    # Format amounts and balance as currency\n    if col_idx >= 3 do\n      UmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"#{col}#{row}\", \"$#,##0.00\")\n    end\n  end)\nend)\n\n# Apply auto filter to the entire data set\nUmyaSpreadsheet.set_auto_filter(spreadsheet, \"Sheet1\", \"A1:E8\")\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"financial_report.xlsx\")\n```\n\nWith this setup, users can:\n\n- Filter transactions by category\n- Sort by amount (largest to smallest)\n- Filter to see only expenses (negative amounts)\n- Filter by date ranges","ref":"auto_filters.html#example-financial-data-with-auto-filters"},{"type":"extras","title":"Limitations - Auto Filters","doc":"- The library adds the auto filter capability, but the actual filtering happens in Excel or other spreadsheet applications\n- Auto filters are applied to entire columns within the specified range, not partial columns\n- Complex filter conditions cannot be pre-set; they must be applied by the user in Excel","ref":"auto_filters.html#limitations"},{"type":"extras","title":"Conditional Formatting","doc":"# Conditional Formatting\n\nThis guide covers the conditional formatting capabilities of UmyaSpreadsheet, which allow you to apply formatting rules based on cell values or content.","ref":"conditional_formatting.html"},{"type":"extras","title":"Overview - Conditional Formatting","doc":"Conditional formatting is a powerful way to visualize data by automatically formatting cells that meet specific conditions. UmyaSpreadsheet supports several types of conditional formatting:\n\n- **Cell Value Rules**: Format cells based on comparison with values (greater than, less than, equal to, etc.)\n- **Color Scales**: Apply color gradients based on cell values\n- **Data Bars**: Show horizontal bars in cells proportional to their values\n- **Icon Sets**: Display different icons based on cell values for visual data representation\n- **Top/Bottom Rules**: Highlight top or bottom values/percentages in a range\n- **Above/Below Average Rules**: Highlight cells above or below the average value of a range\n- **Text Rules**: Format cells based on text content (contains, begins with, etc.)\n\nAll conditional formatting functionality is available through the `UmyaSpreadsheet.ConditionalFormatting` module.","ref":"conditional_formatting.html#overview"},{"type":"extras","title":"Cell Value Rules - Conditional Formatting","doc":"Cell value rules allow you to apply formatting based on cell values that meet specific criteria.\n\n```elixir\nalias UmyaSpreadsheet.ConditionalFormatting\n\n# Highlight cells with values greater than 50 in red\nConditionalFormatting.add_cell_value_rule(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",  # Range to apply formatting to\n  \"greaterThan\",  # Operator\n  \"50\",  # Value to compare against\n  nil,  # Second value (only used for \"between\" and \"notBetween\")\n  \"#FF0000\"  # Format to apply (red background)\n)\n\n# Highlight cells with values between 20 and 80 in green\nConditionalFormatting.add_cell_value_rule(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"between\",\n  \"20\",  # First value\n  \"80\",  # Second value\n  \"#00FF00\"  # Format to apply (green background)\n)\n```","ref":"conditional_formatting.html#cell-value-rules"},{"type":"extras","title":"Available Operators - Conditional Formatting","doc":"- `\"equal\"` - Equal to value\n- `\"notEqual\"` - Not equal to value\n- `\"greaterThan\"` - Greater than value\n- `\"greaterThanOrEqual\"` - Greater than or equal to value\n- `\"lessThan\"` - Less than value\n- `\"lessThanOrEqual\"` - Less than or equal to value\n- `\"between\"` - Between two values (requires second value)\n- `\"notBetween\"` - Not between two values (requires second value)","ref":"conditional_formatting.html#available-operators"},{"type":"extras","title":"Color Scales - Conditional Formatting","doc":"Color scales create a gradient of colors based on cell values, making it easy to visualize the distribution of values in a range.\n\n```elixir\n# Two-color scale (red to green)\nConditionalFormatting.add_color_scale(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  nil,  # Use default min (minimum value in range)\n  nil,  # No mid point\n  nil,  # Use default max (maximum value in range)\n  \"#FF0000\",  # Red for minimum\n  nil,        # No mid color\n  \"#00FF00\"   # Green for maximum\n)\n\n# Three-color scale (red to yellow to green)\nConditionalFormatting.add_color_scale(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  {\"min\", \"\"},         # Use minimum value\n  {\"percentile\", \"50\"}, # Use 50th percentile for mid-point\n  {\"max\", \"\"},         # Use maximum value\n  \"#FF0000\",           # Red for minimum\n  \"#FFFF00\",           # Yellow for middle\n  \"#00FF00\"            # Green for maximum\n)\n```","ref":"conditional_formatting.html#color-scales"},{"type":"extras","title":"Value Types - Conditional Formatting","doc":"For min, mid, and max values, you can use:\n\n- `{\"min\", \"\"}` - Use the minimum value in the range\n- `{\"max\", \"\"}` - Use the maximum value in the range\n- `{\"percentile\", \"X\"}` - Use the Xth percentile (e.g., \"50\" for median)\n- `{\"percent\", \"X\"}` - Use X percent of the range\n- `{\"number\", \"X\"}` - Use a specific number\n- `{\"formula\", \"X\"}` - Use a formula result","ref":"conditional_formatting.html#value-types"},{"type":"extras","title":"Data Bars - Conditional Formatting","doc":"Data bars create horizontal bars in each cell with length proportional to the cell value, providing a visual representation of the data.\n\n```elixir\n# Basic data bars with default min/max values\nConditionalFormatting.add_data_bar(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  nil,  # Use default min (auto)\n  nil,  # Use default max (auto)\n  \"#6C8EBF\"  # Blue bars\n)\n\n# Data bars with custom min/max values\nConditionalFormatting.add_data_bar(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  {\"number\", \"20\"},  # Minimum value is 20\n  {\"number\", \"80\"},  # Maximum value is 80\n  \"#FF9900\"          # Orange bars\n)\n```","ref":"conditional_formatting.html#data-bars"},{"type":"extras","title":"Icon Sets - Conditional Formatting","doc":"Icon sets display different icons in cells based on their values, providing a visual cue for data analysis.\n\n```elixir\n# Basic icon set (3 icons)\nConditionalFormatting.add_icon_set(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"3Symbols\",  # Icon set type\n  nil,          # No specific value range\n  nil           # Default icon style\n)\n\n# Custom icon set with specific values\nConditionalFormatting.add_icon_set(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"3TrafficLights\",  # Icon set type\n  {\"number\", \"0\"},   # Minimum value for red light\n  {\"number\", \"100\"}, # Maximum value for green light\n  nil                 # Default icon style\n)\n```","ref":"conditional_formatting.html#icon-sets"},{"type":"extras","title":"Available Icon Set Types - Conditional Formatting","doc":"- `\"3Symbols\"` - Three symbols (e.g., up/down arrows)\n- `\"3TrafficLights\"` - Traffic light icons (red, yellow, green)\n- `\"4Ratings\"` - Four rating icons (e.g., star ratings)","ref":"conditional_formatting.html#available-icon-set-types"},{"type":"extras","title":"Top/Bottom Rules - Conditional Formatting","doc":"Top/bottom rules highlight cells with values that rank at the top or bottom of a range, either by count or percentage.\n\n```elixir\n# Highlight top 3 values in red\nConditionalFormatting.add_top_bottom_rule(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"top\",    # Rule type\n  3,        # Top 3 values\n  false,    # Not a percentage\n  \"#FF0000\" # Red highlight\n)\n\n# Highlight bottom 20% in yellow\nConditionalFormatting.add_top_bottom_rule(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"bottom\", # Rule type\n  20,       # Bottom 20%\n  true,     # Is a percentage\n  \"#FFFF00\" # Yellow highlight\n)\n```","ref":"conditional_formatting.html#top-bottom-rules"},{"type":"extras","title":"Above/Below Average Rules - Conditional Formatting","doc":"Above/below average rules highlight cells that are above or below the average value of a range, helping to identify outliers.\n\n```elixir\n# Highlight cells above average in green\nConditionalFormatting.add_above_below_average_rule(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"aboveAverage\",  # Rule type\n  nil,              # No specific value\n  \"#00FF00\"        # Green highlight\n)\n\n# Highlight cells below average in red\nConditionalFormatting.add_above_below_average_rule(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"belowAverage\",  # Rule type\n  nil,              # No specific value\n  \"#FF0000\"        # Red highlight\n)\n```","ref":"conditional_formatting.html#above-below-average-rules"},{"type":"extras","title":"Text Rules - Conditional Formatting","doc":"Text rules allow you to apply formatting based on the text content of cells.\n\n```elixir\n# Highlight cells containing \"Error\" in red\nConditionalFormatting.add_text_rule(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"contains\",  # Rule type\n  \"Error\",     # Text to search for\n  \"#FF0000\"    # Red highlight\n)\n\n# Highlight cells beginning with \"Warning\" in yellow\nConditionalFormatting.add_text_rule(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",\n  \"beginsWith\", # Rule type\n  \"Warning\",    # Text to search for\n  \"#FFFF00\"     # Yellow highlight\n)\n```","ref":"conditional_formatting.html#text-rules"},{"type":"extras","title":"Available Text Rule Types - Conditional Formatting","doc":"- `\"contains\"` - Cell contains the text\n- `\"notContains\"` - Cell does not contain the text\n- `\"beginsWith\"` - Cell begins with the text\n- `\"endsWith\"` - Cell ends with the text","ref":"conditional_formatting.html#available-text-rule-types"},{"type":"extras","title":"Getting Conditional Formatting Rules - Conditional Formatting","doc":"UmyaSpreadsheet provides a set of functions to retrieve conditional formatting rules from a spreadsheet. These getter functions allow you to examine the rules applied to specific sheets or ranges.\n\n```elixir\nalias UmyaSpreadsheet.ConditionalFormatting\n\n# Get all conditional formatting rules in a sheet\nrules = ConditionalFormatting.get_conditional_formatting_rules(spreadsheet, \"Sheet1\")\n\n# Get conditional formatting rules for a specific range\nrules = ConditionalFormatting.get_conditional_formatting_rules(spreadsheet, \"Sheet1\", \"A1:A10\")\n\n# Get rules of specific types - these functions return {:ok, list} tuples\ncell_value_rules = ConditionalFormatting.get_cell_value_rules(spreadsheet, \"Sheet1\")\n{:ok, color_scales} = ConditionalFormatting.get_color_scales(spreadsheet, \"Sheet1\")\n{:ok, data_bars} = ConditionalFormatting.get_data_bars(spreadsheet, \"Sheet1\")\n{:ok, icon_sets} = ConditionalFormatting.get_icon_sets(spreadsheet, \"Sheet1\")\ntop_bottom_rules = ConditionalFormatting.get_top_bottom_rules(spreadsheet, \"Sheet1\")\nabove_below_average_rules = ConditionalFormatting.get_above_below_average_rules(spreadsheet, \"Sheet1\")\ntext_rules = ConditionalFormatting.get_text_rules(spreadsheet, \"Sheet1\")\n```","ref":"conditional_formatting.html#getting-conditional-formatting-rules"},{"type":"extras","title":"Getter Response Schemas - Conditional Formatting","doc":"**Return Type Consistency**: As of version 0.6.17, the specific type getter functions (`get_color_scales`, `get_data_bars`, and `get_icon_sets`) now consistently return `{:ok, list()}` tuples for successful results, maintaining consistency with other getter patterns in the library.\n\nEach of the getter functions returns either a list of maps directly (for general getters) or `{:ok, list}` tuples (for specific type getters), with each map representing a conditional formatting rule. The structure of these maps depends on the type of rule. Below are the detailed schemas for each rule type.\n\n#### Cell Value Rules\n\n`get_cell_value_rules/2` and `get_cell_value_rules/3` return a list of maps with the following structure:\n\n```elixir\n%{\n  range: String.t(),           # The cell range to which the rule applies, e.g., \"A1:A10\"\n  rule_type: :cell_is,         # Always :cell_is for cell value rules\n  operator: atom(),            # One of: :equal, :not_equal, :greater_than, :less_than,\n                              # :greater_than_or_equal, :less_than_or_equal, :between, :not_between\n  formula: String.t(),         # The formula or value to compare against\n  format_style: String.t()     # The color applied as formatting (ARGB format, e.g., \"FFFF0000\" for red)\n}\n```\n\nExample:\n\n```elixir\n%{\n  range: \"A1:A10\",\n  rule_type: :cell_is,\n  operator: :greater_than,\n  formula: \"50\",\n  format_style: \"FFFF0000\"\n}\n```\n\n#### Color Scale Rules\n\n`get_color_scales/2` and `get_color_scales/3` return `{:ok, list}` tuples where each map in the list has the following structure:\n\n```elixir\n%{\n  range: String.t(),             # The cell range to which the rule applies\n  rule_type: :color_scale,       # Always :color_scale for color scale rules\n  min_type: atom(),              # The type of the minimum value\n  min_value: String.t(),         # The minimum value (if applicable)\n  min_color: %{argb: String.t()}, # The color for minimum values (ARGB format)\n\n  # For three-color scales only:\n  mid_type: atom(),              # The type of the mid-point value\n  mid_value: String.t(),         # The mid-point value (if applicable)\n  mid_color: %{argb: String.t()}, # The color for mid-point values (ARGB format)\n\n  max_type: atom(),              # The type of the maximum value\n  max_value: String.t(),         # The maximum value (if applicable)\n  max_color: %{argb: String.t()}  # The color for maximum values (ARGB format)\n}\n```\n\nValue type atoms can be: `:min`, `:max`, `:number`, `:percent`, `:percentile`, or `:formula`\n\nExample (two-color scale):\n\n```elixir\n%{\n  range: \"A1:A10\",\n  rule_type: :color_scale,\n  min_type: :min,\n  min_value: \"\",\n  min_color: %{argb: \"FF0000FF\"},  # Blue\n  max_type: :max,\n  max_value: \"\",\n  max_color: %{argb: \"FF00FF00\"}   # Green\n}\n```\n\nExample (three-color scale):\n\n```elixir\n%{\n  range: \"A1:A10\",\n  rule_type: :color_scale,\n  min_type: :min,\n  min_value: \"\",\n  min_color: %{argb: \"FFFF0000\"},  # Red\n  mid_type: :percentile,\n  mid_value: \"50\",\n  mid_color: %{argb: \"FFFFFF00\"},  # Yellow\n  max_type: :max,\n  max_value: \"\",\n  max_color: %{argb: \"FF00FF00\"}   # Green\n}\n```\n\n#### Data Bar Rules\n\n`get_data_bars/2` and `get_data_bars/3` return `{:ok, list}` tuples where each map in the list has the following structure:\n\n```elixir\n%{\n  range: String.t(),    # The cell range to which the rule applies\n  rule_type: :data_bar, # Always :data_bar for data bar rules\n  min_value: term(),    # The minimum value as a tuple like {type, value} or nil\n  max_value: term(),    # The maximum value as a tuple like {type, value} or nil\n  color: String.t()     # The color of the data bar (ARGB format)\n}\n```\n\nThe `min_value` and `max_value` can be:\n\n- A tuple like `{:min, \"\"}` or `{:number, \"20\"}`\n- `nil` when using default values\n\nExample:\n\n```elixir\n%{\n  range: \"C1:C10\",\n  rule_type: :data_bar,\n  min_value: nil,  # Using default min (lowest value in range)\n  max_value: nil,  # Using default max (highest value in range)\n  color: \"FF638EC6\"  # Blue data bar\n}\n```\n\n#### Icon Set Rules\n\n`get_icon_sets/2` and `get_icon_sets/3` return `{:ok, list}` tuples where each map in the list has the following structure:\n\n```elixir\n%{\n  range: String.t(),       # The cell range to which the rule applies\n  rule_type: :icon_set,    # Always :icon_set for icon set rules\n  icon_style: String.t(),  # The icon set type, e.g., \"3arrows\", \"4arrows\", \"5arrows\"\n  thresholds: [{String.t(), String.t()}]  # List of threshold values as {type, value} tuples\n}\n```\n\nExample:\n\n```elixir\n%{\n  range: \"A1:A10\",\n  rule_type: :icon_set,\n  icon_style: \"3arrows\",\n  thresholds: [\n    {\"percent\", \"0\"},\n    {\"percent\", \"33\"},\n    {\"percent\", \"67\"}\n  ]\n}\n```\n\n#### Top/Bottom Rules\n\n`get_top_bottom_rules/2` and `get_top_bottom_rules/3` return a list of maps with the following structure:\n\n```elixir\n%{\n  range: String.t(),          # The cell range to which the rule applies\n  rule_type: :top_bottom,     # Always :top_bottom for top/bottom rules\n  rule_type_value: atom(),    # Either :top or :bottom\n  rank: integer(),            # The number of values or percentage to highlight\n  percent: boolean(),         # Whether rank is a percentage or count\n  format_style: String.t()    # The color applied as formatting (ARGB format)\n}\n```\n\nExample:\n\n```elixir\n%{\n  range: \"A1:A10\",\n  rule_type: :top_bottom,\n  rule_type_value: :top,\n  rank: 3,\n  percent: false,  # Top 3 values, not percentile\n  format_style: \"FFFFFF00\"  # Yellow highlight\n}\n```\n\n#### Above/Below Average Rules\n\n`get_above_below_average_rules/2` and `get_above_below_average_rules/3` return a list of maps with the following structure:\n\n```elixir\n%{\n  range: String.t(),              # The cell range to which the rule applies\n  rule_type: :above_below_average, # Always :above_below_average for these rules\n  rule_type_value: atom(),        # One of: :above, :below, :above_equal, :below_equal\n  std_dev: integer(),             # Standard deviation value (0 for regular above/below)\n  format_style: String.t()        # The color applied as formatting (ARGB format)\n}\n```\n\nExample:\n\n```elixir\n%{\n  range: \"C1:C10\",\n  rule_type: :above_below_average,\n  rule_type_value: :above,\n  std_dev: 0,  # 0 means standard above average, not standard deviation based\n  format_style: \"FF00FF00\"  # Green highlight\n}\n```\n\n#### Text Rules\n\n`get_text_rules/2` and `get_text_rules/3` return a list of maps with the following structure:\n\n```elixir\n%{\n  range: String.t(),      # The cell range to which the rule applies\n  rule_type: :text_rule,  # Always :text_rule for text rules\n  operator: atom(),       # One of: :contains, :not_contains, :begins_with, :ends_with\n  text: String.t(),       # The text to search for\n  format_style: String.t() # The color applied as formatting (ARGB format)\n}\n```\n\nExample:\n\n```elixir\n%{\n  range: \"B1:B10\",\n  rule_type: :text_rule,\n  operator: :begins_with,\n  text: \"Value 1\",\n  format_style: \"FFFFC000\"  # Orange highlight\n}\n```\n\n#### All Rules\n\nWhen using `get_conditional_formatting_rules/2` or `get_conditional_formatting_rules/3`, you'll get a list containing any of the above rule types, each with their respective structure. You can identify the rule type by checking the `:rule_type` field in each map.","ref":"conditional_formatting.html#getter-response-schemas"},{"type":"extras","title":"Working with Rule Results - Conditional Formatting","doc":"The getter functions return a list of rule maps, each containing information about a conditional formatting rule:\n\n```elixir\n# Example: Getting cell value rules\ncell_value_rules = ConditionalFormatting.get_cell_value_rules(spreadsheet, \"Sheet1\")\n\n# Each rule contains details about the formatting condition\nEnum.each(cell_value_rules, fn rule ->\n  IO.puts(\"Range: #{rule.range}\")\n  IO.puts(\"Operator: #{rule.operator}\")\n  IO.puts(\"Formula: #{rule.formula}\")\n  IO.puts(\"Format style: #{rule.format_style}\")\nend)\n```","ref":"conditional_formatting.html#working-with-rule-results"},{"type":"extras","title":"Example: Analyzing Conditional Formatting Rules - Conditional Formatting","doc":"```elixir\nalias UmyaSpreadsheet.ConditionalFormatting\n\n# Read a spreadsheet with conditional formatting\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"formatted_data.xlsx\")\n\n# Get all conditional formatting rules\nall_rules = ConditionalFormatting.get_conditional_formatting_rules(spreadsheet, \"Sheet1\")\n\n# Count rules by type\nrule_counts = Enum.reduce(all_rules, %{}, fn rule, acc ->\n  Map.update(acc, rule.type, 1, &(&1 + 1))\nend)\n\nIO.puts(\"Rule counts by type:\")\nEnum.each(rule_counts, fn {type, count} ->\n  IO.puts(\"#{type}: #{count}\")\nend)\n\n# Find all red formatting\nred_rules = Enum.filter(all_rules, fn rule ->\n  rule.format[\"bgColor\"] in [\"#FF0000\", \"rgb(255,0,0)\"]\nend)\n\nIO.puts(\"\\nRed formatting rules:\")\nEnum.each(red_rules, fn rule ->\n  IO.puts(\"#{rule.type} rule on range #{rule.range}\")\nend)\n```","ref":"conditional_formatting.html#example-analyzing-conditional-formatting-rules"},{"type":"extras","title":"Format Styles - Conditional Formatting","doc":"For all conditional formatting rules, you can specify a format to apply when the condition is met. Currently, the implementation supports specifying a background color in hexadecimal format or RGB format:\n\n- Hexadecimal: `\"#FF0000\"` (red), `\"#00FF00\"` (green), `\"#0000FF\"` (blue)\n- RGB: `\"rgb(255,0,0)\"` (red), `\"rgb(0,255,0)\"` (green), `\"rgb(0,0,255)\"` (blue)","ref":"conditional_formatting.html#format-styles"},{"type":"extras","title":"Complete Example - Conditional Formatting","doc":"Here's a comprehensive example that applies multiple conditional formatting rules to a worksheet:\n\n```elixir\nalias UmyaSpreadsheet.ConditionalFormatting\n\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add test data\nfor i <- 1..10 do\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A#{i}\", \"#{i * 10}\")\nend\n\n# Cell value rule: values less than 30 (red)\nConditionalFormatting.add_cell_value_rule(\n  spreadsheet, \"Sheet1\", \"A1:A10\", \"lessThan\", \"30\", nil, \"#FF0000\"\n)\n\n# Cell value rule: values between 30 and 70 (yellow)\nConditionalFormatting.add_cell_value_rule(\n  spreadsheet, \"Sheet1\", \"A1:A10\", \"between\", \"30\", \"70\", \"#FFFF00\"\n)\n\n# Cell value rule: values greater than 70 (green)\nConditionalFormatting.add_cell_value_rule(\n  spreadsheet, \"Sheet1\", \"A1:A10\", \"greaterThan\", \"70\", nil, \"#00FF00\"\n)\n\n# Add a new sheet for color scales\nUmyaSpreadsheet.add_sheet(spreadsheet, \"ColorScales\")\nfor i <- 1..10 do\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"ColorScales\", \"A#{i}\", \"#{i * 10}\")\nend\n\n# Add a three-color scale\nConditionalFormatting.add_color_scale(\n  spreadsheet, \"ColorScales\", \"A1:A10\",\n  {\"min\", \"\"}, {\"percentile\", \"50\"}, {\"max\", \"\"},\n  \"#FF0000\", \"#FFFF00\", \"#00FF00\"\n)\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"conditional_formatting_example.xlsx\")\n\n# Read back and analyze the rules\n{:ok, read_spreadsheet} = UmyaSpreadsheet.read(\"conditional_formatting_example.xlsx\")\nrules = ConditionalFormatting.get_conditional_formatting_rules(read_spreadsheet, \"Sheet1\")\n\nIO.puts(\"Found #{length(rules)} conditional formatting rules in Sheet1\")\n```","ref":"conditional_formatting.html#complete-example"},{"type":"extras","title":"Notes - Conditional Formatting","doc":"- Conditional formatting is applied to a range of cells, not just individual cells\n- Multiple rules can be applied to the same range, and they will be evaluated in the order they were added\n- The formatting is applied when opening the file in Excel, not in the Elixir code itself\n- For complex formatting needs, consider using multiple rules to achieve the desired effect\n- Use the getter functions to inspect and analyze conditional formatting rules in existing spreadsheets","ref":"conditional_formatting.html#notes"},{"type":"extras","title":"Data Validation","doc":"# Data Validation\n\nThis guide explains how to use UmyaSpreadsheet's data validation features to control what users can enter in Excel cells.","ref":"data_validation.html"},{"type":"extras","title":"Introduction to Data Validation - Data Validation","doc":"Data validation allows you to define rules that restrict what values can be entered in specific cells. This helps ensure data integrity and can provide users with guidance on what they should enter.","ref":"data_validation.html#introduction-to-data-validation"},{"type":"extras","title":"Benefits of Data Validation - Data Validation","doc":"- **Data Integrity**: Ensure data entered meets specific requirements\n- **User Guidance**: Help users understand what values are expected\n- **Error Prevention**: Reduce errors from incorrect data entry\n- **Standardization**: Maintain consistency across your spreadsheet","ref":"data_validation.html#benefits-of-data-validation"},{"type":"extras","title":"Types of Validation Supported - Data Validation","doc":"UmyaSpreadsheet supports several types of validation:\n\n- **List Validation**: Creates dropdown lists with predefined options\n- **Number Validation**: Restricts input to numbers within specific ranges\n- **Date Validation**: Restricts input to dates within specific ranges (supports both ISO strings and Date structs)\n- **Text Length Validation**: Restricts input to text with specific character count requirements\n- **Custom Formula Validation**: Allows advanced validation using Excel formulas","ref":"data_validation.html#types-of-validation-supported"},{"type":"extras","title":"Adding Data Validation Rules - Data Validation","doc":"","ref":"data_validation.html#adding-data-validation-rules"},{"type":"extras","title":"List Validation (Dropdown Lists) - Data Validation","doc":"Create dropdown lists to restrict input to a predefined set of options:\n\n```elixir\nalias UmyaSpreadsheet.{DataValidation}\n\n# Create a dropdown with simple options\nDataValidation.add_list_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:A10\",               # Cell range\n  [\"Red\", \"Green\", \"Blue\"], # List items\n  true,                   # Allow blank (optional)\n  \"Invalid Selection\",    # Error title (optional)\n  \"Please select a color from the list\", # Error message (optional)\n  \"Color Selection\",      # Prompt title (optional)\n  \"Select a color\"        # Prompt message (optional)\n)\n```","ref":"data_validation.html#list-validation-dropdown-lists"},{"type":"extras","title":"Number Validation - Data Validation","doc":"Restrict input to numbers that meet specific criteria:\n\n```elixir\n# Allow only numbers between 1 and 100\nDataValidation.add_number_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"B1:B10\",                # Cell range\n  \"between\",               # Operator\n  1.0,                     # Minimum value\n  100.0,                   # Maximum value\n  true,                    # Allow blank (optional)\n  \"Invalid Number\",        # Error title (optional)\n  \"Please enter a number between 1 and 100\", # Error message (optional)\n  \"Number Input\",          # Prompt title (optional)\n  \"Enter a number between 1 and 100\"         # Prompt message (optional)\n)\n\n# Allow only values greater than 0\nDataValidation.add_number_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"C1:C10\",\n  \"greaterThan\",\n  0.0\n)\n```","ref":"data_validation.html#number-validation"},{"type":"extras","title":"Date Validation - Data Validation","doc":"Restrict input to dates that meet specific criteria. You can use either ISO format strings or Elixir Date structs for date parameters:\n\n```elixir\n# Allow only dates in the current year (using string dates)\nDataValidation.add_date_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"D1:D10\",                # Cell range\n  \"between\",               # Operator\n  \"#{Date.utc_today().year}-01-01\", # Start date as string\n  \"#{Date.utc_today().year}-12-31\", # End date as string\n  true,                    # Allow blank (optional)\n  \"Invalid Date\",          # Error title (optional)\n  \"Please enter a date in #{Date.utc_today().year}\", # Error message (optional)\n  \"Date Input\",            # Prompt title (optional)\n  \"Enter a date in #{Date.utc_today().year}\"         # Prompt message (optional)\n)\n\n# Allow only future dates (using Date struct directly)\nDataValidation.add_date_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"E1:E10\",\n  \"greaterThanOrEqual\",\n  Date.utc_today(),  # Date struct works directly\n  nil,\n  true,\n  \"Invalid Date\",\n  \"Please enter today's date or later\"\n)\n```","ref":"data_validation.html#date-validation"},{"type":"extras","title":"Text Length Validation - Data Validation","doc":"Restrict input to text with specific length requirements:\n\n```elixir\n# Limit input to at most 280 characters (like a tweet)\nDataValidation.add_text_length_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"F1:F10\",                # Cell range\n  \"lessThanOrEqual\",       # Operator\n  280,                     # Maximum length\n  nil,                     # Second value (not used)\n  true,                    # Allow blank (optional)\n  \"Text Too Long\",         # Error title (optional)\n  \"Please enter at most 280 characters\", # Error message (optional)\n  \"Character Limit\",       # Prompt title (optional)\n  \"Enter up to 280 characters\" # Prompt message (optional)\n)\n\n# Require at least 8 characters (like a password)\nDataValidation.add_text_length_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"G1:G10\",\n  \"greaterThanOrEqual\",\n  8\n)\n```","ref":"data_validation.html#text-length-validation"},{"type":"extras","title":"Custom Formula Validation - Data Validation","doc":"Create advanced validation rules using Excel formulas:\n\n```elixir\n# Only allow values divisible by 5\nDataValidation.add_custom_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"H1:H10\",                # Cell range\n  \"MOD(H1,5)=0\",           # Formula (without = sign)\n  true,                    # Allow blank (optional)\n  \"Invalid Value\",         # Error title (optional)\n  \"Please enter a value divisible by 5\", # Error message (optional)\n  \"Value Input\",           # Prompt title (optional)\n  \"Enter a value divisible by 5\" # Prompt message (optional)\n)\n```","ref":"data_validation.html#custom-formula-validation"},{"type":"extras","title":"Retrieving and Inspecting Data Validation Rules - Data Validation","doc":"UmyaSpreadsheet provides functions to retrieve and inspect data validation rules. All getter functions return values in the format `{:ok, result}`.","ref":"data_validation.html#retrieving-and-inspecting-data-validation-rules"},{"type":"extras","title":"Getting All Data Validation Rules - Data Validation","doc":"To retrieve all data validation rules in a sheet:\n\n```elixir\nalias UmyaSpreadsheet.{DataValidation}\n\n# Create or open a spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n# OR\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"my_spreadsheet.xlsx\")\n\n# Get all data validations\n{:ok, all_rules} = DataValidation.get_data_validations(spreadsheet, \"Sheet1\")\n```\n\nThe resulting list will contain maps, each representing a validation rule with properties like:\n\n- `range`: The cell range the validation applies to\n- `rule_type`: The type of validation (`:list`, `:decimal`, `:date`, etc.)\n- Other properties specific to the validation type","ref":"data_validation.html#getting-all-data-validation-rules"},{"type":"extras","title":"Getting Specific Types of Validation Rules - Data Validation","doc":"UmyaSpreadsheet provides specialized getter functions for each validation type:\n\n#### List Validations (Dropdowns)\n\n```elixir\n# Get all dropdown validations\n{:ok, list_rules} = DataValidation.get_list_validations(spreadsheet, \"Sheet1\")\n\n# Each rule includes the list items\nlist_items = hd(list_rules).list_items  # [\"Option1\", \"Option2\", ...]\n```\n\n#### Number Validations\n\n```elixir\n# Get all number validations\n{:ok, number_rules} = DataValidation.get_number_validations(spreadsheet, \"Sheet1\")\n\n# Example of inspecting a number validation rule\nif length(number_rules) > 0 do\n  rule = List.first(number_rules)\n  min_value = rule.value1  # The minimum value (for \"between\" validations)\n  max_value = rule.value2  # The maximum value (for \"between\" validations)\n  operator = rule.operator # The comparison operator (:between, :greater_than, etc.)\nend\n```\n\n#### Date Validations\n\n```elixir\n# Get all date validations\n{:ok, date_rules} = DataValidation.get_date_validations(spreadsheet, \"Sheet1\")\n\n# Each rule includes the operator and date values\nif date_rules != [] do\n  rule = hd(date_rules)\n  IO.puts(\"Date must be #{rule.operator} #{rule.date1} and #{rule.date2}\")\nend\n```\n\n#### Text Length Validations\n\n```elixir\n# Get all text length validations\n{:ok, length_rules} = DataValidation.get_text_length_validations(spreadsheet, \"Sheet1\")\n\n# Each rule includes the operator and length values\nif length_rules != [] do\n  rule = hd(length_rules)\n  IO.puts(\"Text length must be #{rule.operator} #{rule.length1}\")\nend\n```\n\n#### Custom Formula Validations\n\n```elixir\n# Get all custom formula validations\n{:ok, formula_rules} = DataValidation.get_custom_validations(spreadsheet, \"Sheet1\")\n\n# Each rule includes the custom formula\nif formula_rules != [] do\n  formula = hd(formula_rules).formula\n  IO.puts(\"Custom validation formula: #{formula}\")\nend\n```","ref":"data_validation.html#getting-specific-types-of-validation-rules"},{"type":"extras","title":"Filtering Validation Rules by Range - Data Validation","doc":"Each getter function accepts an optional cell range parameter that filters the results:\n\n```elixir\n# Get only validation rules that apply to range A1:B10\n{:ok, rules} = DataValidation.get_data_validations(spreadsheet, \"Sheet1\", \"A1:B10\")\n```","ref":"data_validation.html#filtering-validation-rules-by-range"},{"type":"extras","title":"Utility Functions - Data Validation","doc":"#### Checking If Validations Exist\n\n```elixir\n# Check if any validation rules exist\n{:ok, has_rules} = DataValidation.has_data_validations(spreadsheet, \"Sheet1\")\nif has_rules do\n  IO.puts(\"Sheet has validation rules\")\nend\n\n# Check if a specific range has validation rules\n{:ok, has_rules_in_range} = DataValidation.has_data_validations(spreadsheet, \"Sheet1\", \"A1:A10\")\n```\n\n#### Counting Validation Rules\n\n```elixir\n# Count all validation rules in a sheet\n{:ok, count} = DataValidation.count_data_validations(spreadsheet, \"Sheet1\")\nIO.puts(\"Sheet has #{count} validation rules\")\n\n# Count rules for a specific range\n{:ok, range_count} = DataValidation.count_data_validations(spreadsheet, \"Sheet1\", \"A1:A10\")\n```","ref":"data_validation.html#utility-functions"},{"type":"extras","title":"Removing Validation - Data Validation","doc":"You can remove all validation rules from a range:\n\n```elixir\nDataValidation.remove_data_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1:Z100\"\n)\n```","ref":"data_validation.html#removing-validation"},{"type":"extras","title":"Common Parameters - Data Validation","doc":"All data validation functions accept these common parameters:\n\n- `allow_blank`: Whether to allow blank/empty values (default: true)\n- `error_title`: Title for error message when validation fails (optional)\n- `error_message`: Description for error message when validation fails (optional)\n- `prompt_title`: Title for input prompt (optional)\n- `prompt_message`: Description for input prompt (optional)\n\nAll validation rules include these common properties when retrieved:\n\n- `range`: The cell range the validation applies to\n- `rule_type`: The type of validation\n- `allow_blank`: Whether blank values are allowed\n- `show_error_message`: Whether error messages are shown\n- `error_title`: The title of the error message (if any)\n- `error_message`: The error message text (if any)\n- `show_input_message`: Whether input prompts are shown\n- `prompt_title`: The title of the input prompt (if any)\n- `prompt_message`: The input prompt text (if any)","ref":"data_validation.html#common-parameters"},{"type":"extras","title":"Available Operators - Data Validation","doc":"The following operators are available for number, date, and text length validation:\n\n- `\"between\"` - Value must be between two values (inclusive)\n- `\"notBetween\"` - Value must not be between two values\n- `\"equal\"` - Value must equal the specified value\n- `\"notEqual\"` - Value must not equal the specified value\n- `\"greaterThan\"` - Value must be greater than the specified value\n- `\"lessThan\"` - Value must be less than the specified value\n- `\"greaterThanOrEqual\"` - Value must be greater than or equal to the specified value\n- `\"lessThanOrEqual\"` - Value must be less than or equal to the specified value","ref":"data_validation.html#available-operators"},{"type":"extras","title":"Complete Example - Data Validation","doc":"Here's a complete example showing various validation rules:\n\n```elixir\nalias UmyaSpreadsheet.{DataValidation}\n\n# Create a spreadsheet with validation\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Categories dropdown in column A\nDataValidation.add_list_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"A2:A100\",\n  [\"Product\", \"Service\", \"Subscription\"],\n  true,\n  \"Invalid Category\",\n  \"Please select a valid category\",\n  \"Category\",\n  \"Select a category for this item\"\n)\n\n# Price in column B (must be positive)\nDataValidation.add_number_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"B2:B100\",\n  \"greaterThan\",\n  0.0,\n  nil,\n  true,\n  \"Invalid Price\",\n  \"Price must be greater than 0\",\n  \"Price\",\n  \"Enter the item price\"\n)\n\n# Release date in column C (must be in the past)\nDataValidation.add_date_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"C2:C100\",\n  \"lessThanOrEqual\",\n  Date.utc_today(),  # Date struct works directly\n  nil,\n  true,\n  \"Invalid Date\",\n  \"Release date must be today or in the past\",\n  \"Release Date\",\n  \"Enter when the item was released\"\n)\n\n# Description in column D (between 10 and 200 chars)\nDataValidation.add_text_length_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"D2:D100\",\n  \"between\",\n  10,\n  200,\n  true,\n  \"Invalid Description\",\n  \"Description must be between 10 and 200 characters\",\n  \"Description\",\n  \"Enter a description (10-200 characters)\"\n)\n\n# SKU in column E (must match pattern using custom formula)\nDataValidation.add_custom_validation(\n  spreadsheet,\n  \"Sheet1\",\n  \"E2:E100\",\n  \"AND(LEN(E2)=8,LEFT(E2,3)=\\\"PRD\\\")\",\n  true,\n  \"Invalid SKU\",\n  \"SKU must be 8 characters and start with PRD\",\n  \"SKU\",\n  \"Enter a SKU (format: PRDxxxxx)\"\n)\n\n# Add headers\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Category\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"Price\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C1\", \"Release Date\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"D1\", \"Description\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"E1\", \"SKU\")\n\n# Make headers bold\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1:E1\", true)\n\n# Save the file\nUmyaSpreadsheet.write_file(spreadsheet, \"product_catalog.xlsx\")\n```","ref":"data_validation.html#complete-example"},{"type":"extras","title":"Example: Analyzing All Validation Types in a Sheet - Data Validation","doc":"```elixir\nalias UmyaSpreadsheet.DataValidation\n\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"my_spreadsheet.xlsx\")\n\n# Print a summary of all validation rules\nsheet_name = \"Sheet1\"\n{:ok, rules} = DataValidation.get_data_validations(spreadsheet, sheet_name)\n\nIO.puts(\"Found #{length(rules)} validation rules in #{sheet_name}\")\n\nEnum.each(rules, fn rule ->\n  IO.puts(\"\\nValidation rule for range: #{rule.range}\")\n  IO.puts(\"Type: #{rule.rule_type}\")\n\n  case rule.rule_type do\n    :list ->\n      IO.puts(\"List items: #{Enum.join(rule.list_items, \", \")}\")\n\n    type when type in [:decimal, :whole] ->\n      IO.puts(\"Number must be #{rule.operator} #{rule.value1}#{if rule.value2, do: \" and #{rule.value2}\", else: \"\"}\")\n\n    :date ->\n      IO.puts(\"Date must be #{rule.operator} #{rule.date1}#{if rule.date2, do: \" and #{rule.date2}\", else: \"\"}\")\n\n    :text_length ->\n      IO.puts(\"Text length must be #{rule.operator} #{rule.length1}#{if rule.length2, do: \" and #{rule.length2}\", else: \"\"}\")\n\n    :custom ->\n      IO.puts(\"Custom formula: #{rule.formula}\")\n\n    _ ->\n      IO.puts(\"Other validation type\")\n  end\n\n  if rule.show_error_message do\n    IO.puts(\"Error message: #{rule.error_title} - #{rule.error_message}\")\n  end\n\n  if rule.show_input_message do\n    IO.puts(\"Input prompt: #{rule.prompt_title} - #{rule.prompt_message}\")\n  end\nend)\n```","ref":"data_validation.html#example-analyzing-all-validation-types-in-a-sheet"},{"type":"extras","title":"Tips for Data Validation - Data Validation","doc":"1. **Error Messages**: Provide clear error messages to guide users when they enter invalid data.\n2. **Input Prompts**: Use prompt titles and messages to provide input instructions.\n3. **Allow Blank**: Set to `false` to require input in cells.\n4. **Custom Formulas**: For complex validation, use custom formulas. Note that formulas should not include the `=` sign at the beginning.\n5. **Testing**: Always test your validation rules by opening the Excel file manually to ensure they work as expected.\n6. **Use Date Structs**: For date validation, you can use either ISO date strings or Elixir Date structs.\n7. **Check Validation First**: Use the utility functions to check if validation exists before attempting to add or modify rules.\n8. **Pattern Matching**: Use pattern matching to efficiently check if validation rules exist (e.g., `{:ok, [_ | _]} = DataValidation.get_data_validations(...)`)","ref":"data_validation.html#tips-for-data-validation"},{"type":"extras","title":"Formula Functions","doc":"# Formula Functions\n\nThis guide covers the advanced formula functionality provided by UmyaSpreadsheet, allowing you to work with cell formulas, array formulas, named ranges, and defined names.","ref":"formula_functions.html"},{"type":"extras","title":"Regular Cell Formulas - Formula Functions","doc":"Regular cell formulas are the most common type of formulas in Excel. They are executed in a single cell and return a single value.\n\n```elixir\nalias UmyaSpreadsheet\n\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Set some values to use in our formula\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", 10)\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", 20)\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A3\", 30)\n\n# Set a formula in cell B1 that sums the values in A1:A3\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"B1\", \"SUM(A1:A3)\")\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"formulas.xlsx\")\n```\n\nNote: When setting formulas, do not include the leading equals sign (`=`). The library adds it automatically.","ref":"formula_functions.html#regular-cell-formulas"},{"type":"extras","title":"Common Formula Examples - Formula Functions","doc":"Here are examples of various formulas you can use:\n\n```elixir\n# Math operations\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"C1\", \"A1+A2\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"C2\", \"A1*A2\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"C3\", \"(A1+A2)/2\")  # Average\n\n# Statistical functions\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"D1\", \"AVERAGE(A1:A10)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"D2\", \"MIN(A1:A10)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"D3\", \"MAX(A1:A10)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"D4\", \"COUNT(A1:A10)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"D5\", \"STDEV(A1:A10)\")\n\n# Text manipulation\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"E1\", \"CONCATENATE(F1, \\\" \\\", G1)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"E2\", \"LEFT(F1, 3)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"E3\", \"RIGHT(F1, 4)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"E4\", \"LEN(F1)\")\n\n# Logical formulas\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"F1\", \"IF(A1>20, \\\"High\\\", \\\"Low\\\")\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"F2\", \"AND(A1>5, A1<25)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"F3\", \"OR(A1<5, A1>25)\")\n\n# Date and time\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"G1\", \"TODAY()\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"G2\", \"NOW()\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"G3\", \"YEAR(TODAY())\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"G4\", \"MONTH(TODAY())\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"G5\", \"DAY(TODAY())\")\n\n# Lookup and reference\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"H1\", \"VLOOKUP(I1, A1:B10, 2, FALSE)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"H2\", \"HLOOKUP(I1, A1:J2, 2, FALSE)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"H3\", \"INDEX(A1:B10, MATCH(I1, A1:A10, 0), 2)\")\n\n# Financial functions\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"I1\", \"PMT(0.05/12, 360, 200000)\")  # Monthly payment for a mortgage\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"I2\", \"FV(0.05/12, 120, -100)\")  # Future value of monthly investment\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"I3\", \"NPV(0.1, B1:B5)\")  # Net Present Value\n```","ref":"formula_functions.html#common-formula-examples"},{"type":"extras","title":"Array Formulas - Formula Functions","doc":"Array formulas can return multiple values across a range of cells. They are especially useful for performing calculations on arrays of values.\n\n```elixir\n# Set an array formula that fills cells C1:C3 with the values from A1:A3\nUmyaSpreadsheet.set_array_formula(spreadsheet, \"Sheet1\", \"C1:C3\", \"A1:A3\")\n\n# Set an array formula that calculates the row numbers\nUmyaSpreadsheet.set_array_formula(spreadsheet, \"Sheet1\", \"D1:D5\", \"ROW(1:5)\")\n```","ref":"formula_functions.html#array-formulas"},{"type":"extras","title":"Practical Array Formula Examples - Formula Functions","doc":"Array formulas are powerful for performing calculations across multiple cells:\n\n```elixir\n# Create a sample spreadsheet with data\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add a table of sales data\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Product\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"Region\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C1\", \"Sales\")\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"Apples\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B2\", \"North\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C2\", 5000)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A3\", \"Apples\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B3\", \"South\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C3\", 4200)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A4\", \"Oranges\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B4\", \"North\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C4\", 3800)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A5\", \"Oranges\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B5\", \"South\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C5\", 4100)\n\n# Example 1: Sum-if array formula to calculate total sales by region\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"E1\", \"Region\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"F1\", \"Total Sales\")\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"E2\", \"North\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"E3\", \"South\")\n\n# Array formula to calculate total sales for North region\nUmyaSpreadsheet.set_array_formula(\n  spreadsheet,\n  \"Sheet1\",\n  \"F2\",\n  \"SUM(IF(B2:B5=\\\"North\\\",C2:C5,0))\"\n)\n\n# Array formula to calculate total sales for South region\nUmyaSpreadsheet.set_array_formula(\n  spreadsheet,\n  \"Sheet1\",\n  \"F3\",\n  \"SUM(IF(B2:B5=\\\"South\\\",C2:C5,0))\"\n)\n\n# Example 2: Array formula to calculate product-wise sales\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"E5\", \"Product\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"F5\", \"Total Sales\")\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"E6\", \"Apples\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"E7\", \"Oranges\")\n\n# Array formula for Apples total sales\nUmyaSpreadsheet.set_array_formula(\n  spreadsheet,\n  \"Sheet1\",\n  \"F6\",\n  \"SUM(IF(A2:A5=\\\"Apples\\\",C2:C5,0))\"\n)\n\n# Array formula for Oranges total sales\nUmyaSpreadsheet.set_array_formula(\n  spreadsheet,\n  \"Sheet1\",\n  \"F7\",\n  \"SUM(IF(A2:A5=\\\"Oranges\\\",C2:C5,0))\"\n)\n\n# Example 3: Array formula for calculating multiple statistics at once\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"H1\", \"Sales Statistics\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"H2\", \"Average\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"H3\", \"Min\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"H4\", \"Max\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"H5\", \"Count\")\n\n# Array formula that populates statistics for Sales data\nUmyaSpreadsheet.set_array_formula(\n  spreadsheet,\n  \"Sheet1\",\n  \"I2:I5\",\n  \"{AVERAGE(C2:C5);MIN(C2:C5);MAX(C2:C5);COUNT(C2:C5)}\"\n)\n```","ref":"formula_functions.html#practical-array-formula-examples"},{"type":"extras","title":"Named Ranges - Formula Functions","doc":"Named ranges allow you to refer to a range of cells by a custom name, making formulas more readable and easier to maintain.\n\n```elixir\n# Create a named range called \"Data\" that refers to cells A1:A10\nUmyaSpreadsheet.create_named_range(spreadsheet, \"Data\", \"Sheet1\", \"A1:A10\")\n\n# Now you can use this named range in a formula\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"B10\", \"SUM(Data)\")\n```","ref":"formula_functions.html#named-ranges"},{"type":"extras","title":"Named Range Examples for Financial Reports - Formula Functions","doc":"Here's a complete example of using named ranges for creating a financial report:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Set up headers and data for a quarterly financial report\nheaders = [\"Q1\", \"Q2\", \"Q3\", \"Q4\", \"Total\"]\nrevenue_data = [125000, 142000, 158000, 175000]\nexpenses_data = [95000, 102000, 110000, 118000]\ncategories = [\"Revenue\", \"Expenses\", \"Profit\"]\n\n# Add headers\nEnum.with_index(headers, fn header, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B#{idx + 1}\", header)\nend)\n\n# Add category labels\nEnum.with_index(categories, fn category, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A#{idx + 2}\", category)\nend)\n\n# Add revenue data\nEnum.with_index(revenue_data, fn value, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B#{2 + 0}\", revenue_data)\nend)\n\n# Add expense data\nEnum.with_index(expenses_data, fn value, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B#{2 + 1}\", expenses_data)\nend)\n\n# Create named ranges for better formula readability\nUmyaSpreadsheet.create_named_range(spreadsheet, \"Revenue\", \"Sheet1\", \"B2:E2\")\nUmyaSpreadsheet.create_named_range(spreadsheet, \"Expenses\", \"Sheet1\", \"B3:E3\")\n\n# Calculate quarterly profits using named ranges\nUmyaSpreadsheet.set_array_formula(spreadsheet, \"Sheet1\", \"B4:E4\", \"Revenue-Expenses\")\n\n# Calculate totals using named ranges\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"F2\", \"SUM(Revenue)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"F3\", \"SUM(Expenses)\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sheet1\", \"F4\", \"SUM(B4:E4)\")\n\n# Add some interesting metrics at the bottom\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A6\", \"Profit Margin (%)\")\nUmyaSpreadsheet.create_named_range(spreadsheet, \"TotalRevenue\", \"Sheet1\", \"F2\")\nUmyaSpreadsheet.create_named_range(spreadsheet, \"TotalProfit\", \"Sheet1\", \"F4\")\n\n# Use named ranges in the profit margin calculation\nUmyaSpreadsheet.set_formula(\n  spreadsheet,\n  \"Sheet1\",\n  \"B6\",\n  \"ROUND((TotalProfit/TotalRevenue)*100, 1)\"\n)\n\n# Format cells (optional)\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1:F1\", true)\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A2:A6\", true)\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"F2:F4\", true)\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"B2:F4\", \"#,##0\")\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Sheet1\", \"B6\", \"0.0%\")\n\n# Save the report\nUmyaSpreadsheet.write(spreadsheet, \"financial_report.xlsx\")\n```","ref":"formula_functions.html#named-range-examples-for-financial-reports"},{"type":"extras","title":"Defined Names - Formula Functions","doc":"Defined names are similar to named ranges but can store formulas or constants instead of just cell references.\n\n```elixir\n# Create a defined name for a constant value\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"TaxRate\", \"0.15\")\n\n# Create a defined name for a formula\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"Subtotal\", \"SUM(A1:A10)\")\n\n# Create a sheet-scoped defined name\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"Department\", \"Sales\", \"Sheet1\")\n```\n\nSheet-scoped defined names are only available within the specified sheet.","ref":"formula_functions.html#defined-names"},{"type":"extras","title":"Advanced Defined Names Example: Sales Calculator - Formula Functions","doc":"Here's a more complex example using defined names to create a sales calculator spreadsheet:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Create a sheet for our calculator\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Sales Calculator\")\n\n# Set up headers and formatting\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A1\", \"Sales Calculator\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sales Calculator\", \"A1\", true)\nUmyaSpreadsheet.set_font_size(spreadsheet, \"Sales Calculator\", \"A1\", 16)\n\n# Input section\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A3\", \"Input Parameters\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sales Calculator\", \"A3\", true)\n\n# Create input fields\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A4\", \"Product Price\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"B4\", 100)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A5\", \"Quantity\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"B5\", 5)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A6\", \"Tax Rate (%)\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"B6\", 15)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A7\", \"Discount Rate (%)\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"B7\", 10)\n\n# Create defined names for all the parameters (easier to maintain formulas)\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"Price\", \"Sales Calculator!B4\")\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"Quantity\", \"Sales Calculator!B5\")\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"TaxRatePercent\", \"Sales Calculator!B6\")\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"DiscountRatePercent\", \"Sales Calculator!B7\")\n\n# Create defined names for calculations (constants)\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"TaxRate\", \"TaxRatePercent/100\")\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"DiscountRate\", \"DiscountRatePercent/100\")\n\n# Output section\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A9\", \"Calculation Results\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sales Calculator\", \"A9\", true)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A10\", \"Subtotal\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A11\", \"Discount Amount\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A12\", \"Net Amount\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A13\", \"Tax Amount\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sales Calculator\", \"A14\", \"Total Due\")\n\n# Create formulas using defined names\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"Subtotal\", \"Price*Quantity\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sales Calculator\", \"B10\", \"Subtotal\")\n\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"DiscountAmount\", \"Subtotal*DiscountRate\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sales Calculator\", \"B11\", \"DiscountAmount\")\n\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"NetAmount\", \"Subtotal-DiscountAmount\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sales Calculator\", \"B12\", \"NetAmount\")\n\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"TaxAmount\", \"NetAmount*TaxRate\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sales Calculator\", \"B13\", \"TaxAmount\")\n\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"TotalDue\", \"NetAmount+TaxAmount\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Sales Calculator\", \"B14\", \"TotalDue\")\n\n# Apply currency formatting to amounts\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Sales Calculator\", \"B10:B14\", \"$#,##0.00\")\n\n# Add a second sheet with alternative tax rates for comparison\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Tax Comparison\")\n\n# Create a defined name that's scoped just to this sheet\nUmyaSpreadsheet.create_defined_name(\n  spreadsheet,\n  \"AlternateTaxRate\",\n  \"0.08\",  # 8% tax rate\n  \"Tax Comparison\"\n)\n\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Tax Comparison\", \"A1\", \"Sales with Alternative Tax Rate\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Tax Comparison\", \"A3\", \"Net Amount\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Tax Comparison\", \"A4\", \"Alternative Tax (8%)\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Tax Comparison\", \"A5\", \"Total with Alternative Tax\")\n\n# Use both global and sheet-specific defined names\nUmyaSpreadsheet.set_formula(spreadsheet, \"Tax Comparison\", \"B3\", \"NetAmount\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Tax Comparison\", \"B4\", \"NetAmount*AlternateTaxRate\")\nUmyaSpreadsheet.set_formula(spreadsheet, \"Tax Comparison\", \"B5\", \"B3+B4\")\n\n# Apply the same currency formatting\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Tax Comparison\", \"B3:B5\", \"$#,##0.00\")\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"sales_calculator.xlsx\")\n```","ref":"formula_functions.html#advanced-defined-names-example-sales-calculator"},{"type":"extras","title":"Listing Defined Names - Formula Functions","doc":"You can retrieve all defined names in a workbook:\n\n```elixir\ncase UmyaSpreadsheet.get_defined_names(spreadsheet) do\n  defined_names when is_list(defined_names) ->\n    # Display all defined names\n    Enum.each(defined_names, fn {name, address} ->\n      IO.puts(\"#{name}: #{address}\")\n    end)\n  {:error, reason} ->\n    IO.puts(\"Error getting defined names: #{reason}\")\nend\nend)\n```","ref":"formula_functions.html#listing-defined-names"},{"type":"extras","title":"Working with Retrieved Defined Names - Formula Functions","doc":"Here's an example of how you might use the `get_defined_names` function to generate documentation for a spreadsheet:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Read an existing spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"financial_model.xlsx\")\n\n# Get a list of all defined names\ncase UmyaSpreadsheet.get_defined_names(spreadsheet) do\n  defined_names when is_list(defined_names) ->\n    # Create a documentation sheet\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Documentation\")\n\n# Add headers\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Documentation\", \"A1\", \"Name\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Documentation\", \"B1\", \"Reference/Formula\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Documentation\", \"C1\", \"Description\")\n\n# Format headers\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Documentation\", \"A1:C1\", true)\nUmyaSpreadsheet.set_background_color(spreadsheet, \"Documentation\", \"A1:C1\", \"DDDDDD\")\n\n# Add all defined names to the documentation sheet\nEnum.with_index(defined_names, fn {name, address}, index ->\n  row = index + 2  # Start from row 2 (after headers)\n\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Documentation\", \"A#{row}\", name)\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Documentation\", \"B#{row}\", address)\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Documentation\", \"C#{row}\", \"\")  # Empty description for user to fill\nend)\n\n# Auto-adjust column widths for better readability\nUmyaSpreadsheet.set_column_auto_width(spreadsheet, \"Documentation\", \"A\", true)\nUmyaSpreadsheet.set_column_auto_width(spreadsheet, \"Documentation\", \"B\", true)\nUmyaSpreadsheet.set_column_width(spreadsheet, \"Documentation\", \"C\", 50.0)  # Wide column for descriptions\n\n# Save the updated spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"financial_model_documented.xlsx\")\n```\n\nAnother practical application is to build a workbook analyzer that reports on formula complexity:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Function to analyze a spreadsheet for complex formulas\ndef analyze_spreadsheet_formulas(path) do\n  {:ok, spreadsheet} = UmyaSpreadsheet.read(path)\n\n  case UmyaSpreadsheet.get_defined_names(spreadsheet) do\n    defined_names when is_list(defined_names) ->\n      # Group defined names by their complexity\n  {simple_formulas, complex_formulas} = Enum.split_with(defined_names, fn {_name, formula} ->\n    # Simple heuristic: formulas with fewer than 3 operators are \"simple\"\n    operator_count = formula\n      |> String.graphemes()\n      |> Enum.count(fn char -> char in [\"+\", \"-\", \"*\", \"/\", \"=\", \">\", \"<\"] end)\n\n    operator_count < 3\n  end)\n\n  # Report on findings\n  IO.puts(\"Spreadsheet Formula Analysis: #{path}\")\n  IO.puts(\"Total defined names: #{length(defined_names)}\")\n  IO.puts(\"Simple formulas: #{length(simple_formulas)}\")\n  IO.puts(\"Complex formulas: #{length(complex_formulas)}\")\n\n  IO.puts(\"\\nMost complex formulas:\")\n  complex_formulas\n  |> Enum.sort_by(fn {_name, formula} -> String.length(formula) end, :desc)\n  |> Enum.take(5)\n  |> Enum.each(fn {name, formula} ->\n    IO.puts(\"#{name}: #{if String.length(formula) > 50, do: String.slice(formula, 0, 47) <> \"...\", else: formula}\")\n  end)\n\n  # Return analysis results\n  %{\n    total: length(defined_names),\n    simple: length(simple_formulas),\n    complex: length(complex_formulas),\n    most_complex: Enum.take(complex_formulas, 5)\n  }\nend\n\n# Example usage\nanalysis = analyze_spreadsheet_formulas(\"complex_financial_model.xlsx\")\n```","ref":"formula_functions.html#working-with-retrieved-defined-names"},{"type":"extras","title":"Best Practices - Formula Functions","doc":"1. **Clear Naming**: Use descriptive names for named ranges and defined names\n2. **Avoid Hardcoding**: Use named ranges and defined names instead of hardcoded cell references\n3. **Documentation**: Add comments in your code to explain what formulas are doing\n4. **Error Handling**: Always check the return values of formula functions\n5. **Cell References**: When referencing cells in other sheets, use the format `SheetName!CellAddress`","ref":"formula_functions.html#best-practices"},{"type":"extras","title":"Real-World Example: Financial Dashboard - Formula Functions","doc":"Here's a comprehensive example that combines regular formulas, array formulas, named ranges, and defined names to create a financial dashboard:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Create a new spreadsheet for our financial dashboard\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Rename the default sheet to \"Data\"\nsheet_names = UmyaSpreadsheet.get_sheet_names(spreadsheet)\nfirst_sheet = List.first(sheet_names)\n\nif first_sheet != \"Data\" do\n  UmyaSpreadsheet.clone_sheet(spreadsheet, first_sheet, \"Data\")\n  UmyaSpreadsheet.remove_sheet(spreadsheet, first_sheet)\nend\n\n# Add sheets for our dashboard\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Dashboard\")\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Charts\")\n\n# Set Data sheet as active when opening\nsheet_names = UmyaSpreadsheet.get_sheet_names(spreadsheet)\ndashboard_index = Enum.find_index(sheet_names, fn name -> name == \"Dashboard\" end)\nUmyaSpreadsheet.set_active_tab(spreadsheet, dashboard_index)\n\n# ----- Data Sheet Setup -----\n\n# Add monthly sales data for different regions\nmonths = [\"Jan\", \"Feb\", \"Mar\", \"Apr\", \"May\", \"Jun\"]\nregions = [\"North\", \"South\", \"East\", \"West\"]\n\n# Create headers\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"A1\", \"Month\")\nregions |> Enum.with_index(fn region, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"#{<<66 + idx::utf8>>}1\", region)\nend)\n\n# Add data rows\nmonths |> Enum.with_index(fn month, row_idx ->\n  row = row_idx + 2\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"A#{row}\", month)\n\n  regions |> Enum.with_index(fn _region, col_idx ->\n    col = <<66 + col_idx::utf8>>\n    # Generate some sample sales data (in a real app, this would be actual data)\n    sales = :rand.uniform(10000) + 5000\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"#{col}#{row}\", sales)\n  end)\nend)\n\n# Add cost percentages\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"G1\", \"Cost Factors\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"G2\", \"COGS %\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"G3\", \"Marketing %\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"G4\", \"Admin %\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"H2\", 0.38)  # 38% cost of goods sold\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"H3\", 0.15)  # 15% marketing expenses\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"H4\", 0.12)  # 12% administrative expenses\n\n# Create named ranges for our data\nUmyaSpreadsheet.create_named_range(spreadsheet, \"MonthNames\", \"Data\", \"A2:A7\")\nUmyaSpreadsheet.create_named_range(spreadsheet, \"NorthSales\", \"Data\", \"B2:B7\")\nUmyaSpreadsheet.create_named_range(spreadsheet, \"SouthSales\", \"Data\", \"C2:C7\")\nUmyaSpreadsheet.create_named_range(spreadsheet, \"EastSales\", \"Data\", \"D2:D7\")\nUmyaSpreadsheet.create_named_range(spreadsheet, \"WestSales\", \"Data\", \"E2:E7\")\nUmyaSpreadsheet.create_named_range(spreadsheet, \"AllSales\", \"Data\", \"B2:E7\")\n\n# Create defined names for our constants\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"COGS_RATE\", \"Data!H2\")\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"MARKETING_RATE\", \"Data!H3\")\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"ADMIN_RATE\", \"Data!H4\")\nUmyaSpreadsheet.create_defined_name(spreadsheet, \"PROFIT_RATE\", \"1-COGS_RATE-MARKETING_RATE-ADMIN_RATE\")\n\n# ----- Dashboard Sheet Setup -----\n\n# Create a dashboard title\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A1\", \"SALES DASHBOARD\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Dashboard\", \"A1\", true)\nUmyaSpreadsheet.set_font_size(spreadsheet, \"Dashboard\", \"A1\", 16)\n\n# Setup monthly totals section\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A3\", \"Monthly Summary\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Dashboard\", \"A3\", true)\n\n# Add month headers in the dashboard\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A4\", \"Month\")\nmonths |> Enum.with_index(fn month, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A#{5 + idx}\", month)\nend)\n\n# Add KPI columns\nmetrics = [\"Total Sales\", \"COGS\", \"Marketing\", \"Admin\", \"Profit\"]\nmetrics |> Enum.with_index(fn metric, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"#{<<66 + idx::utf8>>}4\", metric)\nend)\n\n# Create formulas for the dashboard calculations\nmonths |> Enum.with_index(fn _month, row_idx ->\n  row = row_idx + 5\n  data_row = row_idx + 2  # Corresponding row in Data sheet\n\n  # Total Sales (sum across all regions)\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"B#{row}\",\n    \"SUM(Data!B#{data_row}:E#{data_row})\"\n  )\n\n  # COGS (using defined name)\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"C#{row}\",\n    \"B#{row}*COGS_RATE\"\n  )\n\n  # Marketing expenses\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"D#{row}\",\n    \"B#{row}*MARKETING_RATE\"\n  )\n\n  # Admin expenses\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"E#{row}\",\n    \"B#{row}*ADMIN_RATE\"\n  )\n\n  # Profit calculation\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"F#{row}\",\n    \"B#{row}-C#{row}-D#{row}-E#{row}\"\n  )\nend)\n\n# Add totals row using array formulas\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A11\", \"TOTAL\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Dashboard\", \"A11\", true)\n\n[\"B\", \"C\", \"D\", \"E\", \"F\"] |> Enum.each(fn col ->\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"#{col}11\",\n    \"SUM(#{col}5:#{col}10)\"\n  )\n  UmyaSpreadsheet.set_font_bold(spreadsheet, \"Dashboard\", \"#{col}11\", true)\nend)\n\n# Add regional analysis section\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A13\", \"Regional Analysis\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Dashboard\", \"A13\", true)\n\n# Add region headers\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A14\", \"Region\")\nregions |> Enum.with_index(fn region, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A#{15 + idx}\", region)\nend)\n\n# Add KPI columns for regions\n[\"Total\", \"Average\", \"Min\", \"Max\", \"% of Total\"] |> Enum.with_index(fn metric, idx ->\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"#{<<66 + idx::utf8>>}14\", metric)\nend)\n\n# Create array formulas for regional analysis\nnamed_ranges = [\"NorthSales\", \"SouthSales\", \"EastSales\", \"WestSales\"]\nnamed_ranges |> Enum.with_index(fn range_name, idx ->\n  row = 15 + idx\n\n  # Total for region\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"B#{row}\",\n    \"SUM(#{range_name})\"\n  )\n\n  # Average for region\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"C#{row}\",\n    \"AVERAGE(#{range_name})\"\n  )\n\n  # Min for region\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"D#{row}\",\n    \"MIN(#{range_name})\"\n  )\n\n  # Max for region\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"E#{row}\",\n    \"MAX(#{range_name})\"\n  )\n\n  # Percentage of total\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"F#{row}\",\n    \"B#{row}/B19\"\n  )\nend)\n\n# Add Grand Total for regions\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"A19\", \"GRAND TOTAL\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Dashboard\", \"A19\", true)\n\n[\"B\", \"C\", \"D\", \"E\"] |> Enum.each(fn col ->\n  UmyaSpreadsheet.set_formula(\n    spreadsheet,\n    \"Dashboard\",\n    \"#{col}19\",\n    \"SUM(#{col}15:#{col}18)\"\n  )\n  UmyaSpreadsheet.set_font_bold(spreadsheet, \"Dashboard\", \"#{col}19\", true)\nend)\n\n# Set F19 to 100%\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Dashboard\", \"F19\", 1)\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Dashboard\", \"F19\", true)\n\n# Format the dashboard\n# Set number formatting\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Dashboard\", \"B5:B19\", \"$#,##0\")\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Dashboard\", \"C5:F11\", \"$#,##0\")\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Dashboard\", \"B15:E19\", \"$#,##0\")\nUmyaSpreadsheet.set_number_format(spreadsheet, \"Dashboard\", \"F15:F19\", \"0.0%\")\n\n# Add a chart to the Charts sheet\nUmyaSpreadsheet.add_chart(\n  spreadsheet,\n  \"Charts\",\n  \"ColumnChart\",\n  \"B2\",\n  \"H15\",\n  \"Monthly Sales by Region\",\n  [\"Data!B2:B7\", \"Data!C2:C7\", \"Data!D2:D7\", \"Data!E2:E7\"],\n  \"Data!A2:A7\"\n)\n\nUmyaSpreadsheet.add_chart(\n  spreadsheet,\n  \"Charts\",\n  \"PieChart\",\n  \"B17\",\n  \"H30\",\n  \"Regional Sales Distribution\",\n  [\"Dashboard!B15:B18\"],\n  \"Dashboard!A15:A18\"\n)\n\n# Save the dashboard spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"sales_dashboard.xlsx\")\n```","ref":"formula_functions.html#real-world-example-financial-dashboard"},{"type":"extras","title":"Working with Formula Properties - Formula Functions","doc":"UmyaSpreadsheet provides several functions to retrieve formula properties from cells:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Create a spreadsheet with a formula\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\nUmyaSpreadsheet.set_array_formula(spreadsheet, \"Sheet1\", \"A1:A3\", \"ROW(1:3)\")\n\n# Check if a cell contains a formula\nis_formula = UmyaSpreadsheet.is_formula(spreadsheet, \"Sheet1\", \"A1\")\n# => true\n\n# Get the formula text from a cell\nformula = UmyaSpreadsheet.get_formula(spreadsheet, \"Sheet1\", \"A1\")\n# => \"=ROW(1:3)\"\n\n# Get formula type (Normal, Array, DataTable, Shared)\ntype = UmyaSpreadsheet.get_formula_type(spreadsheet, \"Sheet1\", \"A1\")\n# => \"Array\"\n\n# Get the formula shared index (for shared formulas)\nshared_index = UmyaSpreadsheet.get_formula_shared_index(spreadsheet, \"Sheet1\", \"A1\")\n# => nil (for non-shared formulas)\n\n# Get the complete formula object with all details\n{text, type, shared_index, reference} = UmyaSpreadsheet.get_formula_obj(spreadsheet, \"Sheet1\", \"A1\")\n# => {\"=ROW(1:3)\", \"Array\", nil, nil}\n```","ref":"formula_functions.html#working-with-formula-properties"},{"type":"extras","title":"Formula Property Return Values - Formula Functions","doc":"When a property is not applicable to a particular formula, the getter functions return `nil`:\n\n- Integer properties (like `shared_index`) return `nil` instead of `0` when not applicable\n- Boolean properties (like `bx`, `data_table_2d`) return `nil` instead of `false` when not applicable\n- String properties (like `r1`, `r2`) return `nil` instead of empty strings when not applicable\n\nThis makes it easier to distinguish between default values and actual property values.","ref":"formula_functions.html#formula-property-return-values"},{"type":"extras","title":"Limitations - Formula Functions","doc":"- The library doesn't calculate formula results; it only stores the formula text\n- Excel evaluates the formulas when the file is opened\n- Some advanced Excel formula features may not be fully supported\n- Array formulas require Excel to correctly interpret them\n- Special care must be taken to format formulas correctly for Excel compatibility","ref":"formula_functions.html#limitations"},{"type":"extras","title":"Excel Hyperlinks Guide","doc":"# Excel Hyperlinks Guide\n\nThis guide covers the comprehensive hyperlink functionality available in UmyaSpreadsheet, including creating, managing, and removing hyperlinks from Excel spreadsheets.","ref":"hyperlinks.html"},{"type":"extras","title":"Table of Contents - Excel Hyperlinks Guide","doc":"1. [Overview](#overview)\n2. [Quick Start](#quick-start)\n3. [Basic Hyperlink Operations](#basic-hyperlink-operations)\n4. [Advanced Hyperlink Features](#advanced-hyperlink-features)\n5. [Hyperlink Types and Examples](#hyperlink-types-and-examples)\n6. [Best Practices](#best-practices)\n7. [Error Handling](#error-handling)\n8. [Performance Considerations](#performance-considerations)\n9. [Real-World Examples](#real-world-examples)","ref":"hyperlinks.html#table-of-contents"},{"type":"extras","title":"Overview - Excel Hyperlinks Guide","doc":"UmyaSpreadsheet provides a complete API for managing hyperlinks in Excel files. Hyperlinks can point to:\n\n- **Web URLs** (HTTP/HTTPS) - External websites and web services\n- **Email addresses** (mailto) - Direct email composition\n- **File paths** - Local and network files\n- **Internal references** - Other worksheets and cell ranges within the same workbook","ref":"hyperlinks.html#overview"},{"type":"extras","title":"Key Features - Excel Hyperlinks Guide","doc":"- ✅ **Complete CRUD Operations** - Create, Read, Update, Delete hyperlinks\n- ✅ **Multiple Hyperlink Types** - Web, email, file, and internal references\n- ✅ **Rich Metadata** - Custom tooltips and descriptions\n- ✅ **Bulk Operations** - Add or remove multiple hyperlinks efficiently\n- ✅ **Integration with Cell Values** - Hyperlinks work alongside cell content\n- ✅ **Worksheet-Level Management** - Query and manage all hyperlinks in a sheet","ref":"hyperlinks.html#key-features"},{"type":"extras","title":"Quick Start - Excel Hyperlinks Guide","doc":"Here's a simple example to get you started with hyperlinks:\n\n```elixir\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add a web URL hyperlink\n{:ok, _} = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1\",\n  \"https://example.com\",\n  \"Visit our website\"\n)\n\n# Add an internal reference\n{:ok, _} = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"B1\",\n  \"Sheet2!A1\",\n  \"Go to Sheet2\",\n  true  # is_internal = true\n)\n\n# Get hyperlink information\n{:ok, hyperlink_info} = UmyaSpreadsheet.get_hyperlink(spreadsheet, \"Sheet1\", \"A1\")\nIO.inspect(hyperlink_info)\n# Output: %{\n#   \"url\" => \"https://example.com\",\n#   \"tooltip\" => \"Visit our website\",\n#   \"location\" => \"A1\"\n# }\n\n# Save the spreadsheet\n:ok = UmyaSpreadsheet.write(spreadsheet, \"output/hyperlinks_example.xlsx\")\n```","ref":"hyperlinks.html#quick-start"},{"type":"extras","title":"Basic Hyperlink Operations - Excel Hyperlinks Guide","doc":"","ref":"hyperlinks.html#basic-hyperlink-operations"},{"type":"extras","title":"Adding Hyperlinks - Excel Hyperlinks Guide","doc":"#### Simple Web URL\n\n```elixir\n# Basic hyperlink without tooltip\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1\",\n  \"https://google.com\"\n)\n\n# Hyperlink with tooltip\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"A2\",\n  \"https://github.com\",\n  \"GitHub Repository\"\n)\n```\n\n#### Email Links\n\n```elixir\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"B1\",\n  \"mailto:contact@example.com\",\n  \"Send us an email\"\n)\n\n# Email with subject and body\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"B2\",\n  \"mailto:support@example.com?subject=Support%20Request&body=Hello,%20I%20need%20help\",\n  \"Contact Support\"\n)\n```\n\n#### File Path Links\n\n```elixir\n# Local file\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"C1\",\n  \"file:///Users/username/Documents/report.pdf\",\n  \"Open Report\"\n)\n\n# Network file\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"C2\",\n  \"file://server/shared/documents/manual.docx\",\n  \"User Manual\"\n)\n```\n\n#### Internal Worksheet References\n\n```elixir\n# Reference to another sheet\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"D1\",\n  \"Sheet2!A1\",\n  \"Go to Sheet2 Cell A1\",\n  true  # is_internal = true\n)\n\n# Reference to a range\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"D2\",\n  \"Data!A1:C10\",\n  \"View Data Range\",\n  true\n)\n```","ref":"hyperlinks.html#adding-hyperlinks"},{"type":"extras","title":"Getting Hyperlink Information - Excel Hyperlinks Guide","doc":"```elixir\n# Get single hyperlink\ncase UmyaSpreadsheet.get_hyperlink(spreadsheet, \"Sheet1\", \"A1\") do\n  {:ok, hyperlink_info} ->\n    url = hyperlink_info[\"url\"]\n    tooltip = hyperlink_info[\"tooltip\"]\n    location = hyperlink_info[\"location\"]\n    IO.puts(\"Found hyperlink: #{url}\")\n\n  {:error, :not_found} ->\n    IO.puts(\"No hyperlink found in cell A1\")\n\n  {:error, reason} ->\n    IO.puts(\"Error: #{reason}\")\nend\n```","ref":"hyperlinks.html#getting-hyperlink-information"},{"type":"extras","title":"Checking for Hyperlinks - Excel Hyperlinks Guide","doc":"```elixir\n# Check if a specific cell has a hyperlink\n{:ok, has_link} = UmyaSpreadsheet.has_hyperlink(spreadsheet, \"Sheet1\", \"A1\")\n\nif has_link do\n  IO.puts(\"Cell A1 has a hyperlink\")\nelse\n  IO.puts(\"Cell A1 does not have a hyperlink\")\nend\n\n# Check if worksheet has any hyperlinks\n{:ok, has_any} = UmyaSpreadsheet.has_hyperlinks(spreadsheet, \"Sheet1\")\n```","ref":"hyperlinks.html#checking-for-hyperlinks"},{"type":"extras","title":"Updating Hyperlinks - Excel Hyperlinks Guide","doc":"```elixir\n# Update existing hyperlink\n:ok = UmyaSpreadsheet.update_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1\",\n  \"https://newexample.com\",\n  \"Updated tooltip\"\n)\n\n# Convert external to internal reference\n:ok = UmyaSpreadsheet.update_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1\",\n  \"Summary!B5\",\n  \"Go to Summary\",\n  true  # is_internal = true\n)\n```","ref":"hyperlinks.html#updating-hyperlinks"},{"type":"extras","title":"Removing Hyperlinks - Excel Hyperlinks Guide","doc":"```elixir\n# Remove single hyperlink (preserves cell value)\n:ok = UmyaSpreadsheet.remove_hyperlink(spreadsheet, \"Sheet1\", \"A1\")\n\n# Remove all hyperlinks from worksheet\n:ok = UmyaSpreadsheet.remove_all_hyperlinks(spreadsheet, \"Sheet1\")\n```","ref":"hyperlinks.html#removing-hyperlinks"},{"type":"extras","title":"Advanced Hyperlink Features - Excel Hyperlinks Guide","doc":"","ref":"hyperlinks.html#advanced-hyperlink-features"},{"type":"extras","title":"Getting All Hyperlinks from a Worksheet - Excel Hyperlinks Guide","doc":"```elixir\n{:ok, hyperlinks} = UmyaSpreadsheet.get_hyperlinks(spreadsheet, \"Sheet1\")\n\nEnum.each(hyperlinks, fn hyperlink ->\n  IO.puts(\"Cell: #{hyperlink[\"cell\"]}\")\n  IO.puts(\"URL: #{hyperlink[\"url\"]}\")\n  IO.puts(\"Tooltip: #{hyperlink[\"tooltip\"]}\")\n  IO.puts(\"---\")\nend)\n```","ref":"hyperlinks.html#getting-all-hyperlinks-from-a-worksheet"},{"type":"extras","title":"Bulk Hyperlink Operations - Excel Hyperlinks Guide","doc":"```elixir\n# Add multiple hyperlinks at once\nhyperlinks = [\n  {\"A1\", \"https://example.com\", \"Website\"},\n  {\"A2\", \"mailto:test@example.com\", \"Email\"},\n  {\"A3\", \"Sheet2!A1\", \"Internal link\", true},\n  {\"A4\", \"file:///path/to/file.pdf\", \"Document\"}\n]\n\n:ok = UmyaSpreadsheet.add_bulk_hyperlinks(spreadsheet, \"Sheet1\", hyperlinks)\n\n# Using map format\nhyperlinks_map = [\n  %{cell: \"B1\", url: \"https://github.com\", tooltip: \"GitHub\"},\n  %{cell: \"B2\", url: \"mailto:dev@example.com\", tooltip: \"Developer Email\"},\n  %{cell: \"B3\", url: \"Config!A1\", tooltip: \"Config Sheet\", is_internal: true}\n]\n\n:ok = UmyaSpreadsheet.add_bulk_hyperlinks(spreadsheet, \"Sheet1\", hyperlinks_map)\n```","ref":"hyperlinks.html#bulk-hyperlink-operations"},{"type":"extras","title":"Counting Hyperlinks - Excel Hyperlinks Guide","doc":"```elixir\n{:ok, count} = UmyaSpreadsheet.count_hyperlinks(spreadsheet, \"Sheet1\")\nIO.puts(\"Sheet1 has #{count} hyperlinks\")\n```","ref":"hyperlinks.html#counting-hyperlinks"},{"type":"extras","title":"Hyperlinks with Cell Values - Excel Hyperlinks Guide","doc":"```elixir\n# Set cell value and add hyperlink\n:ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Click Here\")\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1\",\n  \"https://example.com\",\n  \"Visit our website\"\n)\n\n# The cell will display \"Click Here\" as clickable text\n```","ref":"hyperlinks.html#hyperlinks-with-cell-values"},{"type":"extras","title":"Hyperlink Types and Examples - Excel Hyperlinks Guide","doc":"","ref":"hyperlinks.html#hyperlink-types-and-examples"},{"type":"extras","title":"1. Web URLs - Excel Hyperlinks Guide","doc":"```elixir\n# HTTPS (secure)\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"A1\",\n  \"https://secure.example.com\", \"Secure Site\"\n)\n\n# HTTP (unsecure)\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"A2\",\n  \"http://example.com\", \"Regular Site\"\n)\n\n# FTP\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"A3\",\n  \"ftp://files.example.com\", \"FTP Server\"\n)\n```","ref":"hyperlinks.html#1-web-urls"},{"type":"extras","title":"2. Email Addresses - Excel Hyperlinks Guide","doc":"```elixir\n# Simple email\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"B1\",\n  \"mailto:contact@example.com\", \"Contact Us\"\n)\n\n# Email with subject\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"B2\",\n  \"mailto:support@example.com?subject=Help%20Request\", \"Get Help\"\n)\n\n# Email with multiple recipients\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"B3\",\n  \"mailto:sales@example.com?cc=manager@example.com&bcc=archive@example.com\",\n  \"Contact Sales Team\"\n)\n```","ref":"hyperlinks.html#2-email-addresses"},{"type":"extras","title":"3. File Paths - Excel Hyperlinks Guide","doc":"```elixir\n# Windows local file\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"C1\",\n  \"file:///C:/Documents/report.pdf\", \"Windows Report\"\n)\n\n# macOS/Linux local file\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"C2\",\n  \"file:///Users/username/Documents/data.xlsx\", \"Data File\"\n)\n\n# Network share (Windows)\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"C3\",\n  \"file://server/share/documents/manual.docx\", \"Network Manual\"\n)\n```","ref":"hyperlinks.html#3-file-paths"},{"type":"extras","title":"4. Internal References - Excel Hyperlinks Guide","doc":"```elixir\n# Reference to specific cell\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"D1\",\n  \"Summary!B5\", \"Go to Summary B5\", true\n)\n\n# Reference to named range\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"D2\",\n  \"DataTable\", \"View Data Table\", true\n)\n\n# Reference to cell range\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"D3\",\n  \"Charts!A1:F20\", \"View Charts Area\", true\n)\n```","ref":"hyperlinks.html#4-internal-references"},{"type":"extras","title":"Best Practices - Excel Hyperlinks Guide","doc":"","ref":"hyperlinks.html#best-practices"},{"type":"extras","title":"1. URL Validation - Excel Hyperlinks Guide","doc":"```elixir\ndefmodule HyperlinkHelpers do\n  def validate_url(url) do\n    case URI.parse(url) do\n      %URI{scheme: scheme} when scheme in [\"http\", \"https\", \"mailto\", \"file\"] ->\n        {:ok, url}\n      _ ->\n        {:error, :invalid_url}\n    end\n  end\n\n  def add_safe_hyperlink(spreadsheet, sheet_name, cell, url, tooltip \\\\ nil) do\n    case validate_url(url) do\n      {:ok, valid_url} ->\n        UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, valid_url, tooltip)\n      {:error, reason} ->\n        {:error, reason}\n    end\n  end\nend\n\n# Usage\ncase HyperlinkHelpers.add_safe_hyperlink(spreadsheet, \"Sheet1\", \"A1\", \"https://example.com\") do\n  :ok -> IO.puts(\"Hyperlink added successfully\")\n  {:error, :invalid_url} -> IO.puts(\"Invalid URL format\")\nend\n```","ref":"hyperlinks.html#1-url-validation"},{"type":"extras","title":"2. Tooltips for User Experience - Excel Hyperlinks Guide","doc":"```elixir\n# Descriptive tooltips help users understand the link destination\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"A1\",\n  \"https://api.example.com/docs\",\n  \"API Documentation - Authentication, endpoints, and examples\"\n)\n\n:ok = UmyaSpreadsheet.add_hyperlink(\n  spreadsheet, \"Sheet1\", \"A2\",\n  \"mailto:support@example.com\",\n  \"Contact technical support (Response within 24 hours)\"\n)\n```","ref":"hyperlinks.html#2-tooltips-for-user-experience"},{"type":"extras","title":"3. Organizing Hyperlinks - Excel Hyperlinks Guide","doc":"```elixir\ndefmodule SpreadsheetBuilder do\n  def add_navigation_section(spreadsheet, sheet_name) do\n    navigation_links = [\n      {\"A1\", \"Summary!A1\", \"📊 Summary Dashboard\", true},\n      {\"A2\", \"Data!A1\", \"📈 Raw Data\", true},\n      {\"A3\", \"Charts!A1\", \"📉 Charts & Graphs\", true},\n      {\"A4\", \"Settings!A1\", \"⚙️ Configuration\", true}\n    ]\n\n    # Add section header\n    :ok = UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A0\", \"Navigation\")\n\n    # Add all navigation links\n    Enum.each(navigation_links, fn {cell, url, tooltip, is_internal} ->\n      UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, url, tooltip, is_internal)\n    end)\n  end\nend\n```","ref":"hyperlinks.html#3-organizing-hyperlinks"},{"type":"extras","title":"4. Error Recovery - Excel Hyperlinks Guide","doc":"```elixir\ndefmodule HyperlinkManager do\n  def add_with_retry(spreadsheet, sheet_name, cell, url, tooltip, retries \\\\ 3) do\n    case UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, url, tooltip) do\n      :ok ->\n        :ok\n      {:error, reason} when retries > 0 ->\n        :timer.sleep(100)\n        add_with_retry(spreadsheet, sheet_name, cell, url, tooltip, retries - 1)\n      {:error, reason} ->\n        {:error, reason}\n    end\n  end\n\n  def safe_bulk_add(spreadsheet, sheet_name, hyperlinks) do\n    Enum.reduce_while(hyperlinks, [], fn hyperlink_spec, acc ->\n      case process_hyperlink(spreadsheet, sheet_name, hyperlink_spec) do\n        :ok ->\n          {:cont, [hyperlink_spec | acc]}\n        {:error, reason} ->\n          {:halt, {:error, reason, acc}}\n      end\n    end)\n  end\n\n  defp process_hyperlink(spreadsheet, sheet_name, {cell, url, tooltip, is_internal}) do\n    UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, url, tooltip, is_internal)\n  end\n\n  defp process_hyperlink(spreadsheet, sheet_name, {cell, url, tooltip}) do\n    UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, url, tooltip)\n  end\n\n  defp process_hyperlink(spreadsheet, sheet_name, {cell, url}) do\n    UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, url)\n  end\nend\n```","ref":"hyperlinks.html#4-error-recovery"},{"type":"extras","title":"Error Handling - Excel Hyperlinks Guide","doc":"","ref":"hyperlinks.html#error-handling"},{"type":"extras","title":"Common Error Scenarios - Excel Hyperlinks Guide","doc":"```elixir\n# Handle missing sheets\ncase UmyaSpreadsheet.add_hyperlink(spreadsheet, \"NonExistentSheet\", \"A1\", \"https://example.com\") do\n  :ok ->\n    IO.puts(\"Success\")\n  {:error, \"Sheet not found\"} ->\n    IO.puts(\"Sheet doesn't exist - creating it first\")\n    :ok = UmyaSpreadsheet.add_worksheet(spreadsheet, \"NonExistentSheet\")\n    :ok = UmyaSpreadsheet.add_hyperlink(spreadsheet, \"NonExistentSheet\", \"A1\", \"https://example.com\")\nend\n\n# Handle invalid cell references\ncase UmyaSpreadsheet.add_hyperlink(spreadsheet, \"Sheet1\", \"INVALID\", \"https://example.com\") do\n  :ok ->\n    IO.puts(\"Success\")\n  {:error, reason} ->\n    IO.puts(\"Invalid cell reference: #{reason}\")\nend\n\n# Handle update of non-existent hyperlinks\ncase UmyaSpreadsheet.update_hyperlink(spreadsheet, \"Sheet1\", \"A1\", \"https://new.com\") do\n  :ok ->\n    IO.puts(\"Updated successfully\")\n  {:error, \"No hyperlink found in cell to update\"} ->\n    IO.puts(\"No existing hyperlink - adding new one\")\n    :ok = UmyaSpreadsheet.add_hyperlink(spreadsheet, \"Sheet1\", \"A1\", \"https://new.com\")\nend\n```","ref":"hyperlinks.html#common-error-scenarios"},{"type":"extras","title":"Error Recovery Patterns - Excel Hyperlinks Guide","doc":"```elixir\ndefmodule RobustHyperlinkOperations do\n  def ensure_hyperlink_exists(spreadsheet, sheet_name, cell, url, tooltip \\\\ nil) do\n    case UmyaSpreadsheet.get_hyperlink(spreadsheet, sheet_name, cell) do\n      {:ok, _existing} ->\n        # Hyperlink exists, optionally update it\n        UmyaSpreadsheet.update_hyperlink(spreadsheet, sheet_name, cell, url, tooltip)\n\n      {:error, :not_found} ->\n        # No hyperlink, add new one\n        UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, url, tooltip)\n\n      {:error, reason} ->\n        {:error, reason}\n    end\n  end\n\n  def cleanup_broken_hyperlinks(spreadsheet, sheet_name) do\n    case UmyaSpreadsheet.get_hyperlinks(spreadsheet, sheet_name) do\n      {:ok, hyperlinks} ->\n        broken_links = Enum.filter(hyperlinks, &is_broken_link?/1)\n\n        Enum.each(broken_links, fn %{\"cell\" => cell} ->\n          UmyaSpreadsheet.remove_hyperlink(spreadsheet, sheet_name, cell)\n        end)\n\n        {:ok, length(broken_links)}\n\n      {:error, reason} ->\n        {:error, reason}\n    end\n  end\n\n  defp is_broken_link?(%{\"url\" => url}) do\n    # Custom logic to check if URL is broken\n    String.contains?(url, \"broken\") or String.length(url) == 0\n  end\nend\n```","ref":"hyperlinks.html#error-recovery-patterns"},{"type":"extras","title":"Performance Considerations - Excel Hyperlinks Guide","doc":"","ref":"hyperlinks.html#performance-considerations"},{"type":"extras","title":"1. Bulk Operations - Excel Hyperlinks Guide","doc":"```elixir\n# ❌ Inefficient - Multiple individual calls\nEnum.each(1..100, fn i ->\n  UmyaSpreadsheet.add_hyperlink(\n    spreadsheet, \"Sheet1\", \"A#{i}\",\n    \"https://example.com/page#{i}\",\n    \"Page #{i}\"\n  )\nend)\n\n# ✅ Efficient - Single bulk operation\nhyperlinks = Enum.map(1..100, fn i ->\n  {\"A#{i}\", \"https://example.com/page#{i}\", \"Page #{i}\"}\nend)\n\n:ok = UmyaSpreadsheet.add_bulk_hyperlinks(spreadsheet, \"Sheet1\", hyperlinks)\n```","ref":"hyperlinks.html#1-bulk-operations"},{"type":"extras","title":"2. Memory Management - Excel Hyperlinks Guide","doc":"```elixir\n# Process hyperlinks in batches for large datasets\ndefmodule BatchProcessor do\n  def process_hyperlinks_in_batches(spreadsheet, sheet_name, hyperlinks, batch_size \\\\ 50) do\n    hyperlinks\n    |> Enum.chunk_every(batch_size)\n    |> Enum.reduce(:ok, fn batch, :ok ->\n      UmyaSpreadsheet.add_bulk_hyperlinks(spreadsheet, sheet_name, batch)\n    end)\n  end\nend\n```","ref":"hyperlinks.html#2-memory-management"},{"type":"extras","title":"3. Lazy Loading - Excel Hyperlinks Guide","doc":"```elixir\n# Only load hyperlink information when needed\ndefmodule LazyHyperlinkInfo do\n  def get_hyperlink_lazy(spreadsheet, sheet_name, cell) do\n    fn ->\n      UmyaSpreadsheet.get_hyperlink(spreadsheet, sheet_name, cell)\n    end\n  end\n\n  def get_all_hyperlinks_stream(spreadsheet, sheet_name) do\n    case UmyaSpreadsheet.get_hyperlinks(spreadsheet, sheet_name) do\n      {:ok, hyperlinks} ->\n        Stream.map(hyperlinks, fn hyperlink ->\n          # Process each hyperlink lazily\n          process_hyperlink_info(hyperlink)\n        end)\n      {:error, reason} ->\n        Stream.repeatedly(fn -> {:error, reason} end) |> Stream.take(1)\n    end\n  end\n\n  defp process_hyperlink_info(hyperlink) do\n    # Expensive processing only when accessed\n    hyperlink\n  end\nend\n```","ref":"hyperlinks.html#3-lazy-loading"},{"type":"extras","title":"Real-World Examples - Excel Hyperlinks Guide","doc":"","ref":"hyperlinks.html#real-world-examples"},{"type":"extras","title":"Example 1: Employee Directory with Contact Links - Excel Hyperlinks Guide","doc":"```elixir\ndefmodule EmployeeDirectory do\n  def create_directory(employees) do\n    {:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n    # Add headers\n    headers = [\"Name\", \"Email\", \"Department\", \"Profile\"]\n    Enum.with_index(headers, fn header, index ->\n      column = get_column_letter(index)\n      UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"#{column}1\", header)\n    end)\n\n    # Add employee data with hyperlinks\n    Enum.with_index(employees, 2, fn employee, row ->\n      # Name\n      UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A#{row}\", employee.name)\n\n      # Email with mailto link\n      UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B#{row}\", employee.email)\n      UmyaSpreadsheet.add_hyperlink(\n        spreadsheet, \"Sheet1\", \"B#{row}\",\n        \"mailto:#{employee.email}\",\n        \"Send email to #{employee.name}\"\n      )\n\n      # Department\n      UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C#{row}\", employee.department)\n\n      # Profile link\n      UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"D#{row}\", \"View Profile\")\n      UmyaSpreadsheet.add_hyperlink(\n        spreadsheet, \"Sheet1\", \"D#{row}\",\n        \"https://company.com/profiles/#{employee.id}\",\n        \"View #{employee.name}'s profile\"\n      )\n    end)\n\n    UmyaSpreadsheet.write(spreadsheet, \"employee_directory.xlsx\")\n  end\n\n  defp get_column_letter(index) do\n    # Convert 0,1,2,3 to A,B,C,D\n    <<65 + index::utf8>>\n  end\nend\n\n# Usage\nemployees = [\n  %{name: \"John Doe\", email: \"john@company.com\", department: \"Engineering\", id: \"emp001\"},\n  %{name: \"Jane Smith\", email: \"jane@company.com\", department: \"Marketing\", id: \"emp002\"},\n  %{name: \"Bob Johnson\", email: \"bob@company.com\", department: \"Sales\", id: \"emp003\"}\n]\n\nEmployeeDirectory.create_directory(employees)\n```","ref":"hyperlinks.html#example-1-employee-directory-with-contact-links"},{"type":"extras","title":"Example 2: Financial Report with Navigation - Excel Hyperlinks Guide","doc":"```elixir\ndefmodule FinancialReport do\n  def create_report(financial_data) do\n    {:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n    # Create multiple sheets\n    sheets = [\"Summary\", \"Income\", \"Expenses\", \"Balance\"]\n    Enum.each(sheets, fn sheet ->\n      if sheet != \"Sheet1\" do\n        UmyaSpreadsheet.add_worksheet(spreadsheet, sheet)\n      else\n        UmyaSpreadsheet.rename_worksheet(spreadsheet, \"Sheet1\", sheet)\n      end\n    end)\n\n    # Add navigation in Summary sheet\n    add_navigation(spreadsheet, \"Summary\")\n\n    # Add external links for regulatory information\n    add_regulatory_links(spreadsheet, \"Summary\")\n\n    UmyaSpreadsheet.write(spreadsheet, \"financial_report.xlsx\")\n  end\n\n  defp add_navigation(spreadsheet, sheet_name) do\n    # Navigation header\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A1\", \"Quick Navigation\")\n\n    # Internal navigation links\n    navigation_links = [\n      {\"A3\", \"Income!A1\", \"📊 Income Statement\", true},\n      {\"A4\", \"Expenses!A1\", \"💰 Expense Report\", true},\n      {\"A5\", \"Balance!A1\", \"⚖️ Balance Sheet\", true}\n    ]\n\n    Enum.each(navigation_links, fn {cell, url, tooltip, is_internal} ->\n      # Set display text\n      display_text = tooltip |> String.replace(~r/[📊💰⚖️] /, \"\")\n      UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, cell, display_text)\n\n      # Add hyperlink\n      UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, url, tooltip, is_internal)\n    end)\n  end\n\n  defp add_regulatory_links(spreadsheet, sheet_name) do\n    # Regulatory information header\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A7\", \"Regulatory Information\")\n\n    # External regulatory links\n    regulatory_links = [\n      {\"A9\", \"https://www.sec.gov\", \"SEC - Securities and Exchange Commission\"},\n      {\"A10\", \"https://www.fasb.org\", \"FASB - Financial Accounting Standards Board\"},\n      {\"A11\", \"https://www.irs.gov\", \"IRS - Internal Revenue Service\"}\n    ]\n\n    Enum.each(regulatory_links, fn {cell, url, tooltip} ->\n      # Set display text\n      display_text = tooltip |> String.split(\" - \") |> List.first()\n      UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, cell, display_text)\n\n      # Add hyperlink\n      UmyaSpreadsheet.add_hyperlink(spreadsheet, sheet_name, cell, url, tooltip)\n    end)\n  end\nend\n\n# Usage\nfinancial_data = %{\n  revenue: 1_000_000,\n  expenses: 750_000,\n  profit: 250_000\n}\n\nFinancialReport.create_report(financial_data)\n```","ref":"hyperlinks.html#example-2-financial-report-with-navigation"},{"type":"extras","title":"Example 3: Project Documentation Hub - Excel Hyperlinks Guide","doc":"```elixir\ndefmodule ProjectDocumentationHub do\n  def create_hub(project_info) do\n    {:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n    # Project overview\n    add_project_overview(spreadsheet, \"Sheet1\", project_info)\n\n    # Documentation links\n    add_documentation_links(spreadsheet, \"Sheet1\", project_info.docs)\n\n    # Team contact information\n    add_team_contacts(spreadsheet, \"Sheet1\", project_info.team)\n\n    # Resource links\n    add_resource_links(spreadsheet, \"Sheet1\", project_info.resources)\n\n    UmyaSpreadsheet.write(spreadsheet, \"project_hub.xlsx\")\n  end\n\n  defp add_project_overview(spreadsheet, sheet_name, project_info) do\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A1\", \"Project: #{project_info.name}\")\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A2\", \"Status: #{project_info.status}\")\n\n    # Project repository link\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A3\", \"Repository\")\n    UmyaSpreadsheet.add_hyperlink(\n      spreadsheet, sheet_name, \"A3\",\n      project_info.repository_url,\n      \"View project source code on GitHub\"\n    )\n  end\n\n  defp add_documentation_links(spreadsheet, sheet_name, docs) do\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A5\", \"Documentation\")\n\n    Enum.with_index(docs, 6, fn doc, row ->\n      UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A#{row}\", doc.title)\n      UmyaSpreadsheet.add_hyperlink(\n        spreadsheet, sheet_name, \"A#{row}\",\n        doc.url,\n        doc.description\n      )\n    end)\n  end\n\n  defp add_team_contacts(spreadsheet, sheet_name, team) do\n    start_row = 6 + length(team) + 2\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A#{start_row}\", \"Team Contacts\")\n\n    Enum.with_index(team, start_row + 1, fn member, row ->\n      UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A#{row}\", member.name)\n      UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"B#{row}\", member.role)\n\n      # Email link\n      UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"C#{row}\", \"Email\")\n      UmyaSpreadsheet.add_hyperlink(\n        spreadsheet, sheet_name, \"C#{row}\",\n        \"mailto:#{member.email}\",\n        \"Send email to #{member.name}\"\n      )\n\n      # Slack link (if available)\n      if member.slack_id do\n        UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"D#{row}\", \"Slack\")\n        UmyaSpreadsheet.add_hyperlink(\n          spreadsheet, sheet_name, \"D#{row}\",\n          \"slack://user?team=#{member.team_id}&id=#{member.slack_id}\",\n          \"Message #{member.name} on Slack\"\n        )\n      end\n    end)\n  end\n\n  defp add_resource_links(spreadsheet, sheet_name, resources) do\n    start_row = 20  # Fixed position for resources\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A#{start_row}\", \"Resources\")\n\n    Enum.with_index(resources, start_row + 1, fn resource, row ->\n      UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A#{row}\", resource.name)\n      UmyaSpreadsheet.add_hyperlink(\n        spreadsheet, sheet_name, \"A#{row}\",\n        resource.url,\n        resource.description\n      )\n    end)\n  end\nend\n\n# Usage\nproject_info = %{\n  name: \"UmyaSpreadsheet\",\n  status: \"Active\",\n  repository_url: \"https://github.com/example/umya-spreadsheet\",\n  docs: [\n    %{title: \"API Documentation\", url: \"https://docs.example.com/api\", description: \"Complete API reference\"},\n    %{title: \"User Guide\", url: \"https://docs.example.com/guide\", description: \"Step-by-step user guide\"},\n    %{title: \"Examples\", url: \"https://docs.example.com/examples\", description: \"Code examples and tutorials\"}\n  ],\n  team: [\n    %{name: \"Alice Developer\", role: \"Lead Developer\", email: \"alice@company.com\", slack_id: \"U123\", team_id: \"T456\"},\n    %{name: \"Bob Tester\", role: \"QA Engineer\", email: \"bob@company.com\", slack_id: \"U789\", team_id: \"T456\"},\n    %{name: \"Carol Manager\", role: \"Project Manager\", email: \"carol@company.com\", slack_id: nil, team_id: nil}\n  ],\n  resources: [\n    %{name: \"CI/CD Pipeline\", url: \"https://ci.example.com/project\", description: \"Build and deployment status\"},\n    %{name: \"Issue Tracker\", url: \"https://issues.example.com/project\", description: \"Bug reports and feature requests\"},\n    %{name: \"Wiki\", url: \"https://wiki.example.com/project\", description: \"Internal project documentation\"}\n  ]\n}\n\nProjectDocumentationHub.create_hub(project_info)\n```\n\nThis comprehensive guide covers all aspects of hyperlink management in UmyaSpreadsheet, from basic operations to advanced use cases and real-world examples. The examples demonstrate practical applications and best practices for different scenarios you might encounter when working with Excel hyperlinks.","ref":"hyperlinks.html#example-3-project-documentation-hub"},{"type":"extras","title":"OLE Objects","doc":"# OLE Objects\n\nThis guide explains how to work with OLE (Object Linking and Embedding) objects in Excel spreadsheets using the UmyaSpreadsheet library.","ref":"ole_objects.html"},{"type":"extras","title":"Overview - OLE Objects","doc":"OLE objects allow you to embed documents from other applications (like Word documents, PowerPoint presentations, or PDF files) directly into Excel spreadsheets. UmyaSpreadsheet provides comprehensive support for:\n\n- Creating and managing OLE object collections\n- Embedding various file types (.docx, .xlsx, .pptx, .pdf, .txt)\n- Loading OLE objects from files or binary data\n- Managing OLE object properties and metadata\n- Retrieving and manipulating embedded objects","ref":"ole_objects.html#overview"},{"type":"extras","title":"Supported File Types - OLE Objects","doc":"UmyaSpreadsheet supports the following OLE object types:\n\n- **Word Documents** (.docx) - ProgID: `Word.DocumentMacroEnabled.12`\n- **Excel Workbooks** (.xlsx) - ProgID: `Excel.SheetMacroEnabled.12`\n- **PowerPoint Presentations** (.pptx) - ProgID: `PowerPoint.ShowMacroEnabled.12`\n- **PDF Documents** (.pdf) - ProgID: `AcroExch.Document.DC`\n- **Text Files** (.txt) - ProgID: `txtfile`","ref":"ole_objects.html#supported-file-types"},{"type":"extras","title":"Getting Started - OLE Objects","doc":"","ref":"ole_objects.html#getting-started"},{"type":"extras","title":"Creating an OLE Objects Collection - OLE Objects","doc":"First, create a new OLE objects collection for a worksheet:\n\n```elixir\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Create a new OLE objects collection for Sheet1\n{:ok, ole_objects} = UmyaSpreadsheet.new_ole_objects()\n\n# Set the OLE objects collection on the worksheet\nUmyaSpreadsheet.set_ole_objects(spreadsheet, \"Sheet1\", ole_objects)\n```","ref":"ole_objects.html#creating-an-ole-objects-collection"},{"type":"extras","title":"Adding OLE Objects from Files - OLE Objects","doc":"Add OLE objects by loading them from files:\n\n```elixir\n# Add a Word document as an OLE object\ncase UmyaSpreadsheet.OleObjects.add_ole_object_from_file(ole_objects, \"/path/to/document.docx\") do\n  {:ok, ole_object} ->\n    IO.puts(\"Word document added successfully\")\n  {:error, reason} ->\n    IO.puts(\"Failed to add document: #{reason}\")\nend\n\n# Add a PDF document\n{:ok, pdf_object} = UmyaSpreadsheet.OleObjects.add_ole_object_from_file(ole_objects, \"/path/to/presentation.pdf\")\n\n# Add a PowerPoint presentation\n{:ok, ppt_object} = UmyaSpreadsheet.OleObjects.add_ole_object_from_file(ole_objects, \"/path/to/slides.pptx\")\n```","ref":"ole_objects.html#adding-ole-objects-from-files"},{"type":"extras","title":"Adding OLE Objects from Binary Data - OLE Objects","doc":"You can also create OLE objects from binary data:\n\n```elixir\n# Read file content as binary\n{:ok, binary_data} = File.read(\"/path/to/document.docx\")\n\n# Create OLE object from binary data with explicit ProgID\n{:ok, ole_object} = UmyaSpreadsheet.OleObjects.add_ole_object_with_data(\n  ole_objects,\n  binary_data,\n  \"Word.DocumentMacroEnabled.12\"\n)\n```","ref":"ole_objects.html#adding-ole-objects-from-binary-data"},{"type":"extras","title":"Working with OLE Objects Collections - OLE Objects","doc":"","ref":"ole_objects.html#working-with-ole-objects-collections"},{"type":"extras","title":"Listing OLE Objects - OLE Objects","doc":"Get information about all OLE objects in a collection:\n\n```elixir\n# Get list of all OLE objects\nole_object_list = UmyaSpreadsheet.OleObjects.get_ole_objects_list(ole_objects)\n\n# Count total objects\ncount = UmyaSpreadsheet.OleObjects.get_ole_objects_count(ole_objects)\nIO.puts(\"Total OLE objects: #{count}\")\n\n# Check if collection has any objects\nhas_objects = UmyaSpreadsheet.OleObjects.has_ole_objects(ole_objects)\n```","ref":"ole_objects.html#listing-ole-objects"},{"type":"extras","title":"Retrieving Specific OLE Objects - OLE Objects","doc":"Access individual OLE objects by index:\n\n```elixir\n# Get the first OLE object (0-based index)\ncase UmyaSpreadsheet.OleObjects.get_ole_object_by_index(ole_objects, 0) do\n  {:ok, ole_object} ->\n    # Work with the OLE object\n    prog_id = UmyaSpreadsheet.OleObjects.get_prog_id(ole_object)\n    IO.puts(\"ProgID: #{prog_id}\")\n  {:error, :not_found} ->\n    IO.puts(\"No OLE object at index 0\")\nend\n```","ref":"ole_objects.html#retrieving-specific-ole-objects"},{"type":"extras","title":"Managing OLE Object Properties - OLE Objects","doc":"","ref":"ole_objects.html#managing-ole-object-properties"},{"type":"extras","title":"Getting Object Information - OLE Objects","doc":"Retrieve various properties from OLE objects:\n\n```elixir\n# Get the ProgID (identifies the application type)\nprog_id = UmyaSpreadsheet.OleObjects.get_prog_id(ole_object)\n\n# Get the file extension\nextension = UmyaSpreadsheet.OleObjects.get_extension(ole_object)\n\n# Get any requirements or dependencies\nrequires = UmyaSpreadsheet.OleObjects.get_requires(ole_object)\n\n# Get the binary data\nbinary_data = UmyaSpreadsheet.OleObjects.get_ole_object_data(ole_object)\n\nIO.puts(\"Object Type: #{prog_id}, Extension: #{extension}\")\n```","ref":"ole_objects.html#getting-object-information"},{"type":"extras","title":"Setting Object Properties - OLE Objects","doc":"Update OLE object properties:\n\n```elixir\n# Set a custom ProgID\nUmyaSpreadsheet.OleObjects.set_prog_id(ole_object, \"CustomApp.Document.1\")\n\n# Set the file extension\nUmyaSpreadsheet.OleObjects.set_extension(ole_object, \".custom\")\n\n# Set requirements\nUmyaSpreadsheet.OleObjects.set_requires(ole_object, \"CustomApplication >= 2.0\")\n\n# Update the binary data\n{:ok, new_data} = File.read(\"/path/to/updated_file.docx\")\nUmyaSpreadsheet.OleObjects.set_ole_object_data(ole_object, new_data)\n```","ref":"ole_objects.html#setting-object-properties"},{"type":"extras","title":"Advanced Operations - OLE Objects","doc":"","ref":"ole_objects.html#advanced-operations"},{"type":"extras","title":"Working with Embedded Object Properties - OLE Objects","doc":"Access properties specific to embedded objects:\n\n```elixir\n# Get embedded object ProgID\nembedded_prog_id = UmyaSpreadsheet.OleObjects.get_embedded_object_prog_id(ole_object)\n\n# Get the shape ID associated with the embedded object\nshape_id = UmyaSpreadsheet.OleObjects.get_embedded_object_shape_id(ole_object)\n\nIO.puts(\"Embedded ProgID: #{embedded_prog_id}, Shape ID: #{shape_id}\")\n```","ref":"ole_objects.html#working-with-embedded-object-properties"},{"type":"extras","title":"File Format Detection - OLE Objects","doc":"Check the format of OLE objects:\n\n```elixir\n# Check if object is in binary format\nis_binary = UmyaSpreadsheet.OleObjects.is_binary_format_ole_object(ole_object)\n\n# Check if object is an Excel format\nis_excel = UmyaSpreadsheet.OleObjects.is_excel_ole_object(ole_object)\n\nIO.puts(\"Binary format: #{is_binary}, Excel format: #{is_excel}\")\n```","ref":"ole_objects.html#file-format-detection"},{"type":"extras","title":"Saving OLE Objects to Files - OLE Objects","doc":"Extract OLE objects and save them as separate files:\n\n```elixir\n# Save an OLE object to a file\ncase UmyaSpreadsheet.OleObjects.save_ole_object_to_file(ole_object, \"/path/to/extracted_document.docx\") do\n  :ok ->\n    IO.puts(\"OLE object saved successfully\")\n  {:error, reason} ->\n    IO.puts(\"Failed to save: #{reason}\")\nend\n```","ref":"ole_objects.html#saving-ole-objects-to-files"},{"type":"extras","title":"Helper Functions - OLE Objects","doc":"Use utility functions for common operations:\n\n```elixir\n# Automatically determine ProgID from file extension\nprog_id = UmyaSpreadsheet.OleObjects.determine_prog_id_from_extension(\".docx\")\n# Returns: \"Word.DocumentMacroEnabled.12\"\n\nprog_id = UmyaSpreadsheet.OleObjects.determine_prog_id_from_extension(\".pdf\")\n# Returns: \"AcroExch.Document.DC\"\n```","ref":"ole_objects.html#helper-functions"},{"type":"extras","title":"Complete Example - OLE Objects","doc":"Here's a comprehensive example that demonstrates various OLE object operations:\n\n```elixir\ndefmodule OleExample do\n  def create_spreadsheet_with_ole_objects do\n    # Create new spreadsheet\n    {:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n    # Create OLE objects collection\n    {:ok, ole_objects} = UmyaSpreadsheet.new_ole_objects()\n\n    # Add various types of OLE objects\n    {:ok, word_object} = UmyaSpreadsheet.OleObjects.add_ole_object_from_file(\n      ole_objects,\n      \"/path/to/contract.docx\"\n    )\n\n    {:ok, pdf_object} = UmyaSpreadsheet.OleObjects.add_ole_object_from_file(\n      ole_objects,\n      \"/path/to/report.pdf\"\n    )\n\n    {:ok, ppt_object} = UmyaSpreadsheet.OleObjects.add_ole_object_from_file(\n      ole_objects,\n      \"/path/to/presentation.pptx\"\n    )\n\n    # Set custom properties\n    UmyaSpreadsheet.OleObjects.set_requires(word_object, \"Microsoft Word 2016 or later\")\n\n    # Set the OLE objects collection on the worksheet\n    UmyaSpreadsheet.set_ole_objects(spreadsheet, \"Sheet1\", ole_objects)\n\n    # Add some context in the spreadsheet\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Embedded Documents\")\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"Contract (Word)\")\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A3\", \"Report (PDF)\")\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A4\", \"Presentation (PowerPoint)\")\n\n    # Save the spreadsheet\n    case UmyaSpreadsheet.write(spreadsheet, \"/path/to/spreadsheet_with_ole.xlsx\") do\n      :ok ->\n        IO.puts(\"Spreadsheet with OLE objects created successfully\")\n      {:error, reason} ->\n        IO.puts(\"Failed to save: #{reason}\")\n    end\n  end\n\n  def extract_ole_objects_from_spreadsheet do\n    # Read existing spreadsheet\n    {:ok, spreadsheet} = UmyaSpreadsheet.read(\"/path/to/spreadsheet_with_ole.xlsx\")\n\n    # Get OLE objects from worksheet\n    case UmyaSpreadsheet.get_ole_objects(spreadsheet, \"Sheet1\") do\n      {:ok, ole_objects} ->\n        count = UmyaSpreadsheet.OleObjects.get_ole_objects_count(ole_objects)\n        IO.puts(\"Found #{count} OLE objects\")\n\n        # Extract each object\n        for index <- 0..(count - 1) do\n          {:ok, ole_object} = UmyaSpreadsheet.OleObjects.get_ole_object_by_index(ole_objects, index)\n\n          prog_id = UmyaSpreadsheet.OleObjects.get_prog_id(ole_object)\n          extension = UmyaSpreadsheet.OleObjects.get_extension(ole_object)\n\n          output_file = \"/path/to/extracted/object_#{index}#{extension}\"\n\n          case UmyaSpreadsheet.OleObjects.save_ole_object_to_file(ole_object, output_file) do\n            :ok ->\n              IO.puts(\"Extracted #{prog_id} object to #{output_file}\")\n            {:error, reason} ->\n              IO.puts(\"Failed to extract object #{index}: #{reason}\")\n          end\n        end\n\n      {:error, :not_found} ->\n        IO.puts(\"No OLE objects found in the worksheet\")\n    end\n  end\nend\n\n# Usage\nOleExample.create_spreadsheet_with_ole_objects()\nOleExample.extract_ole_objects_from_spreadsheet()\n```","ref":"ole_objects.html#complete-example"},{"type":"extras","title":"Error Handling - OLE Objects","doc":"OLE object operations can fail for various reasons. Always handle errors appropriately:\n\n```elixir\ncase UmyaSpreadsheet.OleObjects.add_ole_object_from_file(ole_objects, file_path) do\n  {:ok, ole_object} ->\n    # Success - work with the object\n    IO.puts(\"OLE object added successfully\")\n\n  {:error, :file_not_found} ->\n    IO.puts(\"The specified file does not exist\")\n\n  {:error, :unsupported_format} ->\n    IO.puts(\"The file format is not supported for OLE embedding\")\n\n  {:error, :invalid_data} ->\n    IO.puts(\"The file contains invalid or corrupted data\")\n\n  {:error, reason} ->\n    IO.puts(\"Failed to add OLE object: #{reason}\")\nend\n```\n\nCommon error types:\n\n- `:file_not_found` - The specified file path does not exist\n- `:unsupported_format` - The file type is not supported for OLE embedding\n- `:invalid_data` - The file contains corrupted or invalid data\n- `:not_found` - The requested OLE object or index does not exist\n- `:error` - General error during processing","ref":"ole_objects.html#error-handling"},{"type":"extras","title":"Best Practices - OLE Objects","doc":"1. **File Size Considerations**: OLE objects embed the entire file content, which can significantly increase spreadsheet size. Consider the impact on file size and loading times.\n\n2. **Application Dependencies**: Recipients of the spreadsheet need the appropriate applications installed to open embedded OLE objects.\n\n3. **Resource Management**: OLE objects collections and individual objects are automatically managed by the library, but ensure you don't hold unnecessary references.\n\n4. **Error Handling**: Always implement proper error handling, especially when working with file operations.\n\n5. **Format Consistency**: Use the helper functions to ensure consistent ProgID assignment based on file extensions.\n\n6. **Testing**: Test OLE object functionality with the actual applications and versions your users will have.","ref":"ole_objects.html#best-practices"},{"type":"extras","title":"Limitations - OLE Objects","doc":"- OLE objects require the target application to be installed on the machine where the Excel file is opened\n- Large embedded files can significantly increase spreadsheet file size\n- Some file formats may have compatibility issues across different Excel versions\n- Complex OLE objects may not display correctly in all Excel environments\n\nFor more information about limitations and compatibility, see the [Limitations & Compatibility Guide](limitations.html).","ref":"ole_objects.html#limitations"},{"type":"extras","title":"Charts","doc":"# Charts\n\nUmyaSpreadsheet supports the creation of various types of charts in spreadsheets.\nYou can add charts to your spreadsheet using the `add_chart/9` function or the\nmore advanced `add_chart_with_options/16` function, which allows for greater customization.","ref":"charts.html"},{"type":"extras","title":"Adding Charts - Charts","doc":"","ref":"charts.html#adding-charts"},{"type":"extras","title":"Basic Chart Addition - Charts","doc":"```elixir\nUmyaSpreadsheet.add_chart(\n  spreadsheet,\n  \"Sheet1\",\n  \"LineChart\",  # Chart type\n  \"E1\",         # From cell\n  \"J10\",        # To cell\n  \"Sales Data\", # Chart title\n  [\"Sheet1!$B$2:$B$5\", \"Sheet1!$C$2:$C$5\"],  # Data series\n  [\"Revenue\", \"Expenses\"],                   # Series titles\n  [\"Q1\", \"Q2\", \"Q3\", \"Q4\"]                   # Point titles\n)\n```","ref":"charts.html#basic-chart-addition"},{"type":"extras","title":"Advanced Chart Addition with Options - Charts","doc":"```elixir\nUmyaSpreadsheet.add_chart_with_options(\n  spreadsheet,\n  \"Sheet1\",\n  \"Bar3DChart\",  # Chart type\n  \"E12\",         # From cell\n  \"J22\",         # To cell\n  \"Quarterly Results\",  # Chart title\n  [\"Sheet1!$B$2:$B$5\", \"Sheet1!$C$2:$C$5\"],  # Data series\n  [\"Revenue\", \"Expenses\"],                   # Series titles\n  [\"Q1\", \"Q2\", \"Q3\", \"Q4\"],                  # Point titles\n  1,              # Style (1-48)\n  true,           # Vary colors\n  %{              # 3D view options\n    rot_x: 15,\n    rot_y: 20,\n    perspective: 30,\n    height_percent: 100\n  },\n  %{              # Legend options\n    position: \"right\",\n    overlay: false\n  },\n  %{},            # Axis options (empty map for defaults)\n  %{              # Data label options\n    show_values: true,\n    show_percent: false\n  },\n  %{}             # Chart-specific options (empty map for defaults)\n)\n```","ref":"charts.html#advanced-chart-addition-with-options"},{"type":"extras","title":"Parameters - Charts","doc":"- `spreadsheet`: The spreadsheet object to which the chart will be added.\n- `sheet_name`: The name of the sheet where the chart will be placed.\n- `chart_type`: The type of chart to create (e.g., `\"LineChart\"`, `\"BarChart\"`).\n- `from_cell`: The starting cell for the chart (e.g., `\"E1\"`).\n- `to_cell`: The ending cell for the chart (e.g., `\"J10\"`).\n- `title`: The title of the chart.\n- `data_series`: A list of data series to be plotted (e.g., `[\"Sheet1!$B$2:$B$5\", \"Sheet1!$C$2:$C$5\"]`).\n- `series_titles`: A list of titles for each data series (e.g., `[\"Revenue\", \"Expenses\"]`).\n- `point_titles`: A list of titles for each point on the chart (e.g., `[\"Q1\", \"Q2\", \"Q3\", \"Q4\"]`).\n- `style`: (Optional) The style of the chart (1-48).\n- `vary_colors`: (Optional) Boolean indicating whether to vary colors for different series.\n- `view_options`: (Optional) A map of 3D view options (e.g., rotation angles, perspective).\n- `legend_options`: (Optional) A map of legend options (e.g., position, overlay).\n- `axis_options`: (Optional) A map of axis options (e.g., min/max values, titles).\n- `data_label_options`: (Optional) A map of data label options (e.g., show values, show percentages).\n- `chart_options`: (Optional) A map of chart-specific options (e.g., gridlines, background color).\n- `chart_specific_options`: (Optional) A map of additional chart-specific options.","ref":"charts.html#parameters"},{"type":"extras","title":"Supported Chart Types - Charts","doc":"The following chart types are supported for use with `add_chart/9` and `add_chart_with_options/16`:\n\n| Chart Type        | Description                                        |\n| ----------------- | -------------------------------------------------- |\n| `\"LineChart\"`     | Standard 2D line chart                             |\n| `\"Line3DChart\"`   | 3D line chart with perspective                     |\n| `\"PieChart\"`      | Standard 2D pie chart                              |\n| `\"Pie3DChart\"`    | 3D pie chart with perspective                      |\n| `\"DoughnutChart\"` | Doughnut chart (pie with hole in center)           |\n| `\"ScatterChart\"`  | X-Y scatter plot                                   |\n| `\"BarChart\"`      | Standard 2D bar/column chart                       |\n| `\"Bar3DChart\"`    | 3D bar/column chart with perspective               |\n| `\"RadarChart\"`    | Radar/spider chart                                 |\n| `\"BubbleChart\"`   | Bubble chart (scatter with variable point sizes)   |\n| `\"AreaChart\"`     | Standard 2D area chart                             |\n| `\"Area3DChart\"`   | 3D area chart with perspective                     |\n| `\"OfPieChart\"`    | \"Of Pie\" chart variant (pie with breakout section) |","ref":"charts.html#supported-chart-types"},{"type":"extras","title":"Example Usage - Charts","doc":"```elixir\n# Create a basic line chart\nUmyaSpreadsheet.add_chart(\n  spreadsheet,\n  \"Sheet1\",\n  \"LineChart\",  # Chart type\n  \"E1\",         # From cell\n  \"J10\",        # To cell\n  \"Sales Data\", # Chart title\n  [\"Sheet1!$B$2:$B$5\", \"Sheet1!$C$2:$C$5\"],  # Data series\n  [\"Revenue\", \"Expenses\"],                    # Series titles\n  [\"Q1\", \"Q2\", \"Q3\", \"Q4\"]                    # Point titles\n)\n\n# Create a 3D bar chart with more options\nUmyaSpreadsheet.add_chart_with_options(\n  spreadsheet,\n  \"Sheet1\",\n  \"Bar3DChart\",  # Chart type\n  \"E12\",         # From cell\n  \"J22\",         # To cell\n  \"Quarterly Results\",  # Chart title\n  [\"Sheet1!$B$2:$B$5\", \"Sheet1!$C$2:$C$5\"],  # Data series\n  [\"Revenue\", \"Expenses\"],                    # Series titles\n  [\"Q1\", \"Q2\", \"Q3\", \"Q4\"],                   # Point titles\n  1,              # Style (1-48)\n  true,           # Vary colors\n  %{              # 3D view options\n    rot_x: 15,\n    rot_y: 20,\n    perspective: 30,\n    height_percent: 100\n  },\n  %{              # Legend options\n    position: \"right\",\n    overlay: false\n  },\n  %{},            # Axis options (empty map for defaults)\n  %{              # Data label options\n    show_values: true,\n    show_percent: false\n  },\n  %{}             # Chart-specific options (empty map for defaults)\n)\n```","ref":"charts.html#example-usage"},{"type":"extras","title":"Comments","doc":"# Comments\n\nThis guide covers the comment management functionality in UmyaSpreadsheet, allowing you to add, retrieve, update, and remove cell comments in your Excel spreadsheets.","ref":"comments.html"},{"type":"extras","title":"Adding Comments to Cells - Comments","doc":"Comments are a great way to provide context, leave notes, or give instructions within your spreadsheet without affecting the cell's value.\n\n```elixir\nalias UmyaSpreadsheet\n\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add some data\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Sales Report\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B2\", 5000)\n\n# Add a comment to cell B2\nUmyaSpreadsheet.add_comment(spreadsheet, \"Sheet1\", \"B2\", \"This value represents Q1 sales.\", \"Alex\")\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"comments_example.xlsx\")\n```\n\nThe `add_comment` function allows you to specify:\n\n- The spreadsheet to modify\n- The sheet name where the cell is located\n- The cell address to add the comment to\n- The comment text\n- The author of the comment (optional)","ref":"comments.html#adding-comments-to-cells"},{"type":"extras","title":"Retrieving Comments - Comments","doc":"You can retrieve the text and author of a comment from a specific cell:\n\n```elixir\n# Get comment from cell B2\ncase UmyaSpreadsheet.get_comment(spreadsheet, \"Sheet1\", \"B2\") do\n  {:ok, {text, author}} ->\n    IO.puts(\"Comment by #{author}: #{text}\")\n  {:error, _reason} ->\n    IO.puts(\"No comment found on this cell\")\nend\n```","ref":"comments.html#retrieving-comments"},{"type":"extras","title":"Updating Existing Comments - Comments","doc":"You can update an existing comment on a cell:\n\n```elixir\n# Update the comment on cell B2\nUmyaSpreadsheet.update_comment(\n  spreadsheet,\n  \"Sheet1\",\n  \"B2\",\n  \"Updated: This value represents Q1 sales in USD.\",\n  \"Alex Smith\"  # Updated author name\n)\n```\n\nIf you want to keep the original author, you can omit the author parameter:\n\n```elixir\nUmyaSpreadsheet.update_comment(\n  spreadsheet,\n  \"Sheet1\",\n  \"B2\",\n  \"Updated: This value represents Q1 sales in USD.\"\n  # Author remains unchanged\n)\n```","ref":"comments.html#updating-existing-comments"},{"type":"extras","title":"Removing Comments - Comments","doc":"To remove a comment from a cell:\n\n```elixir\nUmyaSpreadsheet.remove_comment(spreadsheet, \"Sheet1\", \"B2\")\n```","ref":"comments.html#removing-comments"},{"type":"extras","title":"Checking for Comments - Comments","doc":"You can check if a worksheet contains any comments:\n\n```elixir\ncase UmyaSpreadsheet.has_comments(spreadsheet, \"Sheet1\") do\n  true -> IO.puts(\"Sheet1 contains comments\")\n  false -> IO.puts(\"Sheet1 has no comments\")\n  {:error, reason} -> IO.puts(\"Error checking comments: #{reason}\")\nend\n```","ref":"comments.html#checking-for-comments"},{"type":"extras","title":"Counting Comments - Comments","doc":"To get the number of comments in a worksheet:\n\n```elixir\ncase UmyaSpreadsheet.get_comments_count(spreadsheet, \"Sheet1\") do\n  count when is_integer(count) -> IO.puts(\"Sheet1 has #{count} comments\")\n  {:error, reason} -> IO.puts(\"Error getting comment count: #{reason}\")\nend\n```","ref":"comments.html#counting-comments"},{"type":"extras","title":"Best Practices - Comments","doc":"1. **Keep Comments Concise**: Write clear, brief comments that provide valuable context\n2. **Include Dates**: For collaborative spreadsheets, consider including dates in your comments\n3. **Use Consistently**: Develop a consistent approach to commenting within your organization\n4. **Author Attribution**: Always include author information for accountability\n5. **Regular Cleanup**: Remove outdated comments to keep spreadsheets clean and focused","ref":"comments.html#best-practices"},{"type":"extras","title":"Comment Visibility - Comments","doc":"When opening a spreadsheet in Excel or other applications:\n\n- Comments are typically indicated by a small triangle in the corner of cells\n- Users can hover over cells to see the comments\n- Comments retain their author attribution when viewed in Excel","ref":"comments.html#comment-visibility"},{"type":"extras","title":"Image Handling","doc":"# Image Handling\n\nThis guide explains how to work with images in Excel spreadsheets using the UmyaSpreadsheet library.","ref":"image_handling.html"},{"type":"extras","title":"Overview - Image Handling","doc":"UmyaSpreadsheet provides comprehensive image handling functions to:\n\n- **Add images** to specific cells with positioning control\n- **Retrieve and download** images from existing spreadsheets\n- **Replace existing images** with new ones\n- **Get image dimensions** (width and height)\n- **List all images** in a worksheet with their positions\n- **Get detailed image information** including names, positions, and dimensions\n- **Manage image positioning and sizing** within cells","ref":"image_handling.html#overview"},{"type":"extras","title":"Adding Images - Image Handling","doc":"To add an image to a spreadsheet:\n\n```elixir\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add an image to cell A1 of Sheet1\nUmyaSpreadsheet.add_image(spreadsheet, \"Sheet1\", \"A1\", \"/path/to/image.png\")\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"spreadsheet_with_image.xlsx\")\n```","ref":"image_handling.html#adding-images"},{"type":"extras","title":"Retrieving Images - Image Handling","doc":"To retrieve an image from an existing spreadsheet:\n\n```elixir\n# Read a spreadsheet containing images\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"spreadsheet_with_image.xlsx\")\n\n# Download the image from cell A1 to a file\nUmyaSpreadsheet.download_image(spreadsheet, \"Sheet1\", \"A1\", \"output_image.png\")\n```","ref":"image_handling.html#retrieving-images"},{"type":"extras","title":"Changing Images - Image Handling","doc":"To replace an existing image in a spreadsheet:\n\n```elixir\n# Read a spreadsheet containing images\n{:ok, spreadsheet} = UmyaSpreadsheet.read(\"spreadsheet_with_image.xlsx\")\n\n# Change the image at cell A1\nUmyaSpreadsheet.change_image(spreadsheet, \"Sheet1\", \"A1\", \"/path/to/new_image.png\")\n\n# Save the updated spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"updated_spreadsheet.xlsx\")\n```","ref":"image_handling.html#changing-images"},{"type":"extras","title":"Getting Image Information - Image Handling","doc":"","ref":"image_handling.html#getting-image-information"},{"type":"extras","title":"Get Image Dimensions - Image Handling","doc":"You can retrieve the dimensions of an image at a specific cell:\n\n```elixir\n# Get the width and height of an image\ncase UmyaSpreadsheet.get_image_dimensions(spreadsheet, \"Sheet1\", \"A1\") do\n  {:ok, {width, height}} ->\n    IO.puts(\"Image dimensions: #{width}x#{height} pixels\")\n  {:error, reason} ->\n    IO.puts(\"Failed to get image dimensions: #{reason}\")\nend\n```","ref":"image_handling.html#get-image-dimensions"},{"type":"extras","title":"Get Comprehensive Image Information - Image Handling","doc":"To get detailed information about an image including its name, position, and dimensions:\n\n```elixir\n# Get comprehensive image information\ncase UmyaSpreadsheet.get_image_info(spreadsheet, \"Sheet1\", \"A1\") do\n  {:ok, {name, position, width, height}} ->\n    IO.puts(\"Image '#{name}' at position #{position}, dimensions: #{width}x#{height} pixels\")\n  {:error, reason} ->\n    IO.puts(\"Failed to get image info: #{reason}\")\nend\n```","ref":"image_handling.html#get-comprehensive-image-information"},{"type":"extras","title":"List All Images in a Sheet - Image Handling","doc":"To get a list of all images in a specific worksheet:\n\n```elixir\n# List all images in the sheet\ncase UmyaSpreadsheet.list_images(spreadsheet, \"Sheet1\") do\n  {:ok, images} ->\n    IO.puts(\"Found #{length(images)} images in Sheet1:\")\n    Enum.each(images, fn {coordinate, image_name} ->\n      IO.puts(\"  - '#{image_name}' at #{coordinate}\")\n    end)\n  {:error, reason} ->\n    IO.puts(\"Failed to list images: #{reason}\")\nend\n```","ref":"image_handling.html#list-all-images-in-a-sheet"},{"type":"extras","title":"Working with Multiple Images - Image Handling","doc":"Here's a comprehensive example showing how to work with multiple images:\n\n```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add multiple images\nUmyaSpreadsheet.add_image(spreadsheet, \"Sheet1\", \"A1\", \"/path/to/logo.png\")\nUmyaSpreadsheet.add_image(spreadsheet, \"Sheet1\", \"C1\", \"/path/to/chart.png\")\nUmyaSpreadsheet.add_image(spreadsheet, \"Sheet1\", \"E1\", \"/path/to/diagram.png\")\n\n# List all images to verify they were added\n{:ok, images} = UmyaSpreadsheet.list_images(spreadsheet, \"Sheet1\")\nIO.puts(\"Added #{length(images)} images to the spreadsheet\")\n\n# Get detailed information for each image\nEnum.each(images, fn {coordinate, _name} ->\n  {:ok, {name, pos, width, height}} = UmyaSpreadsheet.get_image_info(spreadsheet, \"Sheet1\", coordinate)\n  IO.puts(\"Image '#{name}' at #{pos}: #{width}x#{height} pixels\")\nend)\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"multiple_images.xlsx\")\n```","ref":"image_handling.html#working-with-multiple-images"},{"type":"extras","title":"Error Handling - Image Handling","doc":"All image handling functions return `:ok` on success and `{:error, reason}` on failure:\n\n```elixir\ncase UmyaSpreadsheet.add_image(spreadsheet, \"Sheet1\", \"A1\", \"/path/to/image.png\") do\n  :ok ->\n    IO.puts(\"Image added successfully\")\n  {:error, :not_found} ->\n    IO.puts(\"Sheet not found\")\n  {:error, _} ->\n    IO.puts(\"Failed to add image\")\nend\n```\n\nCommon error reasons:\n\n- `:not_found` - The specified sheet or cell doesn't exist\n- `:invalid_format` - The image file format is not supported\n- `:file_not_found` - The image file does not exist or cannot be accessed\n- `:error` - General error during processing","ref":"image_handling.html#error-handling"},{"type":"extras","title":"Image Positioning and Sizing - Image Handling","doc":"By default, images are positioned at the top-left corner of the specified cell. The library provides the basic `add_image/4` function for simple image insertion:\n\n```elixir\n# Add an image to a specific cell\nUmyaSpreadsheet.add_image(spreadsheet, \"Sheet1\", \"A1\", \"/path/to/image.png\")\n```\n\n**Note**: Advanced positioning and sizing options (such as custom width, height, and offset parameters) may be available in future versions of the library. Currently, images are inserted with their original dimensions at the cell's top-left corner.\n\nFor precise control over image appearance in your Excel files:\n\n1. **Pre-size your images** to the desired dimensions before adding them to the spreadsheet\n2. **Use appropriate image formats** (PNG, JPEG, GIF) that are well-supported by Excel\n3. **Consider cell dimensions** when choosing image sizes for optimal appearance\n4. **Test the output** in Excel to ensure images appear as expected","ref":"image_handling.html#image-positioning-and-sizing"},{"type":"extras","title":"Best Practices - Image Handling","doc":"When working with images in spreadsheets:\n\n1. Use appropriate image formats (PNG, JPEG, GIF) that are well-supported by Excel\n2. Be mindful of image file sizes to keep the spreadsheet file size manageable\n3. Set explicit image dimensions when possible for consistent appearance\n4. Consider using relative paths when working with images in a project structure","ref":"image_handling.html#best-practices"},{"type":"extras","title":"See Also - Image Handling","doc":"- [Styling and Formatting](styling_and_formatting.html) - For overall spreadsheet styling\n- [Sheet Operations](sheet_operations.html) - For managing sheets that contain images","ref":"image_handling.html#see-also"},{"type":"extras","title":"Drawing and Shape Management","doc":"# Drawing and Shape Management\n\nThis guide explains how to add and retrieve shapes, text boxes, and connectors in Excel spreadsheets using UmyaSpreadsheet.","ref":"shapes_and_drawing.html"},{"type":"extras","title":"Introduction to Drawings - Drawing and Shape Management","doc":"Excel supports various drawing objects such as shapes, text boxes, and connector lines that help create visual elements and diagrams in spreadsheets. UmyaSpreadsheet provides functions to both add and retrieve these objects.","ref":"shapes_and_drawing.html#introduction-to-drawings"},{"type":"extras","title":"Supported Drawing Types - Drawing and Shape Management","doc":"UmyaSpreadsheet supports these drawing types:\n\n- **Shapes**: Various geometric shapes including rectangles, ellipses, triangles, diamonds, etc.\n- **Text Boxes**: Text containers with customizable appearance\n- **Connectors**: Lines connecting cells or shapes for creating flowcharts and diagrams\n\nThese features are useful for:\n\n- Creating diagrams and flowcharts\n- Adding annotations and callouts to data\n- Building dashboards with visual elements\n- Emphasizing important information","ref":"shapes_and_drawing.html#supported-drawing-types"},{"type":"extras","title":"Adding Drawing Objects - Drawing and Shape Management","doc":"","ref":"shapes_and_drawing.html#adding-drawing-objects"},{"type":"extras","title":"Adding Shapes - Drawing and Shape Management","doc":"```elixir\nalias UmyaSpreadsheet.Drawing\n\n# Add a blue rectangle at cell A1\nDrawing.add_shape(\n  spreadsheet,\n  \"Sheet1\",\n  \"A1\",                # Cell address where shape will be placed\n  \"rectangle\",         # Shape type\n  200.0,               # Width in pixels\n  100.0,               # Height in pixels\n  \"blue\",              # Fill color\n  \"black\",             # Outline color\n  1.0                  # Outline width in points\n)\n```","ref":"shapes_and_drawing.html#adding-shapes"},{"type":"extras","title":"Supported Shape Types - Drawing and Shape Management","doc":"UmyaSpreadsheet supports the following shape types:\n\n| Shape Type         | Description                           |\n|--------------------|---------------------------------------|\n| `\"rectangle\"`      | Rectangle shape                       |\n| `\"ellipse\"`        | Ellipse shape (also \"oval\", \"circle\") |\n| `\"rounded_rectangle\"` | Rectangle with rounded corners     |\n| `\"triangle\"`       | Triangle shape                        |\n| `\"right_triangle\"` | Right triangle shape                  |\n| `\"pentagon\"`       | Pentagon shape                        |\n| `\"hexagon\"`        | Hexagon shape                         |\n| `\"octagon\"`        | Octagon shape                         |\n| `\"trapezoid\"`      | Trapezoid shape                       |\n| `\"diamond\"`        | Diamond shape                         |\n| `\"arrow\"`          | Arrow shape                           |\n| `\"line\"`           | Line shape                            |","ref":"shapes_and_drawing.html#supported-shape-types"},{"type":"extras","title":"Adding Text Boxes - Drawing and Shape Management","doc":"```elixir\n# Add a white text box with black text at cell B2\nDrawing.add_text_box(\n  spreadsheet,\n  \"Sheet1\",\n  \"B2\",                # Cell address where text box will be placed\n  \"Hello World\",       # Text content\n  150.0,               # Width in pixels\n  75.0,                # Height in pixels\n  \"white\",             # Background color\n  \"black\",             # Text color\n  \"gray\",              # Border color\n  1.0                  # Border width in points\n)\n```","ref":"shapes_and_drawing.html#adding-text-boxes"},{"type":"extras","title":"Adding Connectors - Drawing and Shape Management","doc":"```elixir\n# Add a red connector line from cell C3 to cell D5\nDrawing.add_connector(\n  spreadsheet,\n  \"Sheet1\",\n  \"C3\",                # Starting cell\n  \"D5\",                # Ending cell\n  \"red\",               # Line color\n  1.5                  # Line width in points\n)\n```","ref":"shapes_and_drawing.html#adding-connectors"},{"type":"extras","title":"Retrieving Drawing Objects - Drawing and Shape Management","doc":"UmyaSpreadsheet provides getter functions to retrieve and analyze drawing objects in a spreadsheet.","ref":"shapes_and_drawing.html#retrieving-drawing-objects"},{"type":"extras","title":"Getting All Shapes - Drawing and Shape Management","doc":"```elixir\n# Get all shapes in a sheet\n{:ok, shapes} = Drawing.get_shapes(spreadsheet, \"Sheet1\")\n\n# Get shapes in a specific range\n{:ok, shapes_in_range} = Drawing.get_shapes(spreadsheet, \"Sheet1\", \"A1:E10\")\n\n# Each shape in the result contains these properties:\n# - type: The shape type (\"rectangle\", \"ellipse\", etc.)\n# - cell: The cell address where the shape is placed\n# - width: The width of the shape in pixels\n# - height: The height of the shape in pixels\n# - fill_color: The fill color of the shape as a hex code\n# - outline_color: The outline color as a hex code\n# - outline_width: The width of the outline in points\n```","ref":"shapes_and_drawing.html#getting-all-shapes"},{"type":"extras","title":"Getting Text Boxes - Drawing and Shape Management","doc":"```elixir\n# Get all text boxes in a sheet\n{:ok, text_boxes} = Drawing.get_text_boxes(spreadsheet, \"Sheet1\")\n\n# Get text boxes in a specific range\n{:ok, text_boxes_in_range} = Drawing.get_text_boxes(spreadsheet, \"Sheet1\", \"B2:C5\")\n\n# Each text box in the result contains these properties:\n# - cell: The cell address where the text box is placed\n# - text: The text content of the text box\n# - width: The width of the text box in pixels\n# - height: The height of the text box in pixels\n# - fill_color: The background color as a hex code\n# - text_color: The text color as a hex code\n# - outline_color: The border color as a hex code\n# - outline_width: The width of the border in points\n```","ref":"shapes_and_drawing.html#getting-text-boxes"},{"type":"extras","title":"Getting Connectors - Drawing and Shape Management","doc":"```elixir\n# Get all connectors in a sheet\n{:ok, connectors} = Drawing.get_connectors(spreadsheet, \"Sheet1\")\n\n# Get connectors in a specific range (matches if either end is in range)\n{:ok, connectors_in_range} = Drawing.get_connectors(spreadsheet, \"Sheet1\", \"C3:D5\")\n\n# Each connector in the result contains these properties:\n# - from_cell: The starting cell address\n# - to_cell: The ending cell address\n# - line_color: The connector color as a hex code\n# - line_width: The width of the line in points\n```","ref":"shapes_and_drawing.html#getting-connectors"},{"type":"extras","title":"Utility Functions - Drawing and Shape Management","doc":"```elixir\n# Check if a sheet has any drawing objects\n{:ok, has_drawings} = Drawing.has_drawing_objects(spreadsheet, \"Sheet1\")\n\n# Count drawing objects in a sheet\n{:ok, count} = Drawing.count_drawing_objects(spreadsheet, \"Sheet1\")\n\n# Count drawing objects in a specific range\n{:ok, count_in_range} = Drawing.count_drawing_objects(spreadsheet, \"Sheet1\", \"A1:E10\")\n```","ref":"shapes_and_drawing.html#utility-functions"},{"type":"extras","title":"Complete Example - Drawing and Shape Management","doc":"Here's a complete example showing how to create and analyze a diagram with shapes and connectors:\n\n```elixir\nalias UmyaSpreadsheet.Drawing\n\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add title\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Process Diagram\")\nUmyaSpreadsheet.set_font_bold(spreadsheet, \"Sheet1\", \"A1\", true)\nUmyaSpreadsheet.set_font_size(spreadsheet, \"Sheet1\", \"A1\", 14)\n\n# Add shapes for a flowchart\nDrawing.add_text_box(spreadsheet, \"Sheet1\", \"B3\", \"Start\", 100, 40, \"#D9EAD3\", \"black\", \"#274E13\", 1.0)\nDrawing.add_text_box(spreadsheet, \"Sheet1\", \"B5\", \"Process 1\", 100, 40, \"#FCE5CD\", \"black\", \"#B45F06\", 1.0)\nDrawing.add_shape(spreadsheet, \"Sheet1\", \"B7\", \"diamond\", 100, 80, \"#CFE2F3\", \"black\", 1.0)\nDrawing.add_text_box(spreadsheet, \"Sheet1\", \"E7\", \"Process 2\", 100, 40, \"#FCE5CD\", \"black\", \"#B45F06\", 1.0)\nDrawing.add_text_box(spreadsheet, \"Sheet1\", \"B9\", \"End\", 100, 40, \"#F4CCCC\", \"black\", \"#990000\", 1.0)\n\n# Add connectors to create a flowchart\nDrawing.add_connector(spreadsheet, \"Sheet1\", \"B3\", \"B5\", \"black\", 1.0)\nDrawing.add_connector(spreadsheet, \"Sheet1\", \"B5\", \"B7\", \"black\", 1.0)\nDrawing.add_connector(spreadsheet, \"Sheet1\", \"B7\", \"E7\", \"black\", 1.0)\nDrawing.add_connector(spreadsheet, \"Sheet1\", \"B7\", \"B9\", \"black\", 1.0)\nDrawing.add_connector(spreadsheet, \"Sheet1\", \"E7\", \"B9\", \"black\", 1.0)\n\n# Save the spreadsheet\nUmyaSpreadsheet.write_file(spreadsheet, \"flowchart.xlsx\")\n\n# Analyze the drawing objects\n{:ok, shape_count} = Drawing.count_drawing_objects(spreadsheet, \"Sheet1\")\nIO.puts(\"Total number of drawing objects: #{shape_count}\")\n\n{:ok, connectors} = Drawing.get_connectors(spreadsheet, \"Sheet1\")\nIO.puts(\"Number of connector lines: #{length(connectors)}\")\n\n{:ok, text_boxes} = Drawing.get_text_boxes(spreadsheet, \"Sheet1\")\nIO.puts(\"Number of text boxes: #{length(text_boxes)}\")\n```","ref":"shapes_and_drawing.html#complete-example"},{"type":"extras","title":"Color Specification - Drawing and Shape Management","doc":"All shape functions accept colors specified in two formats:\n\n1. **Named colors**: Common color names like \"red\", \"blue\", \"green\", \"white\", \"black\", etc.\n2. **Hex codes**: Standard hex color codes, with or without the # prefix (e.g., \"#FF0000\" or \"FF0000\" for red)","ref":"shapes_and_drawing.html#color-specification"},{"type":"extras","title":"Tips for Working with Drawing Objects - Drawing and Shape Management","doc":"1. **Cell Positioning**: Drawing objects are anchored to cells but can extend beyond them\n\n2. **Color Values**: Colors can be specified as named colors (\"red\", \"blue\") or hex codes (\"#FF0000\")\n\n3. **Sizing**: Width and height are specified in pixels. Excel uses a resolution of approximately 96 pixels per inch.\n\n4. **Layering**: Shapes are added in the order they are created. Later shapes appear on top of earlier shapes.\n\n5. **Transparency**: You can use \"transparent\" as a color value to create shapes without fill or outline.\n\n6. **Text Boxes**: For multi-line text in text boxes, use the newline character (\"\\n\") to create line breaks.\n\n7. **Filtering**: Use the optional cell range parameter in getter functions to focus on specific areas of a sheet\n\n8. **Optimization**: For large sheets with many drawings, filter by range to improve performance","ref":"shapes_and_drawing.html#tips-for-working-with-drawing-objects"},{"type":"extras","title":"See Also - Drawing and Shape Management","doc":"- [Image Handling](image_handling.html) - For adding images to spreadsheets\n- [Styling and Formatting](styling_and_formatting.html) - For cell and sheet styling options\n- [Sheet Operations](sheet_operations.html) - For managing worksheets\n- [Thread Safety](thread_safety.html) - For information about concurrent operations","ref":"shapes_and_drawing.html#see-also"},{"type":"extras","title":"Page Breaks","doc":"# Page Breaks\n\nThis guide covers how to work with page breaks in UmyaSpreadsheet. Page breaks control where pages split when printing or viewing spreadsheets in Page Break Preview mode.","ref":"page_breaks.html"},{"type":"extras","title":"Table of Contents - Page Breaks","doc":"- [Overview](#overview)\n- [Types of Page Breaks](#types-of-page-breaks)\n- [Basic Operations](#basic-operations)\n- [Advanced Usage](#advanced-usage)\n- [Best Practices](#best-practices)\n- [Troubleshooting](#troubleshooting)","ref":"page_breaks.html#table-of-contents"},{"type":"extras","title":"Overview - Page Breaks","doc":"Page breaks in Excel determine where content splits across pages when printing or viewing in Page Break Preview mode. UmyaSpreadsheet provides comprehensive page break management through the `UmyaSpreadsheet.PageBreaks` module.","ref":"page_breaks.html#overview"},{"type":"extras","title":"Key Features - Page Breaks","doc":"- **Manual Page Breaks**: User-defined breaks that remain fixed\n- **Row Page Breaks**: Horizontal breaks that split pages vertically\n- **Column Page Breaks**: Vertical breaks that split pages horizontally\n- **Bulk Operations**: Add multiple page breaks efficiently\n- **Query Functions**: Check existing page breaks and their properties","ref":"page_breaks.html#key-features"},{"type":"extras","title":"Types of Page Breaks - Page Breaks","doc":"","ref":"page_breaks.html#types-of-page-breaks"},{"type":"extras","title":"Manual vs Automatic Page Breaks - Page Breaks","doc":"Excel supports two types of page breaks:\n\n- **Manual Page Breaks**: Explicitly set by users and have priority over automatic breaks\n- **Automatic Page Breaks**: Calculated by Excel based on page size, margins, and content\n\nUmyaSpreadsheet focuses on manual page breaks as they provide precise control over document layout.","ref":"page_breaks.html#manual-vs-automatic-page-breaks"},{"type":"extras","title":"Row Page Breaks - Page Breaks","doc":"Row page breaks create horizontal lines where pages split. Content above the break appears on one page, and content from the specified row onwards appears on the next page.\n\n```elixir\n# Add a page break above row 25\n:ok = UmyaSpreadsheet.PageBreaks.add_row_page_break(spreadsheet, \"Sheet1\", 25)\n\n# This means:\n# - Rows 1-24 will be on the first page\n# - Rows 25+ will be on subsequent pages\n```","ref":"page_breaks.html#row-page-breaks"},{"type":"extras","title":"Column Page Breaks - Page Breaks","doc":"Column page breaks create vertical lines where pages split. Content to the left of the break appears on one page, and content from the specified column onwards appears on the next page.\n\n```elixir\n# Add a page break to the left of column 10 (column J)\n:ok = UmyaSpreadsheet.PageBreaks.add_column_page_break(spreadsheet, \"Sheet1\", 10)\n\n# This means:\n# - Columns A-I will be on the left page\n# - Columns J+ will be on subsequent pages\n```","ref":"page_breaks.html#column-page-breaks"},{"type":"extras","title":"Basic Operations - Page Breaks","doc":"","ref":"page_breaks.html#basic-operations"},{"type":"extras","title":"Adding Page Breaks - Page Breaks","doc":"#### Single Row Page Break\n\n```elixir\n# Add a manual page break above row 50\n:ok = UmyaSpreadsheet.PageBreaks.add_row_page_break(spreadsheet, \"Sales Report\", 50)\n\n# Add an automatic page break above row 75\n:ok = UmyaSpreadsheet.PageBreaks.add_row_page_break(spreadsheet, \"Sales Report\", 75, false)\n```\n\n#### Single Column Page Break\n\n```elixir\n# Add a manual page break to the left of column 8 (column H)\n:ok = UmyaSpreadsheet.PageBreaks.add_column_page_break(spreadsheet, \"Sales Report\", 8)\n\n# Add an automatic page break to the left of column 12 (column L)\n:ok = UmyaSpreadsheet.PageBreaks.add_column_page_break(spreadsheet, \"Sales Report\", 12, false)\n```","ref":"page_breaks.html#adding-page-breaks"},{"type":"extras","title":"Removing Page Breaks - Page Breaks","doc":"#### Remove Specific Page Breaks\n\n```elixir\n# Remove the page break above row 50\n:ok = UmyaSpreadsheet.PageBreaks.remove_row_page_break(spreadsheet, \"Sales Report\", 50)\n\n# Remove the page break to the left of column 8\n:ok = UmyaSpreadsheet.PageBreaks.remove_column_page_break(spreadsheet, \"Sales Report\", 8)\n```\n\n#### Clear All Page Breaks\n\n```elixir\n# Clear all row page breaks\n:ok = UmyaSpreadsheet.PageBreaks.clear_row_page_breaks(spreadsheet, \"Sales Report\")\n\n# Clear all column page breaks\n:ok = UmyaSpreadsheet.PageBreaks.clear_column_page_breaks(spreadsheet, \"Sales Report\")\n```","ref":"page_breaks.html#removing-page-breaks"},{"type":"extras","title":"Querying Page Breaks - Page Breaks","doc":"#### Check for Specific Page Breaks\n\n```elixir\n# Check if there's a page break above row 50\n{:ok, has_break} = UmyaSpreadsheet.PageBreaks.has_row_page_break(spreadsheet, \"Sales Report\", 50)\n\nif has_break do\n  IO.puts(\"Page break found at row 50\")\nelse\n  IO.puts(\"No page break at row 50\")\nend\n\n# Check if there's a page break to the left of column 8\n{:ok, has_break} = UmyaSpreadsheet.PageBreaks.has_column_page_break(spreadsheet, \"Sales Report\", 8)\n```\n\n#### Get All Page Breaks\n\n```elixir\n# Get all row page breaks\n{:ok, row_breaks} = UmyaSpreadsheet.PageBreaks.get_row_page_breaks(spreadsheet, \"Sales Report\")\n# Returns: [{25, true}, {50, false}, {75, true}]\n# Format: [{row_number, is_manual}, ...]\n\n# Get all column page breaks\n{:ok, column_breaks} = UmyaSpreadsheet.PageBreaks.get_column_page_breaks(spreadsheet, \"Sales Report\")\n# Returns: [{8, true}, {15, true}]\n# Format: [{column_number, is_manual}, ...]\n```\n\n#### Count Page Breaks\n\n```elixir\n# Count row page breaks\n{:ok, row_count} = UmyaSpreadsheet.PageBreaks.count_row_page_breaks(spreadsheet, \"Sales Report\")\nIO.puts(\"Total row page breaks: #{row_count}\")\n\n# Count column page breaks\n{:ok, col_count} = UmyaSpreadsheet.PageBreaks.count_column_page_breaks(spreadsheet, \"Sales Report\")\nIO.puts(\"Total column page breaks: #{col_count}\")\n```","ref":"page_breaks.html#querying-page-breaks"},{"type":"extras","title":"Advanced Usage - Page Breaks","doc":"","ref":"page_breaks.html#advanced-usage"},{"type":"extras","title":"Bulk Operations - Page Breaks","doc":"For efficiency when adding multiple page breaks, use the bulk operation functions:\n\n```elixir\n# Add multiple row page breaks at once\n:ok = UmyaSpreadsheet.PageBreaks.add_row_page_breaks(\n  spreadsheet,\n  \"Financial Report\",\n  [25, 50, 75, 100, 125]\n)\n\n# Add multiple column page breaks at once\n:ok = UmyaSpreadsheet.PageBreaks.add_column_page_breaks(\n  spreadsheet,\n  \"Financial Report\",\n  [5, 10, 15, 20]\n)\n\n# Remove multiple page breaks efficiently\n:ok = UmyaSpreadsheet.PageBreaks.remove_row_page_breaks(\n  spreadsheet,\n  \"Financial Report\",\n  [25, 75]  # Remove some breaks\n)\n\n# Get all page breaks at once\n{:ok, %{row_breaks: rows, column_breaks: cols}} =\n  UmyaSpreadsheet.PageBreaks.get_all_page_breaks(spreadsheet, \"Financial Report\")\n\n# Clear all page breaks from a sheet\n:ok = UmyaSpreadsheet.PageBreaks.clear_all_page_breaks(spreadsheet, \"Financial Report\")\n```","ref":"page_breaks.html#bulk-operations"},{"type":"extras","title":"Creating Report Sections - Page Breaks","doc":"Page breaks are particularly useful for creating structured reports with distinct sections:\n\n```elixir\ndefmodule ReportGenerator do\n  def create_quarterly_report(spreadsheet) do\n    # Add headers and data...\n\n    # Create page breaks between quarters\n    quarterly_breaks = [\n      30,   # End of Q1 section\n      60,   # End of Q2 section\n      90,   # End of Q3 section\n      120   # End of Q4 section\n    ]\n\n    :ok = UmyaSpreadsheet.PageBreaks.add_row_page_breaks(\n      spreadsheet,\n      \"Quarterly Report\",\n      quarterly_breaks\n    )\n\n    # Add column breaks to separate different metric groups\n    metric_breaks = [8, 15, 22]  # Separate revenue, costs, profit sections\n\n    :ok = UmyaSpreadsheet.PageBreaks.add_column_page_breaks(\n      spreadsheet,\n      \"Quarterly Report\",\n      metric_breaks\n    )\n  end\nend\n```","ref":"page_breaks.html#creating-report-sections"},{"type":"extras","title":"Conditional Page Break Management - Page Breaks","doc":"```elixir\ndefmodule PageBreakManager do\n  def setup_dynamic_breaks(spreadsheet, sheet_name, data_rows) do\n    # Only add page breaks if we have substantial data\n    if data_rows > 50 do\n      # Add page breaks every 25 rows for long reports\n      breaks = Enum.take_every(25..data_rows, 25)\n\n      UmyaSpreadsheet.PageBreaks.add_row_page_breaks(\n        spreadsheet,\n        sheet_name,\n        breaks\n      )\n    end\n  end\n\n  def reset_page_breaks(spreadsheet, sheet_name) do\n    # Clear existing breaks before applying new layout\n    with :ok <- UmyaSpreadsheet.PageBreaks.clear_row_page_breaks(spreadsheet, sheet_name),\n         :ok <- UmyaSpreadsheet.PageBreaks.clear_column_page_breaks(spreadsheet, sheet_name) do\n      :ok\n    end\n  end\nend\n```","ref":"page_breaks.html#conditional-page-break-management"},{"type":"extras","title":"Working with Page Break Information - Page Breaks","doc":"```elixir\ndefmodule PageBreakAnalyzer do\n  def analyze_page_breaks(spreadsheet, sheet_name) do\n    # Get all page breaks\n    {:ok, row_breaks} = UmyaSpreadsheet.PageBreaks.get_row_page_breaks(spreadsheet, sheet_name)\n    {:ok, col_breaks} = UmyaSpreadsheet.PageBreaks.get_column_page_breaks(spreadsheet, sheet_name)\n\n    # Analyze the data\n    manual_row_breaks = Enum.filter(row_breaks, fn {_row, manual} -> manual end)\n    auto_row_breaks = Enum.filter(row_breaks, fn {_row, manual} -> not manual end)\n\n    manual_col_breaks = Enum.filter(col_breaks, fn {_col, manual} -> manual end)\n    auto_col_breaks = Enum.filter(col_breaks, fn {_col, manual} -> not manual end)\n\n    %{\n      total_row_breaks: length(row_breaks),\n      manual_row_breaks: length(manual_row_breaks),\n      automatic_row_breaks: length(auto_row_breaks),\n      total_column_breaks: length(col_breaks),\n      manual_column_breaks: length(manual_col_breaks),\n      automatic_column_breaks: length(auto_col_breaks),\n      row_break_positions: Enum.map(row_breaks, fn {row, _} -> row end),\n      column_break_positions: Enum.map(col_breaks, fn {col, _} -> col end)\n    }\n  end\nend\n```","ref":"page_breaks.html#working-with-page-break-information"},{"type":"extras","title":"Best Practices - Page Breaks","doc":"","ref":"page_breaks.html#best-practices"},{"type":"extras","title":"1. Strategic Placement - Page Breaks","doc":"- **Place breaks at logical boundaries**: End of sections, after headers, before summaries\n- **Consider content flow**: Ensure related data stays together\n- **Account for print margins**: Leave sufficient space for headers and footers","ref":"page_breaks.html#1-strategic-placement"},{"type":"extras","title":"2. Consistency - Page Breaks","doc":"```elixir\n# Use consistent spacing for similar reports\ndefmodule ReportStandards do\n  @section_break_interval 25\n  @subsection_break_interval 50\n\n  def apply_standard_breaks(spreadsheet, sheet_name, total_rows) do\n    # Apply breaks at standard intervals\n    major_breaks = Enum.take_every(@subsection_break_interval..total_rows, @subsection_break_interval)\n\n    UmyaSpreadsheet.PageBreaks.add_row_page_breaks(\n      spreadsheet,\n      sheet_name,\n      major_breaks\n    )\n  end\nend\n```","ref":"page_breaks.html#2-consistency"},{"type":"extras","title":"3. Performance Optimization - Page Breaks","doc":"```elixir\n# Use bulk operations for better performance\n# Instead of:\n# Enum.each(row_numbers, fn row ->\n#   UmyaSpreadsheet.PageBreaks.add_row_page_break(spreadsheet, sheet_name, row)\n# end)\n\n# Use:\nUmyaSpreadsheet.PageBreaks.add_row_page_breaks(\n  spreadsheet,\n  sheet_name,\n  row_numbers\n)\n```","ref":"page_breaks.html#3-performance-optimization"},{"type":"extras","title":"4. Error Handling - Page Breaks","doc":"```elixir\ndefmodule SafePageBreaks do\n  def add_row_break_safely(spreadsheet, sheet_name, row_number) do\n    case UmyaSpreadsheet.PageBreaks.add_row_page_break(spreadsheet, sheet_name, row_number) do\n      :ok ->\n        {:ok, \"Page break added at row #{row_number}\"}\n\n      {:error, :sheet_not_found} ->\n        {:error, \"Sheet '#{sheet_name}' not found\"}\n\n      {:error, reason} ->\n        {:error, \"Failed to add page break: #{reason}\"}\n    end\n  end\nend\n```","ref":"page_breaks.html#4-error-handling"},{"type":"extras","title":"5. Testing Page Breaks - Page Breaks","doc":"```elixir\ndefmodule PageBreakTests do\n  def verify_page_breaks(spreadsheet, sheet_name, expected_breaks) do\n    {:ok, actual_breaks} = UmyaSpreadsheet.PageBreaks.get_row_page_breaks(spreadsheet, sheet_name)\n    actual_positions = Enum.map(actual_breaks, fn {row, _} -> row end)\n\n    case Enum.sort(actual_positions) == Enum.sort(expected_breaks) do\n      true ->\n        {:ok, \"All expected page breaks found\"}\n\n      false ->\n        missing = expected_breaks -- actual_positions\n        extra = actual_positions -- expected_breaks\n\n        {:error, %{\n          missing: missing,\n          extra: extra,\n          expected: expected_breaks,\n          actual: actual_positions\n        }}\n    end\n  end\nend\n```","ref":"page_breaks.html#5-testing-page-breaks"},{"type":"extras","title":"Real-World Examples - Page Breaks","doc":"","ref":"page_breaks.html#real-world-examples"},{"type":"extras","title":"Financial Report with Sections - Page Breaks","doc":"```elixir\ndefmodule FinancialReport do\n  def create_report(spreadsheet) do\n    sheet_name = \"Financial Report 2024\"\n\n    # Add the sheet\n    UmyaSpreadsheet.add_sheet(spreadsheet, sheet_name)\n\n    # Add headers and data (simplified)\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, \"A1\", \"Financial Report 2024\")\n\n    # Define section boundaries\n    sections = [\n      {30, \"Revenue Section\"},\n      {60, \"Expenses Section\"},\n      {90, \"Profit Analysis\"},\n      {120, \"Year-over-Year Comparison\"}\n    ]\n\n    # Add page breaks between sections\n    section_breaks = Enum.map(sections, fn {row, _name} -> row end)\n\n    UmyaSpreadsheet.PageBreaks.add_row_page_breaks(\n      spreadsheet,\n      sheet_name,\n      section_breaks\n    )\n\n    # Add column breaks to separate quarters\n    quarter_breaks = [8, 15, 22]  # After Q1, Q2, Q3\n\n    UmyaSpreadsheet.PageBreaks.add_column_page_breaks(\n      spreadsheet,\n      sheet_name,\n      quarter_breaks\n    )\n\n    IO.puts(\"Financial report created with structured page breaks\")\n  end\nend\n```","ref":"page_breaks.html#financial-report-with-sections"},{"type":"extras","title":"Large Dataset with Regular Breaks - Page Breaks","doc":"```elixir\ndefmodule LargeDatasetProcessor do\n  def process_large_dataset(spreadsheet, data) do\n    sheet_name = \"Large Dataset\"\n    rows_per_page = 50\n\n    # Calculate total rows\n    total_rows = length(data)\n\n    # Add data (simplified)\n    # ... data insertion logic ...\n\n    # Calculate page break positions\n    page_breaks =\n      rows_per_page\n      |> Stream.iterate(&(&1 + rows_per_page))\n      |> Stream.take_while(&(&1   Enum.to_list()\n\n    # Add page breaks efficiently\n    case UmyaSpreadsheet.PageBreaks.add_row_page_breaks(\n      spreadsheet,\n      sheet_name,\n      page_breaks\n    ) do\n      :ok ->\n        IO.puts(\"Added #{length(page_breaks)} page breaks for #{total_rows} rows\")\n\n      {:error, reason} ->\n        IO.puts(\"Failed to add page breaks: #{reason}\")\n    end\n  end\nend\n```","ref":"page_breaks.html#large-dataset-with-regular-breaks"},{"type":"extras","title":"Troubleshooting - Page Breaks","doc":"","ref":"page_breaks.html#troubleshooting"},{"type":"extras","title":"Common Issues - Page Breaks","doc":"#### Issue: Page breaks not visible in Excel\n\n**Cause**: Page breaks are only visible in Page Break Preview mode or when printing.\n\n**Solution**:\n\n- Switch to Page Break Preview mode in Excel (View > Page Break Preview)\n- Check print preview to see page breaks in action\n\n#### Issue: \"Sheet not found\" errors\n\n**Cause**: Attempting to add page breaks to a non-existent sheet.\n\n**Solution**:\n\n```elixir\n# Always verify sheet exists before adding page breaks\ncase UmyaSpreadsheet.get_sheet_names(spreadsheet) do\n  {:ok, sheet_names} ->\n    if sheet_name in sheet_names do\n      UmyaSpreadsheet.PageBreaks.add_row_page_break(spreadsheet, sheet_name, row)\n    else\n      {:error, \"Sheet '#{sheet_name}' does not exist\"}\n    end\n\n  error -> error\nend\n```\n\n#### Issue: Unexpected page break behavior\n\n**Cause**: Mixing manual and automatic page breaks can cause confusion.\n\n**Solution**: Use consistent approach - either all manual or let Excel handle automatic breaks.","ref":"page_breaks.html#common-issues"},{"type":"extras","title":"Debugging Page Breaks - Page Breaks","doc":"```elixir\ndefmodule PageBreakDebugger do\n  def debug_page_breaks(spreadsheet, sheet_name) do\n    IO.puts(\"=== Page Break Debug Info for '#{sheet_name}' ===\")\n\n    # Get and display row breaks\n    case UmyaSpreadsheet.PageBreaks.get_row_page_breaks(spreadsheet, sheet_name) do\n      {:ok, row_breaks} ->\n        IO.puts(\"Row Page Breaks (#{length(row_breaks)}):\")\n        Enum.each(row_breaks, fn {row, manual} ->\n          type = if manual, do: \"Manual\", else: \"Automatic\"\n          IO.puts(\"  Row #{row}: #{type}\")\n        end)\n\n      {:error, reason} ->\n        IO.puts(\"Error getting row breaks: #{reason}\")\n    end\n\n    # Get and display column breaks\n    case UmyaSpreadsheet.PageBreaks.get_column_page_breaks(spreadsheet, sheet_name) do\n      {:ok, col_breaks} ->\n        IO.puts(\"Column Page Breaks (#{length(col_breaks)}):\")\n        Enum.each(col_breaks, fn {col, manual} ->\n          type = if manual, do: \"Manual\", else: \"Automatic\"\n          IO.puts(\"  Column #{col}: #{type}\")\n        end)\n\n      {:error, reason} ->\n        IO.puts(\"Error getting column breaks: #{reason}\")\n    end\n\n    IO.puts(\"=== End Debug Info ===\")\n  end\nend\n```","ref":"page_breaks.html#debugging-page-breaks"},{"type":"extras","title":"Performance Considerations - Page Breaks","doc":"- **Use bulk operations**: `add_row_page_breaks/3`, `add_column_page_breaks/3`, and other bulk functions are more efficient than individual calls\n- **Clear existing breaks**: Use `clear_*` functions before applying new page break schemes\n- **Minimize break modifications**: Adding/removing breaks frequently can impact performance\n- **Test with realistic data**: Page break behavior can change with different data volumes\n\nThis guide provides comprehensive coverage of page break functionality in UmyaSpreadsheet. Page breaks are powerful tools for controlling document layout and ensuring professional presentation of your spreadsheet data.","ref":"page_breaks.html#performance-considerations"},{"type":"extras","title":"Pivot Tables","doc":"# Pivot Tables\n\nThis guide explains how to use UmyaSpreadsheet's pivot table functionality to summarize and analyze data in your spreadsheets.","ref":"pivot_tables.html"},{"type":"extras","title":"Introduction to Pivot Tables - Pivot Tables","doc":"Pivot tables are powerful tools for data analysis that allow you to:\n\n- Summarize large datasets into a more manageable format\n- Rearrange data to show different perspectives\n- Create custom calculations and aggregations\n- Generate insights through cross-tabulations\n\nUmyaSpreadsheet allows you to create pivot tables programmatically, giving you the ability to build analysis tools and reports without manual Excel operations.","ref":"pivot_tables.html#introduction-to-pivot-tables"},{"type":"extras","title":"Creating a Basic Pivot Table - Pivot Tables","doc":"To create a pivot table, you need source data in a tabular format with headers in the first row. Then you can use the `add_pivot_table/9` function:\n\n```elixir\nUmyaSpreadsheet.add_pivot_table(\n  spreadsheet,\n  \"PivotSheet\",                # Sheet where the pivot table will be placed\n  \"Sales Analysis\",            # Name of the pivot table\n  \"Data\",                      # Sheet containing the source data\n  \"A1:D100\",                   # Range of source data (including headers)\n  \"A3\",                        # Top-left cell for pivot table placement\n  [0],                         # Row fields (0-based indices of source columns)\n  [1],                         # Column fields (0-based indices of source columns)\n  [{2, \"sum\", \"Total Sales\"}]  # Data fields with aggregation functions\n)\n```\n\nThis will create a pivot table that:\n\n- Uses the first column (index 0) as row labels\n- Uses the second column (index 1) as column labels\n- Sums the values from the third column (index 2) at the intersections","ref":"pivot_tables.html#creating-a-basic-pivot-table"},{"type":"extras","title":"Field Types - Pivot Tables","doc":"A pivot table consists of three main field types:\n\n1. **Row Fields**: These fields appear as row labels (vertically) in the pivot table. Each unique value becomes a row in the pivot table.\n\n2. **Column Fields**: These fields appear as column labels (horizontally) in the pivot table. Each unique value becomes a column.\n\n3. **Data Fields**: These fields contain the values that are calculated at the intersection of row and column fields. They require:\n   - A field index (which column to use)\n   - An aggregation function (how to aggregate the values)\n   - A custom name (what to label the data field)","ref":"pivot_tables.html#field-types"},{"type":"extras","title":"Available Aggregation Functions - Pivot Tables","doc":"When setting up data fields, you can specify one of the following aggregation functions:\n\n- `\"sum\"` - Sum of all values\n- `\"count\"` - Count of all values\n- `\"average\"` - Average (mean) of values\n- `\"max\"` - Maximum value\n- `\"min\"` - Minimum value\n- `\"product\"` - Product of all values (multiplication)\n- `\"count_nums\"` - Count of numeric values only\n- `\"stddev\"` - Standard deviation of a sample\n- `\"stddevp\"` - Standard deviation of a population\n- `\"var\"` - Variance of a sample\n- `\"varp\"` - Variance of a population\n\nFor example, to create a pivot table with average values:\n\n```elixir\nUmyaSpreadsheet.add_pivot_table(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Average Analysis\",\n  \"Data\",\n  \"A1:D100\",\n  \"A3\",\n  [0],\n  [1],\n  [{2, \"average\", \"Average Sales\"}]\n)\n```","ref":"pivot_tables.html#available-aggregation-functions"},{"type":"extras","title":"Multiple Data Fields - Pivot Tables","doc":"You can include multiple data fields in a single pivot table:\n\n```elixir\nUmyaSpreadsheet.add_pivot_table(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Complete Analysis\",\n  \"Data\",\n  \"A1:D100\",\n  \"A3\",\n  [0],\n  [1],\n  [\n    {2, \"sum\", \"Total Sales\"},\n    {2, \"average\", \"Average Sales\"},\n    {2, \"max\", \"Max Sale\"}\n  ]\n)\n```\n\nThis creates a pivot table with three data fields, all using the same source column but with different aggregation functions.","ref":"pivot_tables.html#multiple-data-fields"},{"type":"extras","title":"Managing Pivot Tables - Pivot Tables","doc":"UmyaSpreadsheet provides several functions to manage pivot tables:","ref":"pivot_tables.html#managing-pivot-tables"},{"type":"extras","title":"Checking for Pivot Tables - Pivot Tables","doc":"```elixir\n# Check if a sheet has any pivot tables\nif UmyaSpreadsheet.has_pivot_tables?(spreadsheet, \"PivotSheet\") do\n  IO.puts(\"Sheet has pivot tables\")\nend\n\n# Count pivot tables in a sheet\ncount = UmyaSpreadsheet.count_pivot_tables(spreadsheet, \"PivotSheet\")\nIO.puts(\"Sheet has #{count} pivot tables\")\n```","ref":"pivot_tables.html#checking-for-pivot-tables"},{"type":"extras","title":"Refreshing Pivot Tables - Pivot Tables","doc":"When the source data changes, you need to refresh pivot tables to update them:\n\n```elixir\n# Refresh all pivot tables in the spreadsheet\nUmyaSpreadsheet.refresh_all_pivot_tables(spreadsheet)\n```","ref":"pivot_tables.html#refreshing-pivot-tables"},{"type":"extras","title":"Removing Pivot Tables - Pivot Tables","doc":"You can remove a specific pivot table by its name:\n\n```elixir\n# Remove a pivot table\nUmyaSpreadsheet.remove_pivot_table(spreadsheet, \"PivotSheet\", \"Sales Analysis\")\n```","ref":"pivot_tables.html#removing-pivot-tables"},{"type":"extras","title":"Enhanced Pivot Table Features - Pivot Tables","doc":"UmyaSpreadsheet provides enhanced pivot table functionality that allows you to inspect and modify existing pivot tables in detail.","ref":"pivot_tables.html#enhanced-pivot-table-features"},{"type":"extras","title":"Working with Cache Fields - Pivot Tables","doc":"Cache fields represent the original columns from your source data and define how the data is categorized and processed within the pivot table.\n\n#### Getting All Cache Fields\n\n```elixir\n# Get all cache fields for a pivot table\n{:ok, cache_fields} = UmyaSpreadsheet.PivotTable.get_cache_fields(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Sales Analysis\"\n)\n\n# The cache_fields list contains information about each source column\n# Each field includes name, data type, and other metadata\nIO.inspect(cache_fields)\n```\n\n#### Getting Specific Cache Field Information\n\n```elixir\n# Get detailed information about a specific cache field\n{:ok, cache_field} = UmyaSpreadsheet.PivotTable.get_cache_field(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Sales Analysis\",\n  0  # Field index (0-based)\n)\n\n# The cache_field contains detailed information about the field\n# including its name, data type, and unique values\nIO.inspect(cache_field)\n```","ref":"pivot_tables.html#working-with-cache-fields"},{"type":"extras","title":"Working with Data Fields - Pivot Tables","doc":"Data fields are the calculated fields that appear in the body of the pivot table. They specify which source columns to aggregate and how to aggregate them.\n\n#### Getting All Data Fields\n\n```elixir\n# Get all data fields for a pivot table\n{:ok, data_fields} = UmyaSpreadsheet.PivotTable.get_data_fields(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Sales Analysis\"\n)\n\n# Each data field contains information about:\n# - Which source field it references\n# - The aggregation function used\n# - The display name\n# - Number formatting options\nIO.inspect(data_fields)\n```\n\n#### Adding New Data Fields\n\n```elixir\n# Add a new data field to an existing pivot table\n{:ok, _} = UmyaSpreadsheet.PivotTable.add_data_field(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Sales Analysis\",\n  2,          # Source field index (0-based)\n  \"average\",  # Aggregation function\n  \"Avg Sales\" # Display name\n)\n\n# This adds a new data field that shows the average of the Sales column\n# alongside any existing data fields\n```","ref":"pivot_tables.html#working-with-data-fields"},{"type":"extras","title":"Working with Cache Source - Pivot Tables","doc":"The cache source defines where the pivot table gets its data from, including the source range and refresh settings.\n\n#### Getting Cache Source Information\n\n```elixir\n# Get cache source configuration for a pivot table\n{:ok, cache_source} = UmyaSpreadsheet.PivotTable.get_cache_source(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Sales Analysis\"\n)\n\n# The cache_source contains:\n# - Source sheet and range information\n# - Refresh settings\n# - Connection details\nIO.inspect(cache_source)\n```\n\n#### Updating Cache Source\n\n```elixir\n# Update the cache source to point to a different range\n{:ok, _} = UmyaSpreadsheet.PivotTable.update_cache(\n  spreadsheet,\n  \"PivotSheet\",\n  \"Sales Analysis\",\n  \"Sheet1\",    # New source sheet\n  \"A1:D100\"    # New source range\n)\n\n# This updates the pivot table to use data from the new range\n# You should refresh the pivot table after updating the cache\n```","ref":"pivot_tables.html#working-with-cache-source"},{"type":"extras","title":"Advanced Pivot Table Workflow - Pivot Tables","doc":"Here's an example of how to use the enhanced features to analyze and modify an existing pivot table:\n\n```elixir\n# First, inspect the current structure\n{:ok, cache_fields} = UmyaSpreadsheet.PivotTable.get_cache_fields(\n  spreadsheet, \"PivotSheet\", \"Sales Analysis\"\n)\n\n{:ok, data_fields} = UmyaSpreadsheet.PivotTable.get_data_fields(\n  spreadsheet, \"PivotSheet\", \"Sales Analysis\"\n)\n\n{:ok, cache_source} = UmyaSpreadsheet.PivotTable.get_cache_source(\n  spreadsheet, \"PivotSheet\", \"Sales Analysis\"\n)\n\nIO.puts(\"Cache Fields: #{length(cache_fields)}\")\nIO.puts(\"Data Fields: #{length(data_fields)}\")\nIO.puts(\"Source: #{inspect(cache_source)}\")\n\n# Add additional analysis fields\nUmyaSpreadsheet.PivotTable.add_data_field(\n  spreadsheet, \"PivotSheet\", \"Sales Analysis\",\n  2, \"max\", \"Highest Sale\"\n)\n\nUmyaSpreadsheet.PivotTable.add_data_field(\n  spreadsheet, \"PivotSheet\", \"Sales Analysis\",\n  2, \"min\", \"Lowest Sale\"\n)\n\n# Update to use a larger data range\nUmyaSpreadsheet.PivotTable.update_cache(\n  spreadsheet, \"PivotSheet\", \"Sales Analysis\",\n  \"Sheet1\", \"A1:D200\"\n)\n\n# Refresh to apply changes\nUmyaSpreadsheet.refresh_all_pivot_tables(spreadsheet)\n```","ref":"pivot_tables.html#advanced-pivot-table-workflow"},{"type":"extras","title":"Complete Example - Pivot Tables","doc":"Here's a complete example showing how to create a spreadsheet with both source data and a pivot table:\n\n```elixir\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Create headers in Sheet1\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Region\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"Product\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C1\", \"Sales\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"D1\", \"Date\")\n\n# Add some data\nregions = [\"North\", \"South\", \"East\", \"West\"]\nproducts = [\"Apples\", \"Oranges\", \"Bananas\", \"Grapes\"]\n\n# Generate random sales data\nfor row <- 2..50 do\n  region = Enum.random(regions)\n  product = Enum.random(products)\n  sales = :rand.uniform(10000) + 5000\n  date = Date.add(Date.utc_today(), -:rand.uniform(365))\n\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A#{row}\", region)\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B#{row}\", product)\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C#{row}\", \"#{sales}\")\n  UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"D#{row}\", Date.to_iso8601(date))\nend\n\n# Create a sheet for the pivot table\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Sales Analysis\")\n\n# Create region-by-product pivot table\nUmyaSpreadsheet.add_pivot_table(\n  spreadsheet,\n  \"Sales Analysis\",\n  \"Region by Product\",\n  \"Sheet1\",\n  \"A1:D50\",\n  \"A3\",\n  [0], # Region as rows\n  [1], # Product as columns\n  [{2, \"sum\", \"Total Sales\"}] # Sum of sales\n)\n\n# Create a second pivot table showing averages\nUmyaSpreadsheet.add_pivot_table(\n  spreadsheet,\n  \"Sales Analysis\",\n  \"Product Analysis\",\n  \"Sheet1\",\n  \"A1:D50\",\n  \"A20\",\n  [1], # Product as rows\n  [],  # No column fields\n  [\n    {2, \"sum\", \"Total Sales\"},\n    {2, \"average\", \"Average Sale\"},\n    {2, \"count\", \"Number of Sales\"}\n  ]\n)\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"sales_analysis.xlsx\")\n```","ref":"pivot_tables.html#complete-example"},{"type":"extras","title":"Limitations - Pivot Tables","doc":"- Formatting options for pivot tables (like styles, number formats, etc.) are currently limited\n- The pivot table cache is created when the file is saved, but isn't automatically updated when source data changes\n- The `refresh_all_pivot_tables/1` function currently has limited functionality in the backend implementation and may not fully refresh the pivot table data in all cases\n- For best results, re-create pivot tables after significant source data changes, or ensure you call `refresh_all_pivot_tables/1` before saving the spreadsheet\n- The pivot tables will be properly displayed and functional when the file is opened in Excel or other compatible applications","ref":"pivot_tables.html#limitations"},{"type":"extras","title":"Enhanced Features - Pivot Tables","doc":"With the recent enhancements, UmyaSpreadsheet now provides:\n\n- **Complete Cache Field Access**: Inspect all source fields and their properties\n- **Data Field Management**: View and add new calculated fields to existing pivot tables\n- **Cache Source Control**: Update the source data range and refresh settings\n- **Detailed Introspection**: Get comprehensive information about pivot table structure\n\nThese enhanced features make it possible to programmatically analyze and modify existing pivot tables, providing greater flexibility for data analysis workflows.","ref":"pivot_tables.html#enhanced-features"},{"type":"extras","title":"Excel Compatibility - Pivot Tables","doc":"Pivot tables created with UmyaSpreadsheet are compatible with Microsoft Excel and other spreadsheet applications that support the XLSX format. When opening the file in Excel, you'll be able to interact with the pivot tables normally, including:\n\n- Refreshing the data\n- Modifying the layout\n- Changing summary functions\n- Adding filters\n- Creating pivot charts","ref":"pivot_tables.html#excel-compatibility"},{"type":"extras","title":"Print Settings and Page Setup","doc":"# Print Settings and Page Setup\n\nThis guide explains how to configure print settings and page setup options in UmyaSpreadsheet.","ref":"print_settings.html"},{"type":"extras","title":"Overview - Print Settings and Page Setup","doc":"UmyaSpreadsheet provides various functions to control how your worksheets appear when printed. These include:\n\n- Page orientation (portrait/landscape)\n- Paper size\n- Page scaling\n- Fit-to options\n- Page margins\n- Headers and footers\n- Print centering\n- Print area\n- Print titles (repeating rows/columns)","ref":"print_settings.html#overview"},{"type":"extras","title":"Basic Print Setup - Print Settings and Page Setup","doc":"","ref":"print_settings.html#basic-print-setup"},{"type":"extras","title":"Page Orientation - Print Settings and Page Setup","doc":"Set and get the page orientation to portrait or landscape:\n\n```elixir\n# Set to landscape orientation\nUmyaSpreadsheet.set_page_orientation(spreadsheet, \"Sheet1\", \"landscape\")\n\n# Set to portrait orientation\nUmyaSpreadsheet.set_page_orientation(spreadsheet, \"Sheet1\", \"portrait\")\n\n# Get current orientation\ncase UmyaSpreadsheet.get_page_orientation(spreadsheet, \"Sheet1\") do\n  {:ok, orientation} -> IO.puts(\"Current orientation: #{orientation}\")  # \"landscape\" or \"portrait\"\n  {:error, reason} -> IO.puts(\"Error: #{reason}\")\nend\n```","ref":"print_settings.html#page-orientation"},{"type":"extras","title":"Paper Size - Print Settings and Page Setup","doc":"Set and get the paper size using standard size codes:\n\n```elixir\n# Set to A4 paper (code 9)\nUmyaSpreadsheet.set_paper_size(spreadsheet, \"Sheet1\", 9)\n\n# Set to US Letter (code 1)\nUmyaSpreadsheet.set_paper_size(spreadsheet, \"Sheet1\", 1)\n\n# Get current paper size\n{:ok, paper_size} = UmyaSpreadsheet.get_paper_size(spreadsheet, \"Sheet1\")\nIO.puts(\"Current paper size code: #{paper_size}\")\n```\n\nCommon paper size codes:\n\n- 1: Letter (8.5 x 11 in)\n- 5: Legal (8.5 x 14 in)\n- 9: A4 (210 x 297 mm)\n- 10: A3 (297 x 420 mm)","ref":"print_settings.html#paper-size"},{"type":"extras","title":"Page Scaling - Print Settings and Page Setup","doc":"Scale the content to a percentage of its original size:\n\n```elixir\n# Scale to 75%\nUmyaSpreadsheet.set_page_scale(spreadsheet, \"Sheet1\", 75)\n\n# Get current scale\n{:ok, scale} = UmyaSpreadsheet.get_page_scale(spreadsheet, \"Sheet1\")\nIO.puts(\"Current scale: #{scale}%\")  # Example: 75\n```\n\nValid scale values range from 10 to 400 percent.","ref":"print_settings.html#page-scaling"},{"type":"extras","title":"Fit-to Options - Print Settings and Page Setup","doc":"Make your content fit a specific number of pages:\n\n```elixir\n# Fit to 1 page wide by 1 page tall\nUmyaSpreadsheet.set_fit_to_page(spreadsheet, \"Sheet1\", 1, 1)\n\n# Fit to 1 page wide by however many pages needed vertically (0 means no limit)\nUmyaSpreadsheet.set_fit_to_page(spreadsheet, \"Sheet1\", 1, 0)\n\n# Get current fit-to-page settings\n{width, height} = UmyaSpreadsheet.get_fit_to_page(spreadsheet, \"Sheet1\")\nIO.puts(\"Fit to #{width} page(s) wide by #{height} page(s) tall\")\n```","ref":"print_settings.html#fit-to-options"},{"type":"extras","title":"Page Margins - Print Settings and Page Setup","doc":"Set the page margins in inches:\n\n```elixir\n# Set margins (top, right, bottom, left)\nUmyaSpreadsheet.set_page_margins(spreadsheet, \"Sheet1\", 1.0, 0.75, 1.0, 0.75)\n\n# Get current margins\n{top, right, bottom, left} = UmyaSpreadsheet.get_page_margins(spreadsheet, \"Sheet1\")\nIO.puts(\"Margins - Top: #{top}, Right: #{right}, Bottom: #{bottom}, Left: #{left}\")\n```\n\nSet header and footer margins specifically:\n\n```elixir\n# Set header margin to 0.5 inches and footer margin to 0.5 inches\nUmyaSpreadsheet.set_header_footer_margins(spreadsheet, \"Sheet1\", 0.5, 0.5)\n\n# Get current header/footer margins\n{header_margin, footer_margin} = UmyaSpreadsheet.get_header_footer_margins(spreadsheet, \"Sheet1\")\nIO.puts(\"Header margin: #{header_margin}, Footer margin: #{footer_margin}\")\n```","ref":"print_settings.html#page-margins"},{"type":"extras","title":"Headers and Footers - Print Settings and Page Setup","doc":"Set header content with formatting codes:\n\n```elixir\n# Set a centered, bold header\nUmyaSpreadsheet.set_header(spreadsheet, \"Sheet1\", \"&C&\\\"Arial,Bold\\\"Confidential Document\")\n\n# Get current header\n{:ok, header_text} = UmyaSpreadsheet.get_header(spreadsheet, \"Sheet1\")\nIO.puts(\"Current header: #{header_text}\")\n```\n\nSet footer content:\n\n```elixir\n# Set right-aligned page numbers\nUmyaSpreadsheet.set_footer(spreadsheet, \"Sheet1\", \"&RPage &P of &N\")\n\n# Get current footer\n{:ok, footer_text} = UmyaSpreadsheet.get_footer(spreadsheet, \"Sheet1\")\nIO.puts(\"Current footer: #{footer_text}\")\n```","ref":"print_settings.html#headers-and-footers"},{"type":"extras","title":"Header/Footer Formatting Codes - Print Settings and Page Setup","doc":"- Position codes:\n  - `&L`: Left section\n  - `&C`: Center section\n  - `&R`: Right section\n\n- Font formatting:\n  - `&\"Font,Style\"`: Set font name and style\n  - `&B`: Bold\n  - `&I`: Italic\n  - `&U`: Underline\n  - `&S`: Strikethrough\n  - `&nn`: Font size (where nn is the size)\n\n- Content codes:\n  - `&P`: Current page number\n  - `&N`: Total pages\n  - `&D`: Current date\n  - `&T`: Current time\n  - `&F`: File name\n  - `&A`: Sheet name","ref":"print_settings.html#header-footer-formatting-codes"},{"type":"extras","title":"Inspecting Print Settings - Print Settings and Page Setup","doc":"You can retrieve current print settings to inspect or modify existing spreadsheets:\n\n```elixir\n# Get all current print settings\n{:ok, orientation} = UmyaSpreadsheet.get_page_orientation(spreadsheet, \"Sheet1\")\n{:ok, paper_size} = UmyaSpreadsheet.get_paper_size(spreadsheet, \"Sheet1\")\n{:ok, scale} = UmyaSpreadsheet.get_page_scale(spreadsheet, \"Sheet1\")\n{fit_width, fit_height} = UmyaSpreadsheet.get_fit_to_page(spreadsheet, \"Sheet1\")\n{top, right, bottom, left} = UmyaSpreadsheet.get_page_margins(spreadsheet, \"Sheet1\")\n{header_margin, footer_margin} = UmyaSpreadsheet.get_header_footer_margins(spreadsheet, \"Sheet1\")\n{:ok, header} = UmyaSpreadsheet.get_header(spreadsheet, \"Sheet1\")\n{:ok, footer} = UmyaSpreadsheet.get_footer(spreadsheet, \"Sheet1\")\n{h_center, v_center} = UmyaSpreadsheet.get_print_centered(spreadsheet, \"Sheet1\")\n{:ok, print_area} = UmyaSpreadsheet.get_print_area(spreadsheet, \"Sheet1\")\n{title_rows, title_cols} = UmyaSpreadsheet.get_print_titles(spreadsheet, \"Sheet1\")\n\nIO.puts(\"Print Settings for Sheet1:\")\nIO.puts(\"  Orientation: #{orientation}\")\nIO.puts(\"  Paper Size: #{paper_size}\")\nIO.puts(\"  Scale: #{scale}%\")\nIO.puts(\"  Fit to: #{fit_width} x #{fit_height} pages\")\nIO.puts(\"  Margins: T:#{top} R:#{right} B:#{bottom} L:#{left}\")\nIO.puts(\"  Header/Footer Margins: #{header_margin} / #{footer_margin}\")\nIO.puts(\"  Header: #{header || \"None\"}\")\nIO.puts(\"  Footer: #{footer || \"None\"}\")\nIO.puts(\"  Centered: H:#{h_center} V:#{v_center}\")\nIO.puts(\"  Print Area: #{print_area || \"All\"}\")\nIO.puts(\"  Print Titles: Rows:#{title_rows || \"None\"} Cols:#{title_cols || \"None\"}\")\n```","ref":"print_settings.html#inspecting-print-settings"},{"type":"extras","title":"Print Centering - Print Settings and Page Setup","doc":"Center the content on the page:\n\n```elixir\n# Center horizontally only\nUmyaSpreadsheet.set_print_centered(spreadsheet, \"Sheet1\", true, false)\n\n# Center both horizontally and vertically\nUmyaSpreadsheet.set_print_centered(spreadsheet, \"Sheet1\", true, true)\n\n# Get current centering settings\n{horizontal, vertical} = UmyaSpreadsheet.get_print_centered(spreadsheet, \"Sheet1\")\nIO.puts(\"Centered - Horizontal: #{horizontal}, Vertical: #{vertical}\")\n```","ref":"print_settings.html#print-centering"},{"type":"extras","title":"Print Area - Print Settings and Page Setup","doc":"Define a specific area to print:\n\n```elixir\n# Only print cells A1 through H20\nUmyaSpreadsheet.set_print_area(spreadsheet, \"Sheet1\", \"A1:H20\")\n\n# Get current print area\ncase UmyaSpreadsheet.get_print_area(spreadsheet, \"Sheet1\") do\n  {:ok, range} -> IO.puts(\"Print area: #{range}\")\n  {:error, _} -> IO.puts(\"No print area defined\")\nend\n```","ref":"print_settings.html#print-area"},{"type":"extras","title":"Print Titles - Print Settings and Page Setup","doc":"Set rows and/or columns to repeat on each printed page:\n\n```elixir\n# Repeat rows 1 and 2 at the top of each page\nUmyaSpreadsheet.set_print_titles(spreadsheet, \"Sheet1\", \"1:2\", \"\")\n\n# Repeat columns A and B on each page\nUmyaSpreadsheet.set_print_titles(spreadsheet, \"Sheet1\", \"\", \"A:B\")\n\n# Repeat both rows and columns\nUmyaSpreadsheet.set_print_titles(spreadsheet, \"Sheet1\", \"1:2\", \"A:B\")\n\n# Get current print titles\n{rows, columns} = UmyaSpreadsheet.get_print_titles(spreadsheet, \"Sheet1\")\ncase {rows, columns} do\n  {nil, nil} -> IO.puts(\"No print titles defined\")\n  {rows, nil} -> IO.puts(\"Print title rows: #{rows}\")\n  {nil, columns} -> IO.puts(\"Print title columns: #{columns}\")\n  {rows, columns} -> IO.puts(\"Print title rows: #{rows}, columns: #{columns}\")\nend\n```","ref":"print_settings.html#print-titles"},{"type":"extras","title":"Complete Example - Print Settings and Page Setup","doc":"Here's a complete example of setting up a worksheet for printing and then inspecting the settings:\n\n```elixir\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Configure print settings\nUmyaSpreadsheet.set_page_orientation(spreadsheet, \"Sheet1\", \"landscape\")\nUmyaSpreadsheet.set_paper_size(spreadsheet, \"Sheet1\", 9)  # A4\nUmyaSpreadsheet.set_fit_to_page(spreadsheet, \"Sheet1\", 1, 0)  # Fit to 1 page wide\nUmyaSpreadsheet.set_page_margins(spreadsheet, \"Sheet1\", 0.75, 0.75, 0.75, 0.75)\nUmyaSpreadsheet.set_header(spreadsheet, \"Sheet1\", \"&L&D&R&F\")\nUmyaSpreadsheet.set_footer(spreadsheet, \"Sheet1\", \"&RPage &P of &N\")\nUmyaSpreadsheet.set_print_area(spreadsheet, \"Sheet1\", \"A1:G20\")\nUmyaSpreadsheet.set_print_titles(spreadsheet, \"Sheet1\", \"1:1\", \"\")\n\n# Verify the settings were applied\n{:ok, orientation} = UmyaSpreadsheet.get_page_orientation(spreadsheet, \"Sheet1\")\n{:ok, paper_size} = UmyaSpreadsheet.get_paper_size(spreadsheet, \"Sheet1\")\n{fit_width, fit_height} = UmyaSpreadsheet.get_fit_to_page(spreadsheet, \"Sheet1\")\n{:ok, print_area} = UmyaSpreadsheet.get_print_area(spreadsheet, \"Sheet1\")\n\nIO.puts(\"Applied settings:\")\nIO.puts(\"  Orientation: #{orientation}\")      # \"landscape\"\nIO.puts(\"  Paper size: #{paper_size}\")        # 9\nIO.puts(\"  Fit to: #{fit_width}x#{fit_height}\") # 1x0\nIO.puts(\"  Print area: #{print_area}\")        # \"A1:G20\"\n\n# Write the file\nUmyaSpreadsheet.write(spreadsheet, \"print_settings_example.xlsx\")\n```","ref":"print_settings.html#complete-example"},{"type":"extras","title":"Window Settings","doc":"# Window Settings\n\nThis guide covers the window settings functionality in UmyaSpreadsheet, allowing you to control how an Excel workbook and its worksheets appear when opened in Excel.","ref":"window_settings.html"},{"type":"extras","title":"Sheet Selection - Window Settings","doc":"You can set which cell or range is selected when a user opens a particular worksheet:\n\n```elixir\nalias UmyaSpreadsheet\n\n# Create a new spreadsheet\n{:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n# Add some data\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Header\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B2\", \"Content\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"C3\", \"More Content\")\n\n# Set the active cell to B2 when the sheet is opened\nUmyaSpreadsheet.set_selection(spreadsheet, \"Sheet1\", \"B2\")\n\n# Or select a range of cells (the first cell becomes the active cell)\nUmyaSpreadsheet.set_selection(spreadsheet, \"Sheet1\", \"B2:C5\")\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"window_settings.xlsx\")\n```","ref":"window_settings.html#sheet-selection"},{"type":"extras","title":"Working with Active Tabs - Window Settings","doc":"When a workbook contains multiple worksheets, you can control which sheet is active when the workbook is opened:\n\n```elixir\n# Create a new sheet\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Data\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Data\", \"A1\", \"This is the data sheet\")\n\n# Create another sheet\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Summary\")\nUmyaSpreadsheet.set_cell_value(spreadsheet, \"Summary\", \"A1\", \"This is the summary sheet\")\n\n# Set \"Summary\" as the active sheet when the workbook is opened\n# Sheet indices are 0-based, so if \"Summary\" is the third sheet, its index is 2\nUmyaSpreadsheet.set_active_tab(spreadsheet, 2)\n```\n\nTo determine the index of a sheet, you can use:\n\n```elixir\nsheet_names = UmyaSpreadsheet.get_sheet_names(spreadsheet)\n```\n\nYou can also retrieve the current active tab index using:\n\n```elixir\n# Get the active tab index (returns an integer, 0-based)\nactive_tab_index = UmyaSpreadsheet.get_active_tab(spreadsheet)\n\n# Use this to determine which sheet is currently active\nsheet_names = UmyaSpreadsheet.get_sheet_names(spreadsheet)\nactive_sheet_name = Enum.at(sheet_names, active_tab_index)\n\nIO.puts(\"Active sheet: #{active_sheet_name}\")\n```","ref":"window_settings.html#working-with-active-tabs"},{"type":"extras","title":"Window Position and Size - Window Settings","doc":"You can control the initial position and size of the Excel window when a workbook is opened:\n\n```elixir\n# Set the window position (x, y) and size (width, height)\nUmyaSpreadsheet.set_workbook_window_position(spreadsheet, 100, 50, 800, 600)\n```\n\nTo retrieve the current window position and size settings:\n\n```elixir\n# Get the window position and size as a map\nposition = UmyaSpreadsheet.get_workbook_window_position(spreadsheet)\n\n# The returned map has :x, :y, :width, and :height keys\nIO.puts(\"Window position: #{position[:x]}, #{position[:y]}\")\nIO.puts(\"Window size: #{position[:width]} x #{position[:height]}\")\n```","ref":"window_settings.html#window-position-and-size"},{"type":"extras","title":"Setting Active Sheet by Name - Window Settings","doc":"If you know the sheet name rather than its index:\n\n```elixir\n# Find the index of a sheet by name\nsheet_names = UmyaSpreadsheet.get_sheet_names(spreadsheet)\nsummary_index = Enum.find_index(sheet_names, fn name -> name == \"Summary\" end)\nUmyaSpreadsheet.set_active_tab(spreadsheet, summary_index)\n```","ref":"window_settings.html#setting-active-sheet-by-name"},{"type":"extras","title":"Workbook Window Position and Size - Window Settings","doc":"You can control the position and size of the Excel application window when the workbook is opened:\n\n```elixir\n# Set the window position and size (all values in pixels)\n# Parameters: left, top, width, height\nUmyaSpreadsheet.set_workbook_window_position(spreadsheet, 100, 100, 800, 600)\n```\n\nThis setting only works when:\n\n- The workbook is opened in Excel desktop applications\n- The user does not have Excel already open\n- The user's Excel preferences don't override these settings","ref":"window_settings.html#workbook-window-position-and-size"},{"type":"extras","title":"Combining Window Settings - Window Settings","doc":"You can combine multiple window settings to create a specific user experience:\n\n```elixir\n# Create a new spreadsheet with multiple sheets\nspreadsheet = UmyaSpreadsheet.new()\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Data\")\nUmyaSpreadsheet.add_sheet(spreadsheet, \"Analysis\")\n\n# Add data to sheets\n# ...\n\n# Configure window settings\nUmyaSpreadsheet.set_active_tab(spreadsheet, 1)  # \"Analysis\" sheet is active\nUmyaSpreadsheet.set_selection(spreadsheet, \"Analysis\", \"B5\")  # B5 is selected\nUmyaSpreadsheet.set_workbook_window_position(spreadsheet, 50, 50, 1200, 800)  # Large window\n\n# Save the spreadsheet\nUmyaSpreadsheet.write(spreadsheet, \"configured_workbook.xlsx\")\n```","ref":"window_settings.html#combining-window-settings"},{"type":"extras","title":"Best Practices - Window Settings","doc":"1. **User-Friendly Defaults**: Set the active tab to the most relevant sheet for users\n2. **Focus Attention**: Use selection to direct users to important cells or data entry areas\n3. **Screen Compatibility**: When setting window positions and sizes, consider varied screen resolutions\n4. **Testing**: Test your settings on different Excel versions to ensure compatibility\n5. **Documentation**: Document any specific window settings in your code for future reference","ref":"window_settings.html#best-practices"},{"type":"extras","title":"Limitations - Window Settings","doc":"- Some Excel settings may override workbook window settings\n- Window position settings may behave differently across Excel versions and platforms\n- Window settings are suggestions to Excel and may not be honored in all circumstances","ref":"window_settings.html#limitations"},{"type":"extras","title":"Thread Safety and Concurrent Operations","doc":"# Thread Safety and Concurrent Operations\n\nThis guide provides information about using UmyaSpreadsheet in multi-threaded environments and concurrent operations.","ref":"thread_safety.html"},{"type":"extras","title":"Overview - Thread Safety and Concurrent Operations","doc":"UmyaSpreadsheet provides the ability to work with Excel files in concurrent operations. Understanding the thread safety characteristics of the library is important when developing applications that need to handle multiple spreadsheets simultaneously or operate on the same spreadsheet from multiple threads.","ref":"thread_safety.html#overview"},{"type":"extras","title":"Thread Safety Guidelines - Thread Safety and Concurrent Operations","doc":"When working with UmyaSpreadsheet in a multi-threaded environment, keep these guidelines in mind:","ref":"thread_safety.html#thread-safety-guidelines"},{"type":"extras","title":"What Works Well in Concurrent Scenarios - Thread Safety and Concurrent Operations","doc":"1. **Creating Multiple Independent Spreadsheets**: You can safely create and manipulate multiple\n   spreadsheet objects in parallel threads without conflicts.\n\n2. **Drawing Operations on Different Spreadsheets**: Adding shapes, text boxes, and connectors\n   to different spreadsheet objects in parallel is safe.\n\n3. **Reading From Multiple Threads**: Reading operations (getting cell values, etc.) from different\n   threads on the same spreadsheet are generally safe.","ref":"thread_safety.html#what-works-well-in-concurrent-scenarios"},{"type":"extras","title":"Potential Issues in Concurrent Scenarios - Thread Safety and Concurrent Operations","doc":"1. **Race Conditions with Cell Value Updates**: When multiple threads read a cell value and then\n   update it based on that value, race conditions can occur. The operation isn't atomic, so the\n   final value may not reflect all updates.\n\n2. **Spreadsheet Modifications**: Modifying the same spreadsheet from multiple threads without\n   synchronization may lead to unexpected results.","ref":"thread_safety.html#potential-issues-in-concurrent-scenarios"},{"type":"extras","title":"Best Practices for Concurrent Operations - Thread Safety and Concurrent Operations","doc":"1. **Spreadsheet Per Thread**: For maximum thread safety, create and manipulate separate spreadsheet\n   objects in each thread, then combine the results if needed.\n\n2. **Add Synchronization**: If you need to modify the same spreadsheet from multiple threads,\n   consider adding synchronization in your application code (e.g., using `Task.await` or process\n   synchronization mechanisms).\n\n3. **Atomic Operations**: For operations like incrementing a cell value, consider using a dedicated\n   process to handle the operation atomically.","ref":"thread_safety.html#best-practices-for-concurrent-operations"},{"type":"extras","title":"Example: Concurrent Spreadsheet Creation - Thread Safety and Concurrent Operations","doc":"```elixir\n# Create multiple spreadsheets concurrently\ntasks = for i <- 1..5 do\n  Task.async(fn ->\n    # Each task creates its own spreadsheet\n    {:ok, spreadsheet} = UmyaSpreadsheet.new()\n\n    # Perform operations on the spreadsheet\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Spreadsheet #{i}\")\n    UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"B1\", \"Created concurrently\")\n\n    # Save the spreadsheet to a unique file\n    file_path = \"spreadsheet_#{i}.xlsx\"\n    UmyaSpreadsheet.write(spreadsheet, file_path)\n\n    # Return the path and spreadsheet reference\n    {file_path, spreadsheet}\n  end)\nend\n\n# Wait for all tasks to complete\nresults = Enum.map(tasks, &Task.await(&1, 10000))\n\n# Process the results\nEnum.each(results, fn {path, _spreadsheet} ->\n  IO.puts(\"Created: #{path}\")\nend)\n```","ref":"thread_safety.html#example-concurrent-spreadsheet-creation"},{"type":"extras","title":"Example: Synchronized Access to a Shared Spreadsheet - Thread Safety and Concurrent Operations","doc":"```elixir\n# Create an Agent to manage access to a shared spreadsheet\n{:ok, agent} = Agent.start_link(fn ->\n  {:ok, spreadsheet} = UmyaSpreadsheet.new()\n  spreadsheet\nend)\n\n# Function to safely increment a cell value\ndefp increment_cell(agent, sheet, cell, amount) do\n  Agent.update(agent, fn spreadsheet ->\n    # Get current value\n    {:ok, current_value} = UmyaSpreadsheet.get_cell_value(spreadsheet, sheet, cell)\n    current_value = if is_number(current_value), do: current_value, else: 0\n\n    # Set new value\n    UmyaSpreadsheet.set_cell_value(spreadsheet, sheet, cell, current_value + amount)\n\n    # Return the spreadsheet reference (required for Agent.update)\n    spreadsheet\n  end)\nend\n\n# Create multiple tasks that safely update the same spreadsheet\ntasks = for i <- 1..10 do\n  Task.async(fn ->\n    # Each task increments the counter\n    increment_cell(agent, \"Sheet1\", \"A1\", 1)\n\n    # Add a record of the operation\n    Agent.update(agent, fn spreadsheet ->\n      UmyaSpreadsheet.set_cell_value(\n        spreadsheet,\n        \"Sheet1\",\n        \"B#{i+1}\",\n        \"Increment #{i} at #{DateTime.utc_now()}\"\n      )\n      spreadsheet\n    end)\n  end)\nend\n\n# Wait for all tasks to complete\nEnum.each(tasks, &Task.await(&1, 10000))\n\n# Save the final spreadsheet\nAgent.get(agent, fn spreadsheet ->\n  UmyaSpreadsheet.write(spreadsheet, \"synchronized_spreadsheet.xlsx\")\nend)\n\n# Stop the agent\nAgent.stop(agent)\n```","ref":"thread_safety.html#example-synchronized-access-to-a-shared-spreadsheet"},{"type":"extras","title":"Best Practices Summary - Thread Safety and Concurrent Operations","doc":"1. **Use Independent Spreadsheets**: When possible, create separate spreadsheet instances for each thread.\n\n2. **Employ Process Synchronization**: Use Elixir's built-in concurrency primitives (`Agent`, `GenServer`, etc.) to manage access to shared spreadsheets.\n\n3. **Batch Operations**: Instead of many small concurrent operations, consider batching changes and applying them sequentially.\n\n4. **Test Thoroughly**: Always test your concurrent code patterns with the specific operations you'll be performing.\n\n5. **Document Thread Safety Assumptions**: Make sure to document which operations are thread-safe in your application.","ref":"thread_safety.html#best-practices-summary"},{"type":"extras","title":"See Also - Thread Safety and Concurrent Operations","doc":"- [Shapes and Drawing](shapes_and_drawing.html) - For shape drawing operations that can be done concurrently\n- [Sheet Operations](sheet_operations.html) - For managing worksheets in concurrent environments","ref":"thread_safety.html#see-also"},{"type":"extras","title":"UmyaSpreadsheet Troubleshooting Guide","doc":"# UmyaSpreadsheet Troubleshooting Guide\n\nThis guide covers common issues, their solutions, and best practices for using UmyaSpreadsheet effectively.","ref":"troubleshooting.html"},{"type":"extras","title":"Table of Contents - UmyaSpreadsheet Troubleshooting Guide","doc":"- [Installation Issues](#installation-issues)\n- [Runtime Errors](#runtime-errors)\n- [Performance Issues](#performance-issues)\n- [File Format Issues](#file-format-issues)\n- [Memory Issues](#memory-issues)\n- [Concurrency Issues](#concurrency-issues)\n- [Platform-Specific Issues](#platform-specific-issues)\n- [Best Practices](#best-practices)\n- [Debugging Tips](#debugging-tips)","ref":"troubleshooting.html#table-of-contents"},{"type":"extras","title":"Installation Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#installation-issues"},{"type":"extras","title":"Problem: NIF Compilation Fails - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n```\n** (Mix) could not compile dependency :umya_spreadsheet_ex\n```\n\n**Solutions:**\n\n1. **Ensure Rust is installed:**\n   ```bash\n   curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh\n   source ~/.cargo/env\n   ```\n\n2. **Force rebuild:**\n   ```bash\n   export UMYA_SPREADSHEET_BUILD=true\n   mix deps.clean umya_spreadsheet_ex --build\n   mix deps.get\n   mix deps.compile\n   ```\n\n3. **Check Rust version compatibility:**\n   ```bash\n   rustc --version  # Should be 1.70.0 or newer\n   ```","ref":"troubleshooting.html#problem-nif-compilation-fails"},{"type":"extras","title":"Problem: Precompiled NIF Not Found - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n```\n** (RuntimeError) Unable to load NIF\n```\n\n**Solutions:**\n\n1. **Use force build mode:**\n   ```elixir\n   # In config/config.exs\n   config :umya_spreadsheet_ex, force_build: true\n   ```\n\n2. **Check platform compatibility:**\n   ```bash\n   mix deps.get\n   mix deps.compile --force\n   ```","ref":"troubleshooting.html#problem-precompiled-nif-not-found"},{"type":"extras","title":"Problem: Apple Silicon (M1/M2) Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n```\n** (ArgumentError) errors were found at the given arguments\n```\n\n**Solutions:**\n\n1. **Install Rust for Apple Silicon:**\n   ```bash\n   arch -arm64 brew install rust\n   ```\n\n2. **Force ARM64 compilation:**\n   ```bash\n   export CARGO_TARGET_AARCH64_APPLE_DARWIN_LINKER=clang\n   export UMYA_SPREADSHEET_BUILD=true\n   mix deps.compile --force\n   ```","ref":"troubleshooting.html#problem-apple-silicon-m1-m2-issues"},{"type":"extras","title":"Runtime Errors - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#runtime-errors"},{"type":"extras","title":"Problem: Spreadsheet Reference Errors - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n```\n** (ArgumentError) argument error\n```\n\n**Common Causes & Solutions:**\n\n1. **Using invalid spreadsheet reference:**\n   ```elixir\n   # Wrong - using a closed or invalid reference\n   {:ok, spreadsheet} = UmyaSpreadsheet.new()\n   # ... reference becomes invalid somehow ...\n   UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"test\")\n   \n   # Solution - always check if operations succeed\n   case UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"test\") do\n     :ok -> :ok\n     {:error, reason} -> \n       Logger.error(\"Failed to set cell value: #{reason}\")\n       # Handle error appropriately\n   end\n   ```\n\n2. **Concurrent access to the same reference:**\n   ```elixir\n   # Wrong - sharing reference between processes\n   Task.async(fn -> UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"1\") end)\n   Task.async(fn -> UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A2\", \"2\") end)\n   \n   # Solution - use separate spreadsheet instances\n   Task.async(fn -> \n     {:ok, s1} = UmyaSpreadsheet.new()\n     UmyaSpreadsheet.set_cell_value(s1, \"Sheet1\", \"A1\", \"1\")\n   end)\n   ```","ref":"troubleshooting.html#problem-spreadsheet-reference-errors"},{"type":"extras","title":"Problem: Sheet Not Found Errors - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n```\n{:error, \"Sheet not found\"}\n```\n\n**Solutions:**\n\n1. **Check sheet names:**\n   ```elixir\n   # List all sheets first\n   sheets = UmyaSpreadsheet.get_sheet_names(spreadsheet)\n   IO.inspect(sheets)  # [\"Sheet1\", \"Sheet2\", ...]\n   \n   # Use exact sheet name\n   UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"value\")\n   ```\n\n2. **Handle missing sheets gracefully:**\n   ```elixir\n   def safe_set_cell_value(spreadsheet, sheet_name, cell, value) do\n     case UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, cell, value) do\n       :ok -> :ok\n       {:error, \"Sheet not found\"} ->\n         UmyaSpreadsheet.add_sheet(spreadsheet, sheet_name)\n         UmyaSpreadsheet.set_cell_value(spreadsheet, sheet_name, cell, value)\n       {:error, reason} -> {:error, reason}\n     end\n   end\n   ```","ref":"troubleshooting.html#problem-sheet-not-found-errors"},{"type":"extras","title":"Problem: Invalid Cell References - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n```\n{:error, \"Invalid cell reference\"}\n```\n\n**Solutions:**\n\n1. **Use valid Excel cell references:**\n   ```elixir\n   # Valid formats\n   UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"value\")\n   UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"Z100\", \"value\")\n   UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"AA1\", \"value\")\n   \n   # Invalid formats (will fail)\n   # UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"1A\", \"value\")\n   # UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A\", \"value\")\n   ```\n\n2. **Validate cell references:**\n   ```elixir\n   def validate_cell_ref(cell_ref) do\n     case Regex.match?(~r/^[A-Z]+[1-9]\\d*$/, cell_ref) do\n       true -> :ok\n       false -> {:error, \"Invalid cell reference format\"}\n     end\n   end\n   ```","ref":"troubleshooting.html#problem-invalid-cell-references"},{"type":"extras","title":"Performance Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#performance-issues"},{"type":"extras","title":"Problem: Slow File Operations - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n- Long write times for large files\n- High memory usage during operations\n\n**Solutions:**\n\n1. **Use light writers for simple operations:**\n   ```elixir\n   # For simple spreadsheets without complex formatting\n   UmyaSpreadsheet.write_light(spreadsheet, \"output.xlsx\")\n   ```\n\n2. **Use lazy reading for large files:**\n   ```elixir\n   # For reading large files\n   {:ok, spreadsheet} = UmyaSpreadsheet.lazy_read(\"large_file.xlsx\")\n   ```\n\n3. **Batch operations:**\n   ```elixir\n   # Instead of individual cell operations\n   for row <- 1..1000 do\n     UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A#{row}\", \"value#{row}\")\n   end\n   \n   # Use bulk operations when available\n   data = for row <- 1..1000, do: {\"A#{row}\", \"value#{row}\"}\n   # Set multiple values in batch (if such function exists)\n   ```","ref":"troubleshooting.html#problem-slow-file-operations"},{"type":"extras","title":"Problem: Memory Usage Growing - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n- Increasing memory usage over time\n- Out of memory errors with large files\n\n**Solutions:**\n\n1. **Use streaming operations:**\n   ```elixir\n   # Process data in chunks\n   def process_large_file(file_path) do\n     {:ok, spreadsheet} = UmyaSpreadsheet.lazy_read(file_path)\n     \n     # Process data in smaller chunks\n     Enum.chunk_every(1..10000, 100)\n     |> Enum.each(fn chunk ->\n       process_chunk(spreadsheet, chunk)\n       # Allow garbage collection\n       :erlang.garbage_collect()\n     end)\n   end\n   ```\n\n2. **Dispose of references when done:**\n   ```elixir\n   def process_and_cleanup() do\n     {:ok, spreadsheet} = UmyaSpreadsheet.new()\n     \n     try do\n       # Do work with spreadsheet\n       UmyaSpreadsheet.write(spreadsheet, \"output.xlsx\")\n     after\n       # Spreadsheet reference will be garbage collected\n       # when it goes out of scope\n       :ok\n     end\n   end\n   ```","ref":"troubleshooting.html#problem-memory-usage-growing"},{"type":"extras","title":"File Format Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#file-format-issues"},{"type":"extras","title":"Problem: Corrupted Output Files - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n- Excel reports file corruption\n- Unable to open generated files\n\n**Solutions:**\n\n1. **Ensure proper file extensions:**\n   ```elixir\n   # Use .xlsx for Excel files\n   UmyaSpreadsheet.write(spreadsheet, \"output.xlsx\")\n   \n   # Not .xls (older format not supported)\n   ```\n\n2. **Check file permissions:**\n   ```elixir\n   def safe_write(spreadsheet, path) do\n     case UmyaSpreadsheet.write(spreadsheet, path) do\n       :ok -> :ok\n       {:error, reason} -> \n         Logger.error(\"Failed to write file #{path}: #{reason}\")\n         {:error, reason}\n     end\n   end\n   ```\n\n3. **Validate data before writing:**\n   ```elixir\n   def validate_and_write(spreadsheet, path) do\n     # Check if spreadsheet has valid data\n     case UmyaSpreadsheet.get_sheet_names(spreadsheet) do\n       [] -> {:error, \"No sheets in spreadsheet\"}\n       _sheets -> UmyaSpreadsheet.write(spreadsheet, path)\n     end\n   end\n   ```","ref":"troubleshooting.html#problem-corrupted-output-files"},{"type":"extras","title":"Problem: Encoding Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n- Special characters not displaying correctly\n- UTF-8 encoding problems\n\n**Solutions:**\n\n1. **Ensure UTF-8 encoding:**\n   ```elixir\n   # When setting cell values with special characters\n   UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Café ñoño 中文\")\n   ```\n\n2. **Handle CSV encoding properly:**\n   ```elixir\n   # When exporting to CSV\n   UmyaSpreadsheet.to_csv(spreadsheet, \"Sheet1\", \"output.csv\")\n   ```","ref":"troubleshooting.html#problem-encoding-issues"},{"type":"extras","title":"Memory Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#memory-issues"},{"type":"extras","title":"Problem: Out of Memory Errors - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n```\n** (SystemLimitError) a system limit has been reached\n```\n\n**Solutions:**\n\n1. **Process data in smaller chunks:**\n   ```elixir\n   def process_large_dataset(data) do\n     data\n     |> Enum.chunk_every(1000)  # Process 1000 rows at a time\n     |> Enum.reduce({:ok, _} = UmyaSpreadsheet.new(), fn chunk, {:ok, spreadsheet} ->\n       process_chunk(spreadsheet, chunk)\n       {:ok, spreadsheet}\n     end)\n   end\n   ```\n\n2. **Use memory-efficient patterns:**\n   ```elixir\n   # Instead of keeping all data in memory\n   def stream_to_excel(data_stream, output_path) do\n     {:ok, spreadsheet} = UmyaSpreadsheet.new()\n     \n     data_stream\n     |> Stream.with_index(1)\n     |> Stream.each(fn {row_data, row_num} ->\n       row_data\n       |> Enum.with_index(1)\n       |> Enum.each(fn {value, col_num} ->\n         cell = \"#{<<64 + col_num>>}#{row_num}\"\n         UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", cell, value)\n       end)\n     end)\n     |> Stream.run()\n     \n     UmyaSpreadsheet.write(spreadsheet, output_path)\n   end\n   ```","ref":"troubleshooting.html#problem-out-of-memory-errors"},{"type":"extras","title":"Concurrency Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#concurrency-issues"},{"type":"extras","title":"Problem: Race Conditions - UmyaSpreadsheet Troubleshooting Guide","doc":"**Symptoms:**\n- Inconsistent results with concurrent operations\n- Occasional crashes with multiple processes\n\n**Solutions:**\n\n1. **Use separate spreadsheet instances:**\n   ```elixir\n   # Good - each task has its own spreadsheet\n   tasks = for i <- 1..10 do\n     Task.async(fn ->\n       {:ok, spreadsheet} = UmyaSpreadsheet.new()\n       UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"Task #{i}\")\n       UmyaSpreadsheet.write(spreadsheet, \"output_#{i}.xlsx\")\n     end)\n   end\n   \n   Task.await_many(tasks)\n   ```\n\n2. **Coordinate access with GenServer:**\n   ```elixir\n   defmodule SpreadsheetManager do\n     use GenServer\n     \n     def start_link(opts) do\n       GenServer.start_link(__MODULE__, opts, name: __MODULE__)\n     end\n     \n     def update_cell(sheet_name, cell, value) do\n       GenServer.call(__MODULE__, {:update_cell, sheet_name, cell, value})\n     end\n     \n     def init(_opts) do\n       {:ok, spreadsheet} = UmyaSpreadsheet.new()\n       {:ok, %{spreadsheet: spreadsheet}}\n     end\n     \n     def handle_call({:update_cell, sheet_name, cell, value}, _from, state) do\n       result = UmyaSpreadsheet.set_cell_value(state.spreadsheet, sheet_name, cell, value)\n       {:reply, result, state}\n     end\n   end\n   ```","ref":"troubleshooting.html#problem-race-conditions"},{"type":"extras","title":"Platform-Specific Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#platform-specific-issues"},{"type":"extras","title":"macOS Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"**Problem: Code signing issues**\n```bash\n# Solution: Allow unsigned binaries (development only)\nsudo spctl --master-disable\n```\n\n**Problem: Rosetta issues on Apple Silicon**\n```bash\n# Solution: Use native ARM64 Rust\narch -arm64 brew install rust\nexport UMYA_SPREADSHEET_BUILD=true\nmix deps.compile --force\n```","ref":"troubleshooting.html#macos-issues"},{"type":"extras","title":"Linux Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"**Problem: Missing system dependencies**\n```bash\n# Solution: Install required packages\nsudo apt-get update\nsudo apt-get install build-essential pkg-config libssl-dev\n```","ref":"troubleshooting.html#linux-issues"},{"type":"extras","title":"Windows Issues - UmyaSpreadsheet Troubleshooting Guide","doc":"**Problem: Visual Studio Build Tools not found**\n```cmd\nREM Solution: Install Visual Studio Build Tools\nwinget install Microsoft.VisualStudio.2022.BuildTools\n```","ref":"troubleshooting.html#windows-issues"},{"type":"extras","title":"Best Practices - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#best-practices"},{"type":"extras","title":"1. Error Handling - UmyaSpreadsheet Troubleshooting Guide","doc":"Always handle errors appropriately:\n\n```elixir\ndef safe_spreadsheet_operation(spreadsheet, operation) do\n  case operation.(spreadsheet) do\n    :ok -> :ok\n    {:ok, result} -> {:ok, result}\n    {:error, reason} -> \n      Logger.error(\"Spreadsheet operation failed: #{reason}\")\n      {:error, reason}\n  end\nend\n```","ref":"troubleshooting.html#1-error-handling"},{"type":"extras","title":"2. Resource Management - UmyaSpreadsheet Troubleshooting Guide","doc":"Create spreadsheets close to where they're used:\n\n```elixir\ndef generate_report(data) do\n  {:ok, spreadsheet} = UmyaSpreadsheet.new()\n  \n  try do\n    populate_spreadsheet(spreadsheet, data)\n    UmyaSpreadsheet.write(spreadsheet, \"report.xlsx\")\n  rescue\n    error -> \n      Logger.error(\"Failed to generate report: #{inspect(error)}\")\n      {:error, \"Report generation failed\"}\n  end\nend\n```","ref":"troubleshooting.html#2-resource-management"},{"type":"extras","title":"3. Performance Optimization - UmyaSpreadsheet Troubleshooting Guide","doc":"Use appropriate functions for your use case:\n\n```elixir\n# For simple operations\nUmyaSpreadsheet.write_light(spreadsheet, path)\n\n# For large files\n{:ok, spreadsheet} = UmyaSpreadsheet.lazy_read(path)\n\n# For memory optimization\nUmyaSpreadsheet.to_binary_xlsx(spreadsheet)\n```","ref":"troubleshooting.html#3-performance-optimization"},{"type":"extras","title":"4. Data Validation - UmyaSpreadsheet Troubleshooting Guide","doc":"Validate inputs before processing:\n\n```elixir\ndef validate_cell_data(cell_ref, value) do\n  with :ok <- validate_cell_reference(cell_ref),\n       :ok <- validate_cell_value(value) do\n    :ok\n  else\n    {:error, reason} -> {:error, reason}\n  end\nend\n\ndef validate_cell_reference(cell_ref) when is_binary(cell_ref) do\n  if Regex.match?(~r/^[A-Z]+[1-9]\\d*$/, cell_ref) do\n    :ok\n  else\n    {:error, \"Invalid cell reference format\"}\n  end\nend\n\ndef validate_cell_value(value) when is_binary(value) or is_number(value), do: :ok\ndef validate_cell_value(_), do: {:error, \"Invalid cell value type\"}\n```","ref":"troubleshooting.html#4-data-validation"},{"type":"extras","title":"Debugging Tips - UmyaSpreadsheet Troubleshooting Guide","doc":"","ref":"troubleshooting.html#debugging-tips"},{"type":"extras","title":"1. Enable Debug Logging - UmyaSpreadsheet Troubleshooting Guide","doc":"```elixir\n# In config/config.exs\nconfig :logger, level: :debug\n\n# In your code\nrequire Logger\nLogger.debug(\"Spreadsheet operation: #{inspect(operation_details)}\")\n```","ref":"troubleshooting.html#1-enable-debug-logging"},{"type":"extras","title":"2. Inspect Spreadsheet State - UmyaSpreadsheet Troubleshooting Guide","doc":"```elixir\ndef debug_spreadsheet(spreadsheet) do\n  sheets = UmyaSpreadsheet.get_sheet_names(spreadsheet)\n  Logger.debug(\"Available sheets: #{inspect(sheets)}\")\n  \n  for sheet <- sheets do\n    Logger.debug(\"Sheet #{sheet} active: #{UmyaSpreadsheet.is_sheet_visible(spreadsheet, sheet)}\")\n  end\nend\n```","ref":"troubleshooting.html#2-inspect-spreadsheet-state"},{"type":"extras","title":"3. Test with Minimal Examples - UmyaSpreadsheet Troubleshooting Guide","doc":"```elixir\ndef minimal_test() do\n  {:ok, spreadsheet} = UmyaSpreadsheet.new()\n  :ok = UmyaSpreadsheet.set_cell_value(spreadsheet, \"Sheet1\", \"A1\", \"test\")\n  value = UmyaSpreadsheet.get_cell_value(spreadsheet, \"Sheet1\", \"A1\")\n  IO.puts(\"Cell A1 value: #{value}\")\n  UmyaSpreadsheet.write(spreadsheet, \"/tmp/test.xlsx\")\nend\n```","ref":"troubleshooting.html#3-test-with-minimal-examples"},{"type":"extras","title":"4. Check System Resources - UmyaSpreadsheet Troubleshooting Guide","doc":"```elixir\n# Monitor memory usage\n:observer.start()\n\n# Check process memory\n:erlang.memory()\n\n# Monitor file handles\nSystem.cmd(\"lsof\", [\"-p\", \"#{System.otp_release()}\"])\n```","ref":"troubleshooting.html#4-check-system-resources"},{"type":"extras","title":"Getting Help - UmyaSpreadsheet Troubleshooting Guide","doc":"If you encounter issues not covered in this guide:\n\n1. **Check the GitHub Issues**: [umya_spreadsheet_ex issues](https://github.com/alexiob/umya_spreadsheet_ex/issues)\n2. **Review the Documentation**: [HexDocs](https://hexdocs.pm/umya_spreadsheet_ex/)\n3. **Check Rust Library Issues**: [umya-spreadsheet issues](https://github.com/MathNya/umya-spreadsheet/issues)\n4. **Create a Minimal Reproduction**: Provide the smallest possible code that reproduces the issue\n\nWhen reporting issues, include:\n- Elixir and OTP versions\n- Operating system and architecture\n- UmyaSpreadsheet version\n- Minimal code to reproduce the issue\n- Full error messages and stack traces","ref":"troubleshooting.html#getting-help"},{"type":"extras","title":"UmyaSpreadsheet Limitations and Compatibility","doc":"# UmyaSpreadsheet Limitations and Compatibility\n\nThis document outlines the current limitations, compatibility constraints, and known issues with UmyaSpreadsheet.","ref":"limitations.html"},{"type":"extras","title":"Table of Contents - UmyaSpreadsheet Limitations and Compatibility","doc":"- [File Format Limitations](#file-format-limitations)\n- [Feature Limitations](#feature-limitations)\n- [Platform Compatibility](#platform-compatibility)\n- [Version Compatibility](#version-compatibility)\n- [Performance Limitations](#performance-limitations)\n- [Known Issues](#known-issues)\n- [Roadmap and Future Support](#roadmap-and-future-support)","ref":"limitations.html#table-of-contents"},{"type":"extras","title":"File Format Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"","ref":"limitations.html#file-format-limitations"},{"type":"extras","title":"Supported Formats - UmyaSpreadsheet Limitations and Compatibility","doc":"| Format | Read | Write | Notes |\n|--------|------|-------|-------|\n| .xlsx  | ✅   | ✅    | Full support |\n| .xlsm  | ✅   | ✅    | Macro support limited |\n| .xls   | ❌   | ❌    | Legacy format not supported |\n| .csv   | ❌   | ✅    | Export only |\n| .ods   | ❌   | ❌    | OpenDocument not supported |","ref":"limitations.html#supported-formats"},{"type":"extras","title":"Excel Feature Support - UmyaSpreadsheet Limitations and Compatibility","doc":"| Feature | Support Level | Notes |\n|---------|---------------|-------|\n| **Basic Operations** |||\n| Cell values (text, numbers) | ✅ Full | All basic data types |\n| Formulas | ✅ Full | Standard Excel formulas |\n| Multiple sheets | ✅ Full | Add, remove, rename sheets |\n| **Formatting** |||\n| Font styling | ✅ Full | Bold, italic, underline, colors |\n| Cell backgrounds | ✅ Full | Colors and patterns |\n| Borders | ✅ Full | All border styles |\n| Number formats | ✅ Full | Currency, dates, percentages |\n| Conditional formatting | ✅ Partial | Basic rules, color scales, data bars, icon sets |\n| **Advanced Features** |||\n| Charts | ✅ Partial | Line, bar, pie charts supported |\n| Images | ✅ Full | PNG, JPEG insertion |\n| Data validation | ✅ Full | Dropdowns, ranges, custom rules |\n| Pivot tables | ✅ Basic | Creation and basic manipulation |\n| Macros | ❌ Limited | Can preserve existing macros but not execute |\n| **Security** |||\n| Password protection | ✅ Full | Workbook and sheet protection |\n| Digital signatures | ❌ None | Not supported |\n| **Print Features** |||\n| Page setup | ✅ Full | Margins, orientation, scaling |\n| Headers/footers | ✅ Full | Custom headers and footers |\n| Print areas | ✅ Full | Define print ranges |","ref":"limitations.html#excel-feature-support"},{"type":"extras","title":"Unsupported Excel Features - UmyaSpreadsheet Limitations and Compatibility","doc":"- **Macros**: Cannot create or execute VBA macros (can preserve existing ones)\n- **External Links**: Links to other files not fully supported\n- **OLE Objects**: Embedded objects not supported\n- **Smart Art**: Smart Art graphics not supported\n- **3D Charts**: Only 2D chart types supported\n- **Form Controls**: Excel form controls not supported\n- **Custom Functions**: Excel add-in functions not supported\n- **Collaboration Features**: Comments collaboration features limited\n- **Power Query**: Power Query connections not supported","ref":"limitations.html#unsupported-excel-features"},{"type":"extras","title":"Feature Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"","ref":"limitations.html#feature-limitations"},{"type":"extras","title":"Formula Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"```elixir\n# Supported formula types\nUmyaSpreadsheet.set_cell_formula(spreadsheet, \"Sheet1\", \"A1\", \"=SUM(B1:B10)\")\nUmyaSpreadsheet.set_array_formula(spreadsheet, \"Sheet1\", \"A1:A10\", \"=B1:B10*2\")\n\n# Limitations:\n# - Custom functions from add-ins not supported\n# - Some advanced statistical functions may not work\n# - External reference formulas limited\n```","ref":"limitations.html#formula-limitations"},{"type":"extras","title":"Chart Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"```elixir\n# Supported chart types\nchart_types = [\n  \"line\", \"bar\", \"column\", \"pie\", \"area\", \"scatter\", \"doughnut\"\n]\n\n# Not supported:\n# - 3D charts\n# - Bubble charts\n# - Stock charts\n# - Combo charts\n# - Treemap charts\n# - Waterfall charts\n```","ref":"limitations.html#chart-limitations"},{"type":"extras","title":"Conditional Formatting Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"```elixir\n# Supported rules\n:ok = UmyaSpreadsheet.add_cell_value_rule(spreadsheet, sheet, range, operator, value, format)\n:ok = UmyaSpreadsheet.add_color_scale(spreadsheet, sheet, range, colors)\n:ok = UmyaSpreadsheet.add_data_bar(spreadsheet, sheet, range, color)\n:ok = UmyaSpreadsheet.add_icon_set(spreadsheet, sheet, range, style, thresholds)\n\n# Limitations:\n# - Custom formatting rules not supported\n# - Some advanced icon sets not available\n# - Complex multi-condition rules limited\n```","ref":"limitations.html#conditional-formatting-limitations"},{"type":"extras","title":"Data Validation Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"```elixir\n# Supported validation types\nvalidation_types = [\n  \"list\",        # Dropdown lists\n  \"whole\",       # Whole numbers\n  \"decimal\",     # Decimal numbers\n  \"date\",        # Date ranges\n  \"time\",        # Time ranges\n  \"text_length\", # Text length constraints\n  \"custom\"       # Custom formulas\n]\n\n# Limitations:\n# - Error alert customization limited\n# - Input message formatting limited\n# - Circle invalid data feature not supported\n```","ref":"limitations.html#data-validation-limitations"},{"type":"extras","title":"Platform Compatibility - UmyaSpreadsheet Limitations and Compatibility","doc":"","ref":"limitations.html#platform-compatibility"},{"type":"extras","title":"Operating Systems - UmyaSpreadsheet Limitations and Compatibility","doc":"| Platform | Support Level | Notes |\n|----------|---------------|-------|\n| **Linux** |||\n| Ubuntu 20.04+ | ✅ Full | Precompiled binaries available |\n| CentOS/RHEL 8+ | ✅ Full | Precompiled binaries available |\n| Debian 10+ | ✅ Full | Precompiled binaries available |\n| Alpine Linux | ⚠️ Limited | May require manual compilation |\n| **macOS** |||\n| macOS 11+ (Intel) | ✅ Full | Precompiled binaries available |\n| macOS 11+ (Apple Silicon) | ✅ Full | Native ARM64 support |\n| macOS 10.15 and earlier | ❌ None | Not supported |\n| **Windows** |||\n| Windows 10+ | ✅ Full | Precompiled binaries available |\n| Windows Server 2019+ | ✅ Full | Precompiled binaries available |\n| Windows 8.1 and earlier | ❌ None | Not supported |","ref":"limitations.html#operating-systems"},{"type":"extras","title":"Architecture Support - UmyaSpreadsheet Limitations and Compatibility","doc":"| Architecture | Support Level | Notes |\n|--------------|---------------|-------|\n| x86_64 (Intel/AMD 64-bit) | ✅ Full | Primary support |\n| aarch64 (ARM64) | ✅ Full | Apple Silicon, ARM servers |\n| x86 (32-bit) | ❌ None | Not supported |\n| ARM 32-bit | ❌ None | Not supported |","ref":"limitations.html#architecture-support"},{"type":"extras","title":"Alpine Linux / musl libc - UmyaSpreadsheet Limitations and Compatibility","doc":"**Current Status:** ❌ No precompiled binaries available\n\nAlpine Linux uses musl libc instead of glibc, which has limitations with Rust's `cdylib` crate type required for NIFs.\n\n**Workarounds:**\n\n1. **Compile from source** on Alpine:\n\n   ```bash\n   # Install build dependencies\n   apk add --no-cache build-base rust cargo\n\n   # Force compilation\n   export UMYA_SPREADSHEET_BUILD=true\n   mix deps.compile --force\n   ```\n\n2. **Use glibc-based containers** (recommended):\n\n   ```dockerfile\n   # Instead of alpine:latest\n   FROM debian:bullseye-slim\n   # or\n   FROM ubuntu:22.04\n   ```","ref":"limitations.html#alpine-linux-musl-libc"},{"type":"extras","title":"Compilation Requirements - UmyaSpreadsheet Limitations and Compatibility","doc":"When building from source:\n\n```bash\n# Minimum Rust version\nrustc --version  # Should be 1.70.0 or newer\n\n# Required system dependencies (Linux)\nsudo apt-get install build-essential pkg-config libssl-dev\n\n# Required system dependencies (macOS)\n# Xcode Command Line Tools\nxcode-select --install\n\n# Required system dependencies (Windows)\n# Visual Studio Build Tools 2019 or newer\n```","ref":"limitations.html#compilation-requirements"},{"type":"extras","title":"Version Compatibility - UmyaSpreadsheet Limitations and Compatibility","doc":"","ref":"limitations.html#version-compatibility"},{"type":"extras","title":"Elixir/OTP Compatibility Matrix - UmyaSpreadsheet Limitations and Compatibility","doc":"| UmyaSpreadsheet | Elixir | OTP | Notes |\n|-----------------|--------|-----|-------|\n| 0.6.x | 1.12+ | 24+ | Current version |\n| 0.5.x | 1.11+ | 23+ | Legacy support |\n| 0.4.x | 1.10+ | 22+ | End of life |","ref":"limitations.html#elixir-otp-compatibility-matrix"},{"type":"extras","title":"Excel Compatibility - UmyaSpreadsheet Limitations and Compatibility","doc":"| Excel Version | Read Support | Write Support | Notes |\n|---------------|--------------|---------------|-------|\n| Excel 2019+ | ✅ Full | ✅ Full | Recommended |\n| Excel 2016 | ✅ Full | ✅ Full | Fully supported |\n| Excel 2013 | ✅ Full | ✅ Full | Fully supported |\n| Excel 2010 | ✅ Full | ✅ Full | Fully supported |\n| Excel 2007 | ✅ Full | ✅ Full | Minimum supported |\n| Excel 2003 and earlier | ❌ None | ❌ None | Use .xls converter |","ref":"limitations.html#excel-compatibility"},{"type":"extras","title":"LibreOffice/OpenOffice Compatibility - UmyaSpreadsheet Limitations and Compatibility","doc":"| Application | Read Support | Write Support | Notes |\n|-------------|--------------|---------------|-------|\n| LibreOffice Calc 7.x | ✅ Good | ✅ Good | Minor formatting differences |\n| LibreOffice Calc 6.x | ✅ Good | ✅ Good | Minor formatting differences |\n| OpenOffice Calc | ⚠️ Limited | ⚠️ Limited | Basic features only |\n\n**Known LibreOffice Issues:**\n\n- Some conditional formatting rules may not display correctly\n- Chart formatting may differ slightly\n- Custom number formats may not be preserved exactly","ref":"limitations.html#libreoffice-openoffice-compatibility"},{"type":"extras","title":"Performance Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"","ref":"limitations.html#performance-limitations"},{"type":"extras","title":"Memory Usage - UmyaSpreadsheet Limitations and Compatibility","doc":"```elixir\n# Memory usage guidelines\nfile_size_mb = File.stat!(\"large_file.xlsx\").size / (1024 * 1024)\n\nmemory_estimate = cond do\n  file_size_mb < 10 -> \"#{file_size_mb * 2-3} MB RAM\"\n  file_size_mb < 50 -> \"#{file_size_mb * 3-4} MB RAM\"\n  file_size_mb < 100 -> \"#{file_size_mb * 4-5} MB RAM\"\n  true -> \"Consider using lazy loading or chunked processing\"\nend\n\nIO.puts(\"Estimated memory usage: #{memory_estimate}\")\n```","ref":"limitations.html#memory-usage"},{"type":"extras","title":"File Size Limits - UmyaSpreadsheet Limitations and Compatibility","doc":"| Operation | Recommended Limit | Hard Limit | Notes |\n|-----------|-------------------|------------|-------|\n| Read file | < 100 MB | ~ 500 MB | Use `lazy_read` for large files |\n| Write file | < 100 MB | ~ 200 MB | Use `write_light` for simple data |\n| In-memory operations | < 50 MB | ~ 100 MB | Depends on available RAM |\n| Cell count | < 1M cells | ~ 10M cells | Performance degrades |","ref":"limitations.html#file-size-limits"},{"type":"extras","title":"Performance Benchmarks - UmyaSpreadsheet Limitations and Compatibility","doc":"Typical performance on modern hardware:\n\n```elixir\n# Approximate processing speeds\noperations_per_second = %{\n  cell_read: 50_000,          # cells/second\n  cell_write: 25_000,         # cells/second\n  file_read_10mb: 2,          # files/second\n  file_write_10mb: 1,         # files/second\n  formula_calculation: 10_000  # formulas/second\n}\n```","ref":"limitations.html#performance-benchmarks"},{"type":"extras","title":"Known Issues - UmyaSpreadsheet Limitations and Compatibility","doc":"","ref":"limitations.html#known-issues"},{"type":"extras","title":"Issue: Global Defined Names Warning - UmyaSpreadsheet Limitations and Compatibility","doc":"**Symptom:**\n\n```\nWarning: Global defined name 'TaxRate' created without name due to API limitations in umya-spreadsheet 2.3.0\n```\n\n**Impact:** Cosmetic warning only, functionality works correctly\n\n**Workaround:** None needed, can be safely ignored\n\n**Status:** Will be fixed in future umya-spreadsheet release","ref":"limitations.html#issue-global-defined-names-warning"},{"type":"extras","title":"Issue: Password Protection Algorithm Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"**Symptom:**\n\n```\n{:error, \"Failed to write file with password\"}\n```\n\n**Impact:** Some advanced encryption algorithms not supported\n\n**Workaround:**\n\n```elixir\n# Use basic password protection\nUmyaSpreadsheet.write_with_password(spreadsheet, path, \"password\")\n\n# For advanced encryption, use external tools\n```","ref":"limitations.html#issue-password-protection-algorithm-limitations"},{"type":"extras","title":"Issue: Large File Memory Usage - UmyaSpreadsheet Limitations and Compatibility","doc":"**Symptom:** High memory usage with files > 50MB\n\n**Impact:** Potential out-of-memory errors\n\n**Workaround:**\n\n```elixir\n# Use lazy reading\n{:ok, spreadsheet} = UmyaSpreadsheet.lazy_read(\"large_file.xlsx\")\n\n# Process in chunks\ndef process_large_file(file_path) do\n  {:ok, spreadsheet} = UmyaSpreadsheet.lazy_read(file_path)\n\n  # Process specific ranges instead of entire file\n  for row <- 1..1000 do\n    value = UmyaSpreadsheet.get_cell_value(spreadsheet, \"Sheet1\", \"A#{row}\")\n    process_value(value)\n  end\nend\n```","ref":"limitations.html#issue-large-file-memory-usage"},{"type":"extras","title":"Issue: Concurrent Access Limitations - UmyaSpreadsheet Limitations and Compatibility","doc":"**Symptom:** Crashes when multiple processes access same spreadsheet reference\n\n**Impact:** Race conditions in multi-process scenarios\n\n**Workaround:**\n\n```elixir\n# Use separate spreadsheet instances per process\nTask.async(fn ->\n  {:ok, spreadsheet} = UmyaSpreadsheet.new()\n  # ... work with spreadsheet\nend)\n\n# Or coordinate access via GenServer\ndefmodule SpreadsheetServer do\n  use GenServer\n  # ... implementation\nend\n```","ref":"limitations.html#issue-concurrent-access-limitations"},{"type":"extras","title":"Roadmap and Future Support - UmyaSpreadsheet Limitations and Compatibility","doc":"","ref":"limitations.html#roadmap-and-future-support"},{"type":"extras","title":"Planned Features (Future Releases) - UmyaSpreadsheet Limitations and Compatibility","doc":"- **Enhanced Chart Support**: More chart types and customization options\n- **Improved Macro Support**: Better VBA macro preservation and analysis\n- **Advanced Pivot Tables**: More pivot table features and calculations\n- **External Data Sources**: Support for external data connections\n- **Collaboration Features**: Better support for shared workbooks\n- **Performance Improvements**: Streaming operations for very large files","ref":"limitations.html#planned-features-future-releases"},{"type":"extras","title":"Breaking Changes Policy - UmyaSpreadsheet Limitations and Compatibility","doc":"UmyaSpreadsheet follows semantic versioning:\n\n- **Major versions** (1.0, 2.0): Breaking API changes\n- **Minor versions** (0.6.0, 0.7.0): New features, backward compatible\n- **Patch versions** (0.6.1, 0.6.2): Bug fixes only","ref":"limitations.html#breaking-changes-policy"},{"type":"extras","title":"Migration Guides - UmyaSpreadsheet Limitations and Compatibility","doc":"When upgrading between major versions, migration guides will be provided to help update existing code.","ref":"limitations.html#migration-guides"},{"type":"extras","title":"Long-term Support - UmyaSpreadsheet Limitations and Compatibility","doc":"- Current major version: Maintained with bug fixes and security updates\n- Previous major version: Bug fixes only for 6 months after new major release\n- Older versions: Community support only","ref":"limitations.html#long-term-support"},{"type":"extras","title":"Getting Support - UmyaSpreadsheet Limitations and Compatibility","doc":"For issues related to limitations:\n\n1. **Check this document** for known limitations\n2. **Review GitHub Issues** for existing reports\n3. **Check upstream issues** in the Rust umya-spreadsheet library\n4. **Submit feature requests** with clear use cases","ref":"limitations.html#getting-support"},{"type":"extras","title":"Contribution Guidelines - UmyaSpreadsheet Limitations and Compatibility","doc":"Help improve UmyaSpreadsheet by:\n\n1. **Reporting bugs** with minimal reproduction cases\n2. **Suggesting features** with detailed requirements\n3. **Contributing code** to address limitations\n4. **Improving documentation** with real-world examples\n\nFor more information, see the [DEVELOPMENT.md](../DEVELOPMENT.md) guide.","ref":"limitations.html#contribution-guidelines"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.7.0 - 2025-06-04 - Changelog","doc":"First public release.","ref":"changelog.html#0-7-0-2025-06-04"},{"type":"extras","title":"0.6.17 - 2025-06-03 - Changelog","doc":"","ref":"changelog.html#0-6-17-2025-06-03"},{"type":"extras","title":"Added - Changelog","doc":"- **Pivot Table Enhancements**:\n  - **Enhanced Access to Pivot Table Components** - Added comprehensive functions for working with pivot table internal components\n    - New function `UmyaSpreadsheet.PivotTable.get_pivot_table_cache_fields/3` retrieves all cache fields in a pivot table\n    - New function `UmyaSpreadsheet.PivotTable.get_pivot_table_cache_field/4` gets detailed information about a specific cache field\n    - New function `UmyaSpreadsheet.PivotTable.get_pivot_table_data_fields/3` retrieves all data fields in a pivot table\n    - New function `UmyaSpreadsheet.PivotTable.get_pivot_table_cache_source/3` gets the cache source configuration\n  - **Enhanced Modification Capabilities** - Added functions to modify pivot table components\n    - New function `UmyaSpreadsheet.PivotTable.add_pivot_table_data_field/5-7` adds a new data field to an existing pivot table\n    - New function `UmyaSpreadsheet.PivotTable.update_pivot_table_cache/5` updates the cache source configuration\n  - **Comprehensive Testing** - Added thorough test suite for new pivot table functionality\n  - **Improved Documentation** - Updated pivot table guide with detailed documentation for all new enhanced features","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- **Conditional Formatting API Consistency**:\n  - **Return Type Standardization** - Fixed inconsistent return types for conditional formatting getter functions\n    - Functions `get_color_scales/2-3`, `get_data_bars/2-3`, and `get_icon_sets/2-3` now consistently return `{:ok, list()}` tuples\n    - Previously these functions returned raw lists while other similar functions returned `{:ok, list()}` tuples\n    - This change ensures consistent error handling patterns across all conditional formatting getter functions\n    - Updated all related tests to handle the new consistent API\n    - **Breaking Change**: Code using these functions must now pattern match on `{:ok, results}` instead of expecting direct lists","ref":"changelog.html#fixed"},{"type":"extras","title":"Documentation - Changelog","doc":"- **Conditional Formatting Guide**:\n  - Updated documentation to reflect the new consistent return types for getter functions\n  - Added clear examples showing the correct pattern matching for `{:ok, list}` returns\n  - Enhanced documentation with version notes about API consistency improvements","ref":"changelog.html#documentation"},{"type":"extras","title":"0.6.16 - 2025-06-02 - Changelog","doc":"","ref":"changelog.html#0-6-16-2025-06-02"},{"type":"extras","title":"Added - Changelog","doc":"- **Drawing and Shape Features**:\n  - **Drawing Getter Functions** - Added comprehensive getter functions for shapes, text boxes, and connectors\n    - New function `UmyaSpreadsheet.Drawing.get_shapes/2-3` retrieves all shapes in a worksheet\n    - New function `UmyaSpreadsheet.Drawing.get_text_boxes/2-3` retrieves all text boxes in a worksheet\n    - New function `UmyaSpreadsheet.Drawing.get_connectors/2-3` retrieves all connector lines in a worksheet\n    - New utility function `UmyaSpreadsheet.Drawing.has_drawing_objects/2-3` checks if a worksheet contains drawing objects\n    - New utility function `UmyaSpreadsheet.Drawing.count_drawing_objects/2-3` counts drawing objects in a worksheet\n  - **Enhanced Documentation** - Added comprehensive guide for drawing functions with examples\n\n- **Data Validation Enhancements**:\n  - **Enhanced Date Validation** - `add_date_validation/11` now accepts both string dates and Elixir Date structs\n  - **Improved Documentation** - Merged and enhanced data validation documentation into a comprehensive guide\n  - **Rule Retrieval Capabilities** - Added comprehensive getter functions for data validation\n    - New function `UmyaSpreadsheet.DataValidation.get_data_validations/2-3` retrieves all data validation rules for a sheet or range\n    - New function `UmyaSpreadsheet.DataValidation.get_list_validations/2-3` retrieves dropdown list validation rules\n    - New function `UmyaSpreadsheet.DataValidation.get_number_validations/2-3` retrieves numeric constraint validation rules\n    - New function `UmyaSpreadsheet.DataValidation.get_date_validations/2-3` retrieves date constraint validation rules\n    - New function `UmyaSpreadsheet.DataValidation.get_text_length_validations/2-3` retrieves text length validation rules\n    - New function `UmyaSpreadsheet.DataValidation.get_custom_validations/2-3` retrieves custom formula validation rules\n    - New utility function `UmyaSpreadsheet.DataValidation.has_data_validations/2-3` checks if validations exist\n    - New utility function `UmyaSpreadsheet.DataValidation.count_data_validations/2-3` counts validation rules\n\n- **Conditional Formatting Getter Functions**:\n  - **Rule Retrieval Capabilities** - Added comprehensive getter functions for conditional formatting rules\n    - New function `UmyaSpreadsheet.ConditionalFormatting.get_conditional_formatting_rules/2-3` retrieves all conditional formatting rules for a sheet or range\n    - New function `UmyaSpreadsheet.ConditionalFormatting.get_cell_value_rules/2-3` retrieves cell value conditional formatting rules\n    - New function `UmyaSpreadsheet.ConditionalFormatting.get_color_scales/2-3` retrieves color scale conditional formatting rules\n    - New function `UmyaSpreadsheet.ConditionalFormatting.get_data_bars/2-3` retrieves data bar conditional formatting rules\n    - New function `UmyaSpreadsheet.ConditionalFormatting.get_icon_sets/2-3` retrieves icon set conditional formatting rules\n    - New function `UmyaSpreadsheet.ConditionalFormatting.get_top_bottom_rules/2-3` retrieves top/bottom conditional formatting rules\n    - New function `UmyaSpreadsheet.ConditionalFormatting.get_above_below_average_rules/2-3` retrieves above/below average conditional formatting rules\n    - New function `UmyaSpreadsheet.ConditionalFormatting.get_text_rules/2-3` retrieves text conditional formatting rules\n\n- **VML Drawing Getter Functions**:\n  - **Shape Property Retrieval** - Added comprehensive getter functions for VML shapes\n    - New function `UmyaSpreadsheet.VmlDrawing.get_shape_style/3` retrieves the CSS style string\n    - New function `UmyaSpreadsheet.VmlDrawing.get_shape_type/3` retrieves the shape type (rect, oval, etc.)\n    - New function `UmyaSpreadsheet.VmlDrawing.get_shape_filled/3` checks if a shape has fill enabled\n    - New function `UmyaSpreadsheet.VmlDrawing.get_shape_fill_color/3` gets the shape's fill color\n    - New function `UmyaSpreadsheet.VmlDrawing.get_shape_stroked/3` checks if a shape has stroke enabled\n    - New function `UmyaSpreadsheet.VmlDrawing.get_shape_stroke_color/3` gets the shape's stroke color\n    - New function `UmyaSpreadsheet.VmlDrawing.get_shape_stroke_weight/3` gets the shape's stroke weight\n\n- **File Format Options Getters**:\n  - **Compression Level Information** - Added getter for default compression level\n    - New function `UmyaSpreadsheet.FileFormatOptions.get_compression_level/1` returns the default compression level\n  - **Encryption Status Check** - Added functions to check encryption settings\n    - New function `UmyaSpreadsheet.FileFormatOptions.is_encrypted/1` checks if a spreadsheet has encryption enabled\n    - New function `UmyaSpreadsheet.FileFormatOptions.get_encryption_algorithm/1` returns the encryption algorithm used","ref":"changelog.html#added-1"},{"type":"extras","title":"Fixed - Changelog","doc":"- **NIF Function Registration**:\n  - **Missing NIF Exports** - Added previously missing NIF function exports for file format options\n    - Properly registered file format option functions (`write_with_compression`, `write_with_encryption_options`, `to_binary_xlsx`)\n    - Fixed issue where these functions were implemented but not properly exposed","ref":"changelog.html#fixed-1"},{"type":"extras","title":"Documentation - Changelog","doc":"- **File Format Options Documentation**:\n  - Enhanced documentation for file format options with getter function examples\n  - Added information about checking encryption status and retrieving compression settings","ref":"changelog.html#documentation-1"},{"type":"extras","title":"Technical Details - Changelog","doc":"- **Architecture** - Properly aligned Elixir wrapper functions with underlying NIF implementations\n- **Consistency** - Ensured all file format options have corresponding getter functions for inspection","ref":"changelog.html#technical-details"},{"type":"extras","title":"0.6.15 - 2025-05-31 - Changelog","doc":"","ref":"changelog.html#0-6-15-2025-05-31"},{"type":"extras","title":"Fixed - Changelog","doc":"- **Formula Functions Module Fixes**:\n  - **Parameter Type Mismatches** - Fixed functions passing incorrect types to NIFs\n    - Modified 10 formula getter functions to properly extract references from Spreadsheet structs\n    - Resolved ArgumentError issues in `get_formula_type/3`, `get_shared_index/3`, `get_reference/3`, `get_bx/3`, `get_data_table_2d/3`, `get_data_table_row/3`, `get_input_1deleted/3`, `get_input_2deleted/3`, `get_r1/3`, and `get_r2/3`\n  - **Default Value Handling** - Improved null value handling for formula properties\n    - Implemented consistent conversion from default values to `nil`\n    - Fixed numeric properties to convert `0` to `nil` when appropriate\n    - Fixed boolean properties to convert `false` to `nil` when appropriate\n    - Fixed string properties to convert empty strings to `nil` when appropriate\n  - **Doctest Corrections** - Updated doctests to match actual function behavior\n    - Fixed `get_reference/3` doctest expectations to match true function behavior","ref":"changelog.html#fixed-2"},{"type":"extras","title":"Documentation - Changelog","doc":"- **Formula Function Guide Enhancements**:\n  - Added new section on working with formula properties\n  - Documented new consistent behavior for formula property default values\n  - Added examples for formula property getter functions\n  - Clarified return value expectations for different property types","ref":"changelog.html#documentation-2"},{"type":"extras","title":"Technical Details - Changelog","doc":"- **Type Handling** - Fixed all remaining functions that were incorrectly passing Spreadsheet structs to NIFs expecting references\n- **Parameter Extraction** - Now correctly extracting `reference` field from Spreadsheet structs before passing to NIFs\n- **Default Value Standardization** - Consistently treating default values as `nil` for better developer experience and API consistency\n- **Test Coverage** - All 600 doctests and 409 regular tests now pass with the new fixes","ref":"changelog.html#technical-details-1"},{"type":"extras","title":"0.6.14 - 2025-05-30 - Changelog","doc":"","ref":"changelog.html#0-6-14-2025-05-30"},{"type":"extras","title":"Documentation - Changelog","doc":"- **Error Handling Documentation Updates** - Fixed all documentation examples to match actual function return types and demonstrate proper error handling patterns\n- **Return Type Clarification** - Added explicit notes about which functions return direct values vs. tuples, ensuring documentation accuracy\n- **Function Signature Verification** - Updated all guide examples to reflect actual wrapper function behavior and NIF specifications\n- **Auto Filter Documentation** - Fixed error handling examples for `has_auto_filter/2` and `get_auto_filter_range/2` functions","ref":"changelog.html#documentation-3"},{"type":"extras","title":"Fixed - Changelog","doc":"- **Documentation Consistency Updates**:\n  - **Error Handling Standardization** - Updated all documentation examples to match actual function return types\n    - Fixed workbook protection examples to use proper `{:ok, boolean()}` pattern matching instead of direct if statements\n    - Updated comment checking examples to handle `boolean() | {:error, atom()}` return types properly\n    - Corrected formula function examples to show proper error handling for `get_defined_names/1`\n    - Fixed sheet operations examples to show correct tuple destructuring for `get_active_sheet/1`\n    - Updated print settings examples to demonstrate proper error handling for getter functions\n  - **Return Type Documentation** - Clarified which functions return direct values vs. tuples\n    - Added explicit notes about `get_sheet_count/1` returning direct integer values\n    - Documented error handling patterns for functions that can fail vs. those that cannot\n    - Fixed inconsistent documentation showing wrong assignment patterns\n  - **Function Signature Verification** - Ensured all documented examples match actual wrapper function behavior\n    - Verified ErrorHandling.standardize_result() usage patterns across different modules\n    - Confirmed NIF function specifications align with wrapper implementations\n    - Updated examples to reflect actual return type standardization","ref":"changelog.html#fixed-3"},{"type":"extras","title":"Technical Details - Changelog","doc":"- **Documentation Accuracy** - All getter function examples now correctly demonstrate error handling patterns\n- **Consistency Improvements** - Standardized error handling examples across all guide documents\n- **User Experience** - Developers can now copy-paste documentation examples with confidence they will work correctly","ref":"changelog.html#technical-details-2"},{"type":"extras","title":"0.6.13 - 2025-05-30 - Changelog","doc":"","ref":"changelog.html#0-6-13-2025-05-30"},{"type":"extras","title":"Added - Changelog","doc":"- **Print Settings Getter Functions**:\n  - **Page Setup Inspection** - Retrieve current print and page setup settings\n    - `UmyaSpreadsheet.get_page_orientation/2` - Get page orientation (\"portrait\" or \"landscape\", default: \"portrait\")\n    - `UmyaSpreadsheet.get_paper_size/2` - Get paper size code (default: 1 for Letter)\n    - `UmyaSpreadsheet.get_page_scale/2` - Get page scale percentage (default: 100)\n    - `UmyaSpreadsheet.get_fit_to_page/2` - Get fit-to-page settings as {width, height} tuple (default: {1, 1})\n  - **Margin Inspection** - Retrieve page and header/footer margin settings\n    - `UmyaSpreadsheet.get_page_margins/2` - Get page margins as {top, right, bottom, left} tuple in inches (default: {0.75, 0.7, 0.75, 0.7})\n    - `UmyaSpreadsheet.get_header_footer_margins/2` - Get header/footer margins as {header, footer} tuple in inches (default: {0.3, 0.3})\n  - **Header/Footer Content Inspection** - Retrieve header and footer text\n    - `UmyaSpreadsheet.get_header/2` - Get header text with formatting codes (default: empty string)\n    - `UmyaSpreadsheet.get_footer/2` - Get footer text with formatting codes (default: empty string)\n  - **Print Options Inspection** - Retrieve print centering and area settings\n    - `UmyaSpreadsheet.get_print_centered/2` - Get print centering as {horizontal, vertical} boolean tuple (default: {false, false})\n    - `UmyaSpreadsheet.get_print_area/2` - Get print area range or nil if not set (default: nil)\n    - `UmyaSpreadsheet.get_print_titles/2` - Get print titles as {rows, columns} tuple or nils if not set (default: {nil, nil})\n  - **Native Rust Implementation** - All getter functions implemented in native Rust for optimal performance\n  - **Error Handling** - Proper error handling for non-existent sheets with appropriate default value returns\n  - **Comprehensive Test Coverage** - Full unit test suite with 19 test cases covering all getter/setter functions, default values, and error scenarios\n  - **Documentation Updates** - Complete print settings guide with getter function examples and inspection patterns","ref":"changelog.html#added-2"},{"type":"extras","title":"Technical Details - Changelog","doc":"- **DefinedName API Integration** - Properly uses `get_address()` method for retrieving print area and print titles from Excel's defined names\n- **Type Safety** - All primitive return values properly dereferenced in Rust NIFs using `*` operator for u32, f64, and bool types\n- **String Formatting** - Header/footer text properly formatted using Rust's `format!(\"{:?}\")` for consistent string representation\n- **Default Value Consistency** - All getter functions return Excel-compatible default values when settings are not explicitly configured","ref":"changelog.html#technical-details-3"},{"type":"extras","title":"0.6.12 - 2025-05-29 - Changelog","doc":"","ref":"changelog.html#0-6-12-2025-05-29"},{"type":"extras","title":"Added - Changelog","doc":"- **Row and Column Property Getter Functions**:\n  - **Row Dimension Inspection** - Retrieve row properties and settings\n    - `UmyaSpreadsheet.get_row_height/3` - Get row height in points (default: 15.0)\n    - `UmyaSpreadsheet.get_row_hidden/3` - Get row hidden state (default: false)\n  - **Column Dimension Inspection** - Retrieve column properties and settings\n    - `UmyaSpreadsheet.get_column_width/3` - Get column width in characters (default: 8.43)\n    - `UmyaSpreadsheet.get_column_auto_width/3` - Get auto-width enabled state (default: false)\n    - `UmyaSpreadsheet.get_column_hidden/3` - Get column hidden state (default: false)\n  - **Native Rust Implementation** - All getter functions implemented in native Rust for optimal performance\n  - **Error Handling** - Proper error handling for non-existent sheets with appropriate default value returns\n  - **Auto-width Persistence Fix** - Modified `set_column_auto_width` to set both `auto_width` and `best_fit` fields for Excel compatibility\n  - **Comprehensive Test Coverage** - Full unit test suite with 11 test cases covering all getter/setter functions and error scenarios","ref":"changelog.html#added-3"},{"type":"extras","title":"Fixed - Changelog","doc":"- **Auto-width Persistence Issue** - Fixed `get_column_auto_width` to return `best_fit` value since that's what actually persists in Excel files\n- **Error Handling Standardization** - Unified error handling across all row/column NIFs to return simple error strings instead of nested error tuples\n- **Option Handling in Rust NIFs** - Fixed proper handling of cases where row/column dimensions don't exist by returning appropriate default values","ref":"changelog.html#fixed-4"},{"type":"extras","title":"0.6.11 - 2025-05-29 - Changelog","doc":"","ref":"changelog.html#0-6-11-2025-05-29"},{"type":"extras","title":"Added - Changelog","doc":"- **Row and Column Property Getter Functions**:\n  - **Row Dimension Inspection** - Retrieve row properties and settings\n    - `UmyaSpreadsheet.get_row_height/3` - Get row height in points (default: 15.0)\n    - `UmyaSpreadsheet.get_row_hidden/3` - Get row hidden state (default: false)\n  - **Column Dimension Inspection** - Retrieve column properties and settings\n    - `UmyaSpreadsheet.get_column_width/3` - Get column width in characters (default: 8.43)\n    - `UmyaSpreadsheet.get_column_auto_width/3` - Get auto-width enabled state (default: false)\n    - `UmyaSpreadsheet.get_column_hidden/3` - Get column hidden state (default: false)\n  - **Native Rust Implementation** - All getter functions implemented in native Rust for optimal performance\n  - **Error Handling** - Proper error handling for non-existent sheets with appropriate default value returns\n  - **Auto-width Persistence Fix** - Modified `set_column_auto_width` to set both `auto_width` and `best_fit` fields for Excel compatibility\n  - **Comprehensive Test Coverage** - Full unit test suite with 11 test cases covering all getter/setter functions and error scenarios\n\n- **Sheet Property Getter Functions**:\n  - **Sheet Metadata Inspection** - Comprehensive sheet information retrieval\n    - `UmyaSpreadsheet.SheetFunctions.get_sheet_count/1` - Get total number of sheets in spreadsheet\n    - `UmyaSpreadsheet.SheetFunctions.get_active_sheet/1` - Get currently active sheet tab index (0-based)\n    - `UmyaSpreadsheet.SheetFunctions.get_sheet_state/2` - Get sheet visibility state (\"visible\", \"hidden\", \"veryhidden\")\n    - `UmyaSpreadsheet.SheetFunctions.get_sheet_protection/2` - Get detailed sheet protection settings and status\n    - `UmyaSpreadsheet.SheetFunctions.get_merge_cells/2` - Get list of merged cell ranges in a sheet\n  - **Native Rust Implementation** - All getter functions implemented in native Rust for optimal performance\n  - **Error Handling** - Proper error handling for non-existent sheets and invalid operations\n  - **Comprehensive Test Coverage** - Full unit test suite with 8 test cases covering success and error scenarios\n\n- **Sheet View Getter Functions**:\n  - **Sheet Display Settings** - Retrieve sheet view display settings\n    - `UmyaSpreadsheet.get_show_grid_lines/2` - Get whether gridlines are shown (true/false)\n    - `UmyaSpreadsheet.get_zoom_scale/2` - Get zoom level percentage (e.g., 100, 150, 75)\n    - `UmyaSpreadsheet.get_tab_color/2` - Get tab color in hex format (e.g., \"#FF0000\")\n    - `UmyaSpreadsheet.get_sheet_view/2` - Get view type (\"normal\", \"page_layout\", \"page_break_preview\")\n    - `UmyaSpreadsheet.get_selection/2` - Get active cell and selection range as map\n\n- **Workbook View Getter Functions**:\n  - **Active Tab Retrieval** - Get the currently active worksheet in a workbook\n    - `UmyaSpreadsheet.get_active_tab/1` - Returns the 0-based index of the active tab\n  - **Window Position Retrieval** - Get the position and size of the Excel window\n    - `UmyaSpreadsheet.get_workbook_window_position/1` - Returns a map with :x, :y, :width, and :height of the workbook window\n\n- **Workbook Protection Getter Functions**:\n  - **Protection Status** - Check if a workbook has protection settings enabled\n    - `UmyaSpreadsheet.is_workbook_protected/1` - Returns true if the workbook has protection enabled\n  - **Protection Details** - Get detailed information about workbook protection settings\n    - `UmyaSpreadsheet.get_workbook_protection_details/1` - Returns a map with detailed protection settings\n\n- **Complete Cell Formatting Getter Functions**:\n  - **Font Property Inspection API** - Retrieve all font properties from spreadsheet cells\n    - `UmyaSpreadsheet.get_font_name/3` - Get font name/typeface (Arial, Times New Roman, etc.)\n    - `UmyaSpreadsheet.get_font_size/3` - Get font size in points\n    - `UmyaSpreadsheet.get_font_bold/3` - Get bold state (true/false)\n    - `UmyaSpreadsheet.get_font_italic/3` - Get italic state (true/false)\n    - `UmyaSpreadsheet.get_font_underline/3` - Get underline style (none, single, double, accounting)\n    - `UmyaSpreadsheet.get_font_strikethrough/3` - Get strikethrough state (true/false)\n    - `UmyaSpreadsheet.get_font_family/3` - Get font family type (roman, swiss, modern, script, decorative)\n    - `UmyaSpreadsheet.get_font_scheme/3` - Get font scheme (major, minor, none)\n    - `UmyaSpreadsheet.get_font_color/3` - Get font color (hex codes or theme references)\n  - **Cell Alignment Inspection** - Retrieve text alignment and formatting properties\n    - `UmyaSpreadsheet.get_cell_horizontal_alignment/3` - Get horizontal alignment (left, center, right, justify, etc.)\n    - `UmyaSpreadsheet.get_cell_vertical_alignment/3` - Get vertical alignment (top, middle, bottom, etc.)\n    - `UmyaSpreadsheet.get_cell_wrap_text/3` - Get text wrap state (true/false)\n    - `UmyaSpreadsheet.get_cell_text_rotation/3` - Get text rotation angle (0-359 degrees)\n  - **Border Property Inspection** - Retrieve border styles and colors for all positions\n    - `UmyaSpreadsheet.get_border_style/4` - Get border style (thin, medium, thick, dashed, dotted, double, none)\n    - `UmyaSpreadsheet.get_border_color/4` - Get border color (hex codes with default black FF000000)\n    - Support for all border positions: top, bottom, left, right, diagonal\n  - **Fill and Background Inspection** - Retrieve cell background and pattern properties\n    - `UmyaSpreadsheet.get_cell_background_color/3` - Get cell background color (hex codes)\n    - `UmyaSpreadsheet.get_cell_foreground_color/3` - Get pattern foreground color\n    - `UmyaSpreadsheet.get_cell_pattern_type/3` - Get fill pattern type (solid, none, etc.)\n  - **Number Format Inspection** - Retrieve number formatting information\n    - `UmyaSpreadsheet.get_cell_number_format_id/3` - Get number format ID reference\n    - `UmyaSpreadsheet.get_cell_format_code/3` - Get format code string (e.g., \"#,##0.00\")\n  - **Cell Protection Inspection** - Retrieve cell protection properties\n    - `UmyaSpreadsheet.get_cell_locked/3` - Get cell locked state (true/false)\n    - `UmyaSpreadsheet.get_cell_hidden/3` - Get cell hidden state (true/false)\n  - **Table Inspection API** - Comprehensive table property getters for Excel table analysis\n    - Table information retrieval (structure, range, columns)\n    - Table style properties (name, column/row highlights, banding)\n    - Table column definitions (names, IDs, totals functions)\n    - Totals row visibility status (true/false)\n  - **Background Functions Enhancement** - Added missing background property getters\n    - `UmyaSpreadsheet.get_cell_background_color/3` - Get cell background color (hex codes)\n    - `UmyaSpreadsheet.get_cell_foreground_color/3` - Get cell foreground/pattern color (hex codes)\n    - `UmyaSpreadsheet.get_cell_pattern_type/3` - Get cell fill pattern type (solid, gray125, etc.)\n  - **Comprehensive Test Coverage** - 100% test coverage with proper error handling validation\n  - **Consistent API Design** - All getter functions follow the same pattern and return appropriate default values","ref":"changelog.html#added-4"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed border color getter to return default black color (FF000000) instead of empty string when no color is set\n- Fixed foreground color getter to correctly return pattern background color, addressing Excel/OpenXML terminology confusion\n- Fixed test expectations for border colors - corrected to expect default black color when no explicit colors are set\n- Fixed Rust compilation errors in font getter functions caused by improper `Option<&Cell>` handling\n- Fixed Color API method calls in `get_font_color` function (corrected `get_argb()` and `get_theme_index()` usage)\n- Resolved all cell formatting getter function compilation issues in native Rust code","ref":"changelog.html#fixed-5"},{"type":"extras","title":"0.6.10 - 2025-05-29 - Changelog","doc":"","ref":"changelog.html#0-6-10-2025-05-29"},{"type":"extras","title":"Added - Changelog","doc":"- **Enhanced Font Management Features**:\n  - **Font Family Control** - Set font family types for text styling\n    - `UmyaSpreadsheet.set_font_family/4` - Apply font family numbering (roman, swiss, modern, script, decorative)\n  - **Font Scheme Support** - Control theme-aware font schemes\n    - `UmyaSpreadsheet.set_font_scheme/4` - Apply font schemes (major, minor, none)\n  - **Advanced Typography** - Comprehensive font styling capabilities\n    - Combine font family, scheme, and name for consistent typography\n  - **Complete Font Styling System** - Integrated font management with existing style properties","ref":"changelog.html#added-5"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed issue where font family and font scheme properties weren't correctly applied to Excel files","ref":"changelog.html#fixed-6"},{"type":"extras","title":"0.6.9 - 2025-05-28 - Changelog","doc":"","ref":"changelog.html#0-6-9-2025-05-28"},{"type":"extras","title":"Added - Changelog","doc":"- **Complete Document Properties Support**:\n  - **Core Document Properties** - Standard metadata fields for Excel documents\n    - `UmyaSpreadsheet.DocumentProperties.set_title/2`, `get_title/1` - Document title management\n    - `UmyaSpreadsheet.DocumentProperties.set_description/2`, `get_description/1` - Document description\n    - `UmyaSpreadsheet.DocumentProperties.set_subject/2`, `get_subject/1` - Document subject\n    - `UmyaSpreadsheet.DocumentProperties.set_keywords/2`, `get_keywords/1` - Document keywords\n    - `UmyaSpreadsheet.DocumentProperties.set_category/2`, `get_category/1` - Document category\n    - `UmyaSpreadsheet.DocumentProperties.set_creator/2`, `get_creator/1` - Document creator\n    - `UmyaSpreadsheet.DocumentProperties.set_last_modified_by/2`, `get_last_modified_by/1` - Last editor\n    - `UmyaSpreadsheet.DocumentProperties.set_company/2`, `get_company/1` - Company information\n    - `UmyaSpreadsheet.DocumentProperties.set_manager/2`, `get_manager/1` - Manager information\n    - `UmyaSpreadsheet.DocumentProperties.set_created/2`, `get_created/1` - Creation date\n    - `UmyaSpreadsheet.DocumentProperties.set_modified/2`, `get_modified/1` - Last modification date\n  - **Custom Document Properties** - User-defined key-value pairs for application-specific metadata\n    - `UmyaSpreadsheet.DocumentProperties.set_custom_property_string/3` - Set string properties\n    - `UmyaSpreadsheet.DocumentProperties.set_custom_property_number/3` - Set numeric properties\n    - `UmyaSpreadsheet.DocumentProperties.set_custom_property_bool/3` - Set boolean properties\n    - `UmyaSpreadsheet.DocumentProperties.set_custom_property_date/3` - Set date properties\n    - `UmyaSpreadsheet.DocumentProperties.get_custom_property/2` - Retrieve typed properties\n    - `UmyaSpreadsheet.DocumentProperties.remove_custom_property/2` - Remove specific properties\n    - `UmyaSpreadsheet.DocumentProperties.clear_custom_properties/1` - Remove all custom properties\n  - **Property Management Utilities** - Metadata management and retrieval\n    - `UmyaSpreadsheet.DocumentProperties.set_properties/2` - Set multiple properties at once\n    - `UmyaSpreadsheet.DocumentProperties.get_all_properties/1` - Retrieve all core properties\n    - `UmyaSpreadsheet.DocumentProperties.get_custom_property_names/1` - List all custom property names\n    - `UmyaSpreadsheet.DocumentProperties.get_custom_properties_count/1` - Count custom properties\n    - `UmyaSpreadsheet.DocumentProperties.has_custom_property/2` - Check if property exists\n  - **Comprehensive Documentation** - Complete guide with examples and best practices\n    - Detailed guide for core and custom document properties\n    - Best practices for date handling, Unicode support, and large numbers\n    - Error handling patterns and troubleshooting guidance\n\n- **VML Drawing Support**:\n  - **VmlDrawing Module** - Full support for Vector Markup Language elements in spreadsheets\n    - `UmyaSpreadsheet.VmlDrawing.create_shape/3` - Create VML shapes in worksheets\n    - `UmyaSpreadsheet.VmlDrawing.set_shape_type/4` - Set shape type (rect, oval, line, etc.)\n    - `UmyaSpreadsheet.VmlDrawing.set_shape_style/4` - Set CSS style for positioning and dimensions\n    - `UmyaSpreadsheet.VmlDrawing.set_shape_filled/4` - Control shape fill visibility\n    - `UmyaSpreadsheet.VmlDrawing.set_shape_fill_color/4` - Set shape fill color\n    - `UmyaSpreadsheet.VmlDrawing.set_shape_stroked/4` - Control shape outline visibility\n    - `UmyaSpreadsheet.VmlDrawing.set_shape_stroke_color/4` - Set outline color\n    - `UmyaSpreadsheet.VmlDrawing.set_shape_stroke_weight/4` - Set outline thickness\n  - **Legacy Drawing Compatibility** - Support for legacy Office drawing objects\n  - **Complex Drawing Object Management** - Creation and control of sophisticated drawing elements","ref":"changelog.html#added-6"},{"type":"extras","title":"Fixed - Changelog","doc":"- **Document Properties Module Fixes**:\n  - Fixed NIF loading error in UmyaNative module for document properties\n  - Fixed missing module declaration for VML support in lib.rs\n  - Fixed type conversion issues for floating-point and negative numeric properties\n  - Improved date handling with timezone-aware comparisons\n  - Enhanced error standardization for property not found cases\n  - Improved handling of very large numeric values and scientific notation\n  - Added comprehensive property value conversion for proper type support","ref":"changelog.html#fixed-7"},{"type":"extras","title":"0.6.8 - 2025-05-27 - Changelog","doc":"","ref":"changelog.html#0-6-8-2025-05-27"},{"type":"extras","title":"Added - Changelog","doc":"- **Complete Page Breaks Implementation**:\n  - **Row Page Break Management** - Full control over manual row page breaks for print layout\n    - `UmyaSpreadsheet.PageBreaks.add_row_page_break/4` - Add manual row breaks at specific rows\n    - `UmyaSpreadsheet.PageBreaks.remove_row_page_break/3` - Remove specific row breaks\n    - `UmyaSpreadsheet.PageBreaks.get_row_page_breaks/2` - Retrieve all row breaks for a worksheet\n    - `UmyaSpreadsheet.PageBreaks.clear_row_page_breaks/2` - Remove all row breaks from worksheet\n    - `UmyaSpreadsheet.PageBreaks.has_row_page_break/3` - Check if row break exists at specific row\n  - **Column Page Break Management** - Full control over manual column page breaks for print layout\n    - `UmyaSpreadsheet.PageBreaks.add_column_page_break/4` - Add manual column breaks at specific columns\n    - `UmyaSpreadsheet.PageBreaks.remove_column_page_break/3` - Remove specific column breaks\n    - `UmyaSpreadsheet.PageBreaks.get_column_page_breaks/2` - Retrieve all column breaks for a worksheet\n    - `UmyaSpreadsheet.PageBreaks.clear_column_page_breaks/2` - Remove all column breaks from worksheet\n    - `UmyaSpreadsheet.PageBreaks.has_column_page_break/3` - Check if column break exists at specific column\n  - **Bulk Operations & Convenience Functions** - Efficient batch operations for page break management\n    - `UmyaSpreadsheet.PageBreaks.add_row_page_breaks/3` - Add multiple row breaks in single operation\n    - `UmyaSpreadsheet.PageBreaks.add_column_page_breaks/3` - Add multiple column breaks in single operation\n    - `UmyaSpreadsheet.PageBreaks.remove_row_page_breaks/3` - Remove multiple row breaks efficiently\n    - `UmyaSpreadsheet.PageBreaks.remove_column_page_breaks/3` - Remove multiple column breaks efficiently\n    - `UmyaSpreadsheet.PageBreaks.clear_all_page_breaks/2` - Clear both row and column breaks\n    - `UmyaSpreadsheet.PageBreaks.get_all_page_breaks/2` - Get both row and column breaks as single result\n  - **Comprehensive Page Breaks Documentation**:\n    - **Complete Page Breaks Guide** - Comprehensive documentation for print layout control\n      - Guide covers manual page break insertion with row and column break management\n      - Detailed examples for basic operations, bulk operations, and advanced usage patterns\n      - Best practices for print layout design and performance optimization\n      - Real-world examples including reports, invoices, and multi-section documents\n      - Complete API reference with error handling patterns and troubleshooting guide\n\n- **Complete OLE Objects Documentation**:\n  - **Comprehensive OLE Objects Guide** - Complete documentation for working with embedded objects in Excel\n    - Guide covers embedding Word documents (.docx), PowerPoint presentations (.pptx), PDF files (.pdf), and text files (.txt)\n    - Detailed examples for creating OLE object collections and managing embedded objects\n    - Documentation for all supported ProgIDs and file format detection\n    - Complete API reference with error handling patterns and best practices\n    - Advanced operations including property management and object extraction\n  - **Enhanced Documentation Structure** - Added OLE Objects guide to HexDocs navigation\n    - Integrated OLE Objects guide into the main documentation index and mix.exs configuration\n    - Fixed documentation reference warnings (UmyaNative, missing file links)\n    - Consistent formatting and style matching existing documentation guides\n    - Cross-references to related guides (limitations, troubleshooting)\n\n- **Complete Rich Text Support**:\n  - **Core Rich Text Functionality** - Create and manipulate formatted text within Excel cells\n    - `UmyaSpreadsheet.RichText.create/0` - Create new empty rich text objects\n    - `UmyaSpreadsheet.RichText.create_from_html/1` - Parse HTML strings into rich text with formatting\n    - `UmyaSpreadsheet.RichText.to_html/1` - Generate HTML output from rich text objects\n    - `UmyaSpreadsheet.RichText.set_cell_rich_text/4` - Apply rich text formatting to specific cells\n    - `UmyaSpreadsheet.RichText.get_cell_rich_text/3` - Retrieve rich text objects from cells\n  - **Text Element Management** - Fine-grained control over formatted text segments\n    - `UmyaSpreadsheet.RichText.create_text_element/2` - Create individual text elements with custom formatting\n    - `UmyaSpreadsheet.RichText.add_text_element/2` - Add text elements to rich text objects\n    - `UmyaSpreadsheet.RichText.add_formatted_text/3` - Convenient method to add formatted text directly\n    - `UmyaSpreadsheet.RichText.get_elements/1` - Retrieve all text elements from rich text objects\n    - `UmyaSpreadsheet.RichText.get_element_text/1` - Extract text content from individual elements\n    - `UmyaSpreadsheet.RichText.get_element_font_properties/1` - Get font properties from text elements\n  - **Comprehensive Font Formatting** - Support for all Excel text formatting options\n    - **Bold, Italic, Underline, Strikethrough** - Standard text styling options\n    - **Font Size and Font Name** - Custom typography control\n    - **Text Color** - Support for hex colors and named colors\n    - **Mixed Formatting** - Multiple formatting styles within a single cell\n    - **Idiomatic Elixir API** - Uses atom keys (`:bold`, `:italic`) with automatic conversion to Rust string keys\n\n- **Robust Implementation**:\n  - **Resource Management** - Proper Rust resource handling with automatic cleanup\n    - `RichTextResource` and `TextElementResource` for memory-safe operations\n    - Thread-safe resource management with Mutex protection\n    - Automatic resource cleanup when resources go out of scope\n  - **Error Handling** - Comprehensive error management throughout the rich text system\n    - Graceful handling of invalid HTML input with fallback to plain text\n    - Validation of font properties with appropriate error messages\n    - Safe resource access with proper error propagation\n  - **Performance Optimized** - Efficient implementation for large documents\n    - Zero-copy string handling where possible\n    - Efficient HTML parsing and generation\n    - Optimized font property serialization/deserialization","ref":"changelog.html#added-7"},{"type":"extras","title":"Improved - Changelog","doc":"- **Elixir Interface** - Enhanced user experience with idiomatic Elixir patterns\n  - **Atom Key Support** - Use idiomatic Elixir atom keys (`:bold`, `:italic`) instead of string keys\n  - **Automatic Key Conversion** - Seamless conversion between Elixir atoms and Rust strings\n  - **Consistent API** - Rich text functions follow established UmyaSpreadsheet patterns\n  - **Type Specifications** - Complete type specs for all rich text functions\n- **Documentation** - Comprehensive documentation for rich text functionality\n  - **Rich Text Guide** - Created comprehensive 600+ line guide covering all rich text functionality\n    - Complete API documentation with function signatures and return values\n    - Quick start examples and step-by-step tutorials for common use cases\n    - Font properties documentation with practical examples for all formatting options\n    - Best practices for performance, color consistency, font selection, and HTML import\n    - Error handling patterns and comprehensive troubleshooting guide\n    - Four detailed real-world examples: Formatted Headers, Status Indicators, Multi-line Instructions, HTML Import\n  - **Rich Text Examples** - Added complete rich text examples to README.md\n    - Basic rich text creation and HTML import examples\n    - Mixed formatting demonstrations with multiple colors and styles\n    - Integration examples showing rich text with other UmyaSpreadsheet features\n  - **Function Documentation** - Detailed docstrings with examples for all rich text functions\n  - **Type Documentation** - Clear parameter and return value documentation\n  - **Updated Documentation Structure** - Enhanced guides.md with rich text guide reference\n    - Added rich text to \"Styling and Formatting\" section in documentation index\n    - Complete feature description with capabilities overview","ref":"changelog.html#improved"},{"type":"extras","title":"Fixed - Changelog","doc":"- **Configuration Warning** - Resolved `Application.get_env/3` deprecation warning in module compilation\n  - Updated to use compile-time configuration where appropriate\n  - Maintained compatibility with standalone scripts and Mix.install scenarios","ref":"changelog.html#fixed-8"},{"type":"extras","title":"0.6.7 - 2025-05-26 - Changelog","doc":"","ref":"changelog.html#0-6-7-2025-05-26"},{"type":"extras","title":"Added - Changelog","doc":"- **Complete Excel Hyperlinks Functionality**:\n  - **Core Hyperlink Management** - Comprehensive hyperlink creation and management system\n    - `add_hyperlink/4-6` - Create hyperlinks with web URLs, email addresses, file paths, and internal references\n    - `get_hyperlink/3` - Retrieve hyperlink information from specific cells with complete metadata\n    - `get_hyperlinks/2` - Get all hyperlinks from worksheets for bulk operations\n    - `update_hyperlink/4-6` - Modify existing hyperlinks with new URLs, tooltips, and properties\n    - `remove_hyperlink/3` - Delete individual hyperlinks while preserving cell values\n    - `remove_all_hyperlinks/2` - Clear all hyperlinks from worksheets efficiently\n  - **Advanced Hyperlink Features** - Rich functionality for complex hyperlink scenarios\n    - `add_bulk_hyperlinks/3` - Add multiple hyperlinks efficiently with tuple or map formats\n    - `has_hyperlink/3` - Check if specific cells contain hyperlinks\n    - `has_hyperlinks/2` - Verify if worksheets contain any hyperlinks\n    - `count_hyperlinks/2` - Count total hyperlinks in worksheets for management\n    - Support for custom tooltips and descriptions for enhanced user experience\n    - Integration with cell values for seamless data presentation\n  - **Multiple Hyperlink Types** - Complete support for all Excel hyperlink formats\n    - **Web URLs** - HTTP/HTTPS links to external websites and web services\n    - **Email Addresses** - Mailto links with optional subject and body parameters\n    - **File Paths** - Local and network file references (Windows, macOS, Linux)\n    - **Internal References** - Links to other worksheets, cell ranges, and named ranges\n\n- **Comprehensive Hyperlinks Documentation**:\n  - **Excel Hyperlinks Guide** - Complete 900+ line guide covering all hyperlink functionality\n    - Quick start examples and step-by-step tutorials for common use cases\n    - Complete API documentation with function signatures and return values\n    - Hyperlink types documentation with practical examples for each format\n    - Advanced features guide including bulk operations and worksheet-level management\n    - Best practices for URL validation, tooltips, organization, and error recovery\n    - Error handling patterns with comprehensive recovery strategies\n    - Performance considerations for bulk operations and memory management\n    - Three detailed real-world examples: Employee Directory, Financial Report Navigation, Project Documentation Hub\n  - **Updated Main Documentation** - Enhanced README.md and documentation structure\n    - Added hyperlinks to main features list with detailed capabilities\n    - Updated documentation index in guides.md with hyperlinks guide reference\n    - Enhanced mix.exs documentation structure for proper HexDocs integration\n  - **API Documentation** - Complete function documentation with examples and error handling\n    - Type specifications for all hyperlink functions with return value patterns\n    - Comprehensive parameter documentation with validation requirements\n    - Error scenarios documentation with descriptive error messages","ref":"changelog.html#added-8"},{"type":"extras","title":"Improved - Changelog","doc":"- **Documentation Structure** - Enhanced organization for better discoverability\n  - Added hyperlinks guide to \"Advanced Features\" section in documentation groups\n  - Updated guides index with comprehensive hyperlinks feature description\n  - Enhanced cross-references between hyperlinks and related functionality","ref":"changelog.html#improved-1"},{"type":"extras","title":"0.6.6 - 2025-05-26 - Changelog","doc":"","ref":"changelog.html#0-6-6-2025-05-26"},{"type":"extras","title":"Added - Changelog","doc":"- **Complete Excel Tables Functionality**:\n  - **Core Table Management** - Comprehensive table creation and management system\n    - `add_table/8` - Create structured tables with headers, ranges, and totals row options\n    - `get_tables/2` - Retrieve all tables from worksheets with complete metadata\n    - `remove_table/3` - Delete tables by name with proper cleanup\n    - `has_tables?/2` - Check if worksheets contain tables\n    - `count_tables/2` - Count tables in worksheets for management operations\n  - **Advanced Table Styling** - Professional table appearance with built-in Excel styles\n    - `set_table_style/8` - Apply Excel's built-in table styles (Light, Medium, Dark themes)\n    - Style customization options: first/last column emphasis, banded rows/columns\n    - Support for 60+ built-in table styles (TableStyleLight1-21, TableStyleMedium1-28, TableStyleDark1-11)\n    - `remove_table_style/3` - Remove styling while preserving table structure\n  - **Dynamic Column Management** - Add and modify table columns programmatically\n    - `add_table_column/6` - Add new columns with totals row functions\n    - `modify_table_column/7` - Update existing column properties (name, totals function, labels)\n    - Support for all Excel totals functions: sum, average, count, countNums, max, min, stdDev, var\n  - **Totals Row Control** - Flexible totals row management\n    - `set_table_totals_row/4` - Enable/disable totals rows with automatic calculations\n    - Automatic function application based on column configurations\n    - Dynamic updates when columns are added or modified\n\n- **Comprehensive Documentation Suite for Tables**:\n  - **Excel Tables Guide** - Complete 400+ line guide covering all table functionality\n    - Step-by-step table creation and management examples\n    - Complete styling guide with all available table styles and options\n    - Column management patterns and best practices\n    - Real-world examples: Employee Management System, Sales Reports with multiple tables\n    - Error handling patterns and recovery strategies\n    - Performance considerations and optimization tips\n  - **Updated Main Documentation** - Enhanced README.md with table examples\n    - Added table functionality to feature list with detailed capabilities\n    - Complete table workflow example with styling and column management\n    - Updated documentation links to include Excel Tables guide\n  - **API Documentation** - Comprehensive function documentation with examples\n    - Type specifications for all table functions with tuple return patterns\n    - Complete parameter documentation with validation rules\n    - Error scenarios and return value documentation\n\n- **Robust Error Handling & Validation**:\n  - **Consistent Return Format** - All table functions return `{:ok, value}` or `{:error, reason}` tuples\n  - **Comprehensive Validation** - Sheet existence, table name uniqueness, range validation\n  - **Descriptive Error Messages** - Clear error reasons for debugging and user feedback\n  - **Edge Case Handling** - Non-existent sheets, duplicate table names, invalid ranges\n\n- **Complete Test Coverage**:\n  - **Unit Tests** - 15 comprehensive tests covering all table functionality\n  - **Integration Tests** - Complete workflow tests from creation to deletion\n  - **Error Case Testing** - Validation of all error scenarios and edge cases\n  - **Tuple Return Validation** - Ensures consistent API patterns across all functions","ref":"changelog.html#added-9"},{"type":"extras","title":"Technical Implementation - Changelog","doc":"- **Native Rust Integration** - High-performance table operations via NIF\n  - Created comprehensive table.rs module with proper error handling\n  - Memory-safe operations with proper Rust borrowing patterns\n  - Type-safe conversions between Rust and Elixir data structures\n  - Integration with existing umya-spreadsheet table infrastructure\n- **Elixir Wrapper Module** - Clean, idiomatic Elixir API\n  - Complete UmyaSpreadsheet.Table module with full documentation\n  - Proper delegation patterns and error handling\n  - Type specifications for all public functions\n  - Integration with main UmyaSpreadsheet module\n- **Module Registration** - Proper NIF function exports and library integration\n  - Updated lib.rs with table module inclusion and function exports\n  - Added table function declarations to UmyaNative module\n  - Main module integration with aliases and delegations","ref":"changelog.html#technical-implementation"},{"type":"extras","title":"Quality Assurance - Changelog","doc":"- **Zero Compilation Warnings** - Clean codebase with no warnings or errors\n- **100% Test Pass Rate** - All 15 table tests passing successfully\n- **Memory Safety** - Proper resource management and cleanup\n- **API Consistency** - Follows established patterns from other modules","ref":"changelog.html#quality-assurance"},{"type":"extras","title":"0.6.5 - 2025-05-25 - Changelog","doc":"","ref":"changelog.html#0-6-5-2025-05-25"},{"type":"extras","title":"Added - Changelog","doc":"- **Comprehensive Documentation Suite**:\n  - **Enhanced Main Module Documentation** - Updated `UmyaSpreadsheet` module with comprehensive architecture overview\n    - Added ASCII diagram showing core architecture and specialized function modules\n    - Documented data flow (NIF Layer → Spreadsheet Reference → Function Modules → Error Handling → Memory Management)\n    - Added thread safety and performance characteristics documentation\n    - Included compatibility matrix for Excel versions, Elixir/OTP versions, and platforms\n    - Added quick start guide with code examples and error handling patterns\n  - **Troubleshooting Guide** - Created comprehensive `TROUBLESHOOTING.md` covering:\n    - Installation issues (NIF compilation, precompiled binaries, platform-specific problems)\n    - Runtime errors (spreadsheet reference errors, sheet not found, invalid cell references)\n    - Performance issues (slow file operations, memory usage growth)\n    - File format issues (corrupted files, encoding problems)\n    - Memory issues (out of memory errors, optimization strategies)\n    - Concurrency issues (race conditions, coordination patterns)\n    - Platform-specific solutions for macOS, Linux, and Windows\n    - Best practices for error handling, resource management, and performance optimization\n  - **Limitations and Compatibility Guide** - Created comprehensive `LIMITATIONS.md` covering:\n    - File format support matrix (.xlsx ✅, .xlsm ✅, .xls ❌, etc.)\n    - Excel feature support levels (basic operations, formatting, advanced features)\n    - Platform compatibility matrix (Linux, macOS, Windows with architecture support)\n    - Version compatibility (Elixir/OTP, Excel versions, LibreOffice compatibility)\n    - Performance limitations with memory usage guidelines and benchmarks\n    - Known issues with workarounds and roadmap information\n\n- **Sheet Management Functions**:\n  - `rename_sheet` - Renames an existing worksheet with comprehensive validation\n    - Validates sheet existence and name conflicts\n    - Prevents renaming to empty or whitespace-only names\n    - Returns appropriate error messages for invalid operations\n    - Full test coverage with 6 test scenarios\n\n- **Advanced Conditional Formatting - Icon Sets**:\n  - `add_icon_set` - Adds icon set conditional formatting rules to cell ranges\n    - Supports multiple icon styles: \"3_traffic_lights\", \"5_arrows\", \"4_red_to_black\", etc.\n    - Flexible threshold configuration (2-5 thresholds per icon set)\n    - Multiple threshold types: \"min\", \"max\", \"number\", \"percent\", \"percentile\", \"formula\"\n    - Comprehensive validation for threshold count and types\n    - Enhanced error handling for invalid inputs and nonexistent sheets\n\n- **Advanced Conditional Formatting - Above/Below Average Rules**:\n  - `add_above_below_average_rule` - Adds statistical conditional formatting rules\n    - Rule types: \"above\", \"below\", \"above_equal\", \"below_equal\"\n    - Optional standard deviation parameter for advanced statistical rules\n    - Customizable format styles for conditional highlighting\n    - Support for colors, fonts, and other formatting options\n\n- **Enhanced Test Coverage**:\n  - Added 17 comprehensive tests for new conditional formatting features\n  - Integration tests demonstrating combined usage of new features\n  - Error case testing for invalid inputs and edge scenarios\n  - Test file generation for visual verification of formatting rules","ref":"changelog.html#added-10"},{"type":"extras","title":"Fixed - Changelog","doc":"- **Function Call Consistency**: Updated test files to use correct API function names\n  - Changed `UmyaSpreadsheet.new_file()` to `UmyaSpreadsheet.new()`\n  - Changed `UmyaSpreadsheet.write_file()` to `UmyaSpreadsheet.write()`\n- **Return Value Handling**: Fixed case clause errors in conditional formatting functions\n  - Properly handle `{:ok, :ok}` return patterns from native functions\n  - Added comprehensive pattern matching for all possible return values\n  - Consistent error handling across all conditional formatting functions","ref":"changelog.html#fixed-9"},{"type":"extras","title":"Improved - Changelog","doc":"- **Native Function Integration**: Enhanced NIF registration and error handling\n- **Documentation**: Added comprehensive documentation with examples for all new functions\n- **API Consistency**: New functions follow existing patterns and conventions\n- **Error Messages**: Improved error reporting with descriptive messages for debugging","ref":"changelog.html#improved-2"},{"type":"extras","title":"0.6.4 - 2025-05-24 - Changelog","doc":"","ref":"changelog.html#0-6-4-2025-05-24"},{"type":"extras","title":"Fixed - Changelog","doc":"- **GitHub Actions workflows**: Fixed critical issues in CI/CD pipeline\n  - Updated project paths from incorrect \"example\" to correct \"umya_native\"\n  - Upgraded to modern action versions (actions/checkout@v4, actions/upload-artifact@v4)\n  - Fixed cross-compilation setup with proper musl target handling\n  - Added RUSTLER_NIF_VERSION environment variable passthrough for consistent builds\n- **Cross-compilation configuration**: Created comprehensive Cross.toml setup\n  - Added target-specific Docker images for reliable cross-platform builds\n  - Configured environment variable passthrough for NIF compilation\n  - Added support for all major platforms (Linux, macOS, Windows)\n- **Rust build system improvements**:\n  - Created build.rs script with platform-specific link arguments\n  - Added musl target detection and handling\n  - Fixed umya-spreadsheet dependency from incorrect path to proper crates.io version \"2.3.0\"\n  - Enhanced error handling in compilation process\n- **Formula functions**: Fixed test failures in defined name functionality\n  - Resolved private method access issues with DefinedName.set_name()\n  - Updated to use worksheet.add_defined_name() for proper name creation\n  - Improved error handling and validation in formula operations\n- **CI environment enhancements**:\n  - Added UMYA_SPREADSHEET_BUILD=true environment variable\n  - Improved Rust toolchain setup and system dependencies\n  - Enhanced build reliability across different platforms","ref":"changelog.html#fixed-10"},{"type":"extras","title":"Improved - Changelog","doc":"- Enhanced build reliability and cross-platform compatibility\n- Streamlined release process with proper artifact generation\n- Better error reporting in CI/CD pipeline\n- Improved documentation for build and release processes","ref":"changelog.html#improved-3"},{"type":"extras","title":"0.6.3 - 2025-05-24 - Changelog","doc":"","ref":"changelog.html#0-6-3-2025-05-24"},{"type":"extras","title":"Added - Changelog","doc":"- Advanced formula functionality:\n  - `set_formula` - Sets a regular formula in a cell\n  - `set_array_formula` - Sets an array formula for a range of cells\n  - `create_named_range` - Creates a named range reference\n  - `create_defined_name` - Creates a defined name with an associated formula\n  - `get_defined_names` - Retrieves all defined names in the workbook\n- Auto Filter functionality:\n  - `set_auto_filter` - Adds filter dropdown buttons to a range of cells\n  - `remove_auto_filter` - Removes an auto filter from a worksheet\n  - `has_auto_filter` - Checks if a worksheet has an auto filter\n  - `get_auto_filter_range` - Gets the range of an existing auto filter\n- Enhanced file format options:\n  - `write_with_compression` - Controls the compression level (0-9) for XLSX files\n  - `write_with_encryption_options` - Enhanced encryption with algorithm selection and security parameters\n  - `to_binary_xlsx` - Converts a spreadsheet to binary for web responses or in-memory processing\n- Added test coverage for formula, auto filter, and file format functionality:\n  - Tests for regular and array formulas\n  - Tests for named ranges and defined names\n  - Tests for creating, removing, and querying auto filters\n  - Tests for auto filter persistence between save and load operations\n  - Tests for file compression and binary conversion","ref":"changelog.html#added-11"},{"type":"extras","title":"0.6.2 - 2025-05-23 - Changelog","doc":"","ref":"changelog.html#0-6-2-2025-05-23"},{"type":"extras","title":"Added - Changelog","doc":"- Window settings for workbooks and sheets:\n  - Added `set_selection` for setting active cell and selection range in worksheets\n  - Added `set_active_tab` to control which tab is active when opening the workbook\n  - Added `set_workbook_window_position` to set Excel application window position and size\n- Added new test files:\n  - Added tests for sheet selection functionality\n  - Created comprehensive tests for workbook view settings\n  - Updated existing tests to ensure compatibility with new window features\n- Added comment management functionality:\n  - `add_comment` - Adds a comment to a cell with text and author\n  - `get_comment` - Retrieves comment text and author from a cell\n  - `update_comment` - Updates an existing comment with new text and optionally a new author\n  - `remove_comment` - Removes a comment from a cell\n  - `has_comments` - Checks if a worksheet contains any comments\n  - `get_comments_count` - Returns the number of comments in a worksheet","ref":"changelog.html#added-12"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed incorrect function name in tests (changed `create_sheet` to `add_sheet`)\n- Fixed Rust API usage for accessing workbook view in spreadsheet structure","ref":"changelog.html#fixed-11"},{"type":"extras","title":"0.6.1 - 2025-05-23 - Changelog","doc":"","ref":"changelog.html#0-6-1-2025-05-23"},{"type":"extras","title":"Added - Changelog","doc":"- Sheet-level features that have been implemented:\n  - Tab colors (`set_tab_color`)\n  - Sheet views (normal, page layout, page break preview) (`set_sheet_view`)\n  - Zoom settings (`set_zoom_scale`, `set_zoom_scale_normal`, `set_zoom_scale_page_layout`, `set_zoom_scale_page_break`)\n  - Freeze panes (`freeze_panes`)\n  - Split panes (`split_panes`)","ref":"changelog.html#added-13"},{"type":"extras","title":"Fixed - Changelog","doc":"- Release builds","ref":"changelog.html#fixed-12"},{"type":"extras","title":"0.5.6 - 2025-05-21 - Changelog","doc":"","ref":"changelog.html#0-5-6-2025-05-21"},{"type":"extras","title":"Added - Changelog","doc":"- Advanced cell formatting features:\n  - Added `set_font_italic` for italic text formatting\n  - Added `set_font_underline` with support for various underline styles (single, double, accounting)\n  - Added `set_font_strikethrough` for strikethrough text\n  - Enhanced borders with `set_border_style` supporting various styles (dotted, dashed, double)\n  - Added `set_cell_rotation` for text rotation within cells\n  - Added `set_cell_indent` for text indentation\n  - Comprehensive documentation and examples for all new formatting features\n  - Test suite covering all advanced formatting options","ref":"changelog.html#added-14"},{"type":"extras","title":"0.5.5 - 2025-05-20 - Changelog","doc":"","ref":"changelog.html#0-5-5-2025-05-20"},{"type":"extras","title":"Added - Changelog","doc":"- Concurrent operation capabilities:\n  - Added comprehensive test suite for concurrent spreadsheet operations\n  - Documented thread safety guidelines and best practices\n  - Verified support for multi-threaded access to independent spreadsheets","ref":"changelog.html#added-15"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed compilation errors in drawing_functions.rs:\n  - Consolidated duplicate imports for drawing structs\n  - Fixed type specifications in drawing function implementations\n  - Improved error handling and return values","ref":"changelog.html#fixed-13"},{"type":"extras","title":"Improved - Changelog","doc":"- Enhanced documentation structure:\n  - Created dedicated thread safety guide for concurrent operations\n  - Enhanced shapes and drawing documentation with thread safety guidelines\n  - Added examples for concurrent operation patterns\n  - Added tests for concurrent shape creation and manipulation","ref":"changelog.html#improved-4"},{"type":"extras","title":"0.5.3 - 2025-05-20 - Changelog","doc":"","ref":"changelog.html#0-5-3-2025-05-20"},{"type":"extras","title":"Added - Changelog","doc":"- Drawing and shape functionality:\n  - `add_shape` - Add various shapes (rectangles, ellipses, triangles, etc.) to worksheets\n  - `add_text_box` - Create text boxes with customizable text, background, and border\n  - `add_connector` - Draw connector lines between cells\n- Comprehensive shape documentation:\n  - Added detailed guide for shapes and drawing\n  - Example code for diagrams and flowcharts\n  - Support for multiple shape types and color specifications","ref":"changelog.html#added-16"},{"type":"extras","title":"Improved - Changelog","doc":"- Updated README with drawing and shape examples\n- Added shapes and drawing guide to documentation\n- Fixed compatibility issues with umya-spreadsheet 2.3.0\n- Added test script for drawing functionality","ref":"changelog.html#improved-5"},{"type":"extras","title":"0.5.2 - 2025-05-20 - Changelog","doc":"","ref":"changelog.html#0-5-2-2025-05-20"},{"type":"extras","title":"Added - Changelog","doc":"- Pivot table functionality:\n  - `add_pivot_table` - Create pivot tables with customizable row, column, and data fields\n  - `has_pivot_tables?` - Check if a sheet contains pivot tables\n  - `count_pivot_tables` - Count the number of pivot tables on a sheet\n  - `refresh_all_pivot_tables` - Update pivot table data\n  - `remove_pivot_table` - Remove a specific pivot table\n- Comprehensive pivot table documentation:\n  - Added detailed guide for pivot table usage\n  - Example code for common pivot table operations\n  - Full API documentation with typespecs","ref":"changelog.html#added-17"},{"type":"extras","title":"Improved - Changelog","doc":"- Updated README with pivot table examples\n- Added pivot table guide to documentation navigation\n- Implemented tests for all pivot table functionality\n- Exposed more functionality from the underlying Rust library","ref":"changelog.html#improved-6"},{"type":"extras","title":"0.5.1 - 2025-05-20 - Changelog","doc":"","ref":"changelog.html#0-5-1-2025-05-20"},{"type":"extras","title":"Added - Changelog","doc":"- Data validation functionality:\n  - `add_list_validation` - Create dropdown lists in cells\n  - `add_number_validation` - Apply number range constraints\n  - `add_date_validation` - Apply date constraints\n  - `add_text_length_validation` - Restrict text by character count\n  - `add_custom_validation` - Apply custom formula-based validation\n  - `remove_data_validation` - Remove validation from cells","ref":"changelog.html#added-18"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed compatibility issues with camelCase and snake_case operator strings in data validation functions\n- Updated tests to properly handle the `{:ok, value}` return type from `get_cell_value`\n- Fixed deprecated Rustler initialization in lib.rs by removing explicit function listing\n- Improved error handling in data validation functions","ref":"changelog.html#fixed-14"},{"type":"extras","title":"0.5.0 - 2025-05-19 - Changelog","doc":"","ref":"changelog.html#0-5-0-2025-05-19"},{"type":"extras","title":"Added - Changelog","doc":"- Comprehensive documentation for chart types:\n  - Added detailed chart types documentation to `add_chart` and `add_chart_with_options` functions\n  - Added a \"Supported Chart Types\" section to `DEVELOPMENT.md` with all 13 chart types\n  - Complete reference for all available chart types (`LineChart`, `PieChart`, `BarChart`, etc.)\n- Conditional formatting capabilities with several rule types:\n  - Cell value rules (greater than, less than, equal to, between, etc.)\n  - Top and bottom ranking rules (top N, bottom N%, etc.)\n  - Data bars (visual representation of values)\n  - Color scales (color gradients based on values)\n  - Text-based rules (contains, begins with, ends with, etc.)\n- Enhanced documentation structure:\n  - Added dedicated guide documents in the `docs` folder\n  - Created a guides index for better navigation\n  - Integrated guides into ExDocs for improved documentation experience\n- Organized guides by topic:\n  - Charts guide\n  - CSV export and performance guide\n  - Image handling guide\n  - Sheet operations guide\n  - Styling and formatting guide","ref":"changelog.html#added-19"},{"type":"extras","title":"Fixed - Changelog","doc":"- Rust code improvements:\n  - Fixed deprecated rustler initialization format in `lib.rs`\n  - Fixed multiple unused variables in `chart_functions.rs` by prefixing them with underscore\n  - Cleaned up Rust warnings for better maintainability","ref":"changelog.html#fixed-15"},{"type":"extras","title":"Improved - Changelog","doc":"- Documentation quality and accessibility:\n  - References to guides from `README.md` for better discoverability\n  - Updated main module documentation with links to guides\n  - Organized documentation groups in `mix.exs` for improved navigation\n  - Enhanced in-code documentation for all chart-related functions","ref":"changelog.html#improved-7"},{"type":"extras","title":"0.4.0 - 2025-05-18 - Changelog","doc":"","ref":"changelog.html#0-4-0-2025-05-18"},{"type":"extras","title":"Added - Changelog","doc":"- CSV export functionality:\n  - `write_csv/3` - Export specific sheets to CSV format\n- Light writer functions for better memory usage:\n  - `write_light/2` - Write files with less memory overhead\n  - `write_with_password_light/3` - Password protection with memory efficiency\n- New empty spreadsheet creation:\n  - `new_empty/0` - Create spreadsheets without default worksheets\n- Image handling:\n  - `add_image/4`\n  - `download_image/4`\n  - `change_image/4`\n- Sheet operations:\n  - `clone_sheet/3`\n  - `remove_sheet/2`\n  - `set_sheet_state/3`\n  - `set_sheet_protection/4`\n- Row and column operations:\n  - `insert_new_row/4`\n  - `insert_new_column/4`\n  - `insert_new_column_by_index/4`\n  - `remove_row/4`\n  - `remove_column/4`\n  - `remove_column_by_index/4`\n  - `copy_row_styling/6`\n  - `copy_column_styling/6`\n- Chart support:\n  - `add_chart/9` with multiple chart types\n- Cell formatting:\n  - `get_formatted_value/3`\n  - `set_number_format/4`\n  - `set_font_name/4`\n  - `set_wrap_text/4`\n- Sheet appearance:\n  - `set_show_grid_lines/3`\n  - `add_merge_cells/3`\n- Column dimensions:\n  - `set_column_width/4`\n  - `set_column_auto_width/4`\n- Workbook protection:\n  - `set_workbook_protection/2`\n- Enhanced documentation:\n  - New guide for styling and formatting\n  - New guide for sheet operations\n  - New guide for chart support\n  - New guide for image handling\n- Additional test files for new features","ref":"changelog.html#added-20"},{"type":"extras","title":"Improved - Changelog","doc":"- Updated README with comprehensive feature list\n- Added examples showcasing new functionality\n- Enhanced test coverage for all new features","ref":"changelog.html#improved-8"},{"type":"extras","title":"0.3.0 - 2025-05-17 - Changelog","doc":"","ref":"changelog.html#0-3-0-2025-05-17"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- Updated umya-spreadsheet Rust dependency to v2.3.0 from crates.io\n- Updated Rustler to v0.36.1\n- Changed some API functions to handle new return types (may affect pattern matching)","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Added - Changelog","doc":"- Font styling functions:\n  - `set_font_color/4`\n  - `set_font_size/4`\n  - `set_font_bold/4`\n- Password-protected file creation with `write_with_password/3`\n- Better examples in documentation\n- Comprehensive test suite with proper ExUnit test files\n- Added test files for styling and password protection features\n- Added integration tests ported from the Rust library's test suite","ref":"changelog.html#added-21"},{"type":"extras","title":"Fixed - Changelog","doc":"- Compatibility with Rustler 0.36.1 by handling `{:ok, val}` tuples properly\n- Color handling in `set_background_color` and `set_font_color`\n- Font size handling with proper float conversion","ref":"changelog.html#fixed-16"},{"type":"extras","title":"Improved - Changelog","doc":"- Converted demo scripts into proper test files\n- Added .gitignore entries for test output files\n- Enhanced documentation with testing information\n- Imported test files from the Rust library for comprehensive testing","ref":"changelog.html#improved-9"},{"type":"extras","title":"0.2.0 - Initial Release - Changelog","doc":"- Basic Excel file operations (create, read, write)\n- Cell manipulation\n- Basic styling with background colors\n- Sheet operations","ref":"changelog.html#0-2-0-initial-release"},{"type":"extras","title":"Development Notes","doc":"# Development Notes","ref":"development.html"},{"type":"extras","title":"Missing Features Analysis - Development Notes","doc":"Based on comprehensive analysis of the Rust structs vs. implemented NIF functions, the following features are not yet implemented in the Elixir wrapper:","ref":"development.html#missing-features-analysis"},{"type":"extras","title":"Technical Notes - Development Notes","doc":"- All features should follow the existing NIF pattern established in the codebase\n- Rust implementations already exist in the main library\n- Focus on exposing existing Rust functionality rather than reimplementing\n- Maintain backward compatibility with existing wrapper functions","ref":"development.html#technical-notes"},{"type":"extras","title":"Future Improvements - Development Notes","doc":"","ref":"development.html#future-improvements"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}